--战争会所
local div_chamber_str = [[
	{
	local buildingpos = arg[1]
	local ainfo = arg[2]
	local aconf = arg[3]
	local aupconf = arg[4]
	local nbuilding = arg[5]
	}
	<mx:Canvas id="chamber_main" width="720" height="1280" onloadcmp="chamber_onloadcmp">
		<mx:Canvas width="720" height="112">
			<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
			{local str = string.format("%s LV.%d",CData:GetTranlang("战争会所"),nbuilding)
			if g_main_apptype == 1 then 
				str = string.format("%s 레벨 %d",CData:GetTranlang("战争会所"),nbuilding)
			end
			}
			<mx:Label id="frameTop_txt" text="${str}" width="720" textAlign="center" y="35"/>
			<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" setts="4" onclick="chamber_btnClick"/>
		</mx:Canvas>
		<mx:Image source="assets/images/bg01.jpg" width="720" height="990" y="111"/>
		<mx:Image source="assets/images/baokuTop.png" y="111"/>
		<!mx:Label text="提高等级获得更多的出兵数量和出战队列" styleName="white02" y="222" x="32" width="593" textAlign="center"/>
		{local str = string.format(CData:GetTranlang("联军上限: %d"),chamber_getLimit(aupconf["F16"]))}
		<mx:Label text="${str}" styleName="white02" y="222" x="32" width="593" textAlign="center"/>
		<mx:Button styleName="btn01Detail" y="211" x="652" setts="1" onclick="chamber_btnClick"/>
		<mx:Button onclick="city_btnTopClick" setts="${buildingpos}|1" styleName="navi01" label="功能" sound="assets/sound/421.ogg" enabled="false" x="24" y="118"/>
		<mx:Button onclick="city_btnTopClick" setts="${buildingpos}|2" styleName="navi01" label="升级" sound="assets/sound/421.ogg" x="366" y="118"/>
		
		<mx:Image source="assets/images/bar03.png" x="90" y="432"/>
		<mx:Image source="assets/images/img01Hs.png" x="300" y="342"/>
		<mx:Label text="可组成联军的数量" fontSize="24" styleName="white01" x="212" y="459" width="297" textAlign="center"/>
		<mx:Label text="${chamber_getLimit(aupconf["F16"])}" fontSize="24" styleName="green01" x="212" y="496" width="297" textAlign="center"/>
		<mx:Text fontSize="24" styleName="brown01" x="90" y="557" text="${aconf["F3"]}" width="540"/>
		
		<!mx:Image source="assets/images/bar08.png" y="930"/>
		<!mx:Label text="正有一支大军正在集结" styleName="red01" fontSize="24" y="948" width="720" textAlign="center"/>
		<!mx:Button styleName="btn05" label="查看集结信息" y="1005" x="139" setts="2" onclick="chamber_btnClick"/>
		<!mx:Button styleName="btn05" label="查看进攻目标" y="1005" x="416" setts="3" onclick="chamber_btnClick"/>
	
	</mx:Canvas>
]]
local g_chamber_buildingpos = 0
function chamber_getGodsRelicBuffVal(nneedActivited)
	local nval8303 = 0
	
	local ngodsRelicId = 8303
	local nnow = CUserData:getCurServerTime()
	
	local v = godsRelic_getGodsRelic(ngodsRelicId)
	if #v > 0 then 
		local nid,ngrade,nCD,ntechParam1,ntechParam2,ntechParam3,ntechParam4,ntempParam1,ntempParam2,ntempParam3 = godsRelic_tableSplit(v)
		if (ntechParam3 > nnow or nneedActivited == 0) and ngrade > 0 then 
			local aconfig = cfgmgr_query2(G_DE_CFG_GODS_RELIC_UPG,ngodsRelicId,ngrade)
			if aconfig ~= nil then 
				nval8303 = jdtonumber(aconfig["F5"] )
				
				local vv = godsRelic_getGodsRelicDetail(ngodsRelicId)
				if #vv > 0 then 
					local alist = vv[2]
					for i=1,#alist do
						local nlv,npreVal,ncurVal,ntempParam1,ntempParam2,ntempParam3 = godsRelic_detailTableSplit(alist[i] )
						nval8303 = nval8303 + ncurVal --洗练的当前值
					end
				end
				
			end
		end
	end
	return nval8303
end
function chamber_getLimit(nval)
	local nval = jdtonumber(nval)
	local nplus756 = buff_get(756)
	local nval8303 = chamber_getGodsRelicBuffVal(1)
	print("chamber_getLimit nval:"..nval..",nplus756:"..nplus756..",nval8303:"..nval8303)
	
	nval = math.floor(nval * (1000+nplus756+nval8303 ) / 1000 )
	print("chamber_getLimit ret nval:"..nval)
	return nval
end


function chamber_show(npos)
	g_chamber_buildingpos = npos
	local ainfo = CUserData:getBuildBypos(npos)
	if ainfo ~= nil then
		local aconf = CUserData:getbuildingConfigByid(ainfo[2] )
		local aupconf = CUserData:getbuildingUpgConfigByid( ainfo[2] * 10000 + ainfo[3] )	
		
		if aconf ~= nil and aupconf ~= nil then
			local nbuilding = ainfo[3]
			local arg = {npos,ainfo,aconf,aupconf,nbuilding}
			local notuseopeneffect = buildUpgrade_getNotUseOpeneffect()
			--,nil,nil,notuseopeneffect
			flextodiv(div_chamber_str,arg ,"frame_more",nil,nil,(notuseopeneffect and {} or {5,"chamber_onloadcmp",{g_dTouchX,g_dTouchY}}))
			--frame_TopPushId({1,"chamber_main","战争会所"} )
		end
	end
end

function chamber_btnClick(a)
	g_dTouchX = a.dTouchX
	g_dTouchY = a.dTouchY
	local nindex = tonumber(a.pBase:getts() )
	print("chamber_btnClick nindex:"..nindex)
	if nindex == 1 then
		buildInfo_show(g_chamber_buildingpos)
	elseif nindex == 2 then--查看集结信息
	
	elseif nindex == 3 then--查看进攻目标
	
	elseif nindex == 4 then--
		--deldiv("main","chamber_main")
		frame_CityOrMapBtnClick()
	end
end

function chamber_onloadcmp(a)
	deldiv("main","buildUpgrade_main")
end	


