--城市改名
local div_cityName_str = [[
	{
	local sname = arg[1]
	}
	<mx:Canvas id="cityName_main" width="720" height="1280">
		<mx:Canvas width="720" height="112">
			<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
			<mx:Label id="frameTop_txt" text="城市改名" width="720" textAlign="center" y="35"/>
			<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" setts="2" onclick="cityName_btnClick"/>
		</mx:Canvas>
		<mx:Image source="assets/images/bg01.jpg" width="720" height="990" y="111"/>
		
		<mx:Image source="assets/images/txtBar01.png" x="20" y="117"/>
		<mx:Text fontSize="24" styleName="white01" leading="10" text="最多输入长度为16的名称，无法与其他玩家的城市名字相同" x="131" y="134" width="468"/>
		<mx:Image source="assets/images/bg05Input.png" y="235" x="108"/>
		{if sname == "" then
			sname = "请输入名字"
		end}
		<mx:TextInput keyboardtype="0" id="cityName_input"  autorow="false" height="37" clickclear="true" width="390" textAlign="center" y="242" x="152" borderStyle="none" backgroundAlpha="0" text="${sname}"/>
		<mx:Button styleName="btn08" label="确认" y="333" x="203" id="cityName_btn_1" setts="1" onclick="cityName_btnClick"/>
		
	</mx:Canvas>
	
]]
function cityName_show()
	local sname = CUserData.m_szCityName
	local arg = {sname}
	flextodiv(div_cityName_str,arg ,"frame_more")
	--frame_TopPushId({2,"cityName_main","城市改名"} )
end

function cityName_btnClick(a)
	local nindex = tonumber(a.pBase:getts() )
	print("cityName_btnClick nindex:"..nindex)
	if nindex == 1 then	
		cityName_popshow()
		local div = getid2("main","cityName_input")
		if div ~= nil then
			local text = div:gettext() 
			if text ~= nil then
				httpsend( 1 , 0x010c , 0 , {CUserData.m_nUserID,{16,text},0 },"cityName_revMsg","httpdp_svrStatus"  )--兵种操作					
				btnloading_show( a.pBase:getid() )
			end
		end
	elseif nindex == 2 then
		deldiv("frame_more","cityName_main",{3})
	end
end

function cityName_revMsg(ntype , nseqno , nret , arg )--0x0106
	http_getdata(ntype , nseqno , nret , arg)
	print("ntype: nseqno: nret: arg:",ntype,nseqno,nret,tabletostring(arg))
	btnloading_del("cityName_btn_1")
	btnloading_del("cityName_popBtn_1")
	btnloading_del("cityName_popBtn_2")
	if nret ~= 0 then 	
		return 
	end 
	table.insert(arg,1,nret)
	
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s camp_revMsg" , ntype , nseqno , nret, tabletostring(arg) ) )
	--数据刷新
	CUserData:onCityRename(arg)
	--界面刷新
	--frame_TopDelDiv()
	mansion_show(mansion_getpos() )
	
	showClum({"城市改名成功",1})	
end

local div_cityNamePop_str = [[
	<mx:Canvas id="cityNamePop_main" width="720" height="489" horizontalCenter="0" verticalCenter="0">
		<mx:Image source="assets/images/popBg01.png" width="720" height="489"/>
		<mx:Button styleName="btn02Close" id="closeBtn" x="619" y="5" setts="1" id="cityName_popBtn_1" onclick="cityName_popBtnClick"/>
		
		<mx:Label text="城市改名/君主改名" styleName="brown01" x="165" y="29" width="340" textAlign="center"/>
		<mx:Image source="assets/images/line02.png" x="86" y="71"/>
		<mx:Canvas x="66" y="128" width="124" height="127">
			<mx:Image source="assets/images/headerBg03.png"/>
			<mx:Image source="assets/images/testImg05.png" x="9" y="9"/>
			<!-- 以下仓库里时显示 -->
			<mx:Image source="assets/images/numBg01.png" x="77" y="83"/>
			<mx:Label text="99" fontSize="20" styleName="white01" textAlign="center" x="79" y="87" width="39"/>
			<!-- 以上仓库里时显示 -->
		</mx:Canvas>
		<mx:Label fontSize="24" styleName="brown01" text="数量：1" x="57" y="266" width="145" textAlign="center"/>
		<mx:Label fontSize="24" styleName="brown01" text="改名字需要消耗一个道具" x="213" y="174"/>
		<mx:Button styleName="btn09" x="174.5" y="357" setts="2" id="cityName_popBtn_2" onclick="cityName_popBtnClick"/>
		<mx:Label text="3,300" styleName="white01" fontSize="20" x="184" y="363" width="358" textAlign="center" mouseThrough="true"/>
		<mx:Label text="立刻训练" styleName="white01" fontSize="20" x="184" y="387" width="358" textAlign="center" mouseThrough="true"/>
	</mx:Canvas>	
]]
function cityName_popshow()
	local arg = {}
	flextodiv(div_cityNamePop_str,arg ,"frame_more")
end

function cityName_popBtnClick(a)
	local nindex = tonumber( a.pBase:getts() )
	print("cityName_popBtnClick nindex:"..nindex)
	if nindex == 1 then
		deldiv("main","cityNamePop_main")
	elseif nindex == 2 then
		local div = getid2("main","cityName_input")
		if div ~= nil then
			local text = div:gettext() 
			if text ~= nil then
				httpsend( 1 , 0x010c , 0 , {CUserData.m_nUserID,{15,text},0 },"cityName_revMsg","httpdp_svrStatus"  )--兵种操作	
				btnloading_show( a.pBase:getid() )				
			end
		end
		deldiv("main","cityNamePop_main")
	end
end


