--大使馆
local div_embassy_str = [[
	{
	local buildingpos = arg[1]
	local ainfo 	  = arg[2]
	local asoldier    = arg[3]
	local narmyid     = arg[4]
	local abuildInfo  = arg[5]
	local abuildconf  = arg[6]	
	local abuildupconf= arg[7]	
	local ntotalnum   = arg[8]
	local nbuildinglv = arg[9]
	local nnum        = abuildupconf["F16"]
	if nnum == nil then nnum = 0 end
	}
	<mx:Canvas id="embassy_main" width="720" height="1280" onloadcmp="embassy_onloadcmp">
		<mx:Canvas width="720" height="112">
			<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
			{local str = string.format("%s LV.%d",CData:GetTranlang("大使馆"),nbuildinglv)
			if g_main_apptype == 1 then 
				str = string.format("%s 레벨 %d",CData:GetTranlang("大使馆"),nbuildinglv)
			end
			}
			<mx:Label id="frameTop_txt" text="${str}" width="720" textAlign="center" y="35"/>
			<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" setts="4" onclick="embassy_btnClick"/>
		</mx:Canvas>
		<!mx:Image source="assets/images/bg02.jpg" width="720" height="990" y="111"/>
		<mx:Image source="assets/images/bg01.jpg" width="720" height="990" y="111"/>
		<mx:Image source="assets/images/baokuTop.png" y="111"/>
		{local str = string.format(CData:GetTranlang("当前驻守：%d/%d"),ntotalnum,nnum) }
		{local str = string.format(CData:GetTranlang("驻军上限: %d"),nnum) }
		<mx:Label text="${str}" styleName="white02" y="220" x="32" width="593" textAlign="center"/>
		<mx:Button styleName="btn01Detail" y="211" x="652" setts="2" onclick="embassy_btnClick"/>
		<mx:Button onclick="city_btnTopClick" setts="${buildingpos}|1" styleName="navi01" label="功能" sound="assets/sound/421.ogg" enabled="false" x="24" y="118"/>
		<mx:Button onclick="city_btnTopClick" setts="${buildingpos}|2" styleName="navi01" label="升级" sound="assets/sound/421.ogg" x="366" y="118"/>
		<mx:Canvas height="725" y="277" setslidetype="1">
			<mx:VBox verticalGap="5" x="19"   verticalScrollPolicy="off"  mouseThrough="true">
				{for i = 1 , #ainfo do
					local v = ainfo[i]
					
					local ncount = 0
					for k = 8 , 31 do
						if v[k] ~= nil and tonumber(v[k]) > 0 then
							ncount = ncount + tonumber(v[k])
						end	
					end
					for k = 32 , 36,2 do
						if v[k] ~= nil and tonumber(v[k]) > 0 then
							ncount = ncount + tonumber(v[k])
						end	
					end
					for k = 39 , 47 do
						if v[k] ~= nil and tonumber(v[k]) > 0 then
							ncount = ncount + tonumber(v[k])
						end	
					end
					}
					<mx:Canvas width="684" mouseThrough="true" height="110">
						<mx:Image source="assets/images/line01.png" y="106"/>
						{if tonumber(narmyid) == tonumber(ainfo[i][1]) then}
							<mx:Button styleName="radio01" enabled="false" x="35" y="35" mouseThrough="true"/>
						{else}
							<mx:Button styleName="radio01" enabled="true" x="35" y="35" mouseThrough="true"/>
						{end}
						{local str = string.format(CData:GetTranlang("玩家名称:%s"),v[3])}
						<mx:Label text="${str}" fontSize="24" styleName="brown01" x="233" y="21" mouseThrough="true"/>
						
						<mx:Canvas width="684" height="70" setts="${ainfo[i][1]}" sound="defalut" onclick="embassy_btnItemClick" mouseThrough="true"/>
						
						
						<mx:Image source="assets/images/headerBg02.png" x="92" y="20" mouseThrough="true"/>
						<mx:Image source="assets/role/small/${v[4]}.png" x="100" y="26" width="58" height="58" mouseThrough="true"/>
						
						<mx:Image source="assets/union/small/rank${v[32]}.png" x="189" y="26" width="35" height="35" mouseThrough="true"/>
						
						<mx:Image source="assets/images/ic06.png" x="189" y="59" mouseThrough="true"/>
						
						<mx:Label text="${ncount}" fontSize="24" styleName="brown01" x="233" y="61" mouseThrough="true"/>
												
						<mx:Button styleName="btn11" label="详情" x="521" y="50" setts="${v[1]}" onclick="embassy_btnDetailClick"/>
						
						
					</mx:Canvas>
				{end}
			</mx:VBox>
			{if #ainfo <= 0 then}
				<mx:Image source="assets/images/bg01.jpg" width="720" height="990" y="0"/>
				<mx:Label text="没有任何驻守" fontSize="30" styleName="brown01" horizontalCenter="0" y="300"/>
			{end}
		</mx:Canvas>
		<mx:Image source="assets/images/bar01.png" y="1000"/>
		<mx:Button styleName="btn01" label="遣送回家" y="1020" x="181" setts="3" id="embassy_btn_3" onclick="embassy_btnClick"/>
	</mx:Canvas>
	
]]
local g_embassy_buildingpos = 0 
local g_embassy_narmyid = 0
local g_embassy_arg = {}
--[[
步兵 1 ~ 6
骑兵 11 ~ 16
弓兵 21 ~ 26
攻城 201 ~ 204
]]
function embassy_show(npos ,narmyid)--npos 大使馆建筑位子索引,narmyid 选中的部队索引
	if npos == -1 then --npos == 1 ,则 赋值该建筑最大值
		local ainfo = CUserData:getMaxLvBuildByid(14)--大使馆 类型 14
		if ainfo ~= nil then
			npos = 	ainfo[1]	
		end
	end
	
	g_embassy_buildingpos = npos
	g_embassy_narmyid = narmyid
	local ainfo = copytable(CUserData.m_aReinforce )
	local aconfAll = CUserData:getSoldierConfigAll()	
	local asoldierid   = {1,2,3,4,5,6, 11,12,13,14,15,16, 21,22,23,24,25,26, 201,202,203,204,205,206,301,0,311,0,321,0, 0 ,7,17,27,8,18,28,9,19,29 }
	local asoldier = {}--兵种名称
	for i = 1 ,#asoldierid do
		local id = asoldierid[i]
		local str= ""
		for k = 1 ,#aconfAll do			
			if id > 0 and tonumber(aconfAll[k]["F0"]) == id then
				str = aconfAll[k]["F2"]
				break
			end
		end 
		table.insert(asoldier,{id,str })
	end 
	print("embassy_show ainfo:"..tabletostring(ainfo) )
	--embassy_show ainfo:{{8,4,"ssss77",1001,"",0,0,2,60,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0}}
	--测试数据
--	ainfo = {
--		{1,1,"11",1,"1111", 1,1,99999999,99999999,99999999,99999999,99999999,99999999,99999999,99999999, 99999999,99999999,99999999,99999999,99999999, 99999999,99999999,99999999,99999999,99999999, 99999999,99999999,99999999,99999999,0, 0},
--		{2,1,"22",1,"2222", 1,1,1,1,1, 1,1,1,1,1, 1,1,1,1,1, 1,1,1,1,1, 1,1,1,1,1, 1},
--		{3,1,"33",1,"3333", 1,1,1,1,1, 1,1,1,1,1, 1,1,1,1,1, 1,1,1,1,1, 1,1,1,1,1, 1},
--		{4,1,"44",1,"4444", 1,1,1,1,1, 1,1,1,1,1, 1,1,1,1,1, 1,1,1,1,1, 1,1,1,1,1, 1},
--	}
	--
	local ntotalnum = 0 --军队士兵总量
	for i = 1 ,#ainfo do
		for k = 8 , 8 + 29 do	
			if asoldierid[i] > 0 and asoldier[k-7] ~= nil and ainfo[i][k] ~= nil and ainfo[i][k] ~= 0 then	
				ntotalnum = ntotalnum + ainfo[i][k]
			end
		end
		for k = 39 , 39 + 8 do	
			if asoldierid[i] > 0 and asoldier[k-7] ~= nil and ainfo[i][k] ~= nil and ainfo[i][k] ~= 0 then	
				ntotalnum = ntotalnum + ainfo[i][k]
			end
		end
	end
	--建筑信息
	local abuildInfo = CUserData:getBuildBypos(npos)
	if abuildInfo ~= nil then	
		local abuildConf = CUserData:getbuildingConfigByid(abuildInfo[2] )
		local abuildUpconf	 = CUserData:getbuildingUpgConfigByid(abuildInfo[2] * 10000 + abuildInfo[3])
		if abuildConf ~= nil then
			if abuildUpconf == nil then
				abuildUpconf = {}
			end
			local nbuildinglv = abuildInfo[3]
			local arg = {g_embassy_buildingpos,ainfo ,asoldier,narmyid,abuildInfo,abuildConf,abuildUpconf,ntotalnum,nbuildinglv}
			g_embassy_arg = arg
			local notuseopeneffect = buildUpgrade_getNotUseOpeneffect()
			--,nil,nil,notuseopeneffect
			flextodiv(div_embassy_str,arg ,"frame_more",nil,nil,(notuseopeneffect and {} or {5,"embassy_onloadcmp",{g_dTouchX,g_dTouchY}}))
		end
	end
end

function embassy_btnClick(a)
	g_dTouchX = a.dTouchX
	g_dTouchY = a.dTouchY
	local nindex = tonumber(a.pBase:getts())
	print("embassy_btnClick nindex:"..nindex)
	if nindex == 1 then
		deldiv("frame_more","embassy_main")
	elseif nindex == 2 then
		buildInfo_show(g_embassy_buildingpos)
	elseif nindex == 3 then--遣送回家
		local arg = g_embassy_arg
		local ainfo 	  = arg[2]
		local asoldier    = arg[3]
		local narmyid     = arg[4]
		local nfind = 0
		for i = 1, #ainfo do
			if ainfo[i][1] == narmyid then
				nfind = 1
			end
		end
		if nfind == 1 then
			httpsend( 1 , 0x0127 , 0 , {CUserData.m_nUserID,narmyid },"embassy_revMsg","httpdp_svrStatus"  )--兵种操作
			btnloading_show( a.pBase:getid() )
		else
			showClum({"请选择部队",1})			
		end
	elseif nindex == 4 then--
		--deldiv("main","embassy_main")
		frame_CityOrMapBtnClick()
	end
end
function embassy_revMsg(ntype , nseqno , nret , arg )--0x0127
	http_getdata(ntype , nseqno , nret , arg)
	print("ntype: nseqno: nret: arg:",ntype,nseqno,nret,tabletostring(arg))
	btnloading_del("embassy_btn_3")
	if nret ~= 0 then 	
		return 
	end 
	table.insert(arg,1,nret)
	
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s embassy_revMsg" , ntype , nseqno , nret, tabletostring(arg) ) )
	--数据刷新
	CUserData:onReinforceSendBack(arg)
	--界面刷新
	embassy_show(g_embassy_buildingpos ,g_embassy_narmyid)
	showClum({"操作成功",1})		
end

function embassy_onloadcmp(a)
	deldiv("main","buildUpgrade_main")
end	

function embassy_btnItemClick(a)
	local nindex = tonumber(a.pBase:getts() )
	print("embassy_btnItemClick nindex:"..nindex)
	embassy_show(g_embassy_buildingpos, nindex )
end	

function embassy_refBySNReinforce()
	local div = getid2("main","embassy_main")
	if div ~= nil then
		embassy_show(g_embassy_buildingpos,g_embassy_narmyid)
	end
end


function embassy_btnDetailClick(a)
	print("embassy_btnDetailClick ")
	local nindex = tonumber(a.pBase:getts() )
	print("embassy_btnDetailClick nindex:"..nindex)
	
	g_dTouchX = a.dTouchX
	g_dTouchY = a.dTouchY
	
	embassyDetail_show(nindex )
end

