--铁匠铺 (装备)
local div_equip_str = [[
	{
	local alist = arg[1]
	local buildingpos = arg[2]
	local aqueue = arg[3]
	local strbuff = arg[4]
	local nbuildinglv = arg[5]
	}
	<mx:Canvas id="equip_main" width="720" height="1280" onloadcmp="equip_onloadcmp">
		<mx:Canvas width="720" height="112">
			<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
			{local str = string.format("%s LV.%d",CData:GetTranlang("铁匠铺"),nbuildinglv )	
			if g_main_apptype == 1 then 
				str = string.format("%s 레벨 %d",CData:GetTranlang("铁匠铺"),nbuildinglv )	
			end
			}
			<mx:Label id="frameTop_txt" text="${str}" width="720" textAlign="center" y="35"/>
			<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" setts="2" onclick="equip_btnClick"/>
		</mx:Canvas>
		<mx:Image source="assets/images/bg02.jpg" width="720" height="990" y="111"/>
		<mx:Image source="assets/images/baokuTop.png" y="111"/>
		<mx:Label visible="false" text="${strbuff}" styleName="white02" y="222" x="32" width="593" textAlign="center"/>
		<mx:Button styleName="btn01Detail" y="211" x="652" setts="1" onclick="equip_btnClick"/>
		<mx:Button onclick="city_btnTopClick" setts="${buildingpos}|1" styleName="navi01" label="功能" sound="assets/sound/421.ogg" enabled="false" x="24" y="118"/>
		<mx:Button onclick="city_btnTopClick" setts="${buildingpos}|2" styleName="navi01" label="升级" sound="assets/sound/421.ogg" x="366" y="118"/>
		{
		local vbox_y = 277
		if #aqueue > 0 then
			vbox_y = vbox_y + 80 
			
			local dismax = aqueue[3] - aqueue[2]
			local discur = CUserData:getLeavingsTime(aqueue[3])
			local strtime= formatTime(discur)
			if dismax == 0 then dismax = 1 end
			local dispro = 377 * (1- discur / dismax )
			local protext = string.format(CData:GetTranlang("装备锻造中%s"),strtime) 				
			
			if aqueue[5] == 1 then
				protext = string.format(CData:GetTranlang("圣物合成中%s"),strtime) 
			end
			}
			
			<mx:Canvas y="120">
				<mx:Image source="assets/images/progBg01.png" y="172" x="100" mouseThrough="true"/>
				<mx:Canvas id="equip_prog" styleName="prog07" width="${dispro}" height="31" y="177" x="105" mouseThrough="true"/>
				<mx:Label id="equip_progtext" text="${protext}" fontSize="24" styleName="white01" x="115" y="176" width="357" textAlign="center" mouseThrough="true"/>
				<mx:Button styleName="btn01Close" x="36" y="164" onclick="equip_btnQueueStop"/>
				<mx:Button styleName="btn06" label="加速" x="494" y="169" onclick="equip_btnQueueSpeed"/>
			</mx:Canvas>
		{end}
		{
		--verticalScrollPolicy="off"
		}
		<mx:Canvas setslidetype="1" y="${vbox_y}" width="720" height="${1280-vbox_y-190}">
			<mx:VBox verticalGap="5" x="10" y="${0}" >
				{for i = 1 , #alist do
					local v = alist[i] }
					<mx:Canvas width="706" height="171" setts="${i}" sound="defalut" onclick="equip_btnItemClick" sound="defalut">
						<mx:Image source="assets/images/block06.png" width="706" height="171" mouseThrough="true"/>
						<mx:Label text="${v[1]}" fontSize="24" styleName="brown01" x="94" y="68" width="114" textAlign="center" mouseThrough="true"/>
						<mx:Image source="assets/images/${v[2]}.png" width="105" height="105" x="275" y="40" mouseThrough="true"/>
						<mx:Image source="assets/images/arr01.png" x="623" y="52" mouseThrough="true"/>
					</mx:Canvas>
				{end}
			</mx:VBox>
		</mx:Canvas>
		
		
	</mx:Canvas>
]]
--排程变化后没有更新
local g_equip_itemStr={
	{"锻造","ico_equipForg"},
	{"宝石","ico_equipEnch"},--镶嵌
	{"圣物合成","ico_equipComp"},
	{"符文","runeShop_ico01"},--宝石合成 "ico_gemCompose"
	{"英雄守护灵","guardian_ico01"},
}
local g_equip_building = 0
local g_equip_arg = {}
function equip_getBuildingpos()
	return g_equip_building
end

function equip_show(npos)
	--如果npos 是nil,则找到一个铁匠铺位置赋值,没有找到则赋值-1
	if npos == nil then--铁匠铺 id 4
		local ainfo = CUserData:getMaxLvBuildByid(4)
		if ainfo ~= nil then
			npos = ainfo[1]
		else
			npos = -1
		end
	end
	print("equip_show :"..npos)
	g_equip_building = npos
	local aQueue = {}
	for i = 1 ,#CUserData.m_aQueue do
		if CUserData.m_aQueue[i][1]	== 8 then
			aQueue = copytable( CUserData.m_aQueue[i] )
			break
		end
	end
	if #aQueue > 1 then
		local discur = CUserData:getLeavingsTime(aQueue[3])
		if discur <= 0 then
			aQueue = {}
		end
	end
	local ainfo	  = CUserData:getBuildBypos(npos)
	if ainfo ~= nil then
		print("ainfo:"..tabletostring(ainfo) )
		local strbuff = ""
		local aupconf = CUserData:getbuildingUpgConfigByid( ainfo[2]*10000 + ainfo[3] )
		if aupconf ~= nil then
			strbuff = CUserData:format( { CData:GetTranlang(CUserData:getFuncListByid(aupconf["F15"], 1)), tonumber( aupconf["F16"]) / tonumber(CUserData:getFuncListByid(aupconf["F15"], 5))})
		end
		print("equip_show aQueue:"..tabletostring(aQueue) )
		local nbuildinglv = ainfo[3]
		local arg = {g_equip_itemStr,g_equip_building ,aQueue , strbuff ,nbuildinglv}
		g_equip_arg = arg
		local notuseopeneffect = buildUpgrade_getNotUseOpeneffect()
		--,nil,nil,notuseopeneffect
		flextodiv(div_equip_str,arg ,"frame_more",nil,nil,(notuseopeneffect and {} or {5,"equip_onloadcmp",{g_dTouchX,g_dTouchY}}))
	end
end

function equip_btnClick(a)
	g_dTouchX = a.dTouchX
	g_dTouchY = a.dTouchY
	local nindex = tonumber(a.pBase:getts() )
	if nindex == 1 then
		buildInfo_show(g_equip_building)
	elseif nindex == 2 then
		--deldiv("main","equip_main")
		frame_CityOrMapBtnClick()
	end
end

function equip_btnItemClick(a)
	local nindex = tonumber(a.pBase:getts() )
	print("equip_btnItemClick nindex:"..nindex)
	if nindex == 1 then		--锻造
		equipForg_show(1)
	elseif nindex == 2 then --镶嵌
		equipEnch_show(1,1,1,2)
	elseif nindex == 3 then --圣物合成
		equipComp_show(1)
	elseif nindex == 4 then --材料库
		--equipStuff_show(1)
--		gemCompose_show()
		runeEnch_show()
	elseif nindex == 5 then --材料库
		guardianList_show()
	end
end

function equip_onloadcmp(a)
	equip_refUpTime()	
	deldiv("main","buildUpgrade_main")
end	

function equip_refUpTime()
	--print("buildUpgrade_refUpTime")
	--检查是否需要显示倒计时
	local arg = g_equip_arg 
	local aqueue = arg[3]
	if #aqueue > 1 then
		local dismax = aqueue[3] - aqueue[2]
		local discur = CUserData:getLeavingsTime(aqueue[3])
		local strtime= formatTime(discur)
		if dismax == 0 then dismax = 1 end
		local dispro = 377 * (1- discur / dismax)
--			print("discur:"..discur)
--			print("dismax:"..dismax)
--			print("dispro:"..dispro)
--			print("----------------")
		if discur > 0 and getid2("main","equip_prog") ~= nil then
			global_sw("main","equip_prog",dispro)		
			
			--g_camp_type = 1 --ntype 1 兵营,2城墙 ,3 医院
			global_changetext("main","equip_progtext",string.format(CData:GetTranlang("装备锻造中%s"),strtime))
			if aqueue[5] == 1 then
				global_changetext("main","equip_progtext",string.format(CData:GetTranlang("圣物合成中%s"),strtime))			
			end
			
			settimer(TIMER_ID_EQUIP,1*1000,"equip_refUpTime",1)
		else
			equip_refByQueue()
		end
	else
		--equip_refByQueue()
	end
end

function equip_btnQueueStop(a)
	print("camp_btnTrainingStop")
	local arg = g_equip_arg 
	local aqueue = {}--arg[3]
	--if aqueue == nil then--从英雄界面点击到 锻造界面 再点击 取消队列按钮  g_equip_arg就没有初始化过
		local aQueue = {}
		for i = 1 ,#CUserData.m_aQueue do
			if CUserData.m_aQueue[i][1]	== 8 then
				aQueue = copytable( CUserData.m_aQueue[i] )
				break
			end
		end
		if #aQueue > 1 then
			local discur = CUserData:getLeavingsTime(aQueue[3])
			if discur <= 0 then
				aQueue = {}
			end
		end
		aqueue = aQueue
	--end
	if #aqueue > 1 then
		if aqueue[5] == 0 then--强化
			httpsend( 1 , 0x00000104 , 0 , {CUserData.m_nUserID,9,0,8},"httpdp_teamAddSpeedBack","httpdp_svrStatusLogin"  )
		elseif aqueue[5] == 1 then--合成
			httpsend( 1 , 0x00000104 , 0 , {CUserData.m_nUserID,9,0,8},"httpdp_teamAddSpeedBack","httpdp_svrStatusLogin"  )
		end		
	end
end

function equip_btnQueueSpeed(a)
	print("camp_btnTrainingSpeed")
	--local arg = g_equip_arg 
	local aqueue = {} --arg[3]
	--if aqueue == nil then--从英雄界面点击到 锻造界面 再点击 加速按钮  g_equip_arg就没有初始化过
		local aQueue = {}
		for i = 1 ,#CUserData.m_aQueue do
			if CUserData.m_aQueue[i][1]	== 8 then
				aQueue = copytable( CUserData.m_aQueue[i] )
				break
			end
		end
		if #aQueue > 1 then
			local discur = CUserData:getLeavingsTime(aQueue[3])
			if discur <= 0 then
				aQueue = {}
			end
		end
		aqueue = aQueue
	--end
	if aqueue ~= nil then
		if #aqueue > 1 then
			if aqueue[5] == 0 then--强化
				teamAddSpeed_show(8)
			elseif aqueue[5] == 1 then--合成
				teamAddSpeed_show(8)	
			end
		end	
	else--
		showClum({"数据错误,请退出本界面再重试",1})					
	end
end

function equip_refByQueue()
	local div = getid2("main","equip_main")
	if div ~=  nil then
		equip_show(g_equip_building)
	end
end
