--装备材料库
local div_equipStuff_str = [[
	{
	local aStuff = arg[1]
	local ntype  = arg[2]
	local strBtn = arg[3]
	local nbuilding = arg[4]
	}
	<mx:Canvas id="equipStuff_main" width="720" height="1280">
		<mx:Canvas width="720" height="112">
			<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
			{local str = string.format("%s LV.%d",CData:GetTranlang("铁匠铺"),nbuilding)
			if g_main_apptype == 1 then 
				str = string.format("%s 레벨 %d",CData:GetTranlang("铁匠铺"),nbuilding)
			end
			}
			<mx:Label id="frameTop_txt" text="材料库" width="720" textAlign="center" y="35"/>
			<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" onclick="equipStuff_btnCloseClick"/>
		</mx:Canvas>
		<mx:Image source="assets/images/bg01.jpg" width="720" height="990" y="111"/>
		<mx:Image source="assets/images/bar04.png" y="111"/>
		{local x = 12 - 232
		for i =1 ,#strBtn do
			x = x + 232 
			local senbaled = "true"
			if i == ntype then senbaled = "false" end
			}
			<mx:Button styleName="navi02" label="${strBtn[i]}" x="${x}" y="118" enabled="${senbaled}" setts="${i}" onclick="equipStuff_btnTopClick"/>
		{end}
		
		<mx:Canvas height="835" y="256" setslidetype="1">
			<mx:Tile horizontalGap="35" verticalGap="50" verticalScrollPolicy="off" width="601" x="60" mouseThrough="true">
				{for i = 1 ,#aStuff do
					local ainfo = aStuff[i][1]
					local aconf = aStuff[i][2]}
					<mx:Canvas width="124" height="127" setts="${i}" sound="defalut" onclick="equipStuff_btnItemClick" mouseThrough="true" mouseChildren="false">
						<mx:Image source="assets/images/headerBg03.png"/>
						<mx:Image source="assets/item/${aconf["F1"]}.png" x="9" y="9"/>
						<!-- 以下仓库里时显示 -->
						<mx:Image source="assets/images/numBg01.png" x="77" y="83"/>
						<mx:Label text="${ainfo[2]}" fontSize="20" styleName="white01" textAlign="center" x="79" y="87" width="39"/>
						<!-- 以上仓库里时显示 -->
					</mx:Canvas>
				{end}
			</mx:Tile>
		</mx:Canvas>
		{if #aStuff <= 0 then}
			
			<mx:Label text="没有任何东西" fontSize="30" styleName="brown01" horizontalCenter="0" y="500"/>
		{end}
		
	</mx:Canvas>
]]
local g_equipStuff_btnStr = {"材料","宝石","圣物材料"}
local g_equipStuff_type = 1
local g_equipStuff_arg  = {}
function equipStuff_show(ntype)--ntype:1 材料,2 宝石,3 圣物材料
	g_equipStuff_type = ntype
	local aStuff = {} -- 道具信息,道具配置
	local aItem  = copytable(CUserData.m_aItem)
	local aConfAll = CUserData:getItemConfigAll()
	for i = 1 ,#aItem do
		local aconf = nil --CUserData:getItemConfigByid(aItem[i][1])
		for aa = 1 ,#aConfAll do
			if tonumber(aConfAll[aa]["F0"]) == aItem[i][1] then
				aconf = aConfAll[aa]
				break
			end
		end
		if aconf ~= nil then
			if ntype == 1 then 		--1 材料		(??
				if tonumber(aconf["F4"]) == 7 then
					table.insert(aStuff,{aItem[i],aconf})	
				end	
			elseif ntype == 2 then	--2 宝石	   	(9
				if tonumber(aconf["F4"]) == 9 then
					table.insert(aStuff,{aItem[i],aconf})	
				end		
			else					--3 圣物材料  	(10
				if tonumber(aconf["F4"]) == 10 then
					table.insert(aStuff,{aItem[i],aconf})	
				end	
			end
		else
			print("err equipStuff_show aconf ~= nil id:"..aItem[i][1])
		end
	end
	
	local nbuilding = CUserData:getBuildBypos(equip_getBuildingpos(),3)
	local arg = {aStuff ,ntype ,g_equipStuff_btnStr,nbuilding}
	g_equipStuff_arg = arg
	flextodiv(div_equipStuff_str,arg ,"frame_more",nil,nil,{3})
end

function equipStuff_btnTopClick(a)
	local nindex = tonumber(a.pBase:getts() )
	print("equipStuff_btnTopClick nindex:"..nindex)
	equipStuff_show(nindex)
end

function equipStuff_btnItemClick(a)
	local nindex = tonumber(a.pBase:getts() )
	print("equipStuff_btnItemClick nindex:"..nindex)
	--if g_equipStuff_type ~= 2 then return end
	local arg = g_equipStuff_arg
	local aStuff = arg[1]
	local ntype  = arg[2]
	local i = nindex
	if aStuff[i] ~= nil then
		local ainfo = aStuff[i][1]
		local aconf = aStuff[i][2]
		local aGemCompose = CUserData:getGemComposeConfigByItem(ainfo[1])
		if aGemCompose ~= nil then--宝石
			equipStuffPop_show(ainfo[1])
		else--材料/圣物材料
			equipStuffPop_show(ainfo[1])
		end
	end
end



local div_equipStuffPop_str = [[
	{
	local ainfo = arg[1]
	local aconf = arg[2]
	local aGemCompose = arg[3]
	print("aGemCompose:"..tabletostring(aGemCompose) )
	}
	<mx:Canvas id="equipStuffPop_main" width="720" height="1280" backgroundColor="0x000000" backgroundAlpha="0.6" mouseEnabled="false" systemload="1">
		<mx:Canvas  width="720" height="411" horizontalCenter="0" verticalCenter="0">
			<mx:Image source="assets/images/popBg03.png" width="720" height="411"/>
			<mx:Button styleName="btn02Close" id="closeBtn" x="619" y="4" setts="0" onclick="equipStuffPop_btnClick"/>
			
			<mx:Label text="${aconf["F2"]}" styleName="brown01" x="165" y="29" width="340" textAlign="center" Stroke="0"/>
			
			<mx:Image source="assets/images/line02.png" x="86" y="71"/>
			{
			print("#aGemCompose:"..#aGemCompose)
			if aGemCompose["F0"] == nil then}
				<mx:Label text="${aconf["F3"]}"  id="contentTxt" fontSize="24" styleName="brown01" x="200" y="156" width="500" textAlign="left"/>
			{else}
				<mx:VBox x="180" y="156">
					{
					local aGem = CUserData:getGemConfigByItem(tonumber(aconf["F0"]) )
					if aGem ~= nil then
						for i =3 ,5 ,2 do
							print("i:"..i)
							print("aGem[i]:"..aGem["F"..i])
							local nfuncid = tonumber(aGem["F"..i])
							local nfuncnum= tonumber(aGem["F"..(i+1)]) 
							if nfuncid ~= nil and nfuncid ~= 0 and nfuncnum ~= nil then
								local aconffunc = CUserData:getFuncListByid(nfuncid )
								if aconffunc ~= nil then
									if tonumber(aconffunc["F5"] ) == 10 then
										nfuncnum = nfuncnum / 10
										nfuncnum = nfuncnum .. "%"
									end}
									<mx:HBox>	
										<mx:Label text="${CData:GetTranlang(aconffunc["F3"] )}" fontSize="24" styleName="brown01" x="10" y="7"/>
										<mx:Label text="${nfuncnum}" fontSize="24" styleName="brown01" textAlign="center" y="10"/>
									</mx:HBox>	
								{end
							end
						end
					end}
				</mx:VBox>
			{end}
			<mx:Canvas width="124" height="127" x="50" y="100" setts="0" mouseThrough="true" mouseChildren="false">
				<mx:Image source="assets/images/headerBg03.png"/>
				<mx:Image source="${CUserData:getItemConfigByid(ainfo[1],1)}" x="9" y="9"/>
				<!-- 以下仓库里时显示 -->
				<mx:Image source="assets/images/numBg01.png" x="77" y="83"/>
				<mx:Label text="${ainfo[2]}" fontSize="20" styleName="white01" textAlign="center" x="79" y="87" width="39"/>
				<!-- 以上仓库里时显示 -->
			</mx:Canvas>
			{if aGemCompose["F0"] == nil then}
				<mx:HBox horizontalCenter="0" horizontalGap="90" y="290">
					<mx:Button styleName="btn03" enabled="true" label="确认" id="yesBtn" setts="0" id="equipStuffPop_btn_1" onclick="equipStuffPop_btnClick"/>				
				</mx:HBox>
			{else}
				{local str = string.format(CData:GetTranlang("合成需要数量：%d/%d"),ainfo[2],tonumber(aGemCompose["F8"]))}
				<mx:Label text="${str}" styleName="brown01" x="200" y="240" width="340" textAlign="center" fontSize="24"/>
				{local strEnabled = "true"
				if ainfo[2] < tonumber(aGemCompose["F8"]) then 
					strEnabled = "false"
				end}	
				<mx:HBox horizontalCenter="0" horizontalGap="90" y="290">
					<mx:Button styleName="btn03" enabled="${strEnabled}" label="合成" id="yesBtn" setts="${ainfo[1]}" id="equipStuffPop_btn_1" onclick="equipStuffPop_btnClick"/>				
				</mx:HBox>
			{end}
		</mx:Canvas>
	</mx:Canvas>]]
	--tabArg: { {道具id,道具数量} , 道具配置 }
local g_equipStuffPop_arg = {}
function equipStuffPop_show( nItemId )--nItemId 宝石id
	print("equipStuffPop_show")
	
	local ncount= CUserData:getItemByid(nItemId,2)
	local aconf = CUserData:getItemConfigByid(nItemId )
	if aconf ~= nil then	
		local aGemCompose = CUserData:getGemComposeConfigByItem(nItemId )
		local arg = {}
		if aGemCompose ~= nil then --宝石
			arg = {{nItemId,ncount},aconf}
			table.insert(arg,aGemCompose)
		else                       --材料 ，圣物材料
			arg = {{nItemId,ncount},aconf}
			table.insert(arg,{})
		end
		g_equipStuffPop_arg = arg
		flextodiv(div_equipStuffPop_str,arg ,"frame_more")
	end
end

function equipStuffPop_btnClick(a)
	local nindex = tonumber(a.pBase:getts() )
	print("equipStuffPop_btnClick nindex:"..nindex)	
	if nindex ~= 0 then
		local arg = g_equipStuffPop_arg
		local ainfo = arg[1]
		local aconf = arg[2]
		local aGemCompose = CUserData:getGemComposeConfigByItem(ainfo[1])
		if aGemCompose ~= nil and aGemCompose["F0"] ~= nil then
			httpsend( 1 , 0x011e , 0 , {CUserData.m_nUserID,tonumber(aGemCompose["F0"]) },"equipStuffPop_revMsg","httpdp_svrStatus"  )--道具购买	
			btnloading_show( a.pBase:getid() )
		end
	end
	deldiv("main","equipStuffPop_main")
end

function equipStuffPop_revMsg(ntype , nseqno , nret , arg )--0x0121
	http_getdata(ntype , nseqno , nret , arg)
	print("ntype: nseqno: nret: arg:",ntype,nseqno,nret,tabletostring(arg))
	btnloading_del("equipStuffPop_btn_1")
	if nret ~= 0 then 	
		return 
	end 
	table.insert(arg,1,nret)
	
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s equipStuffPop_revMsg" , ntype , nseqno , nret, tabletostring(arg) ) )
	--数据刷新
	CUserData:onGemCompose(arg)
	--界面刷新
	equipStuff_show(2)
	
	playSound(103)
end

function equipStuff_btnCloseClick(a)
	deldiv("frame_more","equipStuff_main",{3})
end
