--议院(官邸)
local div_mansion_str = [[
	{
	local buildingpos = arg[1]
	local sname = arg[2]
	local nlv = arg[3]
	local npower = arg[4]
	local nsoldier = arg[5]
	local nqueue = arg[6]
	local nbuildinglv = arg[7]
	}
	<mx:Canvas id="mansion_main" width="720" height="1280" onloadcmp="mansion_onloadcmp">
		<mx:Canvas width="720" height="112">
			<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
			{local str = string.format("%s LV.%d",CData:GetTranlang("议院"),nbuildinglv)
			if g_main_apptype == 1 then 
				str = string.format("%s 레벨 %d",CData:GetTranlang("议院"),nbuildinglv)
			end
			}
			<mx:Label id="frameTop_txt" text="${str}" width="720" textAlign="center" y="35"/>
			<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" setts="4" onclick="mansion_btnClick"/>
		</mx:Canvas>
		<mx:Image source="assets/images/bg01.jpg" width="720" height="990" y="111"/>
		<mx:Image source="assets/images/baokuTop.png" y="111"/>
		<mx:Label visible="false" text="提高等级获得更多的出兵数量和出战队列" styleName="white02" y="222" x="32" width="593" textAlign="center"/>
		<mx:Button styleName="btn01Detail" y="211" x="652" setts="3" onclick="mansion_btnClick"/>
		<mx:Button onclick="city_btnTopClick" setts="${buildingpos}|1" styleName="navi01" label="功能" sound="assets/sound/421.ogg" enabled="false" x="24" y="118"/>
		<mx:Button onclick="city_btnTopClick" setts="${buildingpos}|2" styleName="navi01" label="升级" sound="assets/sound/421.ogg" x="366" y="118"/>
		
		<mx:Image source="assets/images/block09.png" width="706" height="234" x="6" y="272"/>
		<mx:Label text="城市等级：" fontSize="26" styleName="brown01" x="50" y="312"/>
		<mx:Image source="assets/images/bg04Input.png" x="210" y="309"/>
		<mx:Label text="${nlv}" styleName="white01" fontSize="24" x="210" y="316" width="244" textAlign="center"/>
		<mx:Label text="城市名称：" fontSize="26" styleName="brown01" x="50" y="372"/>
		<mx:Image source="assets/images/bg04Input.png" x="210" y="369"/>
		<mx:Label id="cityname" text="${sname}" styleName="white01" fontSize="24" x="210" y="376" width="244" textAlign="center"/>
		<mx:Button styleName="btn06" label="修改" y="367" x="499" setts="1" onclick="mansion_btnClick"/>
		<mx:Button styleName="btn06" label="详情" y="428" x="499" setts="2" onclick="mansion_btnClick"/>
		<mx:Label text="战斗力：" fontSize="26" styleName="brown01" x="50" y="432"/>
		<mx:Image source="assets/images/bg04Input.png" x="210" y="429"/>
		<mx:Label text="${npower}" styleName="white01" fontSize="24" x="210" y="436" width="244" textAlign="center"/>
		
		
		<mx:Image source="assets/images/bar03.png" x="88" y="640"/>
		<mx:Image source="assets/images/img01Hs.png" x="298" y="550"/>
		<mx:Label text="单支部队出兵数量" fontSize="24" styleName="white01" x="210" y="667" width="297" textAlign="center"/>
		<mx:Label text="${nsoldier}" fontSize="24" styleName="green01" x="210" y="704" width="297" textAlign="center"/>
		
		<mx:Image source="assets/images/bar03.png" x="88" y="914"/>
		<mx:Image source="assets/images/img01Hs.png" x="298" y="824"/>
		<mx:Label text="出战队列上限" fontSize="24" styleName="white01" x="210" y="941" width="297" textAlign="center"/>
		<mx:Label text="${nqueue}" fontSize="24" styleName="green01" x="210" y="978" width="297" textAlign="center"/>
		
	</mx:Canvas>
]]
local g_mansion_pos = 1
function mansion_getpos()
	return g_mansion_pos
end
function mansion_show(npos )
	print("mansion_show npos:"..npos)
	--需要数据：
	--单支部队出兵数量 ?
	--出战队列上限 ?
	--城市等级 ？
	--城市名称
	--战斗力?	
	g_mansion_pos = npos
	local sname = CUserData.m_szCityName
	local nlv = 0
	for i = 1 ,#CUserData.m_aBuild do
		if CUserData.m_aBuild[i][2] == 1 then
			nlv = CUserData.m_aBuild[i][3]
			break
		end
	end	
	local npower = CUserData.m_nLordPower
	local nsoldier = 0 --单支部队出兵数量
	local nqueue = 0   --出战队列上限
	local aconf = CUserData:getbuildingUpgConfigByid( 1 * 10000 + nlv )
	if aconf ~= nil then
		nsoldier = aconf["F16"]
		nqueue   = aconf["F18"]	
	end
	local nbuildinglv = 0
	local nbuildinginfo = CUserData:getBuildBypos(npos)
	if nbuildinginfo ~= nil then
		nbuildinglv = nbuildinginfo[3]
	end
	local arg = {g_mansion_pos,sname,nlv,npower,nsoldier,nqueue,nbuildinglv}
	local notuseopeneffect = buildUpgrade_getNotUseOpeneffect()
	print("div_mansion_str,",notuseopeneffect)
	flextodiv(div_mansion_str,arg ,"frame_more",nil,nil,(notuseopeneffect and {} or {5,"mansion_onloadcmp",{g_dTouchX,g_dTouchY}}))	
end

function mansion_btnClick(a)
	g_dTouchX = a.dTouchX
	g_dTouchY = a.dTouchY
	local nindex = tonumber(a.pBase:getts())
	print("mansion_btnClick nindex:"..nindex)
	if nindex == 1 then		--修改
		--cityName_show()
		power_changeNameShow(2)
	elseif nindex == 2 then --详情
		power_show(CUserData.m_nUserID)
	elseif nindex == 3 then
		buildInfo_show(g_mansion_pos )
	elseif nindex == 4 then
		--deldiv("main","mansion_main")
		frame_CityOrMapBtnClick()
	end
end

function mansion_onloadcmp(a)
	deldiv("main","buildUpgrade_main")
end	

-- 议院升级后的界面
local div_mansionPop_str = [[
{
	local agift = arg[1]
	local nlv   = arg[2]
}
<mx:Canvas id="mansionPop_main" width="720" height="1280" backgroundColor="0x000000" backgroundAlpha="0.6" mouseThrough="false" systemload="1"  onclick="mansionPop_btnCloseClick" onloadcmp="mansionPop_onloadcmp">
	<mx:Canvas width="676" height="955" horizontalCenter="0" verticalCenter="0"  mouseThrough="false">
		<mx:Image source="assets/images/buildPop.png" width="676" height="955"/>
		<mx:Label text="城市升级" fontSize="34" styleName="red01" x="207" y="48" fontFamily="Arial" width="278" textAlign="center"/>
		{local str = string.format("Level %d",nlv) 
		if g_main_apptype == 1 then 
			str = string.format("레벨 %d",nlv) 
		end
		}
		<mx:Label text="${str}" fontSize="25" styleName="green02" x="269" y="269" fontFamily="Arial" width="144" textAlign="center"/>
		<mx:Canvas y="341" height="463" setslidetype="1">
			<mx:VBox verticalGap="0" x="42" verticalScrollPolicy="off">
				{for i = 1 ,#agift do
					local v = agift[i]
					local strname 	= v[1]--名称
					local strdetail = v[2]--说明
					local ncur      = v[3]--掉落数量
					local strpic    = v[4]--图标路径	 }
				<mx:Canvas mouseThrough="true">
					<mx:Image source="assets/images/line01.png" y="153" width="600" mouseThrough="true"/>
					<mx:Canvas y="12" width="124" height="127" mouseThrough="true" mouseChildren="false">
						<mx:Image source="assets/images/headerBg03.png"/>
						<mx:Image source="${strpic}" x="9" y="9"/>
						<!-- 以下仓库里时显示 -->
						<mx:Image source="assets/images/numBg01.png" x="77" y="83"/>
						<mx:Label text="${ncur}" fontSize="20" styleName="white01" textAlign="center" x="79" y="92" width="39"/>
						<!-- 以上仓库里时显示 -->
					</mx:Canvas>				
					<mx:Label text="${strname}" fontSize="20" styleName="black03" x="140" y="23" mouseThrough="true"/>
					<mx:Text text="${strdetail}" fontSize="20" styleName="brown02" x="140" y="53" width="246" mouseThrough="true"/>
					<mx:Button styleName="btn03" label="查看" x="403" y="37" onclick="mansionPop_btnClick"/>
				</mx:Canvas>
				{end}
			</mx:VBox>
		</mx:Canvas>
		{if g_main_apptype == 0 then }
			<mx:HBox x="0" y="844" width="720" mouseThrough="true">	
				<mx:Button styleName="btn05" x="100" "label="确认1" onclick="mansionPop_btnCloseClick"/>
				<mx:Button styleName="btn05" right="140" "label="分享" onclick="mansionPop_btnShareClick"/>
			</mx:HBox>	
		{else}
			<mx:HBox horizontalCenter="0" y="844" mouseThrough="true">	
				<mx:Button styleName="btn05" label="确认1" onclick="mansionPop_btnCloseClick"/>
			</mx:HBox>			
		{end}
	</mx:Canvas>	
</mx:Canvas>
]]
function mansionPop_show(arg )--0x10000004
--	local divguide = getid2("main","guideNew_main")
--	if divguide ~= nil then
--		print("buildUpgradePop_show divguide ~= nil")		
--		return
--	end
	--判断  掉落通知  网络返回信息 是否合理并整理数据
	if arg[2] == 7 then--建筑升级
		local nlv = arg[3] % 10000
		local nid = arg[3] / 10000
		nid = nid - nid % 1
		if nid == 1 then--议院
			local adata = arg[4]
			--[[
			类型
			编号
			掉落数量
			最终数量		--相应物品当前数量	
			]]	
			local agift = {}
			for i = 1 ,#adata do
				local v = adata[i]
				local strname 	= ""--名称
				local strdetail = ""--说明
				local ncur      = 0--掉落数量
				local strpic    = ""--图标路径	
				if v[1] == 1 then		--1道具
					local aconf = CUserData:getItemConfigByid(v[2])
					if aconf ~= nil then
						strname   = aconf["F2"]--名称
						strdetail = aconf["F3"]--说明
						ncur      = v[3]--掉落数量
						strpic    = "assets/item/"..aconf["F1"]..".png"--图标路径	
					end
				elseif v[1] == 2 then	--2石
					strname   = CData:GetTranlang("石")--名称
					strdetail = ""--说明
					ncur      = v[3]--掉落数量
					strpic    = "assets/images/ico3_stone.png"--图标路径	
				elseif v[1] == 3 then 	--3木	
					strname   = CData:GetTranlang("木")--名称
					strdetail = ""--说明
					ncur      = v[3]--掉落数量
					strpic    = "assets/images/ico3_wood.png"--图标路径	
				elseif v[1] == 4 then	--4铁 
					strname   = CData:GetTranlang("铁")--名称
					strdetail = ""--说明
					ncur      = v[3]--掉落数量
					strpic    = "assets/images/ico3_iron.png"--图标路径	
				elseif v[1] == 5 then 	--5粮
					strname   = CData:GetTranlang("粮")--名称
					strdetail = ""--说明
					ncur      = v[3]--掉落数量
					strpic    = "assets/images/ico3_food.png"--图标路径	
				elseif v[1] == 6 then 	--6银币
					strname   = CData:GetTranlang("银币")--名称
					strdetail = ""--说明
					ncur      = v[3]--掉落数量
					strpic    = "assets/images/ico3_silver.png"--图标路径	
				elseif v[1] == 7 then 	--7金币
					strname   = CData:GetTranlang("金币")--名称
					strdetail = ""--说明
					ncur      = v[3]--掉落数量
					strpic    = "assets/images/ico3_gold.png"--图标路径	
				elseif v[1] == 8 then	--8士兵
					local aconf = CUserData:getSoldierConfigByid(v[2])
					if aconf ~= nil then
						strname   = aconf["F3"]--名称
						strdetail = ""--说明
						ncur      = v[3]--掉落数量
						strpic    = "assets/soldier/"..aconf["F1"]..".png"--图标路径	
					end
				elseif v[1] == 9 then	--9英雄经验
					strname   = CData:GetTranlang("英雄经验")--名称
					strdetail = ""--说明
					ncur      = v[3]--掉落数量
					strpic    = "assets/images/ico3_heroexp.png"--图标路径	
				elseif v[1] == 10 then	--10联盟贡献
					strname   = CData:GetTranlang("联盟点数")--名称
					strdetail = ""--说明
					ncur      = v[3]--掉落数量
					strpic    = "assets/images/ico3_allyPoint.png"--图标路径	
				elseif v[1] == 11 then	--11VIP点数
					strname   = CData:GetTranlang("VIP点数")--名称
					strdetail = ""--说明
					ncur      = v[3]--掉落数量
					strpic    = "assets/images/ico3_vip.png"--图标路径	
				end
				if strname ~= "" then
					table.insert(agift,{strname,strdetail,ncur,strpic}	)
				else
					print("err mansionPop_show "..i )
				end
			end
			local arg = {agift,nlv}	
			print("mansionPop_show arg:"..tabletostring(arg) )
			
			local nenabled = 1
			local divguide = getid2("main","guideNew_main")
			if divguide ~= nil then
				print("buildUpgradePop_show divguide ~= nil")		
				nenabled = 0
				local nstep = tonumber(guideNew_getArg()[1])--当前新手的步骤 
				if guideNew_getMode() == 1 and  (nstep == 25 or nstep == 64 ) then
					nenabled = 1
					ncheck = 1
				end
			end
			if nlv == 3 then 
				nenabled = 0
			end
			if nenabled == 1 then
				flextodiv(div_mansionPop_str,arg ,"frame_more")	
			end
			local nMansionLv   = CUserData:getBuildMaxLvByid(1)
			local str = string.format("3|%d",nlv)
			conenttosocial(9 , str )--9 统计信息 conent:[登陆游戏: "1|0"],[充值成功: "2|充值额度(美金)"],[主城升级:"3|主城当前等级"]
			
			if nlv == 7 then--议院升级到7,跳出评分界面
				if CUserData.m_nIsEmailBinded == 0 then--email绑定奖励是否发放
				--	pingjiaShow()
				end
			end
			if nlv == 10 then--议院升级到10,邀请码变得有效，重新请求信息
				httpsend( 1 , 0x003a , 0 , {CUserData.m_nUserID},"httpdp_revMsgLogin","httpdp_svrStatusLogin"  )--6.1.58.	查询邀请信息
			end
		end
		
	end
	
end

function mansionPop_btnCloseClick(a)
	print("mansionPop_btnCloseClick")
	deldiv("frame_more","mansionPop_main")
end

function mansionPop_btnClick(a)
	print("mansionPop_btnClick")
	deldiv("frame_more","mansionPop_main")
	itemShop_show(1)	
end

function mansionPop_onloadcmp(a)
	guideNew_showHotRect({1,{25,62}})
end

function mansionPop_btnShareClick()
	print("conenttosocial 1")
	local str = inviteCode_getShareString()
	
	--conenttosocial(1 , str )--1.分享,2 邀请 	
	conenttosocial(22 , str )--22 facebook 截屏并上传照片	
end