--跨服入口
div_crossList_str = [[
<mx:Canvas id="crossListdiv" width="720" height="1280" mouseThrough="false" systemload="1">
	<mx:Canvas width="662" height="920" horizontalCenter="0" verticalCenter="0">
		<mx:Image source="assets/images/bg01Kfpm.png" width="662" height="920"/>
		<mx:Button styleName="btn02Close" id="closebtn" x="560" y="15" onclick="crossList_close"/>
		
		<mx:Label text="积分榜" fontSize="30" styleName="white01" x="149" y="66" width="364" textAlign="center"/>
		<mx:Button styleName="nv01" label="个人" width="179" x="62" y="134" enabled="${(arg[1] == 1 and 'false' or 'true')}" setts="1" onclick="crossList_click"/>
		<mx:Button styleName="nv01" label="联盟" width="179" x="241" y="134" enabled="${(arg[1] == 2 and 'false' or 'true')}" setts="2" onclick="crossList_click"/>
		<mx:Button styleName="nv01" label="服务器" width="179" x="420" y="134" enabled="${(arg[1] == 3 and 'false' or 'true')}" setts="3" onclick="crossList_click"/>
		
		<mx:Canvas width="720" height="640" y="233"  setslidetype="1" onslideborder="crossList_slideborder">
			<mx:VBox verticalGap="5" x="80" {if #arg[2] < 10 then} y="0" {end}>
				{for i,v in pairs(arg[2]) do}
				{local str = ""
				if arg[1] == 1 then
					str = CUserData:getUserNameString(v[4],v[5],v[3],true)
				elseif arg[1] == 2 then
					local nserverid = CUserData:getUserServerIDByUid(v[3]) 
					if nserverid > 10000 then 
						nserverid = nserverid - 10000
						str = "(mS"..nserverid..")".."["..v[4].."]"..v[5]
					else 
						str = "(S"..nserverid..")".."["..v[4].."]"..v[5]
					end
				elseif arg[1] == 3 then
					local nserverid = v[3]
					if nserverid > 10000 then 
						nserverid = nserverid - 10000
						str = "mS"..nserverid..""
					else 
						str = "S"..nserverid..""
					end					
				end
				}
				<mx:Canvas fontSize="24"  mouseThrough="true">
					<mx:Image source="assets/images/line09.png" y="40"  mouseThrough="true"/>
					<mx:Label text="${v[1]}" x="10" y="5" styleName="white01" fontSize="20"  mouseThrough="true"/>
					<mx:Label text="${str}" x="105" y="5" styleName="white01" fontSize="20"   mouseThrough="true"/>
					<mx:Label text="${v[2]}" right="0" y="5" styleName="white01" fontSize="20"   mouseThrough="true"/>
				</mx:Canvas>
				{end}
			</mx:VBox>
		</mx:Canvas>
	</mx:Canvas>
</mx:Canvas>]]

local crossList_type = 1
local crossList_list = {}
local crossList_myRank = 0
local crossList_curRank = 0
local crossList_isLastPage = {0,0,0}

function crossList_show(type)
	if type == nil and crossList_type == nil then
		type = 1
	elseif type == nil then
		type = crossList_type
	end
	crossList_type = type
	crossList_list = {}
	crossList_curRank = 0
	crossList_isLastPage[crossList_type] = 0
	flextodiv(div_crossList_str,{crossList_type,crossList_list},"frame_more")
	
	crossList_getlist(crossList_curRank)
end


function crossList_click(a)
	local t = tonumber(a.pBase:getts())
	if t == 1 then
		crossList_show(t)
	elseif t == 2 then
		crossList_show(t)
	elseif t == 3 then
		crossList_show(t)
	end
end

function crossList_getlist(rank)
	btnloading_show()
	if crossList_type == 1 then
		httpsend( 1 , 0x00000040 , crossList_type , {CUserData.m_nUserID,rank},"crossList_getlistBack","httpdp_svrStatusLogin"  )
	elseif crossList_type == 2 then
		httpsend( 1 , 0x00000041 , crossList_type , {CUserData.m_nUserID,rank},"crossList_getlistBack","httpdp_svrStatusLogin"  )
	elseif crossList_type == 3 then
		httpsend( 1 , 0x00000042 , crossList_type , {CUserData.m_nUserID,rank},"crossList_getlistBack","httpdp_svrStatusLogin"  )
	end
end

function crossList_getlistBack(ntype , nseqno , nret , arg)
	btnloading_del()
	print(string.format("httpdp_revMsgLogin ntype:%x ：nseqno:%d nret:%d",ntype , nseqno , nret) )
	if nret ~= 0 then --表示处理消息失败
		return
	end
	if crossList_type ~= nseqno then
		return
	end
	table.insert(arg,1,nret)
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s httpdp_revMsgLogin" , ntype , nseqno , nret, tabletostring(arg) ) )
	
	crossList_isLastPage[crossList_type]=arg[2]
	crossList_myRank=arg[3]
	local t=arg[4]
	if #t>0 then
		for i = 1 , #t do
			if t[i][1]>crossList_curRank then
				table.insert(crossList_list,t[i])
			end
		end
		crossList_curRank=t[#t][1]
	end
	flextodiv(div_crossList_str,{crossList_type,crossList_list},"frame_more")
end

function crossList_slideborder(a)
	if a.nActionType==2 then
		crossList_getlist(crossList_curRank)
	end
end

function crossList_close()
	deldiv("frame_more","crossListdiv")
end

