
function CData:UpdateTicket(aa)
	self.m_ticket = aa[1]
	self.m_ticketouttime = aa[2]
	CData_UpdateTicketLater()
end
function CData:getuid()
	return self.m_nUidIn
end

function CData:MacAddress()
	return self.m_pszMacIn
end

function CData:ticket()
	return self.m_ticket
end

function CData:ticketouttime()
	return self.m_ticketouttime
end
function CData:initserver(nseqno , szip , nport )
	self.m_szipport[nseqno] = {szip , nport }
end

function CData:getserver( nseqno )
	if self.m_szipport[nseqno] == nil then return "" end
	if self.m_szipport[nseqno][1] == nil then return "" end
	return self.m_szipport[nseqno][1]
end

function CData:getserverport(nseqno)
	if self.m_szipport[nseqno] == nil then return 0 end
	if self.m_szipport[nseqno][2] == nil then return 0 end
	return self.m_szipport[nseqno][2]
end

function CData:LoginSucc( ticket , tickettime , servertime , serverzreotime,timezone , logindays , getgift,threegetgift )
	self.m_ticket = ticket
	self.m_ticketouttime=tickettime
	self.m_ticketServerTime=servertime
	self.m_serverzreotime = serverzreotime
	self.m_timezone = timezone
	CUserData.m_aCumulateLoginDays = logindays--当前登陆天数
	CUserData.m_aHasGetLoginGift = getgift --是否已领取登陆礼包
	CUserData.m_aHasGetThreeLoginGift = 	threegetgift
	self.m_comeinCurTime = os.time()
end

--**-----------------------------------------------------------------
function CUserData:onUserLogin(arg)
	self.m_nUserID = arg[2]
	CUserData:setTimeDifSrvClt(arg[4] - os.time() )


	self.m_nTimeZone=arg[3]--服务器时区
	self.m_ntCurTime=arg[4]--服务器时间
	self.m_tTodayZero=arg[5]--今日零时时间
	self.m_nIsMergeServer=arg[6]--是否合服服务器
	self.m_nMergeServerId=arg[7]--合服服务器编号
	
	newDay_setTodayZero(self.m_tTodayZero,1)
end

function CUserData:getServerIdForSocial()
	local nret = 0
	if self.m_nIsMergeServer == 1 then 
		nret = self.m_nMergeServerId
	else 
		nret = CData.m_severid
	end
	print("CUserData:getServerIdForSocial IsMergeServer:"..self.m_nIsMergeServer..",MergeServerId:"..self.m_nMergeServerId..",CData.m_severid:"..CData.m_severid )
	print("CUserData:getServerIdForSocial nret:"..nret)
	return nret
end

function CUserData:updateGold(arg) --更新金币，以后统一用这个，更新界面用
	--print("CUserData:updateGold arg:"..arg)
	if self.m_nGold ~= arg then
		--print("CUserData:updateGold a")
		self.m_nGold = arg
		city_TopRef()
		vipUpdateGold()
	end
end

function CUserData:initUserInfo(arg)
	self.m_szLoginName = arg[3]--主公名称
	self.m_nUserPic=arg[4]--主公头像
	self.m_nBornTime=arg[5]--激活时间
	self.m_nStatus=arg[6]--玩家状态
	self.m_nGold=arg[7]--金币余额
	self.m_nVIPPoint=arg[8]--VIP点数
	self.m_nLordPower=arg[9]--主公战力
	self.m_nTotalKill=CUserData_tranTotalKill(arg[10])--主公击杀
	self.m_nAllyID=arg[11]--所属联盟
	self.m_szAllyName=arg[12]--联盟名称
	self.m_nAllyOfficial=arg[13]--联盟官职
	self.m_nAllyPoint=arg[14]--联盟贡献
	self.m_nAllyShortName =arg[15]--联盟简称
	self.m_nAllyIocn=arg[16]--联盟图标
	self.m_nVIPLevel=arg[17]--VIP等级
	CUserData.m_nVIPConfig = CUserData:getVipListByLevel(self.m_nVIPLevel)
	self.m_aOnlineGiftTime=arg[18]--在线礼包时间
	self.m_aOnlineGiftId=arg[19]--在线礼包编号
	self.m_aRechargeBoxPoint=arg[20]--商城宝箱点数
	SocialData.m_aNotReadReportCount=arg[21]--未读报告数量
	CUserData.nGameAge = arg[22]--连续登录天数,游戏天数
	CUserData.nAttendancedDay = arg[23]--奖励是否领取,上次签到
	CUserData.nHasTopuped = arg[24]--是否充值

	self.m_nIsEmailBinded=arg[25]--email绑定奖励是否发放
	self.m_nIsFacebookBinded=arg[26]--facebook绑定奖励是否发放
	self.m_aBattleCount = arg[28] - arg[27]
	self.m_nIsFBLiked   = arg[29]--Facebook Like奖励是否发放
	self.m_nUnionTitle = arg[30]--联盟称号
	self.m_aPrisoner = arg[31]--俘虏数
	CUserData.m_nUserTitle = arg[32]--玩家称号
	CUserData.m_aHeroEquipType = arg[33]--英雄当前套装编号
	CUserData.m_nstarchart = arg[34]
	dailyReward_set(arg[35],arg[36],arg[37],arg[38])
end

function CUserData:initCityInfo(arg)
	--self.m_nCityID=arg[2]--城池编号
	self.m_szCityName=arg[2]--城池名称
	CUserData:setMapID(arg[3])--地图坐标	
	self.m_nAvatar=arg[4]--城池外观	
	CUserData:updateResource(arg[5],arg[6],arg[7],arg[8],arg[9])--石料 木材  铁矿 食物 银币
	self.m_aBuild=arg[10]--建筑  {建筑位置,建筑类型,建筑等级,建筑状态}
end

function CUserData:initHeroInfo(arg)
	self.m_szHeroName=arg[2]--英雄名称
	self.m_nHeroGID=arg[3]--配置编号
	self.m_nHeroGrade=arg[4]--英雄等级
	self.m_nHeroExp=arg[5]--英雄经验
	self.m_nHeroPower=arg[6]--英雄战力
	self.m_nHeroStatus=arg[7]--英雄状态
	self.m_nItem1=arg[8]--装备1等级
	self.m_nStone11=arg[9]--宝石1编号
	self.m_nStone12=arg[10]--宝石2编号
	self.m_nItem2=arg[11]--装备2等级
	self.m_nStone21=arg[12]--宝石1编号
	self.m_nStone22=arg[13]--宝石2编号
	self.m_nItem3=arg[14]--装备3等级
	self.m_nStone31=arg[15]--宝石1编号
	self.m_nStone32=arg[16]--宝石2编号
	self.m_nItem4=arg[17]--装备4等级
	self.m_nStone41=arg[18]--宝石1编号
	self.m_nStone42=arg[19]--宝石2编号
	self.m_nItem5=arg[20]--装备5等级
	self.m_nStone51=arg[21]--宝石1编号
	self.m_nStone52=arg[22]--宝石2编号
	self.m_nItem6=arg[23]--装备6等级
	self.m_nStone61=arg[24]--宝石1编号
	self.m_nStone62=arg[25]--宝石2编号
	
	self.m_nItem7=arg[26]--装备6等级
	self.m_nStone71=arg[27]--宝石1编号
	self.m_nStone72=arg[28]--宝石2编号
	self.m_nItem8=arg[29]--装备6等级
	self.m_nStone81=arg[30]--宝石1编号
	self.m_nStone82=arg[31]--宝石2编号
	
	
	self.m_nItem99=arg[32]--圣物编号
	
	self.m_aSkill=arg[33]--英雄技能{技能编号,技能等级}

	local list=CUserData:getHeroConfigByid(self.m_nHeroGID)
	self.m_nHeroImageID=list.F2
	if self.m_szHeroName=="" then
		self.m_szHeroName=list.F1
	end
end

function CUserData:updateStatus(nStatus) --更新玩家状态  0＝正常状态 1＝新手保护期
	self.m_nStatus=nStatus--玩家状态
	if nStatus == 0 then
		deldiv("itemBuff_main","itemBuff_main_0")
	end
end

function CUserData:getStatus() --读取玩家状态  0＝正常状态 1＝新手保护期
	return self.m_nStatus--玩家状态
end

function CUserData:initQueueInfo(arg)
	self.m_aQueue = arg[2]--个人队列{队列类型,开始时间,结束时间,参数1,参数2,参数3,参数4}
end

function CUserData:initTechInfo(arg)
	self.m_aTech = arg[2]--个人科技 {科技编号,当前等级}
end

function CUserData:initSoldierInfo(arg)
	self.m_aSoldier = arg[2]--个人兵种{兵种编号,士兵数量,伤兵数量}
end
function CUserData:setSoldierInfo(id,n1,n2)
	if n2==nil then
		n2=0
	end
	for i = 1 , #CUserData.m_aSoldier do
		if CUserData.m_aSoldier[i][1] == id then
			CUserData.m_aSoldier[i][2]=CUserData.m_aSoldier[i][2]+n1
			if n2>0 then
				CUserData.m_aSoldier[i][3]=CUserData.m_aSoldier[i][3]+n2
			end
			return
		end
	end
	table.insert(CUserData.m_aSoldier,{id,n1,n2})
end

--返回城防总量
function CUserData:getTrapTotalNum()
	local nnum = 0
	for i = 1 ,#self.m_aTrap do
		nnum = nnum + self.m_aTrap[i][2]
	end
	return nnum
end

--返回伤兵总量
function CUserData:getWoundedSoldierNum()
	local nnum = 0
	for i = 1 ,#self.m_aSoldier do
		nnum = nnum + self.m_aSoldier[i][3]
	end
	return nnum
end

function CUserData:initTrapInfo(arg)
	self.m_aTrap=arg[2]--个人城防{城防编号,城防数量}
end

function CUserData:initMarchInfo(arg)

end

function CUserData:initEquipInfo(arg)

end

function CUserData:initItemInfo(arg)
	self.m_aItem=arg[2]--个人道具{道具编号,道具数量}
end

function CUserData:initTroopInfo(arg)
	for _,v in pairs(arg[2]) do
		v.serviceid = (v[4] > 0 and 0 or -1)
--		v[4] = math.abs(v[4])
--		v[5] = math.abs(v[5])
		
	end
	self.m_aTroop=arg[2]--个人军队信息
end

function CUserData:onTrade(arg)--物品交易
	CUserData:updateItemCount(arg[2] , arg[4])
	CUserData:updateItemCount(arg[5] , arg[6])
end

function CUserData:onBlackMarketAction(arg)--黑市操作
	if arg[2] == 0 then--查询
	else--1 交易
	end
	for i = 1, 6 do
		self.m_aBlackMarket[i] = arg[i+2]
	end

	CUserData:updateItemCount(arg[7] , arg[8])
end

function CUserData:onGetActHolidayList(arg)--6.1.57.	查询节日活动列表
	print("CUserData:onGetActHolidayList arg:"..tabletostring(arg))
	self.m_aFestival = arg[2]
end

function CUserData:onSoldierAction(arg)
	local nfind = 0
	for i = 1 , #self.m_aSoldier do--个人兵种{兵种编号,士兵数量,伤兵数量}
		if self.m_aSoldier[i][1] == arg[3] then
			self.m_aSoldier[i][2] = arg[4]
			self.m_aSoldier[i][3] = arg[5]
			nfind = 1
			break
		end
	end
	if nfind == 0 then
		table.insert(self.m_aSoldier,{arg[3],arg[4],arg[5]})
	end
	--self.m_nGold = arg[6]--金币余额
	CUserData:updateGold(arg[6])
	CUserData:updateResource(arg[7],arg[8],arg[9],arg[10],arg[11])--石料 木材  铁矿 食物 银币
	
	self.m_nLordPower=arg[12]--主公战力

	CUserData:updateQueue({arg[13],arg[14],arg[15],arg[16],arg[17],arg[18],arg[19]})

	city_TopRef()

	city_sethiddenTipIcoByType(1)
end

function CUserData:onSoldierActionForHero(arg)
	local nfind = 0
	for i = 1 , #self.m_aSoldier do--个人兵种{兵种编号,士兵数量,伤兵数量}
		if self.m_aSoldier[i][1] == arg[3] then
			self.m_aSoldier[i][2] = arg[4]
			nfind = 1
			break
		end
	end
	if nfind == 0 then
		table.insert(self.m_aSoldier,{arg[3],arg[4],0})
	end
	
	CUserData.m_aPrisoner = arg[5]
	--self.m_nGold = arg[6]--金币余额
	CUserData:updateGold(arg[6])
	CUserData:updateResource(arg[7],arg[8],arg[9],arg[10],arg[11])--石料 木材  铁矿 食物 银币
	--更改道具数量
	CUserData:updateItemCount(arg[21],arg[22])
	
	self.m_nHeroPower = arg[12]
	table.remove(arg,12)
	self.m_nLordPower=arg[12]--主公战力

	CUserData:updateQueue({arg[13],arg[14],arg[15],arg[16],arg[17],arg[18],arg[19]})

	city_TopRef()

	city_sethiddenTipIcoByType(1)
end


function CUserData:updateQueue(arg)
	local queue = {}
	local nfind = 0
	for i = 1 , #self.m_aQueue do
		if self.m_aQueue[i][1] == arg[1] then--队列类型
			queue = copytable(self.m_aQueue[i])
			if arg[2] ~= 0 then
				self.m_aQueue[i][2] = arg[2]--开始时间
				self.m_aQueue[i][3] = arg[3]--结束时间
				self.m_aQueue[i][4] = arg[4]--参数1
				self.m_aQueue[i][5] = arg[5]--参数2
				self.m_aQueue[i][6] = arg[6]--参数3
				self.m_aQueue[i][7] = arg[7]--参数4
				queue_updatedata(0,queue_formatdata(1,self.m_aQueue[i]))
			else
				table.remove(self.m_aQueue,i)
				queue_updatedata(1,{1,arg[1]})
			end
			nfind = 1
			break
		end
	end
	if nfind == 0 and arg[2] ~= 0 then
		table.insert(self.m_aQueue,arg)
		queue_updatedata(0,queue_formatdata(1,self.m_aQueue[#self.m_aQueue]))
	end

	--[[推送需求:
	CUserData:onQueueAction  考虑取消推送
	CUserData:updateQueue    考虑新增或者更新推送
	这里只考虑取消排程的情况
	1.等级10以上的建筑 建筑完成提示
	2.等级4以上的科技研发完成
	3.超过5小时军队训练完成]]
	if arg[2] ~= 0 then--新增或者更新推送
		if arg[1] == 1 then
			if arg[5] == 1 then--升级
				local nlvmin = 10
				if g_main_apptype == 1 then 
					nlvmin = 0
				end
				if arg[7] >= nlvmin then--目标等级
					local npos = arg[4]
					local ainfo = CUserData:getBuildBypos(npos)
					if ainfo ~= nil then
						local aconf = CUserData:getbuildingConfigByid(ainfo[2] )
						if aconf ~= nil then
							local strbuildname = CData:GetTranlang( aconf["F1"] )
							local type = "1"
							local content = string.format(CData:GetTranlang("你的%s已经建造完成。"),strbuildname )
							local time = arg[3] - os.time()
							conenttosocial(11 , type.."^"..content.."^"..time )	--11 本地通知  type^content^time...
						end
					end
				end
			end
		elseif arg[1] == 2 then
			local nlvmin = 4
			if g_main_apptype == 1 then 
				nlvmin = 0
			end
			--CUserData:getSkillListByid
			local nskillid =  arg[4]
			local nendlv   =  arg[7]
			if nendlv >= nlvmin then
				local aconf = CUserData:getSkillListByid(nskillid )
				if aconf ~= nil then
					local strskillname = CData:GetTranlang( aconf["F1"] )
					local type = "2"
					local content = string.format(CData:GetTranlang("你的%s已经研发完成。"),strskillname )
					local time = arg[3] - os.time()
					conenttosocial(11 , type.."^"..content.."^"..time )	--11 本地通知  type^content^time...
				end
			end
		elseif arg[1] == 3 then
			local ntimemin = 3600 * 5
			if g_main_apptype == 1 then 
				ntimemin = 5
			end
			local ntime =  arg[3] - arg[2]
			if ntime >= ntimemin then
				local type = "3"
				local content = CData:GetTranlang("你的军队已经训练完毕，请检阅。")
				local time = arg[3] - os.time()
				conenttosocial(11 , type.."^"..content.."^"..time )	--11 本地通知  type^content^time...
			end
		end
	end
	return queue
end

function CUserData:onBuildingAction(arg)
	local nfind = 0
	for i = 1 , #self.m_aBuild do--建筑
		if self.m_aBuild[i][1] == arg[3] then
			if arg[2] == 92 then
				table.remove(self.m_aBuild, i)
			else
				local noldlv = self.m_aBuild[i][3]
				self.m_aBuild[i][2] = arg[4]
				self.m_aBuild[i][3] = arg[5]
				self.m_aBuild[i][4] = arg[6]
				
				if self.m_aBuild[i][1] == 101 then 
					if noldlv ~= self.m_aBuild[i][3] then 
						account_saveGameInfoForKor()
					end
				end
			end
			nfind = 1
			break
		end
	end
	if nfind == 0 then
		table.insert(self.m_aBuild,{arg[3],arg[4],arg[5],arg[6]})
		--如果是特产类建筑新建,则添加特产信息
		if arg[4] == 31 or arg[4] == 32 or arg[4] == 33  or arg[4] == 34  then
			local npos = arg[3]
			local nbuildid = arg[4]
			--local ncur param3= 0
			local ncur = 0
			local param3= 0
			local nmax = 0
			local nlv = arg[5]
			if nlv == 0 then nlv = 1 end
			local aupconf = CUserData:getbuildingUpgConfigByid(nbuildid*10000+nlv )
			if aupconf ~= nil then
				nmax = tonumber(aupconf["F18"] )
			end

			local nfind = 0
			for k = 1 , #self.m_aSpecialty do--{建筑位置,当前可收,最大可收}(特产信息)
				if self.m_aSpecialty[k][1] == npos then
					if nlv == 0 or nlv == 1 then
						self.m_aSpecialty[k][2] = ncur
						self.m_aSpecialty[k][3] = nmax
					end
					nfind = 1
					break
				end
			end
			if nfind == 0 then
				table.insert(self.m_aSpecialty,{npos,ncur,nmax})
			end
		end
	end
	--self.m_nGold = arg[7]--金币余额
	CUserData:updateGold(arg[7])
	CUserData:updateResource(arg[8],arg[9],arg[10],arg[11],arg[12])--石料 木材  铁矿 食物 银币
	--道具
	local nfind = 0
	for i = 1, #self.m_aItem do
		if self.m_aItem[i][1] == arg[13] then
			self.m_aItem[i][2] = arg[14]
			nfind = 1
			break
		end
	end
	if nfind == 0 then
		table.insert(self.m_aItem,{arg[13],arg[14]})
	end

	if arg[13] == 2041 then
		frame_changetext("canlotterybox")
	end
	if arg[13] == 1022 then
		frame_changetext("canlottery2box")
	end

	self.m_nHeroGrade=arg[15]--英雄等级
	self.m_nHeroExp=arg[16]--英雄经验
	self.m_nHeroPower=arg[17]--英雄战力
	self.m_nLordPower=arg[18]--主公战力

	CUserData:updateQueue({arg[19],arg[20],arg[21],arg[22],arg[23],arg[24],arg[25]})

end

function refreshTaskDailyData()
	httpsend( 1 , 0x0000015b , 0 , {CUserData.m_nUserID,0,1,0},"httpdp_revMsgLogin","httpdp_svrStatusLogin"  )
	if CUserData.m_nAllyID>0 then
		httpsend( 1 , 0x0000015b , 0 , {CUserData.m_nUserID,0,2,0},"httpdp_revMsgLogin","httpdp_svrStatusLogin"  )
	end
end

function CUserData:initTaskDailyData(arg)--可刷任务操作
--1结果
--2操作类型
--3任务类型(1＝日常，2＝联盟)
--4今日过期时间
--5今日已完成
--6任务上限
--7下次刷新时间
--8金币余额
--9道具编号
--10道具数量
--11当前任务编号
--12当前任务状态
--13队列类型
--14开始时间
--15结束时间
--16参数1
--17参数2
--18参数3
--19参数4
--20可接任务1
--21可接任务2
--22可接任务3
--23可接任务4
--24可接任务5
	local n=0
	for i=20,24 do
		if arg[i]>0 then
			n=n+1
		end
	end
	if arg[11] > 0 then
		n = n + 1
	end
	local type=arg[3]
	if type==1 then
		CUserData.m_aTaskDailyCount = n
	elseif type==2 then
		CUserData.m_aTaskUnionCount = n
	end
	frame_changetext("m_aTaskDailyCount")

	local time=CUserData:getLeavingsTime(arg[7])
	settimer(TIMER_ID_FOR_TASKDAILY_REQ,(time+10)*1000,"refreshTaskDailyData",1)
end

function CUserData:onTrapAction(arg)--城防操作返回
	local nfind = 0
	for i = 1 , #self.m_aTrap do--个人兵种{兵种编号,士兵数量,伤兵数量}
		if self.m_aTrap[i][1] == arg[3] then
			self.m_aTrap[i][2] = arg[4]
			nfind = 1
			break
		end
	end
	if nfind == 0 then
		table.insert(self.m_aTrap,{arg[3],arg[4],0})
	end
	--self.m_nGold = arg[5]--金币余额
	CUserData:updateGold(arg[5])
	CUserData:updateResource(arg[6],arg[7],arg[8],arg[9],arg[10])--石料 木材  铁矿 食物 银币
	self.m_nLordPower=arg[11]--主公战力


	CUserData:updateQueue({arg[12],arg[13],arg[14],arg[15],arg[16],arg[17],arg[18]})
end

function CUserData:onHospitalAction(arg)--伤兵操作返回
	local nfind = 0
	for i = 1 , #self.m_aSoldier do--个人兵种{兵种编号,士兵数量,伤兵数量}
		if self.m_aSoldier[i][1] == arg[3] then
			self.m_aSoldier[i][2] = arg[4]
			self.m_aSoldier[i][3] = arg[5]
			nfind = 1
			break
		end
	end
	if nfind == 0 then
		table.insert(self.m_aSoldier,{arg[3],arg[4],arg[5]})
	end
	--self.m_nGold = arg[6]--金币余额
	CUserData:updateGold(arg[6])
	CUserData:updateResource(arg[7],arg[8],arg[9],arg[10],arg[11])--石料 木材  铁矿 食物 银币

	CUserData:updateQueue({arg[12],arg[13],arg[14],arg[15],arg[16],arg[17],arg[18]})

	city_TopRef()
	city_sethiddenTipIcoByType(5)
end

function CUserData:onStageAction(arg)
	print("CUserData:onStageAction arg:"..tabletostring(arg) )

end

function CUserData:OnItemExchange(arg)
	showClue(string.format(CData:GetTranlang("兑换成功,获得 %s (%d)。"),CData:GetTranlang(CUserData:getItemConfigByid(arg[3],2)),arg[4]-CUserData:getItemByid(arg[3]  ,2)),CUserData:getItemConfigByid(arg[3],1))
	if arg[3] ~= 0 then
		CUserData:updateItemCount(arg[3],arg[4] )
	end
	if arg[5] ~= 0 then
		CUserData:updateItemCount(arg[5],arg[6] )
	end
	if arg[7] ~= 0 then
		CUserData:updateItemCount(arg[7],arg[8] )
	end
	if arg[9] ~= 0 then
		CUserData:updateItemCount(arg[9],arg[10] )
	end
	if arg[11] and arg[11] ~= 0 then
		CUserData:updateItemCount(arg[11],arg[12] )
	end
	
	
end

function CUserData:onCityRename(arg)--城池改名
	CUserData.m_szCityName = arg[2]
end

function CUserData:onMallBuyItem(arg)--购买道具
	local nfind = 0
	for i = 1 , #self.m_aItem do
		if self.m_aItem[i][1] == arg[2] then
			self.m_aItem[i][2] = arg[4]
			nfind = 1
		end
	end
	if nfind == 0 then
		table.insert(self.m_aItem,{arg[2],arg[4]})
	end

	if arg[2] == 2041 then
		frame_changetext("canlotterybox")
	end
	if arg[2] == 1022 then
		frame_changetext("canlottery2box")
	end
	--self.m_nGold = arg[5]
	CUserData:updateGold(arg[5])
end

function CUserData:onEquipUpgrade(arg)--装备强化
	if arg[3] == 1 then		--装备
		self.m_nItem1 = arg[4]
	elseif arg[3] == 2 then
		self.m_nItem2 = arg[4]
	elseif arg[3] == 3 then
		self.m_nItem3 = arg[4]
	elseif arg[3] == 4 then
		self.m_nItem4 = arg[4]
	elseif arg[3] == 5 then
		self.m_nItem5 = arg[4]
	elseif arg[3] == 6 then
		self.m_nItem6 = arg[4]
	end

	--self.m_nGold = arg[5]--金币
	CUserData:updateGold(arg[5])
	self.m_nSilver = arg[6]--银币

	CUserData:updateQueue({arg[7],arg[8],arg[9],arg[10],arg[11],arg[12],arg[13]})
--	local nfind = 0              --队列
--	for i =1 ,#self.m_aQueue do
--		if self.m_aQueue[i] == arg[7] then
--			if arg[8] == 0 then
--				table.remove(self.m_aQueue[i],i )
--			else
--				self.m_aQueue[i][2] = arg[8]
--				self.m_aQueue[i][3] = arg[9]
--				self.m_aQueue[i][4] = arg[10]
--				self.m_aQueue[i][5] = arg[11]
--				self.m_aQueue[i][6] = arg[12]
--				self.m_aQueue[i][7] = arg[13]
--			end
--			nfind = 1
--			break
--		end
--	end
--	if nfind == 1 and arg[8] ~= 0 then
--		table.insert(self.m_aQueue,{arg[7],arg[8],arg[9],arg[10],arg[11],arg[12],arg[13]} )
--	end


	for j = 1 , #arg[14] do --道具
		local v = arg[14][j]
		CUserData:updateItemCount(v[1] , v[2])
	end
	city_sethiddenTipIcoByType(4)
end

function CUserData:onRelicCompose(arg)
	self.m_nSilver = arg[3] --银币

	CUserData:updateQueue({arg[4],arg[5],arg[6],arg[7],arg[8],arg[9],arg[10]})


	for j = 1 ,#arg[11] do --道具
		local v = arg[11][j]
		CUserData:updateItemCount(v[1] , v[2])
	end

	city_sethiddenTipIcoByType(4)
end

function CUserData:onGemCompose(arg)--宝石合成
	local nfind = 0
	for i =1 , #self.m_aItem do
		if self.m_aItem[i][1] == arg[3] then
			self.m_aItem[i][2] = arg[5]
			nfind = 1
		end
	end
	if nfind == 0 then
		table.insert(self.m_aItem,{arg[3],arg[5]})
	end

	if arg[3] == 2041 then
		frame_changetext("canlotterybox")
	end
	if arg[3] == 1022 then
		frame_changetext("canlottery2box")
	end
	self.m_nSilver = arg[6]
	for i = 1, #arg[7] do
		local v = arg[7][i]
		CUserData:updateItemCount(v[1] , v[2])
	end
end
function CUserData:onEquipSetGem(arg)
	local n1 = arg[3]--更新装备上的宝石
	local n2 = arg[4]
	if arg[2] == 11 then --镶嵌
		if self["m_nStone"..n1..n2] ~= nil then
			self["m_nStone"..n1..n2] = arg[5]
		end
	else--摘除
		if self["m_nStone"..n1..n2] ~= nil then
			self["m_nStone"..n1..n2] = 0
		end
	end
	--道具记录更新
	local nfind = 0
	for i =1 ,#self.m_aItem do
		if self.m_aItem[i][1] == arg[5] then
			if arg[2] == 11 then--镶嵌
				self.m_aItem[i][2] = self.m_aItem[i][2] - 1
				if self.m_aItem[i][2] < 0 then self.m_aItem[i][2]= 0 end
				if self.m_aItem[i][2] == 0 then table.remove(self.m_aItem,i) end
			else--摘除
				self.m_aItem[i][2] = self.m_aItem[i][2] + 1
			end
			nfind = 1
			break
		end
	end
	if nfind == 0 and arg[2] == 12 then
		table.insert(self.m_aItem,{arg[5],1})
	end

	if arg[5] == 2041 then
		frame_changetext("canlotterybox")
	end
	if arg[5] == 1022 then
		frame_changetext("canlottery2box")
	end
	self.m_nSilver=arg[6]--银币
	CUserData.m_nHeroPower=arg[7]--英雄战力
	CUserData.m_nLordPower=arg[8]--主公战力
end
function CUserData:onGetTradingInfo(arg)
	self.m_nTradingPos = arg[2] --当前交易地点
	self.m_nTradingGID = arg[3] --当前交易编号
	self.m_nTradingStart = arg[4] --开始时间
	self.m_nTradingEnd   = arg[5] --结束时间
	self.m_aTrading = arg[6]--{交易地点,所需时间,交易1编号,交易2编号}
end
function CUserData:onTradingAction(arg)--交易所操作
	--self.m_nGold = arg[3]
	CUserData:updateGold(arg[3])
	local aa = {{arg[4],arg[5]},{arg[6],arg[7]}}
	for k = 1 , #aa do
		local v = aa[k]
		local nfind = 0
		for i = 1 ,#self.m_aItem do --更新道具数据
			if self.m_aItem[i][1] == v[1] then
				self.m_aItem[i][2] = v[2]
				nfind = 1
			end
		end
		if nfind == 0 and v[1] ~= 0 then
			table.insert(self.m_aItem,{v[1],v[2]})
		end
		if v[1] == 2041 then
			frame_changetext("canlotterybox")
		end
		if v[1] == 1022 then
			frame_changetext("canlottery2box")
		end
	end

	self.m_nTradingPos 	= arg[8] --当前交易地点
	self.m_nTradingGID 	= arg[9] --当前交易编号
	self.m_nTradingStart= arg[10] --开始时间
	self.m_nTradingEnd  = arg[11] --结束时间
end

function CUserData:onGetSpecialtyInfo(arg)--特产信息
	self.m_aSpecialty = arg[2]
end

function CUserData:SNBaseTask(arg)--基础任务通知

end

function CUserData:SNDailyUserActivity(arg)--7.33.	个人活跃度通知
	self.m_aUserActivity = arg
	unionUserActivity_ref()
	onlinegift_refush()
end

function CUserData:SNSoldierTrap(arg)--士兵、城防变更通知
	for i = 1 , #arg[2] do
		local v = arg[2][i]
		local ntype = CUserData:getSoldierConfigByid(v[1],4) --兵种类型
		if ntype ~= nil then--判断配置表记录是否未找到  返回的可能是 nil 或者 ""
			ntype = tonumber(ntype )
			if ntype ~= nil and (ntype < 10 or ntype > 20) then--士兵
				local nfind = 0
				for k = 1 , #CUserData.m_aSoldier do
					if CUserData.m_aSoldier[k][1] == v[1] then
						CUserData.m_aSoldier[k][2] = v[2]
						CUserData.m_aSoldier[k][3] = v[3]
						nfind = 1
						break
					end
				end
				if nfind == 0 then
					table.insert(CUserData.m_aSoldier,{v[1],v[2],v[3]})
				end
			else--城防
				local nfind = 0
				for k = 1 , #CUserData.m_aTrap do
					if CUserData.m_aTrap[k][1] == v[1] then
						CUserData.m_aTrap[k][2] = v[2]
						nfind = 1
						break
					end
				end
				if nfind == 0 then
					table.insert(CUserData.m_aTrap,{v[1],v[2] })
				end
			end
		end
	end
	camp_refByQueueInfo()

	city_TopRef()
	city_sethiddenTipIcoByType(5)
end

function  CUserData:SNCityOutput(arg)--资源产量变更通知
	--CUserData.m_aResourceOut = {0,0,0,0,0}--资源产量
	--CUserData.m_aResourceMax = {0,0,0,0,0}--资源上限
	self.m_aResourceOut[1] = arg[3]
	self.m_aResourceOut[2] = arg[4]
	self.m_aResourceOut[3] = arg[5]
	self.m_aResourceOut[4] = arg[6]
	self.m_aResourceOut[5] = arg[7]

	self.m_aResourceMax[1] = arg[8]
	self.m_aResourceMax[2] = arg[9]
	self.m_aResourceMax[3] = arg[10]
	self.m_aResourceMax[4] = arg[11]
	self.m_aResourceMax[5] = arg[12]

	self.m_nFoodUpKeep  = arg[13] --粮耗

	--[[
	如果某种资源的存量大于产量上限，仍会返回该种资源的正常产量值，但实际不起作用
	如果粮食存量大于上限，则最终粮食小时产量＝0－粮耗
	如果粮食存量小于上限，则最终粮食小时产量＝产量－粮耗
	]]
end

function CUserData:SNCityResource(arg)
	CUserData:updateResource(arg[3],arg[4],arg[5],arg[6],arg[7])
end

function CUserData:SNItem(arg)
--	0＝系统回收
--	1＝战斗掠夺
--	2＝战斗被掠夺
--  3＝地图采集获得
	local type=arg[2]
	local propList=arg[3]
	for i=1,#propList do
		local propID=propList[i][1]
		local propChange=propList[i][2]
		local propNum=propList[i][3]
		CUserData:updateItemCount(propID,propNum)
--		local t=CUserData:getItemByid(propID)
--		if t==nil then
--			table.insert(CUserData.m_aItem,{propID,propNum})
--		else
--			if propNum>0 then
--				t[2]=arg[i+1]
--			else
--				for i = 1 , #CUserData.m_aItem do
--					if CUserData.m_aItem[i][1] == propID then
--						table.remove(CUserData.m_aItem,i)
--						return
--					end
--				end
--			end
--		end
		if propID == 2041 then
			frame_changetext("canlotterybox")
		end
		if propID == 1022 then
			frame_changetext("canlottery2box")
		end
	end
	festival_ref()
end

function CUserData:SNUserEvent(arg)--玩家事件通知
	local eventType=arg[2]
	local param1=arg[3]
	local param2=arg[4]
	local param3=arg[5]
	local param4=arg[6]
	local param5=arg[7]
	local param6=arg[8]
	local param7=arg[9]
	local param8=arg[10]
	if eventType==1 then
--			参数1：原因，0＝数值变更，1＝提升官职，2＝降低官职，3＝加入联盟，4＝踢出联盟，5＝联盟解散
--			参数2：联盟编号
--			参数3：联盟官职
--			参数4：联盟贡献
		if param1==0 then
			if CUserData.m_nAllyID ~= param2 then
				httpdp_MapQuery(true)
			end
		end
		CUserData.m_nAllyID=param2
		CUserData.m_nAllyOfficial=param3
		CUserData.m_nAllyPoint=param4
		CUserData.m_nUnionTitle=param5
		if param1==0 then

		elseif param1==1 then

		elseif param1==2 then

		elseif param1==3 then
			refreshUnionMainShow()
			joinUnionButtonShow()
			httpdp_MapQuery(true)
		elseif param1==4 or param1==5 then
			local unionMain_main=getid2("frame_more","unionMain_main")
			if unionMain_main~=nil then
				unionMainClose_btnClick()
			end
			joinUnionButtonShow()
			httpdp_MapQuery(true)
		end
	elseif eventType==2 then--特产
		local nfind = 0
		for i = 1 ,#self.m_aSpecialty do
			if self.m_aSpecialty[i][1] == arg[3] then
				self.m_aSpecialty[i][2] = arg[4]
				self.m_aSpecialty[i][3] = arg[5]
				self.m_aSpecialty[i][4] = arg[6]--产出类型
				nfind = 1
			end
		end
		if nfind == 0 and arg[3] ~= 0 then
			table.insert(self.m_aSpecialty,{arg[3],arg[4],arg[5],arg[6] } )
		end
		city_checkSpecialtyCapacity(arg[3])
	elseif eventType==3 then--plus通知
		local nfind = 0
		for i = 1 ,#self.m_aPlusInfo do--plus信息{效果编号 效果参数 开始时间 结束时间	}
			if self.m_aPlusInfo[i][1] == param2 then
				if param1 == 0 then--	参数1：原因，0＝新增/延长，1＝到期
					self.m_aPlusInfo[i][1] = param2
					self.m_aPlusInfo[i][2] = param3
					self.m_aPlusInfo[i][3] = param4
					self.m_aPlusInfo[i][4] = param5
				else
					table.remove(self.m_aPlusInfo,i)
				end
				nfind = 1
				break
			end
		end
		if nfind == 0 and param1 == 0 then
			table.insert(self.m_aPlusInfo, {param2,param3,param4,param5} )
		end
		itemBuff_ref()
	elseif eventType==4 then
--			参数1：获得经验
--			参数2：英雄等级
--			参数3：英雄经验
--			参数4：英雄战力
--			参数5：主公战力
--		if param2>CUserData.m_nHeroGrade then
--			heroLevelUp_show(param2)
--			CUserData.m_nHeroGrade=param2
--		end
--		CUserData.m_nHeroExp=param3
--		CUserData.m_nHeroPower=param4
--		CUserData.m_nLordPower=param5
--		city_TopRef()
	elseif eventType==5 then
		CUserData.m_nVIPPoint=param2
		CUserData.m_nVIPLevel=param3
		CUserData.m_nVIPConfig = CUserData:getVipListByLevel(CUserData.m_nVIPLevel)
		CUserData.m_nVipTodayOpened=param4
		refreshVipShow()
		refreshVIPLevel()
	elseif eventType==6 then--个人联盟帮助通知
		if param1 == 0 then--0＝变更（次数变化），1＝删除（已帮助完成）
			if param2 == 1 then
				CUserData.m_nUnionHelp[4] = param3
			elseif param2 == 2 then
				CUserData.m_nUnionHelp[9] = param3
			end
			showClue("Help加速成功")
		elseif param1 == 1 then
			if param2 == 1 then
				CUserData.m_nUnionHelp[2] = 0
				CUserData.m_nUnionHelp[3] = 0
				CUserData.m_nUnionHelp[4] = 0
				CUserData.m_nUnionHelp[5] = 0
				CUserData.m_nUnionHelp[6] = 0
--				if CUserData.m_nUnionHelp[5] == CUserData.m_nUnionHelp[4] then
--					showClue("Help加速完成")
--				end
			elseif param2 == 2 then
				CUserData.m_nUnionHelp[7] = 0
				CUserData.m_nUnionHelp[8] = 0
				CUserData.m_nUnionHelp[9] = 0
				CUserData.m_nUnionHelp[10] = 0
				CUserData.m_nUnionHelp[11] = 0
--				if CUserData.m_nUnionHelp[10] == CUserData.m_nUnionHelp[9] then
--					showClue("Help加速完成")
--				end
			end

		end
	elseif eventType==7 then--联盟礼物通知
		local exist = false
		for _,v in pairs(CUserData.m_aUnionGiftList) do
			if v[1] == param1 then
				exist = true
				break
			end
		end
		if exist == false then
			table.insert(CUserData.m_aUnionGiftList,{param1,param2,param3,0,0,0,0,0})
		end
		CUserData.m_aUnionGiftLevel = param4 --当前礼物等级
		CUserData.m_aUnionGiftPoint = param5--当前礼物点数
		CUserData.m_aUnionGiftTotalPoint = param6--礼物总点数

		unionMain_changeGiftNum()
		uniongift_refush()
	elseif eventType==8 then--充值通知
		CUserData.nHasTopuped=1
		shouchongButtonShow()
		showClue(string.format(CData:GetTranlang("充值成功,获得%d金币。"),param1),"assets/images/ico3_gold.png")
		CUserData:updateGold(param2)--金币余额
		CUserData.m_aRechargeBoxPoint = param4
		rechargepop_succeed(arg)
		playSound(102)
		conenttosocial(9 , "2|" .. param5 )
		statistics_setRecordPayEvents(param5)
	elseif eventType == 9 then--新报告通知
		mail_getNewReportCount(param1)
	elseif eventType == 10 then--充值失败通知		参数1：0＝充值失败（非法操作），1＝充值订单重复（注意！）
		if param1 == 0 then
			showClue(CData:GetTranlang("充值失败(非法操作)。"))
		else
			showClue(CData:GetTranlang("充值失败(充值订单重复)。"))
		end

	elseif eventType == 11 then--金币变更通知 	参数1：通知原因，1＝采集获得，2＝掠夺获得  3=邀请奖励 4=活动奖励  参数2：金币（当前数量）
		local str = "采集获得%d金币"
		if param1 == 2 then
			str = "掠夺获得%d金币"
		elseif param1 == 3 then
			str = "邀请奖励%d金币"
		elseif param1 == 4 then
			str = "活动奖励%d金币"
		end
		showClue(string.format(CData:GetTranlang(str),param2 - self.m_nGold),CUserData:setAwardImgByValue(7))
		CUserData:updateGold(param2)
	elseif eventType == 12 then--玩家状态变更通知  	参数1：玩家状态，0＝正常状态，1＝新手保护期
		--self.m_nStatus = param1
		CUserData:updateStatus(param1)
	elseif eventType == 13 then--联盟事务通知
		--参数1：待审批入盟申请数量
		CUserData.m_aUnionReqNum=param1
		frame_changetext("m_aUnionReqCount")
	elseif eventType == 15 then--城池坐标
		if getIsInMap() then
			
			if map_checkDataAvailability(param1) == true then--切换地图
				setMapState(0)
			end
			if param1 < 0 then
				map_init(-1,math.abs(param1),nil,true)
			else
				map_init(0,math.abs(param1),nil,true)
			end
		end
		CUserData:setMapID(param1)
	elseif eventType == 16 then--运营活动
		if param1 == 1 then--	参数1：活动编号，1=老玩家回归
			backGift_setType(param2 )
		elseif param1 == 2 then--2=亚马逊推广活动
			CUserData.m_aAmazonReward = 1
		end
	elseif eventType == 17 then--俘虏数量变更
		CUserData.m_aPrisoner = param1
		--param2 变更数量（可以为负数，例如被对方抢走）
		if param2 > 0 then
			showClue(string.format(CData:GetTranlang("获捕到%d俘虏"),param2),"assets/images/img01Cell.png")
		elseif param2 < 0 then
			showClue(string.format(CData:GetTranlang("被人掠夺%d俘虏"),math.abs(param2)),"assets/images/img01Cell.png")
		end
	elseif eventType == 18 then --装备升级活动（24）期间，装备升级队列加速操作暴击通知
		showClue("获得双倍加速效果")
	elseif eventType == 19 then --装备升级活动（24）期间，装备升级操作获得水晶返还通知
		CUserData:updateItemCount(param3,param2)
		
		local szitemname = CUserData:getItemConfigByid(param3,2)
		local str = CUserData:format({CData:GetTranlang("获得{0}个{1}返还"),param1,CData:GetTranlang(szitemname)})
		
		showClue(str)
		--showClue(string.format(CData:GetTranlang("获得%d水晶返还"),param1))
		
		equipForg_refByQueueInfo()
	elseif eventType == 20 then --玩家称号通知
		CUserData.m_nUserTitle = param1
	elseif eventType == 21 then
		dailyReward_setCur(param1)
	end
end

function CUserData:setMapID(mapID)
	CUserData.m_nMapID=mapID
	print("setMapID::",mapID)
	if mapID < 0 then
		
		setMapServiceid( -1)
	else
		
		setMapServiceid( 0)
	end
end

function getUserMapId()--负数是跨服
	return CUserData.m_nMapID
end

function CUserData:SNStageTask(arg)
	local argTemp = self.m_aSNStageTask
	self.m_aSNStageTask = arg
	target_ref()
	guideNew_setMode(arg)
	if argTemp[2] ~= arg[2] then--目标进入了一下阶段

	end
end

function CUserData:onTakeStageTaskBonus(arg)--领取阶段目标奖励

end

function CUserData:onSpecialtyGain(arg)--收取特产
	--把当前可以收取赋0
	for i = 1 , #self.m_aSpecialty do
		if self.m_aSpecialty[i][1] == arg[2] then
			self.m_aSpecialty[i][2] = 0
			break
		end
	end

	--更新道具
	local nfind = 0
	for i = 1 ,#self.m_aItem do
		if self.m_aItem[i][1] == arg[3] then
			self.m_aItem[i][2] = arg[5]
			nfind = 1
			break
		end
	end
	if nfind == 0 and arg[3] ~= 0 then
		table.insert(self.m_aItem,{arg[3],arg[5]})
	end
	if arg[3] == 2041 then
		frame_changetext("canlotterybox")
	end
	if arg[3] == 1022 then
		frame_changetext("canlottery2box")
	end
end

function CUserData:onGetMyReinforceInfo(arg)--初始化 大使馆信息
	self.m_aReinforce = arg[2]
end

function CUserData:onReinforceSendBack(arg)--遣送增援部队
	for i = 1 , #self.m_aReinforce do --删除被遣送部队
		if self.m_aReinforce[i][1] == arg[2] then
			table.remove(self.m_aReinforce,i)
			break
		end
	end
end

function CUserData:onGetWatchTowerOverview(arg)--初始化 瞭望塔概要信息
	self.m_aWatchTower = arg[2]

	city_towerIcoCheck()
end

function CUserData:onGetMyInvitationInfo(arg)--6.1.58.	查询邀请信息
	self.m_aInvitationInfo = arg
end

function CUserData:onUseInvitation(arg)--6.2.75.	使用邀请码
	if self.m_aInvitationInfo ~= nil then
		self.m_aInvitationInfo[2] = arg[2]
		self.m_aInvitationInfo[3] = arg[3]

		self.m_aInvitationInfo[4] = arg[4]
		self.m_aInvitationInfo[5] = arg[5]
		self.m_aInvitationInfo[6] = arg[6]
		self.m_aInvitationInfo[7] = arg[7]
		self.m_aInvitationInfo[8] = arg[8]
		self.m_aInvitationInfo[9] = arg[9]
	end
end

function CUserData:SNWatchTower(arg )--瞭望塔通知
	local nfind = 0
	for i = 1 ,#self.m_aWatchTower do
		if self.m_aWatchTower[i][1] == arg[3] then
			if arg[2] == 0 then--1 新增
				self.m_aWatchTower[i][2] = arg[4]
				self.m_aWatchTower[i][3] = arg[5]
				self.m_aWatchTower[i][4] = arg[6]
				self.m_aWatchTower[i][5] = arg[7]
				self.m_aWatchTower[i][6] = arg[8]
				self.m_aWatchTower[i][7] = arg[9]
				self.m_aWatchTower[i][8] = arg[10]

				playSound(109,3)
			elseif arg[2] == 1 then--2 删除
				CUserData:delWatchTowerDetailById(self.m_aWatchTower[i][1] )

				table.remove(self.m_aWatchTower,i)

			end
			nfind = 1
			break
		end
	end
	if nfind == 0 and arg[2] == 0 then
		table.insert(self.m_aWatchTower,{arg[3],arg[4],arg[5],arg[6],arg[7],arg[8],arg[9],arg[10]})
	end
	tower_refBySNWatchTower()

	city_towerIcoCheck()
end

--查询瞭望塔概要信息
function CUserData:getWatchTowerOverview(id)--
	local aret = nil
	for i = 1 ,#self.m_aWatchTower do
		if self.m_aWatchTower[i][1] == id then
			aret = copytable(self.m_aWatchTower[i] )
			break
		end
	end
	return aret
end

--根据网络数据,来保存瞭望塔详情信息
function CUserData:OnGetWatchTowerDetail(arg)
	local aDetail = {}
	for i = 2 , 15 do
		table.insert(aDetail,arg[i])
	end
	aDetail.serviceid = (aDetail[3] > 0 and 0 or -1)
--	aDetail[3] = math.abs(aDetail[3])
--	aDetail[4] = math.abs(aDetail[4])
	CUserData:setWatchTowerDetailById(aDetail)
end

--根据军队id查询瞭望塔详情信息
function CUserData:getWatchTowerDetailById(id)
	local nret = nil
	for i = 1 ,#self.m_aWatchTowerDetail do
		if self.m_aWatchTowerDetail[i][1] == id then
			nret = copytable(self.m_aWatchTowerDetail[i] )
			break
		end
	end
	return nret
end

--设置瞭望塔详情信息
function CUserData:setWatchTowerDetailById(arg)
	local nfind = 0
	for i = 1 ,#self.m_aWatchTowerDetail do
		if self.m_aWatchTowerDetail[i][1] == arg[1] then
			self.m_aWatchTowerDetail[i] = arg
			nfind = 1
			break
		end
	end
	if nfind == 0 then
		table.insert(self.m_aWatchTowerDetail,arg )
	end
end

--删除瞭望塔详情信息
function CUserData:delWatchTowerDetailById(id)
	for i = 1 ,#self.m_aWatchTowerDetail do
		if self.m_aWatchTowerDetail[i][1] == id then
			table.remove(self.m_aWatchTowerDetail,i)
			break
		end
	end
	towerArmyDetail_refByDel(id)
end

function CUserData:onGetMallLists(arg)--商城列表
	self.m_aMallLists = arg[2]
end

function CUserData:updateReinforce(arg)--更新增援信息
	local nfind = 0
	for i = 1 ,#self.m_aReinforce do
		local v = self.m_aReinforce[i]
		if v[1] == arg[1] then
			self.m_aReinforce[i] = arg
			break
		end
	end
	if nfind == 0 then
		table.insert(self.m_aReinforce,arg)
	end
end

function CUserData:delReinforce(nid)--删除增援信息
	for i = 1 ,#self.m_aReinforce do
		local v = self.m_aReinforce[i]
		if v[1] == nid then
			table.remove(self.m_aReinforce,i)
			break
		end
	end
end

function CUserData:SNReinforce(arg)--增援信息通知
	local aReinforce = {}
	for i = 3 , 40 + 9 do
		table.insert(aReinforce,arg[i])
	end
	if arg[2] == 0 then--新增、变更（某事件发生）
		CUserData:updateReinforce(aReinforce)
	else--删除（某事件结束）
		CUserData:delReinforce(arg[3] )
	end

	--界面刷新
	embassy_refBySNReinforce()
end

function CUserData:getItemPirce( itemid)--返回商城道具价格
	for _,v in pairs(self.m_aMallLists) do
		if v[1] == itemid then
			return v[2]
		end
	end
	return -1
end

function CUserData:onUseItem(arg)--道具使用
	CUserData:updateItemCount(arg[2] , arg[3])
	--self.m_nGold = arg[5]
	CUserData:updateGold(arg[5])
end

function CUserData:updateItemCount(itemid , count)--更新道具数量,count:当前数量
	local nfind = 0
	for i = 1 ,#self.m_aItem do
		if self.m_aItem[i][1] == itemid then
			self.m_aItem[i][2] = count
			if count == 0 then
				table.remove(self.m_aItem,i)
			end
			nfind = 1
			break
		end
	end
	if nfind == 0 and itemid ~= 0 then
		table.insert(self.m_aItem,{itemid,count})
	end
	if itemid == 2041 then
		frame_changetext("canlotterybox")
	end
	if itemid == 1022 then
		frame_changetext("canlottery2box")
	end
end

function CUserData:SNGetBonus(arg )--掉落通知 0x10000004
	local img = "assets/images/unknown.png"
	local str = ""

	for i = 1 ,#arg[4] do
		if i == 1 then
			img = CUserData:setAwardImgByValue(arg[4][i][1] , arg[4][i][2])--取第一个物品的图片为提示用图标
		end
		local type = arg[4][i][1]
		local id = arg[4][i][2]
		local num = arg[4][i][4]
		CUserData:setAwardValueDetail(type,id,num)
	end

	--用于更新界面等
	if arg[2] ==0 then--在线礼包
		--onlinegiftpop_getreward(arg[4])
		str = CData:GetTranlang("在线礼包：") .. CUserData:getAwardStrByTable(arg[4])
	elseif arg[2] ==1 then--打开礼包

	elseif arg[2] ==2 then--使用道具
		str = CData:GetTranlang("使用道具所得：") .. CUserData:getAwardStrByTable(arg[4])
		itemShop_refBySNGetBonus()
	elseif arg[2] ==3 then--任务奖励
		str = CData:GetTranlang("任务奖励:") .. CUserData:getAwardStrByTable(arg[4])
	elseif arg[2] ==4 then--宝箱系统掉落
		if arg[3] == 1 then--1＝VIP宝箱，2＝纪念币宝箱，3＝充值宝箱，4＝联盟礼物
			viplottery_getreward(arg[4])
		elseif arg[3] == 2 then

		elseif arg[3] == 3 then
			str = CData:GetTranlang("充值宝箱：") .. CUserData:getAwardStrByTable(arg[4])
		elseif arg[3] == 4 then
			str = CData:GetTranlang("联盟礼物：") .. CUserData:getAwardStrByTable(arg[4])
		end
	elseif arg[2] == 5 then--充值
		--recharge_getreward(arg[4])
		str = CData:GetTranlang("充值奖励：") .. CUserData:getAwardStrByTable(arg[4])
	elseif arg[2] == 6 then--绿洲采集

	elseif arg[2] == 7 then--建筑升级奖励
		mansionPop_show(arg )
	elseif arg[2] == 8 then--黑市交易所得
		str = CData:GetTranlang("黑市交易所得：") .. CUserData:getAwardStrByTable(arg[4])
		marketBlack_SNGetBonus(arg )--
	elseif arg[2] == 9 then--活动奖励

	elseif arg[2] == 10 then--签到奖励
		str = CData:GetTranlang("签到奖励：") .. CUserData:getAwardStrByTable(arg[4])
	elseif arg[2] == 11 then--首次创建或加入联盟奖励
		city_callJava_firstAddUnion()
	elseif arg[2] == 12 then--推广奖励
		if arg[3] == 1 then--绑定邮箱
			str = CData:GetTranlang("绑定邮箱所得：") .. CUserData:getAwardStrByTable(arg[4])
		elseif arg[3] == 2 then--绑定Facebook
			str = CData:GetTranlang("绑定Facebook所得：") .. CUserData:getAwardStrByTable(arg[4])
		elseif arg[3] == 3 then--分享
			str = CData:GetTranlang("分享所得：") .. CUserData:getAwardStrByTable(arg[4])
		elseif arg[3] == 4 then--邀请
			str = CData:GetTranlang("邀请所得：") .. CUserData:getAwardStrByTable(arg[4])
		end
	elseif arg[2] == 13 then--阶段目标奖励
		str = CData:GetTranlang("目标奖励：") .. CUserData:getAwardStrByTable(arg[4])
	elseif arg[2] == 14 then--战役推图获胜奖励
		str = CData:GetTranlang("战斗奖励：") .. CUserData:getAwardStrByTable(arg[4])
	elseif arg[2] == 15 then--地图怪物战斗奖励

	elseif arg[2] == 16 then--个人活跃度奖励
		str = CData:GetTranlang("个人活跃度奖励：") .. CUserData:getAwardStrByTable(arg[4])
	elseif arg[2] == 18 then--要塞积分排名奖励
		str = CData:GetTranlang("要塞捐献排名奖励：") .. CUserData:getAwardStrByTable(arg[4])
	elseif arg[2] == 19 then--运营活动
		if arg[3] == 1 then
			str = CData:GetTranlang("返线奖励：") .. CUserData:getAwardStrByTable(arg[4])
		elseif arg[3] >= 2 then
			str = CUserData:getAwardStrByTable(arg[4])
		end
	elseif arg[2] == 20 then--珍宝盒
		str = CData:GetTranlang("珍宝盒：") .. CUserData:getAwardStrByTable(arg[4])
	elseif arg[2] == 21 then--联盟充值
		str = CData:GetTranlang("联盟充值：") .. CUserData:getAwardStrByTable(arg[4])
	elseif arg[2] == 22 then--礼包码奖励
		str = CData:GetTranlang("礼包码奖励：") .. CUserData:getAwardStrByTable(arg[4])
	elseif arg[2] == 23 then--资深玩家成就活动奖励
		str = CData:GetTranlang("资深玩家成就活动奖励：") .. CUserData:getAwardStrByTable(arg[4])
	elseif arg[2] == 24 then--运送礼物（道具）活动奖励
		str = CData:GetTranlang("运送礼物（道具）活动奖励：") .. CUserData:getAwardStrByTable(arg[4])
	elseif arg[2] == 25 then--复活节砸蛋活动奖励
		str = CData:GetTranlang("复活节砸蛋活动奖励：") .. CUserData:getAwardStrByTable(arg[4])
	elseif arg[2] == 26 then--单次充值买就送活动奖励
		str = CData:GetTranlang("单次充值买就送活动奖励：") .. CUserData:getAwardStrByTable(arg[4])	
	elseif arg[2] == 27 then--每日消费活动奖励
		str = CData:GetTranlang("每日消费活动奖励:") .. CUserData:getAwardStrByTable(arg[4])	
	elseif arg[2] == 28 then--囚禁英雄挖矿所得
		str = CData:GetTranlang("囚禁英雄挖矿所得:") .. CUserData:getAwardStrByTable(arg[4])	
	elseif arg[2] == 29 then--累计充值活动奖励
		str = CData:GetTranlang("累计充值活动奖励:") .. CUserData:getAwardStrByTable(arg[4])	
	elseif arg[2] == 30 then--连续消费活动奖励
		str = CData:GetTranlang("连续消费活动奖励:") .. CUserData:getAwardStrByTable(arg[4])		
	elseif arg[2] == 31 then--月卡每日额外奖励活动
		str = CData:GetTranlang("月卡每日额外奖励活动:") .. CUserData:getAwardStrByTable(arg[4])	
	elseif arg[2] == 32 then--月卡每日额外奖励活动
		str = CData:GetTranlang("每日悬赏活动奖励:") .. CUserData:getAwardStrByTable(arg[4])				
	end
	print("CUserData:SNGetBonus str:"..str)
	if str ~= "" then
		if arg[2] == 20 then--珍宝盒
			stonebox_setshowClue(str,img)
		else
			showClue(str , img)
		end
	end
end

--个人军队信息通知(军队数组(从序号开始)，通知原因(0新增/变更,1删除)，是否为通知消息)
function CUserData:SNMyTroop(arg,type,isNotify)
	table.remove(arg,1)
	table.remove(arg,1)
	local t=CUserData.m_aTroop
--	1：出发
--2：返回
--3：采集
--4：驻扎
--5：增援
--6：集结（召集者城池内集结）
--7：联合攻击（集结完毕，联合出击）
	arg.serviceid = (arg[4] > 0 and 0 or -1)
--	arg[4] = math.abs(arg[4])
--	arg[5] = math.abs(arg[5])
	local state=arg[3]
	local nOutType = arg[2] --出征类型 xp 20140519
--	更新城内数据(-1减,0不变,1加)
	local update = 0
	local temp=arg
	if (state==1 or (state==6 and isNotify==nil)) and type==0 then
		update=-1
	elseif state==2 and type==1 then
		update=1
		for i = 1 , #t do
			if t[i][1]==arg[1] then
				temp=t[i]
				break
			end
		end
	end
	if update~=0 then
		if nOutType ~= 11 and nOutType ~= 12 then--11：资源运送 xp 20140519  ,12 礼物（道具）运送
			for i = 9 , 26+9 do
				local n=temp[i]
				if n>0 then
					CUserData:setSoldierInfo(soldierIDTable[i-8],n*update)
				end
			end
			for i = 40 , 42+6 do
				local n=temp[i]
				if n>0 then
					local nsoldierid = 0
					if i==40 then 
						nsoldierid = 7
					elseif i == 41 then 
						nsoldierid = 17
					elseif i == 42 then 
						nsoldierid = 27
					
					elseif i==43 then 
						nsoldierid = 8
					elseif i == 44 then 
						nsoldierid = 18
					elseif i == 45 then 
						nsoldierid = 28	
					elseif i==46 then 
						nsoldierid = 9
					elseif i == 47 then 
						nsoldierid = 19
					elseif i == 48 then 
						nsoldierid = 29	
					end
					if nsoldierid > 0 then 
						CUserData:setSoldierInfo(nsoldierid,n*update)
					end
				end
			end
		end
		city_TopRef()
		refreshHeroShow()
	end
	if type==0 then
		for i = 1 , #t do
			if t[i][1]==arg[1] then
				CUserData.m_aTroop[i]=arg
				queue_updatedata(0,queue_formatdata(2,arg))
				armyOperateButtonShow()
				return
			end
		end
		table.insert(CUserData.m_aTroop,arg)
		queue_updatedata(0,queue_formatdata(2,arg))
		
		if arg[8] == 1 then 
			CUserData.m_valherostate = 1
			hero_statetimer()
		end
	elseif type==1 then
		for i = 1 , #t do
			if t[i][1]==arg[1] then
				if t[i][8]>0 then
					CUserData.m_nHeroStatus=0
				end
				table.remove(CUserData.m_aTroop,i)
				queue_updatedata(1,{2,arg[1]})
				armyOperateButtonShow()
				
				print("CUserData:SNMyTroop temp:"..tabletostring(temp))
				if temp[8] == 1 then 
					CUserData.m_valherostate = 0
					hero_statetimer()
				end
				return
			end
		end
	end
	armyOperateButtonShow()
	
	if isNotify == true and type == 1 then
		if (state == 4 or state == 5) then--扎帐篷,或者增援到别人城市时使用的音效
			playSound(406)
		elseif state == 2 then--军队回到城市时使用
			playSound(420)
		end
	end
end

function CUserData:onGetUserPlusInfo(arg)--查询plus信息
	self.m_aPlusInfo = arg[2]
end

function CUserData:onGetUserFuncData(arg)--查询效果数据信息
	self.m_aFuncData = arg[2]
end

function CUserData:getPlusInfo(nid,nindex)
	local v = nil
	for i = 1 , #self.m_aPlusInfo do
		if self.m_aPlusInfo[i][1] == nid then
			if nindex == nil then
				v = copytable(self.m_aPlusInfo[i])
			else
				v = self.m_aPlusInfo[i][nindex]
			end
			break
		end
	end
	if v == nil and nindex ~= nil then
		return 0
	end
	return v
end

-- -------------------------------------
--更新英雄数据
function CUserData:setHeroInfo(arg,i)
	self.m_nHeroGrade,self.m_nHeroExp,self.m_nHeroPower,self.m_nLordPower=arg[i],arg[i+1],arg[i+2],arg[i+3]
end

--更新队列数据
function CUserData:setTeamInfo(arg,i,del)
	local id=arg[i]
	if id>0 then
		if arg[i+1]==0 then
			for i,v in ipairs(self.m_aQueue) do
				if v[1]==id then
					if id==2 and (del==nil or del==false) then
						CUserData:setTechInfo({v[4],v[7]},1)
					end

					table.remove(self.m_aQueue,i)
					queue_updatedata(1,{1,id})
					return
				end
			end
		end
		local t=CUserData:getQueueInfoByid(id)
		if t==nil then
			table.insert(CUserData.m_aQueue,{id,arg[i+1],arg[i+2],arg[i+3],arg[i+4],arg[i+5],arg[i+6]})
			queue_updatedata(0,queue_formatdata(1,CUserData.m_aQueue[#CUserData.m_aQueue]))
		else
			t[1]=id
			t[2]=arg[i+1]
			t[3]=arg[i+2]
			t[4]=arg[i+3]
			t[5]=arg[i+4]
			t[6]=arg[i+5]
			t[7]=arg[i+6]
			queue_updatedata(0,queue_formatdata(1,t))
		end
	end
end

--更新技能等级
function CUserData:setSkillInfo(arg,i)
	local id=arg[i]
	print(id)
	if id>0 then
		local t=CUserData:getSkillByid(id)
		print(t)
		if t==nil then
			table.insert(CUserData.m_aSkill,{id,arg[i+1]})
		else
			t[2]=arg[i+1]
		end
	end
end

--更新科技等级
function CUserData:setTechInfo(arg,i)
	local id=arg[i]
	if id>0 then
		local t=CUserData:getTechByid(id)
		if t==nil then
			table.insert(CUserData.m_aTech,{id,arg[i+1]})
		else
			t[2]=arg[i+1]
		end
	end
end

--更新道具数量
function CUserData:setItemInfo(arg,i)
	local propID=arg[i]
	if propID>0 then
		local propNum=arg[i+1]
		local t=CUserData:getItemByid(propID)
		if t==nil then
			table.insert(CUserData.m_aItem,{propID,propNum})
		else
			if propNum>0 then
				t[2]=arg[i+1]
			else
				for i = 1 , #CUserData.m_aItem do
					if self.m_aItem[i][1] == propID then
						table.remove(CUserData.m_aItem,i)
						return
					end
				end
			end
		end
		if propID == 2041 then
			frame_changetext("canlotterybox")
		end
		if propID == 1022 then
			frame_changetext("canlottery2box")
		end
	end
end
--交易完成通知
function CUserData:SNTrading(arg )

	local nfind = 0
	for i = 1 , #self.m_aItem do
		if self.m_aItem[i][1] == arg[3] then
			self.m_aItem[i][2] = arg[5]
			nfind = 1
		end
	end
	if nfind == 0 and arg[3] ~= 0 then
		table.insert(self.m_aItem,{arg[3],arg[5]})
	end

	if arg[3] == 2041 then
		frame_changetext("canlotterybox")
	end
	if arg[3] == 1022 then
		frame_changetext("canlottery2box")
	end

	self.m_nTradingPos = arg[6] --当前交易地点
	self.m_nTradingGID = arg[7] --当前交易编号
	self.m_nTradingStart = arg[8] --开始时间
	self.m_nTradingEnd   = arg[9] --结束时间

	self.m_aTrading = arg[10]

end
--队列信息通知的处理       (1 建筑,2 科技,) 要考虑到help情况 即可能 排程没有完成 也可能通知会回来
function CUserData:SNQueueInfo(arg )
	print("CUserData:SNQueueInfo ")
	local aQueue = CUserData:updateQueue({arg[3],arg[4],arg[5],arg[6],arg[7],arg[8],arg[9]})

	self.m_nHeroGrade=arg[10]--英雄等级
	self.m_nHeroExp=arg[11]--英雄经验
	self.m_nHeroPower=arg[12]--英雄战力
	self.m_nLordPower=arg[13]--主公战力
	print("CUserData:SNQueueInfo aQueue :"..tabletostring(aQueue) )
	if arg[3] == 1 then		--建筑
		--更新建筑列表数据
		
		local abuildinginfo = {}
		if #aQueue > 0 then
			if arg[4] == 0 then--0 表示队列结束
				if aQueue[5] == 1 then--升级
					for i = 1 , #self.m_aBuild do
						if self.m_aBuild[i][1] == aQueue[4] then
							abuildinginfo = copytable( self.m_aBuild[i] )
							local noldlv = self.m_aBuild[i][3]
							self.m_aBuild[i][3] = aQueue[7]
							playSound(408)
							
							if self.m_aBuild[i][1] == 101 then 
								if noldlv ~= self.m_aBuild[i][3] then 
									account_saveGameInfoForKor()
								end
							end
							break
						end
					end
				elseif aQueue[5] == 2 then--拆除
					for i = 1 , #self.m_aBuild do
						if self.m_aBuild[i][1] == aQueue[4] then
							abuildinginfo = copytable( self.m_aBuild[i] )
							table.remove(self.m_aBuild,i)
							break
						end
					end
					--拆除
					deldiv("main","buildUpgrade_main")
				end
				--city_show()
				city_ref()--2014080101xp
				
			end
		else--新增队列
			--city_show()
			city_ref()--2014080101xp
		end
		if arg[4] == 0 then
			buildUpgrade_showClumByQueueInfo(aQueue,abuildinginfo )
		end
		buildUpgrade_refByQueueInfo()

		guide_freeEnd()
		statistics_setInfo()
	elseif arg[3] == 2 then	--科技
		if arg[4] == 0 then
			CUserData:setTechInfo({aQueue[4],aQueue[7]},1)
		end
		refreshTechShow()
		buildUpgradePop_refByQueueInfo()
		city_sethiddenTipIcoByType(3)
	elseif arg[3] == 3 then	--士兵
		if #aQueue > 0 then
			local nfind = 0
			for i = 1 ,#self.m_aSoldier do
				if self.m_aSoldier[i][1] == aQueue[4] then
					self.m_aSoldier[i][2] = self.m_aSoldier[i][2] + aQueue[5]
					nfind = 1
					break
				end
			end
			if nfind == 0 then
				table.insert(self.m_aSoldier,{aQueue[4],aQueue[5],0})
			end
			city_TopRef()
		end
		camp_refByQueueInfo()
		refreshChubingShow()
		city_sethiddenTipIcoByType(1)
	elseif arg[3] == 4 then	--城防
		if #aQueue > 0 then
			local nfind = 0
			for i = 1 ,#self.m_aTrap do
				if self.m_aTrap[i][1] == aQueue[4] then
					self.m_aTrap[i][2] = self.m_aTrap[i][2] + aQueue[5]
					nfind = 1
					break
				end
			end
			if nfind == 0 then
				table.insert(self.m_aTrap,{aQueue[4],aQueue[5]})
			end
		end
		camp_refByQueueInfo()
	elseif arg[3] == 5 then	--宝石交易
		if arg[2] == 1 then
			showClue(string.format(CData:GetTranlang("交易完成,获得 %s (%d)。"),CData:GetTranlang(CUserData:getItemConfigByid(aQueue[4],2)),aQueue[5]),CUserData:getItemConfigByid(aQueue[4],1))
			local num = CUserData:getItemByid(aQueue[4],2)
			num = num + aQueue[5]
			CUserData:updateItemCount(aQueue[4],num)
		end
		market_refush()
	elseif arg[3] == 6 then	--日常任务

	elseif arg[3] == 7 then	--联盟任务

	elseif arg[3] == 8 then	--参数2  0:装备强化,1:圣物合成
		if #aQueue > 0 then
			if aQueue[5] == 0 then--0:装备强化
				if aQueue[7] == CUserData.m_aHeroEquipType then --套装编号
					if self["m_nItem"..aQueue[4]]  ~= nil then
						self["m_nItem"..aQueue[4]] = aQueue[6]+1
					end
				end
			else--1:圣物合成
				local nfind = 0
				for i = 1 ,#self.m_aItem do
					if self.m_aItem[i][1] == aQueue[4] then
						self.m_aItem[i][2] = self.m_aItem[i][2] + 1
						nfind = 1
						break
					end
				end
				if nfind == 0 and aQueue[4] ~= 0 then
					table.insert(self.m_aItem,{aQueue[4],1})
				end
			end
		end
		equipForg_refByQueueInfo()
		equipComp_refByQueueInfo()
		refreshHeroShow()
		equip_refByQueue()
		city_sethiddenTipIcoByType(4)
		faneCompose_refByQueueInfo()
	elseif arg[3] == 9 then--伤兵治疗
		local nfind = 0
		for i = 1 ,#self.m_aSoldier do
			if self.m_aSoldier[i][1] == aQueue[4] then
				self.m_aSoldier[i][2] = self.m_aSoldier[i][2] + aQueue[5] --治愈后的伤兵数量 加回到士兵总量
				--self.m_aSoldier[i][3] = self.m_aSoldier[i][3] - aQueue[5] --在治疗中的伤兵,已经减过了,在0x108返回时已做处理
				if self.m_aSoldier[i][3] < 0 then
					self.m_aSoldier[i][3] = 0
				end
				nfind = 1
				break
			end
		end
		if nfind == 0 then--有伤兵队列无 士兵记录 的情况
			table.insert(self.m_aSoldier,{aQueue[4],aQueue[5],0})
		end
		camp_refByQueueInfo()
		city_TopRef()
		city_sethiddenTipIcoByType(5)
	elseif arg[3] == 10 then--训练卫队
		if #aQueue > 0 then
			local nfind = 0
			for i = 1 ,#self.m_aSoldier do
				if self.m_aSoldier[i][1] == aQueue[4] then
					self.m_aSoldier[i][2] = self.m_aSoldier[i][2] + aQueue[5]
					nfind = 1
					break
				end
			end
			if nfind == 0 then
				table.insert(self.m_aSoldier,{aQueue[4],aQueue[5],0})
			end
			
		end
		city_TopRef()
		refreshHeroShow()
		heroSoldier_refush()
	elseif arg[3] == 11 then--兵种科技
		if #aQueue > 0 then
			local nfind = 0
			for i=1,#CUserData.m_aTechSoldier do
				if 	CUserData.m_aTechSoldier[i][1] == aQueue[4] then 
					CUserData.m_aTechSoldier[i][2] = aQueue[7]
					nfind = 1
					break
				end	
			end		
			if nfind == 0 then 
				table.insert(CUserData.m_aTechSoldier,{aQueue[4],aQueue[7]})
			end			
		end
		techSoldier_ref()
		refreshTechShow()
	end

end
--队列操作
function CUserData:onQueueAction(arg )
	local aQueue = CUserData:updateQueue({arg[7],arg[8],arg[9],arg[10],arg[11],arg[12],arg[13]})



	--更新 金币余额 等
	--self.m_nGold = arg[4]
	CUserData:updateGold(arg[4])
	local nfind = 0
	for i = 1 , #self.m_aItem do
		if self.m_aItem[i][1] == arg[5] then
			self.m_aItem[i][2] = arg[6]
			nfind = 1
		end
	end
	if nfind == 0 then
		table.insert(self.m_aItem,{arg[5],arg[6]})
	end

	if arg[5] == 2041 then
		frame_changetext("canlotterybox")
	end
	if arg[5] == 1022 then
		frame_changetext("canlottery2box")
	end

	if arg[7] == 1 then		--建筑
		--更新建筑列表数据
		if aQueue[5] == 1 then		--升级
			for i = 1 , #self.m_aBuild do
				if self.m_aBuild[i][1] == aQueue[4]  then
					if arg[8] == 0 and arg[2] ~= 9 then --arg[8] == 0＝无队列,	arg[2] ~= 9 ,非取消操作
						local noldlv = self.m_aBuild[i][3]
						self.m_aBuild[i][3] = aQueue[7]
						
						if self.m_aBuild[i][1] == 101 then 
							if noldlv ~= self.m_aBuild[i][3] then 
								account_saveGameInfoForKor()
							end
						end
					end
					break
				end
			end
		elseif aQueue[5] == 2 then	--拆除
			for i = 1 , #self.m_aBuild do
				if self.m_aBuild[i][1] == aQueue[4] then
					if arg[8] == 0 and arg[2] ~= 9 then --arg[8] == 0＝无队列,	arg[2] ~= 9 ,非取消操作
						table.remove(self.m_aBuild,i)
					end
					break
				end
			end
			--拆除  free
			if arg[2] == 0 then
				deldiv("main","buildUpgrade_main")
			end
		end
		buildUpgrade_refByQueueInfo()
		--city_show()
		city_ref()--2014080101xp
	elseif arg[7] == 2 then	--科技
		if arg[10]==0 and arg[2] ~= 9 then
			CUserData:setTechInfo({aQueue[4],aQueue[7]},1)
		end
		refreshTechShow()
		buildUpgradePop_refByQueueInfo()
		city_sethiddenTipIcoByType(3)
	elseif arg[7] == 3 then	--士兵
		local nfind = 0
		for i = 1 ,#self.m_aSoldier do
			if self.m_aSoldier[i][1] == aQueue[4] then
				if arg[8] == 0 and arg[2] ~= 9 then --arg[8] == 0＝无队列,	arg[2] ~= 9 ,非取消操作
					self.m_aSoldier[i][2] = self.m_aSoldier[i][2] + aQueue[5]
					nfind = 1
				end
				break
			end
		end
		if nfind == 0 and arg[8] == 0 and arg[2] ~= 9 then
			table.insert(self.m_aSoldier,{aQueue[4],aQueue[5],0} )
		end
		--camp_show(1,camp_getBuildingpos())
		camp_refByQueueInfo()
		refreshChubingShow()
		city_TopRef()
		city_sethiddenTipIcoByType(1)
	elseif arg[7] == 4 then	--城防
		local nfind = 0
		for i = 1 ,#self.m_aTrap do
			if self.m_aTrap[i][1] == aQueue[4] then
				if arg[8] == 0 and arg[2] ~= 9 then --arg[8] == 0＝无队列,	arg[2] ~= 9 ,非取消操作
					self.m_aTrap[i][2] = self.m_aTrap[i][2] + aQueue[5]
					nfind = 1
				end
				break
			end
		end
		if nfind == 0 and arg[8] == 0 and arg[2] ~= 9 then
			table.insert(self.m_aTrap,{aQueue[4],aQueue[5]} )
		end
		--camp_show(2,camp_getBuildingpos())
		camp_refByQueueInfo()
	elseif arg[7] == 5 then	--交易
		if arg[10] == 0 then
			showClue(string.format(CData:GetTranlang("交易完成,获得 %s (%d)。"),CData:GetTranlang(CUserData:getItemConfigByid(aQueue[4],2)),aQueue[5]),CUserData:getItemConfigByid(aQueue[4],1))
			local num = CUserData:getItemByid(aQueue[4],2)
			num = num + aQueue[5]
			CUserData:updateItemCount(aQueue[4],num)
		end
		market_refush()
	elseif arg[7] == 6 then	--日常任务

	elseif arg[7] == 7 then	--联盟任务

	elseif arg[7] == 8 then	--装备强化 /圣物合成
		if arg[8] == 0 and arg[2] ~= 9 then--arg[8] == 0＝无队列,	arg[2] ~= 9 ,非取消操作
			print("aQueue:"..tabletostring(aQueue))
			if aQueue[5] == 0 then--0＝装备强化
				if aQueue[7] == CUserData.m_aHeroEquipType then --套装编号
					CUserData["m_nItem"..aQueue[4] ] = aQueue[6]+1
				end
			elseif aQueue[5] == 1 then--1＝圣物合成
				--道具
				local nfind = 0
				for i = 1, #self.m_aItem do
					if self.m_aItem[i][1] == aQueue[4] then
						self.m_aItem[i][2] = self.m_aItem[i][2] + 1
						nfind = 1
						break
					end
				end
				if nfind == 0 then
					table.insert(self.m_aItem,{aQueue[4],1})
				end
			end
		end
		equipForg_refByQueueInfo()
		equipComp_refByQueueInfo()
		refreshHeroShow()
		equip_refByQueue()
		city_sethiddenTipIcoByType(4)
		faneCompose_refByQueueInfo()
	elseif arg[7] == 9 then	--伤兵治愈
		local nfind = 0
		for i = 1 ,#self.m_aSoldier do
			if self.m_aSoldier[i][1] == aQueue[4] then
				if arg[8] == 0 and arg[2] ~= 9 then --arg[8] == 0＝无队列,	arg[2] ~= 9 ,非取消操作
					self.m_aSoldier[i][2] = self.m_aSoldier[i][2] + aQueue[5]
					self.m_aSoldier[i][3] = self.m_aSoldier[i][3] - aQueue[5]
					if self.m_aSoldier[i][3] < 0 then
						self.m_aSoldier[i][3] = 0
					end
					nfind = 1
				end
				break
			end
		end
		if nfind == 0 and arg[8] == 0 and arg[2] ~= 9 then
			table.insert(self.m_aSoldier,{aQueue[4],aQueue[5],0} )
		end
		--camp_show(3,camp_getBuildingpos())
		camp_refByQueueInfo()
		city_TopRef()
		city_sethiddenTipIcoByType(5)
	elseif arg[7] == 10 then--训练卫队
		if #aQueue > 0 then
			local nfind = 0
			for i = 1 ,#self.m_aSoldier do
				if arg[8] == 0 and arg[2] ~= 9 then --arg[8] == 0＝无队列,	arg[2] ~= 9 ,非取消操作
					if self.m_aSoldier[i][1] == aQueue[4] then
						self.m_aSoldier[i][2] = self.m_aSoldier[i][2] + aQueue[5]
						nfind = 1
						break
					end
				end
			end
			if nfind == 0  and arg[8] == 0 and arg[2] ~= 9 then
				table.insert(self.m_aSoldier,{aQueue[4],aQueue[5],0})
			end
		end
		city_TopRef()
		refreshHeroShow()
		heroSoldier_refush()
	elseif arg[7] == 11 then--兵种科技
		if #aQueue > 0 then
			if arg[8] == 0 and arg[2] ~= 9 then--arg[8] == 0＝无队列,	arg[2] ~= 9 ,非取消操作
				local nfind = 0
				for i=1,#CUserData.m_aTechSoldier do
					if 	CUserData.m_aTechSoldier[i][1] == aQueue[4] then 
						CUserData.m_aTechSoldier[i][2] = aQueue[7]
						nfind = 1
						break
					end	
				end	
				if nfind == 0 then 
					table.insert(CUserData.m_aTechSoldier,{aQueue[4],aQueue[7]})
				end					
			end
		end
		techSoldier_ref()
		refreshTechShow()
	end

	--[[推送需求:
	CUserData:onQueueAction  考虑取消推送
	CUserData:updateQueue    考虑新增或者更新推送
	这里只考虑取消排程的情况
	1.等级10以上的建筑 建筑完成提示
	2.等级4以上的科技研发完成
	3.超过5小时军队训练完成]]
	if arg[2] == 9 then--取消排程
		if arg[7] == 1 then
			if aQueue[5] == 1 then--升级
				local type = "1"
				local content = "0000"
				local time = "-1"
				conenttosocial(11 , type.."^"..content.."^"..time )	--11 本地通知  type^content^time...
			end
		elseif arg[7] == 2 then
			local type = "2"
			local content = "0000"
			local time = "-1"
			conenttosocial(11 , type.."^"..content.."^"..time )	--11 本地通知  type^content^time...
		elseif arg[7] == 3 then
			local type = "3"
			local content = "0000"
			local time = "-1"
			conenttosocial(11 , type.."^"..content.."^"..time )	--11 本地通知  type^content^time...
		end
	end
end
--效果数据通知
function CUserData:SNFuncData(arg )
	for k = 1 , #arg[2] do
		local v = arg[2][k]
		local nfind = 0
		for i = 1 ,#self.m_aFuncData do
			if self.m_aFuncData[i][1] == v[1] then
				self.m_aFuncData[i][2] = v[2]
				nfind = 1
				break
			end
		end
		if nfind == 0 then
			table.insert(self.m_aFuncData,{v[1],v[2]})
		end
	end
end
-- -------------------------------------
--根据队列类型返回队列
function CUserData:getQueueInfoByid(id,index)
	for i,v in ipairs(self.m_aQueue) do
		if v[1]==id then
			if index == nil then
				return v
			else
				return v[index]
			end
		end
	end
	if index == nil then
		return nil
	else
		return 0
	end
end

--根据科技id返回对应科技
function CUserData:getTechByid(id,index)
	for i,v in ipairs(self.m_aTech) do
		if v[1]==id then
			if index == nil then
				return v
			else
				return v[index]
			end
		end
	end
	if index == nil then
		return nil
	else
		return 0
	end
end

--根据技能id返回对应技能
function CUserData:getSkillByid(id,index)
	for i,v in ipairs(self.m_aSkill) do
		if v[1]==id then
			if index == nil then
				return v
			else
				return v[index]
			end
		end
	end
	if index == nil then
		return nil
	else
		return 0
	end
end

--根据道具id返回对应道具
function CUserData:getItemByid(id,index)
	for i,v in ipairs(self.m_aItem) do
		if v[1]==id then
			--print("CUserData:getItemByid v:"..tabletostring(v))
			if index == nil then
				return v
			else
				return v[index]
			end
		end
	end
	if index == nil then
		return nil
	else
		return 0
	end
end

--根据建筑位置返回建筑信息
function CUserData:getBuildBypos(npos,nindex)
	if npos == nil then
		return self.m_aBuild
	else
		local vfind = nil
		for i,v in ipairs(self.m_aBuild) do
			if v[1] == npos then
				vfind = v
				break
			end
		end
		if nindex == nil then
			return vfind
		else
			local nret = 0
			if vfind ~= nil then
				nret = vfind[nindex]
			end
			if nret == nil then
				return 0
			else
				return nret
			end
		end
	end
end
--根据建筑位置返回建筑信息
function CUserData:getSpecialtyBypos(npos)
	if npos == nil then
		return self.m_aSpecialty
	else
		local vfind = nil
		for i,v in ipairs(self.m_aSpecialty) do
			if v[1] == npos then
				vfind = v
				break
			end
		end
		if vfind == nil then
			vfind = {npos,0,0}
		end
		return vfind
	end
end
--根据队列类型、参数1 返回队列
function CUserData:getQueueBytype(ntype,arg1)
--	print("CUserData:getQueueBytype:"..ntype,arg1)
--	print("CUserData:getQueueBytype:"..tabletostring(self.m_aQueue) )
	for i,v in ipairs(self.m_aQueue) do
		if v[1] == ntype and (arg1 == nil or v[4] == arg1) then
			return v
		end
	end
	return nil
end

--根据建筑id返回该类最高等级的建筑
function CUserData:getMaxLvBuildByid(id)
	local nmaxlv = 0
	local ainfo = nil
	for i,v in ipairs(self.m_aBuild) do
		if v[2] == id then
			if v[3] > nmaxlv then
				nmaxlv = v[3]
				ainfo = self.m_aBuild[i]
			end
		end
	end
	return ainfo
end
--根据建筑id返回该类建筑的最高等级
function CUserData:getBuildMaxLvByid(id)
	local nmaxlv = 0
	for i,v in ipairs(self.m_aBuild) do
		if v[2] == id then
			if v[3] > nmaxlv then
				nmaxlv = v[3]
			end
		end
	end
	return nmaxlv
end
--根据建筑id返回该类建筑的个数
function CUserData:getBuildCountByid(id)
	local ncount = 0
	for i,v in ipairs(self.m_aBuild) do
		if v[2] == id then
			ncount = ncount + 1
		end
	end
	return ncount
end
--根据建筑id返回该类建筑集合
function CUserData:getBuildColByid(id)
	local ncol = {}
	for i,v in ipairs(self.m_aBuild) do
		if v[2] == id then
			table.insert(ncol,self.m_aBuild[i] )
		end
	end
	return ncol
end
--返回英雄当前经验比值
function CUserData:getHeroExpRatio()
	local cur=CUserData.m_nHeroExp
	--local total=CUserData:getHeroUpgListByid(1)
	local level=CUserData.m_nHeroGrade
	local aconf = CUserData:getHeroUpgListByLevel(level + 1 )
	local total = 0
	if aconf ~= nil then
		total = tonumber( aconf["F1"])
	end
	if total==nil or total==0 then
		return 1
	end
	return math.min(1,cur/total)
end
--返回英雄当前经验比值
function CUserData:getHeroExpRatioString()
	local cur=CUserData.m_nHeroExp
	--local total=CUserData:getHeroUpgListByid(1)
	local level=CUserData.m_nHeroGrade
	local aconf = CUserData:getHeroUpgListByLevel(level + 1 )
	local total = 0
	if aconf ~= nil then
		total = tonumber( aconf["F1"])
	end
	local str = ""
	if total==nil or total==0 then
		str = string.format("%s",CUserData:getNumStr(cur,2) )
	else
		str = string.format("%s/%s",CUserData:getNumStr(cur,2),CUserData:getNumStr(total,2))
	end
	return str
end

--根据资源的种类和数量返回合计的金币数
function CUserData:getGoldOfResource(ntype,nnum)
	--[[1金币兑换物品
	--改成为:
	1金币等于石头333，不足1金币取1金币。其他如
	石	333
	木	333
	铁	333
	粮	433
	银币 133

	1金币等于石头3000，不足1金币取1金币。其他如
	石	3000
	木	3000
	铁	3000
	粮	3900
	银币	1200
	]]
	local nret = 0
	if ntype == 1 then		--石	360
		nret = nnum / 3000
	elseif ntype == 2 then	--木	360
		nret = nnum / 3000
	elseif ntype == 3 then	--铁	270
		nret = nnum / 3000
	elseif ntype == 4 then	--粮	450
		nret = nnum / 3900
	elseif ntype == 5 then	--银币	180
		nret = nnum / 1200
	end
	if nret < 0 then nret = 0 end
	return nret
end

--根据道具的种类和数量返回合计的金币数
function CUserData:getGoldOfItem(ntype,nnum)
	local nprice = 0
	for i = 1 ,#self.m_aMallLists do
		if self.m_aMallLists[i][1] == ntype then
			nprice = self.m_aMallLists[i][2]
			break
		end
	end
	local nret = nprice * nnum
	if nret < 0 then nret = 0 end
	return nret
end

--根据时间秒数返回合计的金币数
function CUserData:getGoldOfTime(nnum,nIsCamp)
	--时间	450秒

	--改成为:
	--时间	75秒
	--士兵城防金币训练：资源不足同上，时间按60秒1金币计算    伤兵
	--[[改为：梯度价格

	0-60秒	60
	61-180秒	120
	181-600秒	420
	601-900秒	300
	901-1800秒	450
	1801-3600秒	450
	3601-10800秒	480
	10801-28800秒	514
	28801-57600秒	576
	57601-86400秒	720
	86401-259200秒	640
	259201秒以上	640
	]]
	local aprice={
		{1,60},
		{61,120},
		{181,420},
		{601,300},
		{901,450},
		{1801,450},
		{3601,480},
		{10801,514},
		{28801,576},
		{57601,720},
		{86401,640},
		{259201,640},
	}
	local ntotal = 0
	local nindex = 1
	for i = #aprice , 1 ,-1 do
		local v = aprice[i]
		if nnum >= v[1] then
			--print("nnum:"..nnum)
			local ntime = nnum - v[1] + 1
			local nprice= v[2]
			ntotal= ntime / nprice
--			print("ntime:"..ntime)
--			print("nprice:"..nprice)
--			print("================ntotal:"..ntotal)
			local npre = v[1]
			for k = i-1 ,1 , -1 do
				local v = aprice[k]
				ntime = npre - v[1]
				nprice= v[2]
				ntotal= ntotal + ntime / nprice
				npre = v[1]
--				print("ntime:"..ntime)
--				print("nprice:"..nprice)
--				print("================ntotal:"..ntotal)
			end
			break
		end
	end

	if ntotal < 0 then ntotal = 0 end

	return ntotal

--	if nIsCamp == nil then --士兵城防伤兵
--		nIsCamp = 0
--	end
--	local nret = nnum /75   --时间	450秒
--	if nIsCamp == 1 then
--		nret = nnum /60
--	end
--	if nret < 0 then nret = 0 end
--	return nret
end

function CUserData:updateResource(a1,a2,a3,a4,a5)--更新 石料 木材  铁矿 食物 银币
	local nIsNeedRef = 0 --是否需要资源值更新
	if self.m_nStone ~= a1 or self.m_nWood~=a2 or self.m_nIron~=a3 or self.m_nFood~=a4 or self.m_nSilver~=a5 then
		nIsNeedRef = 1
	end
	self.m_nStone=a1--石料
	self.m_nWood=a2--木材
	self.m_nIron=a3--铁矿
	self.m_nFood=a4--食物
	self.m_nSilver=a5--银币
	if nIsNeedRef == 1 then
		self.m_nStoneTime=os.time()

		city_TopRef()
	end
end
function CUserData:getResourceIco(ntype)
	local apng = {"ico_ResourceStone.png","ico_ResourceWood.png","ico_ResourceIron.png","ico_ResourceFood.png","ico_ResourceSilver.png"}
	local str  = apng[ntype]
	if str ~= nil then
		return "assets/images/"..str
	else
		return ""
	end
end

--获取资源名
function CUserData:getResourceName(ntype)
	local name = {"石料","木材","铁矿","粮食","银币"}
	return CData:GetTranlang(name[ntype])
end

function CUserData:getResourceOut(ntype)--资源 产量  ntype:1石,2木,3铁,4粮,5银
	local nret = 0
	if ntype == 1 then
		nret = CUserData:getStoneOut()--石产量 /h
	elseif ntype == 2 then
		nret = CUserData:getWoodOut()--木产量 /h
	elseif ntype == 3 then
		nret = CUserData:getIronOut()--铁产量 /h
	elseif ntype == 4 then
		nret = CUserData:getFoodOut()--粮产量 /h
	elseif ntype == 5 then
		nret = CUserData:getSilverOut()--银产量 /h
	end
	return nret
end
function CUserData:getResourceValue(ntype)--资源 拥有 ntype:1石,2木,3铁,4粮,5银
	local nret = 0
	if ntype == 1 then
		nret = CUserData:getStone()--石 拥有
	elseif ntype == 2 then
		nret = CUserData:getWood()--木 拥有
	elseif ntype == 3 then
		nret = CUserData:getIron()--铁 拥有
	elseif ntype == 4 then
		nret = CUserData:getFood()--粮 拥有
	elseif ntype == 5 then
		nret = CUserData:getSilver()--银 拥有
	end

	return nret
end

function CUserData:getResourceUpperLimit(ntype)--资源 上限
--	local abuildid = {23,24,25,26,27 }
--	local nbuildid = abuildid[ntype]
--	local nvalue = 0
--	if nbuildid ~= nil then
--		if ntype == 5 then--基础产量上限：石木铁粮每小时各5000，银币3000.
--			nvalue = nvalue + 3000
--		else
--			nvalue = nvalue + 5000
--		end
--		local abuild   = CUserData:getBuildColByid(nbuildid)
--		for i = 1 ,#abuild do
--			local aupconf = CUserData:getbuildingUpgConfigByid(abuild[i][2]*10000+abuild[i][3])
--			if aupconf ~= nil then
--				nvalue = nvalue + tonumber( aupconf["F18"] )
--			end
--		end
--	end
--	--[[石料产量上限千分比	31*（1+121）
--		木材产量上限千分比	32*（1+122）
--		铁矿产量上限千分比	33*（1+123）
--		粮食产量上限千分比	34*（1+124）
--		银币产量上限千分比	35*（1+125）
--	]]
--	if ntype == 1 then
--		nvalue = nvalue * (1 + CUserData:getFuncData(121)/1000)
--	elseif ntype == 2 then
--		nvalue = nvalue * (1 + CUserData:getFuncData(122)/1000)
--	elseif ntype == 3 then
--		nvalue = nvalue * (1 + CUserData:getFuncData(123)/1000)
--	elseif ntype == 4 then
--		nvalue = nvalue * (1 + CUserData:getFuncData(124)/1000)
--	elseif ntype == 5 then
--		nvalue = nvalue * (1 + CUserData:getFuncData(125)/1000)
--	end
	local nvalue = self.m_aResourceMax[ntype]
	if nvalue == nil then
		nvalue = 0
	end
	return nvalue
end
function CUserData:getResourceBuff(ntype)
	local abuff = {
		{101,511},
		{102,512},
		{103,513},
		{104,514},
		{105,515},
	}
	local nbuff1 = 0
	local nbuff2 = 0
	if abuff[ntype] ~= nil then
		nbuff1 = abuff[ntype][1]
		nbuff2 = abuff[ntype][2]
	end
	return nbuff1,nbuff2
end

function CUserData:getResourceAddValue(ntype,buf1,buf2,nretType)--ntype:1石,2木,3铁,4粮,5银 . nretType:1,返回 增量值, 2 ,返回产量值  （每小时增量值）
	--[[
	23	采石场
	24	伐木场
	25	铁矿场
	26	农庄
	27	民居
	]]
--	local abuildid = {23,24,25,26,27 }
--	local nbuildid = abuildid[ntype]
--	local abuild   = CUserData:getBuildColByid(nbuildid)
--	local nvalue = 0
--	if nbuildid ~= nil then
--		if ntype == 5 then--基础产量：石木铁粮每小时各500，银币300.
--			nvalue = nvalue + 300
--		else
--			nvalue = nvalue + 500
--		end
--		for i = 1 ,#abuild do
--			local aupconf = CUserData:getbuildingUpgConfigByid(abuild[i][2]*10000+abuild[i][3])
--			if aupconf ~= nil then
--				nvalue = nvalue + tonumber( aupconf["F16"] )
--			end
--		end
--	end
----	print("--------------------------------------")
----	print("ntype:"..ntype)
----	print("nvalue:"..nvalue)
--
--	local nbuffvalue = nvalue * (1 + CUserData:getFuncData(buf1)/1000 + CUserData:getFuncData(buf2)/1000 )
	--print("nbuffvalue:"..nbuffvalue)
	local nbuffvalue = CUserData:getResourceOut(ntype)
	local dish = ( os.time() - self.m_nStoneTime ) / 3600 --小时
	--print("sec:"..( os.time() - self.m_nStoneTime ) )
	--print("dish:"..dish)
	local disvalue = dish * nbuffvalue
	--print("disvalue:"..disvalue)
	--print("CUserData:getResourceAddValue disvalue:"..disvalue)
	disvalue = disvalue - disvalue % 1
	if nretType == 1 then
		return disvalue
	else
		return nbuffvalue
	end
end

function CUserData:getStoneOut()--石产量 /h
--	local nbuff1,nbuff2 = CUserData:getResourceBuff(1)
--	return CUserData:getResourceAddValue(1,nbuff1,nbuff2,2)
	return self.m_aResourceOut[1]
end
function CUserData:getWoodOut()--木产量 /h
--	local nbuff1,nbuff2 = CUserData:getResourceBuff(2)
--	return CUserData:getResourceAddValue(2,nbuff1,nbuff2,2)
	return self.m_aResourceOut[2]
end
function CUserData:getIronOut()--铁产量 /h
--	local nbuff1,nbuff2 = CUserData:getResourceBuff(3)
--	return CUserData:getResourceAddValue(3,nbuff1,nbuff2,2)
	return self.m_aResourceOut[3]
end
function CUserData:getFoodOut()--粮产量 /h
--	local nbuff1,nbuff2 = CUserData:getResourceBuff(4)
--	return CUserData:getResourceAddValue(4,nbuff1,nbuff2,2)
	return self.m_aResourceOut[4]
end
function CUserData:getSilverOut()--银产量 /h
--	local nbuff1,nbuff2 = CUserData:getResourceBuff(5)
--	return CUserData:getResourceAddValue(5,nbuff1,nbuff2,2)
	return self.m_aResourceOut[5]
end

function CUserData:getStone()--石 拥有
	local nret = CUserData.m_nStone
	--CUserData.m_nStoneTime=0--资源时间,(本地时间点,)
	--	石料产量	17*（1+101+511）
	--基础产量：石木铁粮每小时各500，银币300.
	--产量上限基数：石木铁粮每小时各500，银币300

	local nmax = CUserData:getResourceOut(1) --上限
	if nret < nmax then -- 不足上限
		local nbuff1,nbuff2 = CUserData:getResourceBuff(1)
--		print("nbuff1:"..nbuff1)
--		print("nbuff2:"..nbuff2)
--		print("nret:"..nret)
		nret = nret + CUserData:getResourceAddValue(1,nbuff1,nbuff2,1)
		--print("nret:"..nret)
		if nret >= nmax then
			nret = nmax

		end
	end
	--print(string.format("CUserData:getStone:%d",nret) )
	return nret
end

function CUserData:getWood()--木 拥有
	local nret = CUserData.m_nWood
	--	木材产量	18*（1+102+512）
	local nmax = CUserData:getResourceOut(2) --上限
	if nret < nmax then -- 不足上限
		local nbuff1,nbuff2 = CUserData:getResourceBuff(2)
		nret = nret + CUserData:getResourceAddValue(2,nbuff1,nbuff2,1)
		if nret >= nmax then
			nret = nmax

		end
	end
	--print(string.format("CUserData:getWood:%d",nret) )
	return nret
end

function CUserData:getIron()--铁 拥有
	local nret = CUserData.m_nIron
	--铁矿产量	19*（1+103+513）
	local nmax = CUserData:getResourceOut(3) --上限
	if nret < nmax then -- 不足上限
		local nbuff1,nbuff2 = CUserData:getResourceBuff(3)
		nret = nret + CUserData:getResourceAddValue(3,nbuff1,nbuff2,1)
		if nret >= nmax then
			nret = nmax

		end
	end
	--print(string.format("CUserData:getIron:%d",nret) )
	return nret
end

function CUserData:getFood()--粮 拥有
	local nret = CUserData.m_nFood
	--粮食产量	20*（1+104+514）
	local nmax = CUserData:getResourceOut(4) --上限
	local nadd = CUserData:getFoodAdd() --维持

	local dish = ( os.time() - self.m_nStoneTime ) / 3600 --小时
	--print(string.format("CUserData:getFood nadd :%d",nadd) )
	nadd = nadd * dish
	nadd = nadd - nadd % 1
	if nadd > 0 then			--维持大于0
		if nret < nmax then 	--存量小于上限
			nret = nret + nadd
			if nret > nmax then
				nret = nmax
			end
		end
	else--维持小于或者等于0
		nret = nret + nadd
	end
	if nret < 0 then
		nret = 0
	end
	--print(string.format("CUserData:getFood:%d",nret) )
	return nret
end

function CUserData:getSilver()--银 拥有
	local nret = CUserData.m_nSilver
	--银币产量	21*（1+105+515）
	local nmax = CUserData:getResourceOut(5) --上限
--	print("CUserData:getSilver nret:"..nret..",type:"..type(nret))
--	print("CUserData:getSilver nmax:"..nmax..",type:"..type(nmax))
	if nret < nmax then -- 不足上限
		local nbuff1,nbuff2 = CUserData:getResourceBuff(5)
		nret = nret + CUserData:getResourceAddValue(5,nbuff1,nbuff2,1)
		if nret >= nmax then
			nret = nmax

		end
	end
	--print(string.format("CUserData:getSilver:%d",nret) )
	return nret
end

function CUserData:getFuncData(nid)
	local nret = 0
	for i = 1 , #self.m_aFuncData do
		if self.m_aFuncData[i][1] == nid then
			nret = self.m_aFuncData[i][2]
			break
		end
	end
	return nret
end
function CUserData:getFoodAdd()--粮的维持(即:农庄的产量 - 士兵粮耗 )
--	local nuse = 0
--	--维持 兵营的士兵和 军队的士兵
--	local aSoldier = copytable(self.m_aSoldier )
--	local aid      = {1,2,3,4,5,6,11,12,13,14,15,16,21,22,23,24,25,201,202,203,204,205,206}
--	local nindex = 9
--	for i = 1 ,#aid do
--		local nid = aid[i]
--		local nnum= self.m_aTroop[nindex]
--		if nnum ~= nil then
--			if nnum > 0 then
--				local nfind = 0
--				for k = 1 ,#aSoldier do
--					if aSoldier[k][1] == nid then
--						aSoldier[k][1] = aSoldier[k][1] + nnum
--						nfind = 1
--						break
--					end
--				end
--				if nfind == 0 then
--					table.insert(aSoldier,{nid,nnum} )
--				end
--			end
--		end
--		nindex = nindex + 1
--	end
--
--	for i = 1 ,#aSoldier do
--		local v = aSoldier[i]
--		local aconf = CUserData:getSoldierConfigByid(v[1] )
--		if aconf ~= nil then
--			nuse = nuse + ( tonumber(aconf["F18"]) * v[2] )
--		end
--	end

	--[[
	则最终粮食小时产量＝产量－粮耗
	]]
	local nuse = CUserData.m_nFoodUpKeep   --粮耗
	local nadd = CUserData:getFoodOut()--粮产量 /h
	nadd = nadd - nuse
	return nadd
end

function CUserData:getSpecialtyOut(ntype)--特产 产量  ntype:1陶器,2皮革,3布匹,4葡萄酒
	--[[31	制陶所
		32	制皮所
		33	织布厂
		34	酿酒厂
	]]
	local abuildid = {31,32,33,34 }
	local nbuildid = abuildid[ntype]
	local nvalue = 0
	if nbuildid ~= nil then
		local abuild   = CUserData:getBuildColByid(nbuildid)

		for i = 1 ,#abuild do
			local aupconf = CUserData:getbuildingUpgConfigByid(abuild[i][2]*10000+abuild[i][3])
			nvalue = nvalue + tonumber( aupconf["F16"] )
		end
	end
	return nvalue
end
function CUserData:getSpecialtyValue(ntype)--特产 拥有 ntype:1陶器,2皮革,3布匹,4葡萄酒
	--[[特产 6001 陶器
		6002	皮革
		6003	布匹
		6004	葡萄酒
	]]
	local aitemid = {6001,6002,6003,6004 }
	local nitemid = aitemid[ntype]
	local nret = 0
	if nitemid ~= nil then
		for k = 1 ,#CUserData.m_aItem do
			if CUserData.m_aItem[k][1] == nitemid then
				nret = CUserData.m_aItem[k][2]
			end
		end
	end
	return nret
end
function CUserData:getSpecialtyUpperLimit(ntype)--特产 上限 ntype:1陶器,2皮革,3布匹,4葡萄酒
	--[[31	制陶所
		32	制皮所
		33	织布厂
		34	酿酒厂
	]]
	local abuildid = {31,32,33,34 }
	local nbuildid = abuildid[ntype]
	local nvalue = 0
	if nbuildid ~= nil then
		local abuild   = CUserData:getBuildColByid(nbuildid)

		for i = 1 ,#abuild do
			local aupconf = CUserData:getbuildingUpgConfigByid(abuild[i][2]*10000+abuild[i][3])
			nvalue = nvalue + tonumber( aupconf["F18"] )
		end
	end
	return nvalue
end

function getNumStr(num , ntype)--1 :100.1K(B,M,K ) ,2: 1,000,000,000
	return CUserData:getNumStr( num , ntype )
end

function CUserData:getNumStr( num , ntype ) --1 :100.1K(B,M,K ) ,2: 1,000,000,000
	if type(num ) == "string" then
		num = tonumber(num)
		if num == nil then
			num = 0
		end
	end

	local function lfunc_modefloat(nvalue1,nvalue2 )
		local a,b = math.modf(nvalue1)--分割成整数 和小数
		b = b * 10 * nvalue2
		local c,d = math.modf(b)--分割成整数 和小数
		local ssss = d + 0.000000009
		if ssss >= 1 then
		else
			sub = b%1
			b   = ( b - sub )/ ( 10 * nvalue2 )
			nvalue1    = a + b
		end
		return nvalue1
	end

	if ntype == 1 then--1 :100.1K(B,M,K )
		if num >= 1000000000 then	--1B=1000000000
			num = num / 1000000000
			--num = num - num % 0.1
			num = lfunc_modefloat(num,1)
			num = num .. "B"
		elseif num >= 1000000 then	--1M=1000000
			num = num / 1000000
			--num = num - num % 0.1
			num = lfunc_modefloat(num,1)
			num = num .. "M"
		elseif num >= 1000 then		--1K=1000
			num = num / 1000
			--num = num - num % 0.1
			num = lfunc_modefloat(num,1)
			num = num .. "K"
		else
			num = num - num % 1
		end
		return num
	else--2: 1,000,000,000
		local flag = true
		local afield = {}
		repeat
			local ntail = num % 1000
			num = num / 1000
			num = num - num % 1
			table.insert(afield,ntail)
			if num <= 0 then
				flag = false
			end
		until flag == false
		num = ""
		for i = #afield , 1 , -1 do
			if i == #afield then
				num = num .. afield[i]
			else
				local ntail = afield[i]
				if ntail < 10 then
					ntail = "00"..ntail
				elseif ntail < 100 then
					ntail = "0"..ntail
				end
				num = num .. "," .. ntail
			end
		end
		return num
	end
end
-- -------------------------------------
--联盟商店表返回全部
function CUserData:getAllyStoreConfigAll()
	local v = getDataForSql("config/ally_store", string.format("select * from ally_store"), nil)
	if v ~= nil and type(v) == "table" then
		return v
	end
	return v
end
--根据道具ID返回对应联盟商店列
function CUserData:getAllyStoreListByid(id,nindex)
	local v = getDataForSql("config/ally_store", string.format("select * from ally_store where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end

--根据资源ID返回对应资源列
function CUserData:getResourceListByid(id,nindex)
	local v = getDataForSql("config/resource", string.format("select * from resource where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end
--根据所有英雄配置
function CUserData:getAllHeroConfig()
	local v = getDataForSql("config/hero", string.format("select * from hero"), nil)
	return v
end
--根据英雄配置编号返回
function CUserData:getHeroConfigByid(id,nindex)
	local v = getDataForSql("config/hero", string.format("select * from hero where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end
--返回当前英雄升级列
function CUserData:getHeroUpgListByid(nindex)
	local level=CUserData.m_nHeroGrade
	local v = getDataForSql("config/hero_upg", string.format("select * from hero_upg where F0 = '%s'",level), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end
--根据英雄等级返回对应英雄升级列
function CUserData:getHeroUpgListByLevel(level)
	local v = getDataForSql("config/hero_upg", string.format("select * from hero_upg where F0 = '%s'",level), nil)
	if v ~= nil and type(v) == "table" then
		return v[1]
	end
	return v
end
--兵种表兵种编号查询返回
function CUserData:getSoldierConfigByid(id,nindex)
	local v = getDataForSql("config/soldier_upg", string.format("select * from soldier_upg where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			if nindex == 1 then
				return "assets/soldier/"..v[1]["F"..nindex]..".png"
			end
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	if nindex ~= nil then
		return ""
	else
		return v
	end
end
--联盟个人活跃度奖励配置
function CUserData:getDailyUserActivityById(nid)
	local v = getDataForSql("config/daily_user_activity_bonus", string.format("select * from daily_user_activity_bonus where F0 = '%s'",nid), nil)
	if v ~= nil and type(v) == "table" then
		return v[1]
	end
	return v
end
--联盟权限表返回全部
function CUserData:getAllyRankConfigAll()
	local v = getDataForSql("config/ally_rank", string.format("select * from ally_rank"), nil)
	if v ~= nil and type(v) == "table" then
		return v
	end
	return v
end

--联盟权限表返回全部
function CUserData:getAllyRankConfigById(id,nindex)
	local v = getDataForSql("config/ally_rank", string.format("select * from ally_rank where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end


--兵种表返回全部
function CUserData:getSoldierConfigAll()
	local v = getDataForSql("config/soldier_upg", string.format("select * from soldier_upg"), nil)
	if v ~= nil and type(v) == "table" then
		return v
	end
	return v
end
--根据装备升级码返回
function CUserData:getEquipUpgConfigAll()
	local v = getDataForSql("config/equip_upg", string.format("select * from equip_upg "), nil)
	if v ~= nil and type(v) == "table" then
		return v
	end
	v = {}
	return v
end
--根据装备升级码返回
function CUserData:getEquipUpgConfigByid(id,nindex)
	local v = getDataForSql("config/equip_upg", string.format("select * from equip_upg where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end
--返回签到奖励
function CUserData:getAllAttendanceConfig()
	local v = getDataForSql("config/daily_attendance", string.format("select * from daily_attendance "), nil)
	return v
end

--返回当前等级VIP列
function CUserData:getCurVipList()
	local p=CUserData.m_nVIPPoint
	local v = getDataForSql("config/vip", string.format("select * from vip where F1 <= '%s'",p), nil)
	if v ~= nil and type(v) == "table" then
		return v[#v]
	end
	return v
end

--返回指定等级VIP列
function CUserData:getVipListByLevel(level)
	if level == nil and CUserData.m_nVIPConfig ~= nil then
		return CUserData.m_nVIPConfig
	end
	if level==nil then
		level=CUserData.m_nVIPLevel
	elseif level==-1 then
		level=CUserData.m_nVIPLevel+1
	end
	local v = getDataForSql("config/vip", string.format("select * from vip where F0 = '%s'",level), nil)
	if v ~= nil and type(v) == "table" then
		return v[1]
	end
	return v
end
--返回free的时间上限
function CUserData:getFreeTime()
	local list=CUserData:getVipListByLevel()
	if list~=nil then
		return tonumber(list.F3)
	end
	return 0
end

--根据装备位置返回对应装备升级列
function CUserData:getEquipUpgListByid(id,level)
	if id==0 then
		return nil
	end
	local nF16 = CUserData.m_aHeroEquipType 
	if nF16 == nil then nF16 = 0 end
	if nF16 ~= 1 then nF16 = 0 end
	local l=level
	if level==nil or level==0 or level==-1 then
		l=CUserData["m_nItem"..id]
		if level~=nil and level==-1 then
			l=l+1
		end
	end
	id=id*1000+l
	local v = getDataForSql("config/equip_upg", string.format("select * from equip_upg where F0 = '%s' and F16 = '"..nF16.."'",id), nil)
	if v ~= nil and type(v) == "table" then
		return v[1]
	end
	return v
end
--返回所有技能类
function CUserData:getSkillList()
	local v = getDataForSql("config/skill", "select * from skill", nil)
	return v
end
--根据技能id返回
function CUserData:getSkillListByid(id,nindex)
	local v = getDataForSql("config/skill", string.format("select * from skill where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end
--根据技能ID返回对应技能升级列
function CUserData:getSkillUpgListByid(id,level)
	if id==0 then
		return nil
	end
	local l=level
	if level==nil or level==0 or level==-1 then
		l=CUserData:getSkillByid(id,2)
		if level~=nil and level==-1 then
			l=l+1
		end
	end
	id=id*100+l
	local v = getDataForSql("config/skill_upg", string.format("select * from skill_upg where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		return v[1]
	end
	return v
end
--返回所有科技
function CUserData:getAllTechList()
	local v = getDataForSql("config/tech", "select * from tech", nil)
	return v
end
--根据科技id返回
function CUserData:getTechListByid(id,nindex)
	local v = getDataForSql("config/tech", string.format("select * from tech where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end
--根据配置id返回事件内容
function CUserData:getSYSListByid(id,nindex)
	local v = getDataForSql("config/sys_notify", string.format("select * from sys_notify where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end
--根据功能id返回对应列或值
function CUserData:getFuncListAll()
	local v = getDataForSql("config/func_list", string.format("select * from func_list "), nil)
	if v ~= nil and type(v) == "table" then
	else
		v = {}
	end
	return v
end
--根据功能id返回对应列或值
function CUserData:getFuncListByid(id,index)
	local v = getDataForSql("config/func_list", string.format("select * from func_list where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if index == nil then
			return v[1]
		elseif v[1]["F"..index] ~= nil then
			if index == 1 and v[1]["F"..index] == "0" then
				return ""
			end
			return v[1]["F"..index]
		else
			return ""
		end
	end
	if index ~=nil then
		return ""
	end
	return v
end
--根据科技id返回对应科技升级列
function CUserData:getTechUpgListByid(id,level)
	if id==0 then
		return nil
	end
	local l=level
	if level==nil or level==0 or level==-1 then
		l=CUserData:getTechByid(id,2)
		if level~=nil and level==-1 then
			l=l+1
		end
	end
	id=id*100+l
	local v = getDataForSql("config/tech_upg", string.format("select * from tech_upg where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		return v[1],l
	end
	return v,l
end
--黑市表查询返回
function CUserData:getBlackMarketConfigByid(id,nindex)
	local v = getDataForSql("config/black_market", string.format("select * from black_market where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	if nindex ~= nil then
		return v
	else
		return ""
	end
end
--建筑表建筑编号查询返回
function CUserData:getbuildingConfigByid(id,nindex)
	local v = getDataForSql("config/building", string.format("select * from building where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			if nindex == 2 then
				return "assets/building/"..v[1]["F"..nindex]..".png"
			else
				return v[1]["F"..nindex]
			end
		else
			return ""
		end
	end
	if nindex ~= nil then
		return v
	else
		return ""
	end
end
--建筑升级表建筑升级编号(;(F0)建筑编号×10000＋等级 )查询返回
function CUserData:getbuildingUpgConfigAll()
	local v = getDataForSql("config/building_upg", string.format("select * from building_upg "), nil)
	if v ~= nil and type(v) == "table" then
	else
		v = {}
	end
	return v
end
--建筑升级表建筑升级编号(;(F0)建筑编号×10000＋等级 )查询返回
function CUserData:getbuildingUpgConfigByid(id,nindex)
	local v = getDataForSql("config/building_upg", string.format("select * from building_upg where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			if nindex == 1 then
				return "assets/building/"..v[1]["F"..nindex]..".png","assets/building/on"..v[1]["F"..nindex]..".png"
			else
				return v[1]["F"..nindex]
			end
		else
			return ""
		end
	end
	if nindex ~= nil then
		if nindex == 1 then
			return "",""
		else
			return ""
		end
	else
		return v
	end
end
--圣物表返回道具
function CUserData:getRelicConfigAll()
	local v = getDataForSql("config/relic", string.format("select * from relic "), nil)
	if v ~= nil and type(v) == "table" then
		return v
	end
	v = {}
	return v
end
--圣物表返回道具
function CUserData:getRelicConfigByid(id,nindex)
	local v = getDataForSql("config/relic", string.format("select * from relic where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end
--根据道具分类列ID和分类类型返回
--4道具标签（1特殊2资源3加速4战斗5宝箱6特产类7装备强化材料类8圣物类9宝石类）
--5道具类型（1通用加速类2行军时间缩短类3获得资源类4各种buff类5特殊类6英雄经验丹类7圣物类8宝石类
--12购买链接类型(1石，2木，3铁，4粮，5银币，6加速类，7行军时间缩短类，8战斗加成)
--注小熊猫暂定：5后台用，12前台用
function CUserData:getItemByListIDAndTypeID(listID,typeID)
	local v = getDataForSql("config/item", string.format("select * from item where F%s = '%s'",listID,typeID), nil)
	return v
end
--道具表返回道具
function CUserData:getItemConfigByid(id,nindex,ntest)--ntest 传1 ,返回 测试图片
	local v = getDataForSql("config/item", string.format("select * from item where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			if nindex == 1 then
				if ntest == 1 then
					return "assets/item/testItem.png"
				else
					return "assets/item/"..v[1]["F1"]..".png" --测试 string.format("assets/item/%d.png" , tonumber(v[1]["F"..nindex]))
				end
			end
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	if nindex ~= nil then
		return ""
	else
		return v
	end
end
--道具全部返回
function CUserData:getItemConfigAll()
	local v = getDataForSql("config/item", string.format("select * from item"), nil)
	if v ~= nil and type(v) == "table" then
		return v
	end
	v = {}
	return v
end
--建筑表建筑编号查询返回
function CUserData:getbuildingConfigAll()
	local v = getDataForSql("config/building", string.format("select * from building"), nil)
	if v ~= nil and type(v) == "table" then
		return v
	end
	return v
end
--宝石合成表返回
function CUserData:getGemComposeConfigByItem(id,nindex)
	local v = getDataForSql("config/gem_compose", string.format("select * from gem_compose where F7 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end
--宝石表返回
function CUserData:getGemConfigAll()
	local v = getDataForSql("config/gem", string.format("select * from gem "), nil)
	if v ~= nil and type(v) == "table" then
		return v
	end
	v = {}
	return v
end
--宝石表返回
function CUserData:getGemConfigByItem(id,nindex)
	local v = getDataForSql("config/gem", string.format("select * from gem where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end
--任务表返回
function CUserData:getTaskConfigByid(id,nindex)
	local v = getDataForSql("config/task_base", string.format("select * from task_base where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end
--每日任务表返回
function CUserData:getTaskDailyConfigByid(id,nindex)
	local v = getDataForSql("config/task_daily", string.format("select * from task_daily where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end
--联盟任务表返回
function CUserData:getTaskAllyConfigByid(id,nindex)
	local v = getDataForSql("config/task_ally", string.format("select * from task_ally where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end
--交易表兑换目标编号查询返回
function CUserData:getGemTradeConfigByid(id,nindex)
	local v = getDataForSql("config/gem_trade", string.format("select * from gem_trade where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end
--交易表兑换目标编号查询返回
function CUserData:getTradeConfigAll()
	local v = getDataForSql("config/trade", string.format("select * from trade"), nil)
	if v ~= nil and type(v) == "table" then
		return v
	end
	return v
end
--活动表返回
function CUserData:getActionConfigByid(id,nindex)
	local v = getDataForSql("config/activity", string.format("select * from activity where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end
--活动表返回 方尖碑
function CUserData:getActionObeliskConfigByid(id,nindex)
	local v = getDataForSql("config/obelisk", string.format("select * from obelisk where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end
--活动表返回 情人节
function CUserData:getActionEvtConfigByid(id,nindex)
	local v = getDataForSql("config/evt", string.format("select * from evt where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end
--活动目标表返回
function CUserData:getActionTargetConfigByid(id,nindex)
	local v = getDataForSql("config/act_target", string.format("select * from act_target where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end
--活动目标表返回 方尖碑
function CUserData:getActionObeliskTargetConfigByid(id,nindex)
	local v = getDataForSql("config/obelisk_target", string.format("select * from obelisk_target where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end
--活动目标表返回 情人节
function CUserData:getActionEvtTargetConfigByid(id,nindex)
	local v = getDataForSql("config/evt_target", string.format("select * from evt_target where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end
--根据活动排名返回奖励
function CUserData:getActionRankConfigByrank(rank)
	local v = getDataForSql("config/act_rank", string.format("select * from act_rank where F1 <= '%s' and F2 >= '%s'",rank), nil)
	if v ~= nil and type(v) == "table" then
		return v[1].F3
	end
	return ""
end
--根据类型返回所有活动排名
function CUserData:getActionRankConfigByType(type)
	local v = getDataForSql("config/act_rank", string.format("select * from act_rank where F0 like '%s___'",type), nil)
	return v
end
--根据类型返回所有活动排名 方尖碑
function CUserData:getActionObeliskRankConfigByType(type)
	local v = getDataForSql("config/obelisk_rank", string.format("select * from obelisk_rank where F0 like '%s___'",type), nil)
	return v
end
--根据类型返回所有活动排名 情人节
function CUserData:getActionEvtRankConfigByType(type)
	local v = getDataForSql("config/evt_rank", string.format("select * from evt_rank where F0 like '%s___'",type), nil)
	return v
end
--活动排名返回
function CUserData:getActionRankConfigByid(id,nindex)
	local v = getDataForSql("config/act_rank", string.format("select * from act_rank where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end
--服务器列表返回
function CUserData:getServerListConfigByid(id,nindex)
	local v = getDataForSql("config/server_list", string.format("select * from server_list where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end
--目标查询
function CUserData:getTaskStageByid(id)
	local v = getDataForSql("config/task_stage", string.format("select * from task_stage where F0 like '%s___'",id), nil)
	if v ~= nil and type(v) == "table" then
		return v
	end
	return v
end

--目标查询
function CUserData:getTaskStageConf(id)
	local v = getDataForSql("config/task_stage", string.format("select * from task_stage where F0 = '%d'",id), nil)
	if v ~= nil and type(v) == "table" then
		return v[1]
	end
	return v
end

--道具兑换表查询返回
function CUserData:getItemExchangeConfigAll()
	local v = getDataForSql("config/item_exchange", string.format("select * from item_exchange"), nil)
	if v ~= nil and type(v) == "table" then
		return v
	end
	return v
end
-- --------------------------------------
function newStringFormat(arg)
	return CUserData:format(arg ) 
end
function CUserData:format(arg )-- {"AAA{1}BBB{0}CCC{2}",nvalue1,nvalue2,nvalue3}
 	local ret = ""
	if #arg >= 2 then
		local str = arg[1]
		--str = string.gsub( str,"%%","%%%%")--屏蔽行列字符，这些字符出导致显示出错
		if type(str) == "string" then
			for i = 2,#arg do
				if arg[i] == nil then
					arg[i] = "***"
				end
				--print(str,string.format("{%d}",i-2) , arg[i])
				str = string.gsub(str , string.format("{%d}",i-2) , arg[i])
			end

			str = string.gsub(str  , '{%d}' , "***")
			return str
--			local tabNum = {}
--
--			local strRep=""
--			local flag = true
--			local pos = 1
--			repeat
--				local i1 = string.find(str,"{",pos)
--				local i2 = nil
--				if i1 ~= nil then
--					i2 = string.find(str,"}",i1+1 )
--					if i2 ~= nil then
--						local dis =  i2 - i1
--						if dis > 1 then--
--							local num = tonumber( string.sub(str,i1+1,i2-1) )
--							if num ~= nil then
--								table.insert(tabNum,num )
--							else
--								--continue
--							end
--						else--
--							--continue
--						end
--						strRep = strRep..string.sub(str,pos,i1-1).."%s"
--						--print("pos,i1-1",pos,(i1-1))
--						--print("strRep:"..strRep)
--						pos = i2 + 1
--					else
--						flag = false
--						--strRep = strRep..string.format(str,pos)
--					end
--				else
--					flag = false
--					--strRep = strRep..string.format(str,pos)
--				end
--				if flag == false then
--					strRep = strRep..string.sub(str,pos)
--				--	print("strRep:"..strRep)
--				end
--				--print("i1,i2,pos:",i1,i2,pos)
--
--			until flag == false
--
--			local avalue = {}
--			for i = 2 ,#arg do
--				table.insert(avalue,arg[i])
--			end
--			local aReVa = {}
--			for i = 1 , #tabNum do
--				local n = tabNum[i] + 1
--				local a1 = avalue[n]
--				if a1 ~= nil then
--					table.insert(aReVa,a1)
--				end
--			end
--			for i = 1 , #avalue do
--				local nfind = 0
--				for j = 1 , #aReVa do
--					if avalue[i] == aReVa[j] then
--						nfind = 1
--						break
--					end
--				end
--				if nfind == 0 then
--					table.insert(aReVa,avalue[i])
--				end
--			end
--			aReVa.n = #aReVa
--			--print("argFormat:"..tabletostring(aReVa) )
--			return string.format(strRep,unpack(aReVa) )
		else
			return ret
		end
	else
		return ret
	end
end

local g_time_difSrvClt = 0 --服务器和客户端的时间差值 (  服务器时间 - 客户端时间  )
function CUserData:getTimeDifSrvClt()--服务器和客户端的时间差值 (  服务器时间 - 客户端时间  )
	return g_time_difSrvClt
end
function CUserData:setTimeDifSrvClt(ndif)
	print("CUserData:setTimeDifSrvClt ndif:"..ndif)
	g_time_difSrvClt = ndif
end
function CUserData:getLeavingsTime(ntime )--ntime:参数 是时间点
	local nsrvtime = os.time() + g_time_difSrvClt
	local ret = ntime - nsrvtime
	if ret >= 0 then
		return ret
	else
		return 0
	end

end

function CUserData:getMissTime(ntime )--ntime:参数 是时间点
	local nsrvtime = os.time() + g_time_difSrvClt
	local ret = nsrvtime - ntime
	local ret = math.floor(ret/60)--转为分钟
	if ret > 0 then
		local day = math.floor(ret/(24*60))--天
		if day > 0 then
			if day > 1 then
				return string.format(CData:GetTranlang("%d天之前s"),day)
			end
			return string.format(CData:GetTranlang("%d天之前"),day)
		else
			local hour = math.floor(ret/(60))--小时
			if hour > 0 then
				if hour > 1 then
					return string.format(CData:GetTranlang("%d小时之前s"),hour)
				end
				return string.format(CData:GetTranlang("%d小时之前"),hour)
			else
				return string.format(CData:GetTranlang("%d分钟之前"),ret)
			end
		end
	else
		return string.format(CData:GetTranlang("%d分钟之前"),1)
	end

end


local heroImgs = {56103,56108,56113,56118,56123,56128,56138,56143,56148,56153,56173,56178,56188,56193,56198,56203,56208,56213,56218,56223,56228,56233,56238,56243,56253,56263,56293,56298,56303,56308,56403,56408,56413,56418,56423,56428,56433,56438,56443,56448,56453,56458,56463,56468,56473,56803,56808,56813,56704,56707}
function CUserData:getRandomHeroImg()
	return "assets/card/" .. heroImgs[math.random(1,#heroImgs)] .. ".png"
end

function CUserData:getUnionTitleImg( rank , isbig, title) --根据头衔获得联盟头衔图标
	if rank == nil or rank == 0 then
		return ""
	end
	if isbig then
		if title == nil or (rank ~=4 or (rank == 4 and title ~= 1)) then
			return string.format("assets/union/big/rank%d.png",rank)
		else
			return "assets/union/big/rank45.png"
		end
	end
	if title == nil or (rank ~=4 or (rank == 4 and title ~= 1)) then
		return string.format("assets/union/small/rank%d.png",rank)
	end
	return "assets/union/small/rank45.png"
end

function CUserData:getUnionImg( id ,isbig) --根据联盟图标编号获取图标地址
	if id == nil or id == 0 then
		return ""
	end
	if isbig then
		return string.format("assets/union/big/%d.png",id)
	end
	return string.format("assets/union/small/%d.png",id)
end

local unionTitleStr = {"会长","副会长","统帅","外交官","教官"}
function CUserData:getUnioinTitleStr(rank,title)
	if rank == nil or rank == 0 then
		rank = ""
	end
	if title ~= nil and title > 0 then
		return unionTitleStr[1 + title]
	end
	if title ~= nil and title == 0 and rank == 4 then
		if g_main_apptype == 1 then 
			return "장로"
		else 
			return "Rank4"
		end
	end
	if rank == 5 then
		return unionTitleStr[1]
	end
	if title == nil then
		return ""
	end
	if rank == 4 then
		return unionTitleStr[title + 1]
	end
	return ""
end

--解析掉落(字符串，返回图片的大/中/小)
function CUserData:getAwardTableByStr(str,iconType)
	if iconType==nil then
		iconType=3
	end
	local ret={}
	local t=string.split(str,"|")
	for i = 1 , #t do
		local t2=string.split(t[i],"^")
		local type=tonumber(t2[1])
		if type > 0 then
			if #t2 >= 3 then
				local id=t2[2]
				local num=t2[3]
				if type == 18 then 
					local nval=tonumber(id )
					if nval == nil then nval = 0 end
					
					id=math.floor(nval /10000)
					
					num=nval%10000
					
					if CUserData:getFuncListByid(id,5) == "10" then 
						num= num / 10
						num= "+" .. num .."%"
					end
				end
				local img = CUserData:setAwardImgByValue(type,id,iconType)
				local title=CUserData:getAwardNameByValue(type,id)
				table.insert(ret,{title,num,img,type})
			end
		end
	end
	return ret
end
--解析掉落字符串(返回字符串)
function CUserData:getAwardStringByStr(s , sep )
	if sep == nil then
		sep = ","
	end
	local str=""
	local t=CUserData:getAwardTableByStr(s)
	for i = 1 , #t do
		if i>1 then
			str=str..sep
		end
		str=str..t[i][1].."×"..t[i][2]
	end
	return str
end
--设置掉落数值
function CUserData:setAwardValueByStr(str)
	local t=string.split(str,"|")
	for i = 1 , #t do
		local t2=string.split(t[i],"^")
		local type=t2[1]
		local id=t2[2]
		local num=t2[3]
		CUserData:setAwardValueDetail(type,id,num)
	end
end

function CUserData:setAwardValueDetail(type,id,num)
	if type==1 or type == 13 then
		local nfind = 0
		for j = 1 , #CUserData.m_aItem do
			if CUserData.m_aItem[j][1]==id then
				CUserData.m_aItem[j][2]=num
				nfind = 1
				break
			end
		end
		if nfind == 0 and num ~= 0 then
			table.insert(CUserData.m_aItem,{id,num})
		end
		if id == 2041 then
			frame_changetext("canlotterybox")
		end
		if id == 1022 then
			frame_changetext("canlottery2box")
		end
		
	elseif type==2 then
		CUserData.m_nStone=num
		CUserData:updateResource(CUserData.m_nStone,CUserData.m_nWood,CUserData.m_nIron,CUserData.m_nFood,CUserData.m_nSilver)--更新 石料 木材  铁矿 食物 银币
	elseif type==3 then
		CUserData.m_nWood=num
		CUserData:updateResource(CUserData.m_nStone,CUserData.m_nWood,CUserData.m_nIron,CUserData.m_nFood,CUserData.m_nSilver)--更新 石料 木材  铁矿 食物 银币
	elseif type==4 then
		CUserData.m_nIron=num
		CUserData:updateResource(CUserData.m_nStone,CUserData.m_nWood,CUserData.m_nIron,CUserData.m_nFood,CUserData.m_nSilver)--更新 石料 木材  铁矿 食物 银币
	elseif type==5 then
		CUserData.m_nFood=num
		CUserData:updateResource(CUserData.m_nStone,CUserData.m_nWood,CUserData.m_nIron,CUserData.m_nFood,CUserData.m_nSilver)--更新 石料 木材  铁矿 食物 银币
	elseif type==6 then
		CUserData.m_nSilver=num
		CUserData:updateResource(CUserData.m_nStone,CUserData.m_nWood,CUserData.m_nIron,CUserData.m_nFood,CUserData.m_nSilver)--更新 石料 木材  铁矿 食物 银币
	elseif type==7 then
		--CUserData.m_nGold=num
		CUserData:updateGold(num)
	elseif type==8 then
		--个人兵种{兵种编号,士兵数量,伤兵数量}
		local exist = false
		for i = 1 , #CUserData.m_aSoldier do
			if CUserData.m_aSoldier[i][1] == id then
				CUserData.m_aSoldier[i][2]=num
				exist = true
				break
			end
		end
		if exist == false then
			table.insert(CUserData.m_aSoldier,{id,num,0})
		end
		city_TopRef()
	elseif type==9 then
--		CUserData.m_nHeroExp=num
	elseif type==10 then
		CUserData.m_nAllyPoint=num
	elseif type==11 then
		CUserData.m_nVIPPoint=num
	elseif type==12 then
		--联盟礼物不用处理，事件有通知
	elseif type == 14 then
		--联盟基金不用处理
	elseif type == 15 then
		--兵符的掉落类型是15 新增的
	elseif type == 19 then
		local nGrade = id % 1000
		local nHeroGId = math.floor(id/1000)
		guardian_set(nHeroGId,nGrade)
	end
end

function CUserData:getAwardStrByTable(arg)
	local str = ""
	for _,v in pairs(arg) do
		str = str .. v[1].."^"..v[2].."^"..v[3].."|"
	end
	return CUserData:getAwardStringByStr(str)
end

--获得掉落图片(类型，ID，大/中/小)
function CUserData:setAwardImgByValue(type,id,iconType)
	if iconType==nil then
		iconType=3
	end
	local img = ""
--1	道具
--2	石头
--3	木头
--4	铁矿
--5	粮食
--6	银币
--7	元宝
--8	兵种士兵
--9	英雄经验
--10联盟贡献点
--11VIP经验点
	if type==1 or type == 13 then
		img = CUserData:getItemConfigByid(id,1)
	elseif type==2 then
		img = "assets/images/ico"..iconType.."_stone.png"
	elseif type==3 then
		img = "assets/images/ico"..iconType.."_wood.png"
	elseif type==4 then
		img = "assets/images/ico"..iconType.."_iron.png"
	elseif type==5 then
		img = "assets/images/ico"..iconType.."_food.png"
	elseif type==6 then
		img = "assets/images/ico"..iconType.."_silver.png"
	elseif type==7 then
		img = "assets/images/ico"..iconType.."_gold.png"
	elseif type==8 then
		img = CUserData:getSoldierConfigByid(id,1)
	elseif type==9 then
		img = "assets/images/ico"..iconType.."_heroexp.png"
	elseif type==10 then
		img = "assets/images/ico"..iconType.."_allyGongxian.png"
	elseif type == 11 then
		img = "assets/images/ico"..iconType.."_vip.png"
	elseif type == 12 then
		img = "assets/uniongift/"..CUserData:getUnionGiftConfig(id,2)..".png"
	elseif type == 14 then
		img = "assets/images/ico2_allyPoint.png"
	elseif type == 15 then
		img = "assets/images/ico_bingfu.png"
	elseif type == 16 then
		img = "assets/images/activityRecharge_ico02.png"
	elseif type == 18 then
		local npic = CUserData:getFuncListByid(id,6)
		if npic == "1800117" then 
			npic = "1800516"
		end
		img = "assets/buff/" .. npic ..".png"
	elseif type == 19 then
		img = "assets/guardian/"..(math.floor(id/1000))..".png"
	end
	if img == "" then
		img = "assets/images/unknown.png"--测试
	end
	return img
end

function CUserData:getAwardNameByValue(type,id) --返回掉落的名字
	local img = ""
--	1	道具
--2	石头
--3	木头
--4	铁矿
--5	粮食
--6	银币
--7	元宝
--8	兵种士兵
--9	英雄经验
--10	联盟贡献点
--11	VIP经验点
	if type==1 or type == 13 then
		img = CData:GetTranlang(CUserData:getItemConfigByid(id,2) )
	elseif type==2 then
		img = CData:GetTranlang("石头")
	elseif type==3 then
		img = CData:GetTranlang("木头")
	elseif type==4 then
		img = CData:GetTranlang("铁矿")
	elseif type==5 then
		img = CData:GetTranlang("粮食")
	elseif type==6 then
		img = CData:GetTranlang("银币")
	elseif type==7 then
		img = CData:GetTranlang("金币")
	elseif type==8 then
		img = CData:GetTranlang( CUserData:getSoldierConfigByid(id,2) )
	elseif type==9 then
		img = CData:GetTranlang("英雄经验")
	elseif type==10 then
		img = CData:GetTranlang("联盟点数")
	elseif type == 11 then
		img = CData:GetTranlang("VIP经验点")
	elseif type == 12 then
		img = CData:GetTranlang(CUserData:getUnionGiftConfig(id,1))
	elseif type == 14 then
		img = CData:GetTranlang("联盟基金")
	elseif type == 15 then
		img = CData:GetTranlang("兵符：")
	elseif type == 16 then
		img = CData:GetTranlang("充值积分")
	elseif type == 18 then 
		img = CData:GetTranlang(CUserData:getFuncListByid(id,3))
	elseif type == 19 then 
		img = CData:GetTranlang(cfgmgr_queryValue(G_DE_CFG_GUARDIAN_LIST,id,"F4"))
	end
	return img
end

function CUserData:getBuidingupImgBypos(npos)
	--[[up img
	buidingup_GID5.png	城墙				210 * 255
	buidingup_GID12.png 竞技场			259 * 186
	buidingup_GID3.png  瞭望塔			126 * 166
	buidingup_GID27.png 民居 	默认           159 * 135
	buidingup_GID1.png  议院 			405 * 255
	
	]]
	local ainfo = CUserData:getBuildBypos(npos)
	if ainfo ~= nil then
		local ntype = ainfo[2]
		local png = ""
		if ntype == 5 then
			png = "buidingup_GID5.png"
		elseif ntype == 12 then
			png = "buidingup_GID12.png"
		elseif ntype == 3 then
			png = "buidingup_GID3.png"
		elseif ntype == 27 then
			png = "buidingup_GID27.png"
		elseif ntype == 1 then
			png = "buidingup_GID1.png"
		elseif ntype == 16 then--交易所
			png = "buidingup_GID1.png"
		else
			png = "buidingup_GID27.png"
		end
		png = "assets/images/"..png
		return png
	end
	return ""
end

function CUserData:getBuidingImgSizeBypos(npos)
	--[[up img
	buidingup_GID5.png	城墙				1082 , 1228
	buidingup_GID12.png 竞技场			259 , 186
	buidingup_GID3.png  瞭望塔			126 , 166
	buidingup_GID27.png 民居 	默认           159 , 135
	buidingup_GID1.png  议院 			405 , 255
	交易所								405 , 255
	]]
	local ainfo = CUserData:getBuildBypos(npos)
	if ainfo ~= nil then
		local ntype = ainfo[2]
		local png = ""
		if ntype == 5 then
			return 1431 , 1230--210 , 255
		elseif ntype == 12 then
			return 259 , 186
		elseif ntype == 3 then
			return 126 , 166
		elseif ntype == 27 then
			return  159 , 135
		elseif ntype == 1 then
			return 405 , 255
		elseif ntype == 16 then
			return 405 , 255
		else
			return 159,135
		end
	end
	return 159,135
end
function CUserData:getEquipImg(npos)
	local img = "assets/equip/160"..npos.."001.png" --1603001.png
	return img
end

function CUserData:getTowerArmyTypeImg(ntype)
	--[[	1：占领（资源、空地、帐篷）
	2：攻击（城池、NPC）
	3：侦查
	4：增援
	5：联盟战争
	]]
	local strimg = "assets/images/occupy.png"
	if ntype == 1 then
		strimg = "assets/images/occupy.png"
	elseif ntype == 2 then
		strimg = "assets/images/attack.png"
	elseif ntype == 3 then
		strimg = "assets/images/spy.png"
	elseif ntype == 4 then
		strimg = "assets/images/reinforce.png"
	elseif ntype == 5 then
		strimg = "assets/images/uniteAttack.png"
	elseif ntype == 11 then
		strimg = "assets/images/freight.png"
	end
	return strimg
end


function CUserData:onSetMiscInfo(arg )
	CUserData.m_aFaneItem[1] =  arg[4]
	CUserData.m_aFaneItem[2] =  arg[5]
	CUserData.m_aFaneItem[3] =  arg[6]
end

function CUserData:onKeepAlive(arg )
	--settimer(TIMER_ID_KEEPALIVE,1*60*1000,"CUserData_KeepAliveTimer",1)--心跳包、主要检查网络是否连接状态
	--CUserData:updateResource(arg[8],arg[9],arg[10],arg[11],arg[12])--石料 木材  铁矿 食物 银币	,心跳包取消了资源的带回
	CUserData_KeepAliveSet()
	city_TopRef() --每1分钟心跳包回来后,刷新一下主城 / 用于更新建筑是否可以升级的状态
end

function CUserData_KeepAliveSet()
	settimer(TIMER_ID_KEEPALIVE,1*60*1000,"CUserData_KeepAliveTimer",1)--心跳包、主要检查网络是否连接状态
end

function CUserData_KeepAliveTimer(a)
	httpsend( 1 , 0x0101 , 0 , {CUserData.m_nUserID,1,os.time()},"httpdp_revMsgLogin","httpdp_svrStatusLogin"  )
	CUserData_KeepAliveSet()
end

function CUserData:Announces(arg,num) --获取通知:{{编号，时间，内容}}
	print("**********************:",tabletostring(arg))
	local new = {}
	for _,v in pairs(arg) do
		local exist = false
		for _,w in pairs(self.m_aAnnounces) do
			if v[1] == w[1] then
				exist = true
				break
			end
		end
		if exist == false then
			table.insert(new,v)
		end
	end
	local temp = {}
	for _,v in pairs(new) do
		--如:{编号，时间,内容，标题,类型}
		if v[5] == 0 then
			local t = copytable(v)
			--t[4] = string.gsub(t[4],"id",'-$"[]/n<>%{}')
			t.content = string.gsub(t[3],"%/n","")
			--t[4] = changeInputText(t[4])
			t.num = num--播放了几次
			table.insert(temp,t)--去掉换行符
		elseif v[5] == 1 then
			noticeTip_push(v[4],(num == 0 and 1 or 10),1)
		end
		v.content = changeInputText(v[3])
		
		table.insert(self.m_aAnnounces , v)
	end
	g_city_getAnnouncess(temp)
end

function CUserData:initTaskList(arg)--基础任务列表
	CUserData.m_nTaskList = arg
	frame_changetext("m_aTaskCompImage")
end
function CUserData:updateTaskList(arg)--更新任务列表
	CUserData.m_nTaskList[2] = arg[2]
	CUserData.m_nTaskList[7] = arg[3]
	CUserData.m_nTaskList[8] = arg[4]
	CUserData.m_nTaskList[9] = arg[5]
	CUserData.m_nTaskList[10] = arg[6]
	CUserData.m_nTaskList[11] = arg[7]
	CUserData.m_nTaskList[12] = arg[13]
	CUserData.m_nTaskList[13] = arg[14]
	CUserData.m_nTaskList[14] = arg[15]
	local t=CUserData.m_nTaskList[15]
	for i=1,#t do
		if t[i][1]==arg[8] then
			t[i][2]=arg[9]
			t[i][3]=arg[10]
			t[i][4]=arg[11]
			t[i][5]=arg[12]
			break
		end
	end
	frame_changetext("m_aTaskCompImage")
	showTuijianTask()
end

function CUserData:initUnionHelp(arg)--联盟帮助
	CUserData.m_nUnionHelp = arg
end

function CUserData:updateUnionHelp(arg)
	print("updateUnionHelp:start:",tabletostring(self.m_nUnionHelp))
	if #self.m_nUnionHelp >= 12 then --server可能会在登录阶段 self.m_nUnionHelp未初始化的情况下 来了通知
		local exist = false
		for i,v in pairs(self.m_nUnionHelp[12]) do
			if v[1] == arg[3] and v[4] == arg[6] then
				if arg[2] == 0 then
					self.m_nUnionHelp[12][i] = {arg[3] , arg[4] , arg[5] , arg[6] , arg[7] , arg[8] , arg[9] , arg[10] , arg[11] ,arg[12]}
					unionHelp_refush(0,self.m_nUnionHelp[12][i])
				elseif arg[2] == 1 then
					unionHelp_refush(2,self.m_nUnionHelp[12][i])
					table.remove(self.m_nUnionHelp[12] , i)
				end
				exist = true
				break
			end
		end
		if arg[2] == 0 and exist == false then
			table.insert(self.m_nUnionHelp[12] , {arg[3] , arg[4] , arg[5] , arg[6] , arg[7] , arg[8] , arg[9] , arg[10] , arg[11] , arg[12]})
			unionHelp_refush(1,self.m_nUnionHelp[12][#self.m_nUnionHelp[12]])
		end
	end
	print("updateUnionHelp:end:",tabletostring(self.m_nUnionHelp))
	queue_refrushHelp()
end

function CUserData:getUnionHelpCount()--等待自己帮助的玩家数量
	return #self.m_nUnionHelp[12]
end

function CUserData:getUnionHelpState( type ) -- 获取建筑==1与科技==2队列有没有发送过联盟帮助
	--print("type::",type)
	--print("getUnionHelpState::",tabletostring(self.m_nUnionHelp))
	if guideNew_getMode() == 4 and type == 1 then
		return guideNew_getUnionHelpState()
	end
	if self.m_nAllyID == 0 then
		return 1
	elseif type == 1 and self.m_nUnionHelp[2] > 0 then
		local v = CUserData:getQueueBytype(type)
		if v == nil then
			return 1
		end
		local bulid = CUserData:getBuildBypos(v[4])
		if bulid then
			return 1
		end
		if bulid[2] == self.m_nUnionHelp[2] then
			return 1
		else
			--当前建筑排程与HELP记录不一致
			--说明过程有误，需要清空HELP记录
			CUserData.m_nUnionHelp[2] = 0
			CUserData.m_nUnionHelp[3] = 0
			CUserData.m_nUnionHelp[4] = 0
			CUserData.m_nUnionHelp[5] = 0
			CUserData.m_nUnionHelp[6] = 0
		end
		return 0
	elseif type == 2 and self.m_nUnionHelp[7] > 0 then
		local v = CUserData:getQueueBytype(type)
		if v == nil then
			return 1
		end
		if v[4] == self.m_nUnionHelp[7] then
			return 1
		else
			--当前科技排程与HELP记录不一致
			--说明过程有误，需要清空HELP记录
			CUserData.m_nUnionHelp[7] = 0
			CUserData.m_nUnionHelp[8] = 0
			CUserData.m_nUnionHelp[9] = 0
			CUserData.m_nUnionHelp[10] = 0
			CUserData.m_nUnionHelp[11] = 0
		end
		return 0
	end
	return 0
end

function CUserData:getRechargeConfig(id  ,nindex, t, arg)
	local v
	if t == nil then t = 1 end
	if t == 2 then
		v = getDataForSql("config/topup_holiday", string.format("select * from topup_holiday where F0 = '%s'",math.abs(id)), nil)
	elseif t == 3 then
		v = getDataForSql("config/topup_newbie", string.format("select * from topup_newbie where F0 = '%s'",math.abs(id)), nil)
	else
		if t == 4 and nindex and (nindex == 8 or nindex == 1 or nindex == 4) then
			v = getDataForSql("config/topup_activity", string.format("select * from topup_activity where F0 = '%s' and F2= '%s'",id,arg), nil)
		else
			v = getDataForSql("config/topup", string.format("select * from topup where F0 = '%s'",id), nil)
		end
	end
	if t == 4 and nindex and nindex == 8 then
		nindex = 3
	end
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end

function CUserData:getUnionGiftConfig(id , nindex)
	local v = getDataForSql("config/ally_gift", string.format("select * from ally_gift where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end

--收到留言数据
function CUserData:getUnionLeaveWord(arg , isckeckrepeat)--isckeckrepeat是否判断重复
	if CUserData.m_nUnionLeaveWords == nil then
		CUserData.m_nUnionLeaveWords = {}
	end
	local news = {}
	for _,v in pairs(arg) do
		local exist = false
		if isckeckrepeat then
			for _,w in pairs(CUserData.m_nUnionLeaveWords) do
				if v[1] == w[1] then
					exist = true
					break
				end
			end
		end
		if exist == false then
			v[11] = v[10] --记录原语言
			SocialData:setOriginalStr(string.format("6_%d",v[1]),v[9])--记录原内容
			v[9] = changeInputText(v[9])

			table.insert(news , v)
			table.insert(CUserData.m_nUnionLeaveWords , v)
			if CUserData.m_nUnionLeaveWordMinID == 0 or CUserData.m_nUnionLeaveWordMinID > v[1] then
				CUserData.m_nUnionLeaveWordMinID = v[1]
			end
		end
	end
	return news
end

--更新留言
function CUserData:UpdateUnionLeaveWord(str,lang,id)
	for _,v in pairs(CUserData.m_nUnionLeaveWords) do
		if v[1] == id then
			v[9] = changeInputText(str)
			v[10] = lang
			return v
		end
	end
	return nil
end


function CUserData:getVipLotteryConfig( vip )
	print("getVipLotteryConfig",vip)
	local v = getDataForSql("config/lottery_vip", string.format("select * from lottery_vip where F0 = '%s'",vip), nil)
	if v ~= nil and type(v) == "table" then
		return v[1]
	end
	return v
end

function CUserData:getEquipNameByPoint( point )
	local name = ""
	if point == 1 then
		name = "罗马短剑"
	elseif point == 2 then
		name = "祈福之环"
	elseif point == 3 then
		name = "罗马军盔"
	elseif point == 4 then
		name = "蓝玉戒指"
	elseif point == 5 then
		name = "钣金胸甲"
	elseif point == 6 then
		name = "军用胫甲"
	elseif point == 7 then
		name = "王者披风"
	elseif point == 8 then
		name = "狂战护肩"
	end

	return name
end

function CUserData:getSoldierNum()
	local nnum = 0
	for i = 1 ,#CUserData.m_aSoldier do
		nnum = nnum + CUserData.m_aSoldier[i][2]
	end
	return nnum
end

function CUserData:getSoldierNumByID(id)
	for _,v in pairs(CUserData.m_aSoldier) do
		if v[1] == id then
			return v[2]
		end
	end
	return 0
end

function CUserData:getSoldier(id)
	for _,v in pairs(CUserData.m_aSoldier) do
		if v[1] == id then
			return v
		end
	end
	return nil
end

--[联盟简称]玩家名称
function CUserData:getUserNameString(unionShort,userName,userID,hasServer)
	if userName==nil or userName == "" then
		return "..."
	end
	local server = ""--几服
	if userID and userID > 0 and (hasServer or getMapServiceid() == -1) then
		server = CUserData:getUserServerIDByUid(userID)
	end
	if unionShort == "" then
		if server == "" then
			return userName
		end
		return "(S"..server..")"..userName
	end
	if server == "" then
		return "["..unionShort.."]"..userName
	end
	return "(S"..server..")".."["..unionShort.."]"..userName
end

function CUserData:getUserServerIDByUid(userID)
	return math.floor((userID - 1)/1000000) + 1
end
--坐标
function CUserData:getMapPosString(x,y)
	return "(X:"..x.." Y:"..y..")"
end

function CData:GetTranlang(szText)--返回转换语言文字,(转好的文字的label Tranlang="false" )
	local tt = getlang( szText )
	if tt == nil then
	return szText
	end
	return tt
end

--兵种ID数组
soldierIDTable={1,2,3,4,5,6,11,12,13,14,15,16,21,22,23,24,25,26,201,202,203,204,0,0,301,311,321}
--兵种ID数组,含卫队的等级数据
soldierIDTableII={1,2,3,4,5,6,11,12,13,14,15,16,21,22,23,24,25,26,201,202,203,204,0,0,301,0,311,0,321,0}
--兵种ID的位置
function getSoldierIDPos(id)
	for i=1,#soldierIDTable do
		if soldierIDTable[i]==id then
			return i
		end
	end
	return 0
end

--返回建筑面积标题(建筑ID，等级-可不填)
function getBuildTitleByIDAndLevel(id,level)
	local buildName=CUserData:getbuildingConfigByid(id,1)
	--自动查找最大等级
	if level == nil then
		local ainfo = CUserData:getMaxLvBuildByid(id)
		print(tabletostring(ainfo))
		if ainfo == nil then
			level=0
		else
			level = ainfo[3]
		end
	end
	if g_main_apptype == 1 then 
		return CData:GetTranlang(buildName).." 레벨 "..level
	else 
		return CData:GetTranlang(buildName).." LV."..level
	end
end

--返回功能对应的数值(功能ID,数值)
function getEffValueByIDAndValue(id,value)
	value=tonumber(value)
	if value==0 then
		return "0"
	end
	local n=tonumber(CUserData:getFuncListByid(id,5))
	if n==0 then
		return ""
	elseif n==1 then
		if id==601 then
			return value.."s"
		else
			return value..""
		end
	else
		return "+"..(value/n).."%"
	end
end

--播放音效(音效ID，循环次数:-1为一直放)
function playSound(id,loop)
print("playSound"..id,loop)
	if loop==nil then
		loop=1
	end
	local mtype="effect"
	if loop==-1 then
		mtype="music"
	end
	local str='<mx:sound id="sound'..id..'" soundtype="'..mtype..'" source="assets/sound/'..id..'.ogg" play="true" loop="'..loop..'"/>'
	flextodiv(str,{},"main")
end
--删除音效
function delSound(id)
	delid2("main","sound"..id)
end
--获取资源图片
function getResourceIconByType(type,size)
	print("getResourceIconByType type,size:"..tabletostring({type,size}))
	if type==nil or type==0 then
		return ""
	end
	print("getResourceIconByType::",type,size)
	if type == 13 then
		return "assets/item/1306011.png"
	elseif type == 14 then
		return "assets/item/1305411.png"
	elseif type == 15 then
		return "assets/item/1305412.png"
	elseif type == 21 then
		return "assets/item/1305631.png"
	elseif type == 22 then
		return "assets/item/1305632.png"
	elseif type == 23 then
		return "assets/item/1305633.png"	
	elseif type == 24 then
		return "assets/item/1305660.png"
	elseif type == 25 then
		return "assets/item/1305831.png"	--return "assets/item/1305696.png"	
	elseif type == 26 or type == 27 or type == 28 or type == 29 then
		return "assets/item/1305521.png"--"assets/item/1305702.png" 1305835 1305521		 	
	end
	
	if size==nil then
		size=2
	end
	local str=""
	if type==1 then
		str="stone"
	elseif type==2 then
		str="wood"
	elseif type==3 then
		str="iron"
	elseif type==4 then
		str="food"
	elseif type==6 then
		str="gold"
	elseif type==11 then
		return "assets/images/ic21.png"
	elseif type==12 then
		return "assets/images/ic20.png"
	elseif type==13 then
		return "assets/images/ic13.png"
	elseif type==16 then
		return "assets/images/ic31.png"
	elseif type==17 then
		return "assets/images/ic32.png"
	elseif type==18 then
		return "assets/images/ic33.png"
	else
		str="silver"
	end
	return "assets/images/".."ico"..size.."_"..str..".png"
end



--点击效果显示
function clickEffectShow(a)
	local div=a.pBase
	div:setalpha(.3)
end
--点击效果隐藏
function clickEffectHide(a)
	local div=a.pBase
	div:setalpha(0)
end


--//-----------------------------------以下要塞-------------------------------
function CUserData:getFortressId()
	if CUserData.m_aFortress == nil then
		return 0
	end
	return CUserData.m_aFortress[1]
end

function CUserData:getFortressData(index)
	if index == nil or CUserData.m_aFortress == nil then
		return CUserData.m_aFortress
	end
	return CUserData.m_aFortress[index]
end

function CUserData:updateMyFortress(arg)
	if arg == nil then
		CUserData.m_aFortress = nil
		mapAllyBaseButtonShow()
		return
	end
	
	--兵符数量
	CUserData.m_nbingfu=arg[13]
	
	CUserData.m_nxuanzhan=arg[14]--已宣战数量
	CUserData.m_nxuanzhanbei=arg[15]--被宣战数量
	
	local type = arg[2]
	table.remove(arg,1)
	table.remove(arg,1)
	print("以下要塞-------------------",tabletostring(arg))
	if CUserData.m_aFortress == nil then
		CUserData.m_aFortress = arg
		mapAllyBaseButtonShow()
	else
		if arg[1] ~= CUserData.m_aFortress[1] then
			CUserData.m_aFortress = arg
			mapAllyBaseButtonShow()
		else
			if arg[9] ~= CUserData.m_aFortress[9] then
				--驻军上限变了
				fortresszhujun_refush()
			end
			CUserData.m_aFortress = arg
		end

	end
	if arg[1] > 0 then
		fortressMain_update()
	end
end

function CUserData:updateMyFortressTech(arg)
	table.remove(arg,1)
	if CUserData.m_aFortressTech == nil then
		CUserData.m_aFortressTech = {arg}
	else
		local exist = false
		for i,v in pairs(CUserData.m_aFortressTech) do
			if arg[1] == v[1] then
				v[2] = arg[2]
				v[3] = arg[3]
				exist = true
				break
			end
		end
		if exist == false then
			table.insert(CUserData.m_aFortressTech , arg)
		end
	end
	fortresstech_updatetech(arg)
end

--根据要塞等级返回要塞配置
function CUserData:getFortressConfigByLv(level , nindex)
	local v = getDataForSql("config/ally_base", string.format("select * from ally_base where F0 = '%s'",level), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end


--根据要塞科技编号返回配置
function CUserData:getFortressTechById(id , nindex)
	local v = getDataForSql("config/ally_tech", string.format("select * from ally_tech where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end

--根据要塞科技编号及等级返回配置
function CUserData:getFortressTechUpgById(id ,level,nindex)
	local v = getDataForSql("config/ally_tech_upg", string.format("select * from ally_tech_upg where F0 = '%s'",tonumber(id)*100 + level), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end

--返回how to play数据表
--根据科技id返回
function CUserData:getHowToPlayConfig()
	local v = getDataForSql("config/how_to_play", "select * from how_to_play", nil)
	return v
end

function getCurTime()
	return CUserData:getCurServerTime()
end

function CUserData:getCurServerTime()
	return os.time() + g_time_difSrvClt
end

--以下推图，战役
--根据编号获得推图数据
function CUserData:getBattleConfigById(id,nindex)
	local v = getDataForSql("config/city_pve", string.format("select * from city_pve where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end

--根据地图编号获得推图数据
function CUserData:getBattleConigByNo(id)
	local v = getDataForSql("config/city_pve", string.format("select * from city_pve where F0 like '%s__'",id), nil)
	return v
end

--获取地图的最大编号
function CUserData:getBattleMaxNo()
	local v = getDataForSql("config/city_pve", "select * from city_pve where F2 = '0'", nil)
	if v ~= nil and type(v) == "table" then
		return v[1]["F0"]
	end
	return v
end

--根据编号获得推图的NPC数据
function CUserData:getBattleNPCConfigById(id,nindex)
	local v = getDataForSql("config/npc_troop", string.format("select * from npc_troop where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end

--根据城池等级获取资源运送配置
function CUserData:getFreightByCityLv(lv,nindex)
	local v = getDataForSql("config/resource_help", string.format("select * from resource_help where F0 = '%s'",lv), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end

--判断id1,id2的战报伤兵是否已经购回
function CUserData:checkHasRenewSlider(id1,id2)
	if CUserData.m_renewSlider == nil then
		return true
	end
	for _,v in pairs(CUserData.m_renewSlider[3]) do
		if v[1] == id1 and v[2] == id2 then
			return true
		end
	end
	return false
end



--//------------------------------------------以下 跨服-------------------------------
function setMapServiceid(id)
	CUserData.mapServiceid = id
end

function getMapServiceid()
	return CUserData.mapServiceid
end

function CUserData:initCrossBeachHead(arg)
	if map_checkDataAvailability(arg[2]) == false then
--		return
	end
	CUserData.m_aCrossHeachHead = arg[3]
	map_controlBeachHeadBtns()
	
end

function CUserData:initCross(arg,fresh)
	if CUserData:getLeavingsTime(arg[2]) > 0 then
		--未开始
		CUserData.m_aCrossService = {0,arg[2],arg[3]}
	elseif CUserData:getLeavingsTime(arg[3]) > 0 then
		CUserData.m_aCrossService = {1,arg[2],arg[3]}
	else
		CUserData.m_aCrossService = {-1,arg[2],arg[3]}
	end 
	if fresh then
		crossService_fresh()
	end
end


--根据要塞等级返回要塞配置
function CUserData:getForGiftConfigByLv(level , nindex)
	local v = getDataForSql("config/ally_base_donate_bonus", string.format("select * from ally_base_donate_bonus where F0 = '%s'",level), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end


function CUserData:initGamTrade(arg)
	table.remove(arg,1)
	self.m_aGamTrade = arg
	market_refush()
end

function CUserData:initAllServerAction(arg)
	--格式成普通活动一致
	local temp = {}
	for _,v in pairs(arg[2]) do
		v[5] = 0
		v[6] = v[3]
		v[3] = v[4]
		v[4] = 0
		v[7] = 0
		if v[2] > 0 then
			table.insert(temp,v)
		end
	end
	self.m_aAllServerAction = temp
end

--根据要塞等级返回要塞配置
function CUserData:getKFActionRankConfigByid(level , nindex)
	local v = getDataForSql("config/kf_act_rank", string.format("select * from kf_act_rank where F0 = '%s'",level), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end

--根据类型返回所有活动排名
function CUserData:getKFActionRankConfigByType(type)
	local v = getDataForSql("config/kf_act_rank", string.format("select * from kf_act_rank where F0 like '%s___'",type), nil)
	return v
end

--活动配置返回
function CUserData:getActCycleConfigAll()
	local v = getDataForSql("config/act_cycle", string.format("select * from act_cycle"), nil)
	if v ~= nil and type(v) == "table" then
		return v
	end
	return v
end

function CUserData:initRechargeOnlyOne(arg)
	table.remove(arg,1)
	if account_getPartnerId() == 2 then--亚马逊707条目不要
		for i,v in pairs(arg[5]) do
			if v[1] == 707 then
				table.remove(arg[5],i)
				break
			end
		end
	end
	CUserData.m_aRechargeOnlyOne = arg
	rechargeOnlyOne_refush()
	city_refushOnlyOneRechargeBtn()
end

--根据称号编号获取称号配置
function CUserData:getTitleConfigByid(id , nindex)
	local v = getDataForSql("config/user_title", string.format("select * from user_title where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end
--根据称号编号获取称号配置
function CUserData:getstarChartConfigByid(id , nindex)
	local v = getDataForSql("config/star_chart", string.format("select * from star_chart where F0 = '%s'",id), nil)
	if v ~= nil and type(v) == "table" then
		if nindex == nil then
			return v[1]
		elseif v[1]["F"..nindex] ~= nil then
			return v[1]["F"..nindex]
		else
			return ""
		end
	end
	return v
end

function CUserData:onGetMySoldierTechInfo(arg)
	CUserData.m_aTechSoldier = arg[2]
end 

function CUserData_tranTotalKill(kill)
	local nval = kill
	if g_main_apptype == 0 then 
		if kill ~= nil and type(kill) == "number" then
			if kill < 0 then
				kill = kill + 0x100000000
				kill = kill + 0x1
			end
		end
	end
	print("CUserData_tranTotalKill nval:"..nval..",kill:"..kill)
	return kill
end
