--mapbubble
local g_mapbubble_list = {}
function mapbubble_clear()
	g_mapbubble_list = {}
end
function mapbubble_clearbyblock(nblock)
	local adellist = {}
	for i=1,#g_mapbubble_list do
		local v = g_mapbubble_list[i]
		if v[2]==nblock then
			table.insert(adellist,v[1][1] )
		end
	end
	for i=1,#adellist do
		for j=1,#g_mapbubble_list do
			if g_mapbubble_list[j][1][1] == adellist[i] then 
				table.remove(g_mapbubble_list,j)
				break
			end
		end
	end
	
end
function mapbubble_get(nmapid)
--	print("mapbubble_get nmapid:"..nmapid)
	local v = {}
	for i=1,#g_mapbubble_list do
		if g_mapbubble_list[i][1][1] == nmapid then 
			v = g_mapbubble_list[i][1]
			break
		end
	end
	return v
end
function mapbubble_insert(v,nblock,ntype)
	local nfind = 0
	for i=1,#g_mapbubble_list do
		if g_mapbubble_list[i][1][1] == v[1] then 
			if ntype == 0 then
				g_mapbubble_list[i][1] = v
				g_mapbubble_list[i][2] = nblock
			else 
				table.remove(g_mapbubble_list,i)
			end
			nfind = 1
			break
		end
	end
	if nfind == 0 and ntype == 0 then 
		table.insert(g_mapbubble_list,{v,nblock})
	end
end

