--activityRecharge
G_DE_ACTIVITY_RECHARGE_TYPE_DAILY = 1
G_DE_ACTIVITY_RECHARGE_TYPE_WEEKLY= 2
local _adataDaily = {}
local _adataWeekly= {}
function activityRecharge_recMsgSNTopupDaily(arg)
	print("activityRecharge_recMsgSNTopupDaily arg:"..tabletostring(arg))
	_adataDaily = arg
	
	activityRecharge_goldIcoCmp()
end
function activityRecharge_recMsgSNTopupWeekly(arg)
	print("activityRecharge_recMsgSNTopupWeekly arg:"..tabletostring(arg))
	_adataWeekly = arg
end

function activityRecharge_dailyTableSplit(v)
	local nuserId,nstart,nend,nisRechared,szgift = v[1],v[2],v[3],v[4],v[5]
	return nstart,nend,nisRechared,szgift
end

function activityRecharge_weeklyTableSplit(v)
	local nuserId,nstart,nend,ncurPoint,nparam1,nparam2,nparam3,atarget = v[1],v[2],v[3],v[4],v[5], v[6],v[7],v[8]
	return nstart,nend,ncurPoint,nparam1,nparam2,nparam3,atarget
end

function activityRecharge_getRechargeDivParam()
	local nisRechared = 0
	local szgift	  = ""
	local sztime	  = ""
	if #_adataDaily > 0 then 
		print("activityRecharge_getRechargeDivParam _adataDaily:"..tabletostring(_adataDaily))
		local nstart,nend,nisRechared_1,szgift_1 = activityRecharge_dailyTableSplit(_adataDaily)
		nisRechared = nisRechared_1
		szgift		= szgift_1 -- "1^2113^5|8^16^500" --szgift_1
		
		local nnow = CUserData:getCurServerTime()
		sztime = string.format(CData:GetTranlang("结束将于%s"),formatTime(nend - nnow ,true))
	end
	print("activityRecharge_getRechargeDivParam nisRechared,szgift:"..tabletostring({nisRechared,szgift}))
	return nisRechared,szgift,sztime
end
-- 
function activityRecharge_goldIcoCmp()
	local div = getid2("main","activityRecharge_goldIco01")
	if div ~= nil then 
		local nisRechared = 0
		if #_adataDaily > 0 then 
			local nstart,nend,nisRechared_1,szgift_1 = activityRecharge_dailyTableSplit(_adataDaily)
			nisRechared = nisRechared_1
		end
		if nisRechared == 0 then 
			div:sethidden(0)
		else
			div:sethidden(1)
		end
	end
end

function activityRecharge_rechargeCmp()
	print("activityRecharge_rechargeCmp")
	activityRecharge_rechargeDivTimer()
end
function activityRecharge_rechargeDivTimer()
	local div = getid2("main","activityRecharge_timeText")
	if div ~= nil then 
		if #_adataDaily > 0 then 
			local nstart,nend,nisRechared_1,szgift_1 = activityRecharge_dailyTableSplit(_adataDaily)
			local nnow = CUserData:getCurServerTime()
			local str = string.format(CData:GetTranlang("结束将于%s"),formatTime(nend - nnow ,true))
			
			div:changetext(str )
			settimer(TIMER_ID_ACTIVITY_RECHARGE,1*1000,"activityRecharge_rechargeDivTimer",1)
		end
	end
end
function activityRecharge_getRechargeDivStr()
	local strtemp = [[
	{
	local nisRechared,szgift,sztime = activityRecharge_getRechargeDivParam()
	local agift				 = treasure_getDivParam(szgift)
	}
	<mx:Canvas id="activityRecharge_rechargeMain" width="720" height="500" styleName="block12Cz"  mouseThrough="true" onloadcmp="activityRecharge_rechargeCmp">
		<mx:Canvas width="720" height="500"  mouseThrough="true">
			<mx:Canvas width="665" height="60"  mouseThrough="true"  x="24" y="32">
				<mx:Image source="assets/images/hotBg01.png"  mouseThrough="true"/>
				<mx:Label text="每日充值活动" fontSize="24" styleName="white01" fontFamily="Arial" x="29" y="15"  mouseThrough="true"/>
			</mx:Canvas>
			<mx:VBox>
				<mx:Label id="activityRecharge_timeText" mouseThrough="true" text="${sztime}" fontSize="24" styleName="black03" x="60" y="100"/>
				<mx:Label text="玩家每天充值任意金额可以获得以下奖励一份（每日限一次）" width="600" styleName="black03" fontSize="22" x="60" mouseThrough="true"/>
				<mx:Tile x="50" width="630" horizontalGap="0" verticalGap="0">
					{for _,w in ipairs(agift ) do}
						<mx:Canvas width="100">
							<mx:Image source="assets/images/headerBg04.png" horizontalCenter="0" mouseThrough="true"/>
							<mx:Image source="${w[3]}" width="55" height="55" y="4" horizontalCenter="0" mouseThrough="true"/>
							<mx:Label text="${w[2]}" fontSize="22" styleName="black03" width="100" y="65" textAlign="center" mouseThrough="true"/>
						</mx:Canvas>
					{end}
				</mx:Tile>
				{if nisRechared == 1 then}
					<mx:Label text="今日已经充值" x="60" fontSize="22" styleName="black03" mouseThrough="true"/>
				{else}
					<mx:Label text="今日没有充值" x="60" fontSize="22" styleName="black03" mouseThrough="true"/>
				{end}
			</mx:VBox>
				
		</mx:Canvas>
		
	</mx:Canvas>	
	]]
	return strtemp
end

function activityRecharge_actionCmp()
	activityRecharge_actionWeeklyTimer()
end
function activityRecharge_actionWeeklyTimer()
	if #_adataWeekly > 0 then 
		local nstart,nend,ncurPoint,nparam1,nparam2,nparam3,atarget = activityRecharge_weeklyTableSplit(_adataWeekly)
		local nnow = CUserData:getCurServerTime()
		local ncount = 0
		local div = getid2("main","activityRecharge_actionTimeText")
		if div ~= nil then 
			div:changetext(CData:GetTranlang("进行中:")..formatTime(nend-nnow,1) )
			ncount = ncount + 1
		end
		
		local div = getid2("main","activityRecharge_detailTimerText")
		if div ~= nil then 
			div:changetext(formatTime(nend-nnow,1) )
			ncount = ncount + 1
		end
		if ncount >  0 then 
			settimer(TIMER_ID_ACTIVITY_RECHARGE,1*1000,"activityRecharge_actionWeeklyTimer",1)
		end
	end
end
function activityRecharge_getActionListDivStr()
	local strtemp = [[
	<mx:Canvas styleName="block01Hd" width="695" mouseThrough="true" x="0" onloadcmp="activityRecharge_actionCmp">
		<mx:Image source="assets/images/activityRecharge_ico01.png" x="292" y="50" mouseThrough="true"/>
		<mx:Label fontSize="42" color="0x38230f" text="福利回馈" x="6" y="178" width="683" textAlign="center" mouseThrough="true"/>
		<mx:Label id="activityRecharge_actionTimeText" fontSize="24" styleName="red01"  text="sadfasdf" x="46" y="231" width="603" textAlign="center" mouseThrough="true"/>
		
		<mx:VBox verticalGap="5" y="280" x="9">
			<mx:Canvas styleName="bar18" width="630" x="22" mouseThrough="true">
				<mx:VBox verticalGap="0"  x="12" y="12">
					<mx:Text fontSize="22" texthtml="true" styleName="yellow01" text="每周达到相应目标充值积分可以获得相应奖励，充值积分由充值等方式获得。" width="595" mouseThrough="true"/>
					<mx:Canvas height="10"/>
				</mx:VBox>
			</mx:Canvas>
			<mx:Canvas height="30" mouseThrough="true"/>
			
			<mx:Canvas height="40" mouseThrough="true"/>
			<mx:Button label="查看详细" styleName="btn08" x="153" onclick="activityRecharge_btnClick"/>
			<mx:Canvas height="40" mouseThrough="true"/>
		</mx:VBox>
	</mx:Canvas>
	]]
	return strtemp
end
function activityRecharge_btnClick()
	print("activityRecharge_btnClick")
	activityRecharge_actionDetailShow()
end

function activityRecharge_actionDetailShow()
	local strtemp = [[
	{
	local nnum = arg[1]
	local adata= arg[2]
	local nrank= arg[3]
	}
	<mx:Canvas width="720" height="1280" id="div_treasure_id" onloadcmp="div_treasure_comp">
		<mx:Canvas width="720" height="112">
			<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
			<mx:Label id="frameTop_txt" text="详情" width="720" textAlign="center" y="35"/>
			<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" onclick="treasure_btnCloseClick"/>
		</mx:Canvas>
		<mx:Image source="assets/images/bg04.jpg" width="720" height="1168" y="111"/>
		<mx:Image source="assets/images/hd_block01.png" y="113"/>
		<mx:Label text="福利回馈" fontSize="30" styleName="white01" y="153" x="52" width="350"/>
		<mx:Label id="activityRecharge_detailTimerText" text="" fontSize="24" styleName="white01" y="223" x="52" width="271" />
		
		<mx:HBox y="155" x="474">
			<mx:Image width="30" height="30" source="assets/images/activityRecharge_ico02.png"/>
			{
			local str = string.format(CData:GetTranlang("积分:%d"),nnum)
			}
			<mx:Label text="${nnum}" y="2" fontSize="22" styleName="white01"/>
		</mx:HBox>
		
		<mx:VBox verticalGap="0" y="288" x="22" height="980">
			<mx:Canvas styleName="bar18" width="630" x="22" mouseThrough="true">
				<mx:VBox verticalGap="0"  x="12" y="12">
					<mx:Text fontSize="22" texthtml="true" styleName="yellow01" text="每周达到相应目标充值积分可以获得相应奖励，充值积分由充值等方式获得。" width="595" mouseThrough="true"/>
					<mx:Canvas height="10"/>
				</mx:VBox>
			</mx:Canvas>
			
			<mx:Canvas height="15"/>
			
			<mx:Canvas>
				<mx:Button id="pageBtn1" styleName="arr05" x="34" y="25" mouseThrough="true" visible="false" setts="-1" onclick="treasure_page"/>
				<mx:Image source="assets/images/HdTit01.png" x="111" y="16" mouseThrough="true"/>
				<mx:Label id="titletxt" text="目标奖励" fontSize="22" styleName="white01" x="193" y="28" width="297" textAlign="center" mouseThrough="true"/>
				<mx:Button id="pageBtn2" styleName="arr01" x="600" y="25" mouseThrough="true" visible="false" setts="1" onclick="treasure_page"/>
			</mx:Canvas>
			
			<mx:Canvas height="720" width="720">
				<mx:Canvas styleName="HdDetailsBlock02" height="720" width="679" mouseThrough="true">
					<mx:Label text="奖励" styleName="yellow01" fontSize="24" x="300" y="23" mouseThrough="true"/>
					
					<mx:Canvas height="625" y="72" setslidetype="1">
						<mx:VBox verticalGap="0"  x="39">
							{
							local curPoint = nnum
							
							for i = 1 , #adata do}
								{
								local needPoint = adata[i][1]
								local str 		= adata[i][2]
								local agift 	= treasure_getDivParam(str)
								if needPoint ~= nil and needPoint > 0 then 
									}
									<mx:Canvas>
										<mx:HBox horizontalGap="0" horizontalCenter="0">
											{local str = string.format(CData:GetTranlang("积分:%s"),CUserData:getNumStr(needPoint,2))}
											<mx:Label text="${str}" fontSize="22" styleName="yellow01" y="5" mouseThrough="true"/>
											{
											if needPoint > tonumber(curPoint) then}
												<mx:Image source="assets/images/ic01False2.png" y="1" mouseThrough="true"/>
											{else}
												<mx:Image source="assets/images/ic01Right.png" y="1" mouseThrough="true"/>
											{end}
										</mx:HBox>
										
										<mx:Tile width="630" horizontalGap="0" verticalGap="0" y="41">
											{for _,w in ipairs(agift ) do}
												<mx:Canvas width="100">
													<mx:Image source="assets/images/headerBg04.png" horizontalCenter="0" mouseThrough="true"/>
													<mx:Image source="${w[3]}" width="55" height="55" y="4" horizontalCenter="0" mouseThrough="true"/>
													<mx:Label text="${w[2]}" fontSize="22" styleName="white03" width="100" y="60" textAlign="center" mouseThrough="true"/>
												</mx:Canvas>
											{end}
										</mx:Tile>
										<mx:Canvas height="10"/>
										<mx:Image source="assets/images/line08.png" bottom="0" mouseThrough="true"/>
									</mx:Canvas>
									<mx:Canvas height="20"/>
								{end}
							{end}
						</mx:VBox>
					</mx:Canvas>	
				</mx:Canvas>
				
			</mx:Canvas>
		</mx:VBox>
	</mx:Canvas>
	]]
	local nnum = 0
	local adata= {}
	local nrank= 0
	if #_adataWeekly > 0 then 
		print("activityRecharge_actionDetailShow _adataWeekly:"..tabletostring(_adataWeekly)..",#_adataWeekly:"..(#_adataWeekly))
		local nstart,nend,ncurPoint,nparam1,nparam2,nparam3,atarget = activityRecharge_weeklyTableSplit(_adataWeekly)
		nnum = ncurPoint
		for _,v in pairs(atarget) do
			table.insert(adata,{v[1],v[5]})
		end
	end
--	for i=1,10 do
--		local nkey  = i 
--		local str 	= "1^2113^5|8^16^500"
--		table.insert(adata,{nkey,str})
--	end
	local arg = {nnum,adata,nrank }
	flextodiv(strtemp,arg,"frame_more",nil,nil,{3})
end

