--cfgmgr
G_DE_CFG_EVT_TREASURE_BOX_SRVR_TARGET	= 1
G_DE_CFG_EVT_TREASURE_BOX_USER_TARGET	= 2
G_DE_CFG_EVT_TREASURE_BOX_ALLY_TARGET 	= 3
G_DE_CFG_ALLY_PET = 4
G_DE_CFG_ITEM = 5
G_DE_CFG_ALLY_STORE = 6
G_DE_CFG_RUNE = 7
G_DE_CFG_FUNC_LIST = 8
G_DE_CFG_RUNE_MALL = 9
G_DE_CFG_RUNE_SET  = 10
G_DE_CFG_EVT_AVATAR = 11
G_DE_CFG_OBELISK = 12
G_DE_CFG_GODS_RELIC = 13
G_DE_CFG_GODS_RELIC_UPG = 14
G_DE_CFG_ITEM_EXCHANGE = 15
G_DE_CFG_EVT = 16
G_DE_CFG_NPC_TROOP = 17
G_DE_CFG_SOLDIER_UPG = 18
G_DE_CFG_RELIC = 19
G_DE_CFG_RESOURCE = 20
G_DE_CFG_GUARDIAN_LIST = 21
G_DE_CFG_TECH_UPG = 22

local _adata = {}
local _atab	 = {
	{"evt_treasure_box_srvr_target"},
	{"evt_treasure_box_user_target"},
	{"evt_treasure_box_ally_target"},
	{"ally_pet"},
	{"item"},
	{"ally_store"},
	{"rune"},
	{"func_list"},
	{"rune_mall"},
	{"rune_set"},
	{"evt_avatar"},
	{"obelisk"},
	{"gods_relic"},
	{"gods_relic_upg"},
	{"item_exchange"},
	{"evt"},
	{"npc_troop"},
	{"soldier_upg"},
	{"relic"},
	{"resource"},
	{"guardian"},
	{"tech_upg"},
} 	
local function _redCfg()
	_adata = {}
	for i=1,#_atab do
		local sztab = _atab[i][1]
		local arr=getDataForSql("config/"..sztab,string.format("select * from "..sztab ))
		_adata["a_"..sztab] = {}
		for _,v in pairs(arr) do			
			if v["F0"] ~= nil then 
				if sztab == "gods_relic_upg" then 
					_adata["a_"..sztab]["a"..v["F0"].."_"..v["F1"]]=v
				else
					_adata["a_"..sztab]["a"..v["F0"]]=v
				end
			end
		end
	end
end 

local function _query(nindex,nkey,nkey2)--nindex G_DE_CFG_... 
	local v = nil
	if _atab[nindex] ~= nil and _adata["a_".._atab[nindex][1] ] ~= nil then 
		if nkey2 == 0 and _adata["a_".._atab[nindex][1] ]["a"..nkey] ~= nil then 
			v = _adata["a_".._atab[nindex][1] ]["a"..nkey]
		elseif nkey2 > 0 and _adata["a_".._atab[nindex][1] ]["a"..nkey.."_"..nkey2] ~= nil then 
			v = _adata["a_".._atab[nindex][1] ]["a"..nkey.."_"..nkey2]
		end
	end
	return v 
end

function cfgmgr_query(nindex,nkey)
	return _query(nindex,nkey,0)
end

function cfgmgr_query2(nindex,nkey,nkey2)
	return _query(nindex,nkey,nkey2)
end

function cfgmgr_querylist(nindex)
	if _atab[nindex] ~= nil and _adata["a_".._atab[nindex][1] ] ~= nil then 
		return _adata["a_".._atab[nindex][1] ]
	end
	return {}
end

function cfgmgr_queryValue(nindex,nkey,szcol)
	local val = nil 
	local acfg = cfgmgr_query(nindex,nkey)
	if acfg ~= nil and acfg[szcol] ~= nil then 
		val = acfg[szcol]
	end
	return val
end

function cfgmgr_init()
	_redCfg()
end
