--feedback
local div_feedback_str = [[
	{
	local adata = arg[1]
	local atype = arg[2]
	}
	
	<mx:Canvas id="feedback_main" width="720" height="1280">
		<mx:Canvas width="720" height="112">
			<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
			<mx:Label id="frameTop_txt" text="设置" width="720" textAlign="center" y="35"/>
			<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" setts="0" onclick="feedback_btnClick"/>
		</mx:Canvas>
		
		<mx:Image source="assets/images/bg01.jpg" width="720" height="990" y="111"/>
		<mx:Image source="assets/images/feedTitle.png" y="118" x="16"/>
		<mx:Image source="assets/images/feedBlock01.png" x="120" y="233"/>
		<mx:Text y="258" width="468" fontSize="22" styleName="white03" text="感谢您对我们游戏的喜爱，这个功能的目标是希望朋友们能给我们提供一些支持.当您提供的建议和申报的问题得到处理后，我们会第一时间处理并给予您一份礼物" x="176"/>
		<mx:Image source="assets/images/feedBox.png" y="195" x="50"/>
		
		
		
		<mx:Label text="选择你要报告的类型" fontSize="30" styleName="yellow02" y="144" x="107.5" width="505" textAlign="center"/>
		<mx:Canvas width="720" height="561"  y="431" setslidetype="1">
		<mx:VBox verticalGap="10" x="50" mouseThrough="true" >
			{for i = 1, #atype do}
				{if adata[1] == i then}
					<mx:Button styleName="setReport" label="${atype[i]}" enabled="false" setts="${i}" onclick="feedback_btnTypeClick" mouseThrough="true" />
				{else}
					<mx:Button styleName="setReport" label="${atype[i]}" enabled="true" setts="${i}" onclick="feedback_btnTypeClick" mouseThrough="true" />
				{end}
			{end}
		</mx:VBox>
		</mx:Canvas>
		<mx:Image source="assets/images/bar01.png" y="1000"/>
		<mx:Button styleName="btn08" label="下一步" y="1020" x="192" setts="1" onclick="feedback_btnClick"/>
		
	</mx:Canvas>
	
]]
local g_feedback_model   = ""--手机型号
local g_feedback_release = ""--系统版本
function feedback_setModel(str)--设置手机型号
	if str == nil then str = "" end
	g_feedback_model = str
end
function feedback_setRelease(str)--设置系统版本
	if str == nil then str = "" end
	g_feedback_release = str
end
local g_feedback_typeText = {"游戏闪退","界面错乱","数据错误","数据丢失","文字错误","操作无效","其他"}
local g_feedback_arg = {
	1,--报告类别,1 游戏闪退,2 界面错乱 ,3 数据错误 ,4 数据丢失 ,5 文字错误 ,6 操作无效 ,7 其他
	"",--服务器
	"",--邮箱
	"",--手机厂商
	"",--手机型号
	"",--系统版本
	"",--描述内容
	"",--	
}
function feedback_resetArg()
	g_feedback_arg = {
		1,--报告类别,1 游戏闪退,2 界面错乱 ,3 数据错误 ,4 数据丢失 ,5 文字错误 ,6 操作无效 ,7 其他
		"",--服务器
		"",--邮箱
		"",--手机厂商
		g_feedback_model,--手机型号
		g_feedback_release,--系统版本
		"",--描述内容
		"",--	
	}
end
function feedback_getCurTypeText()
	local str = g_feedback_typeText[ g_feedback_arg[1] ]
	if str == nil then str = "游戏闪退" end
	return str
end
--数据保存
--[[slqite
1,账号id,
2,时间点,
3,预留
4,预留
5,预留
6,预留
7,预留
8,预留
9,预留
10,预留
]]
local g_feedback_cdSec = 15 * 60 --15分钟
function feedback_createTable()    --建表
	print("account_createTable")
	changeDataToSql("CREATE TABLE IF NOT EXISTS feedback (id INTEGER PRIMARY KEY,sv1 varchar(32),sv2 varchar(32),sv3 varchar(32),sv4 varchar(32),sv5 varchar(32),sv6 varchar(32),sv7 varchar(32),sv8 varchar(32),sv9 varchar(32),sv10 varchar(32) )" )
end
function feedback_setSqlite()    --记录反馈的时间点
	print("feedback_setSqlite")
	feedback_createTable()
	local nset = 0
	local vv = getDataForSql("mb6", string.format("select * from feedback where sv1 = '%s' ",account_getArg()[1])  )
	if vv ~= nil and type(vv) == "table" then
		if #vv > 0 then
			for i = 1 ,#vv do
				if vv[i]["sv1"] == account_getArg()[1] then
					changeDataToSql( string.format( "update feedback set sv2 = '%d' where sv1 = '%s';",os.time(),account_getArg()[1] ) )
					nset = 0
					break
				end
			end
		end
	end
	if nset == 0 then
		changeDataToSql( string.format( "INSERT INTO feedback VALUES(?,'%s','%d','','','','','','','','' );",account_getArg()[1],os.time() ) )
	end
end

--确认记录反馈的时间点 cd时间是否冷却
--返回冷却时间, 0 已经冷却, >0 未冷却
function feedback_checkSqliteTime()  
	print("feedback_checkSqliteTime")
	feedback_createTable()  
	print("feedback_checkSqliteTime a")
	local ntime = 0
	local vv = getDataForSql("mb6", string.format("select * from feedback where sv1 = '%s' ",account_getArg()[1])  )
	if vv ~= nil and type(vv) == "table" then
		if #vv > 0 then
--			print("feedback_checkSqliteTime vv:"..tabletostring(vv) )
--			print("feedback_checkSqliteTime account_getArg()[1]:"..account_getArg()[1] )
			for i = 1 ,#vv do
				if vv[i]["sv1"] == account_getArg()[1] then
--					print("feedback_checkSqliteTime vv[i][\"sv2\"]:"..vv[i]["sv2"])
					ntime = tonumber( vv[i]["sv2"] )
					if ntime == nil then ntime = 0 end
					break
				end
			end
		else
			print("feedback_checkSqliteTime #vv == 0 ")
		end
	else
		print("feedback_checkSqliteTime vv == nil ")
	end
--	print("feedback_checkSqliteTime ntime a:"..ntime)
--	print("feedback_checkSqliteTime ntime os.time():"..os.time())
	if ntime > 0 then
		local nvalue =  os.time() - ntime 
--		print("feedback_checkSqliteTime nvalue:"..nvalue)
		ntime = g_feedback_cdSec - nvalue
--		print("feedback_checkSqliteTime ntime b:"..ntime)
		if ntime < 0 then 
			ntime = 0
		end
	end
	print("feedback_checkSqliteTime ntime:"..ntime)
	return ntime
end


function feedback_show(nretArg)
	print("feedback_show nretArg:"..nretArg)
	if nretArg == 1 then
		feedback_resetArg()
	end
	local nnum = tonumber( g_feedback_arg[1])
	if nnum == nil then
		g_feedback_arg[1] = 1
	else
		local text = g_feedback_typeText[nnum]
		if text == nil then
			g_feedback_arg[1] = 1
		end
	end
	local arg = {g_feedback_arg,g_feedback_typeText}
	flextodiv(div_feedback_str,arg ,"frame_more",nil,nil,{5,nil,{g_dTouchX,g_dTouchY}})	
end

function feedback_btnClick(a)
	local nindex = tonumber(a.pBase:getts() )
	print("feedback_btnClick nindex:"..nindex)
	if nindex == 0 then
		deldiv("frame_more","feedback_main")
		--frame_CityOrMapBtnClick()
	elseif nindex == 1 then
		feedbackMail_show()
	end
end

function feedback_btnTypeClick(a)
	local nindex = tonumber(a.pBase:getts())
	print("feedback_btnTypeClick nindex:"..nindex)
	g_feedback_arg[1] = nindex 
	feedback_show(0)
end
-- --------------------------------------------------------------------------------------------------------------------
-- --------------------------------------------------------------------------------------------------------------------
local div_feedbackMail_str = [[
	<mx:Canvas id="feedbackMail_main" width="720" height="1280">
		<mx:Canvas width="720" height="112">
			<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
			<mx:Label id="frameTop_txt" text="设置" width="720" textAlign="center" y="35"/>
			<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" setts="0" onclick="feedbackMail_btnClick"/>
		</mx:Canvas>
		
		<mx:Image source="assets/images/bg01.jpg" width="720" height="990" y="111"/>
		<mx:Label text="填写您的邮箱" fontSize="30" styleName="green01" y="129" x="107" width="505" textAlign="center"/>
		<mx:Image source="assets/images/line01.png" y="175" x="37"/>
		<mx:Image source="assets/images/bg05Input.png" y="235" x="108"/>
		<mx:TextInput keyboardtype="7" fontSize="26"  autorow="false" height="37" id="feedbackMail_input" clickclear="true" maxchars="128" width="390" textAlign="center" styleName="white01" y="242" x="152" borderStyle="none" backgroundAlpha="0" text="请输入电子邮箱"/>
		<mx:Text fontSize="26" styleName="brown01" text="请填写正确的邮箱，以便我们能够处理结果回执给您，感谢您对我们的热爱" y="308" x="84" width="552"/>
		<mx:Image source="assets/images/bar01.png" y="1000"/>		
		<mx:Button styleName="btn08" label="下一步" y="1020" x="192" setts="1" onclick="feedbackMail_btnClick"/>
		
	</mx:Canvas>
	
]]
function feedbackMail_show()
	print("feedbackMail_show")
	local arg = {}
	flextodiv(div_feedbackMail_str,arg ,"frame_more",nil,nil,{5,nil,{g_dTouchX,g_dTouchY}})	
end

function feedbackMail_btnClick(a)
	local nindex = tonumber(a.pBase:getts() )
	print("feedbackMail_btnClick nindex:"..nindex)
	if nindex == 0 then
		deldiv("frame_more","feedbackMail_main")
	elseif nindex == 1 then
		local div = getid2("main","feedbackMail_input")
		if div ~= nil then
			local stremail = div:gettext() 
			local nindex = string.find(stremail,"@",1)	
			if nindex ~= nil  then
				g_feedback_arg[3] = stremail
				feedbackText_show()
				
			else
				showClum({"请正确输入电子邮箱",1})	
			end
		else
			showClum({"请正确输入电子邮箱",1})	
		end 
		
	end
end
-- ----------------------------------------------------------------------------------------------------------------------
-- ----------------------------------------------------------------------------------------------------------------------
local div_feedbackText_str = [[
	<mx:Canvas id="feedbackText_main" width="720" height="1280">
		<mx:Canvas width="720" height="112">
			<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
			<mx:Label id="frameTop_txt" text="设置" width="720" textAlign="center" y="35"/>
			<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" setts="0" onclick="feedbackText_btnClick"/>
		</mx:Canvas>
		
		<mx:Image source="assets/images/bg01.jpg" width="720" height="990" y="111"/>
		<mx:Label text="填写您的反馈" fontSize="30" styleName="green01" y="129" x="107" width="505" textAlign="center"/>
		<mx:Image source="assets/images/line01.png" y="175" x="37"/>
		{local str = string.format(CData:GetTranlang("报告类别：%s"), CData:GetTranlang( feedback_getCurTypeText() ) ) }
		<mx:Label text="${str}" fontSize="26" styleName="brown01" y="200" x="55"/>
		<mx:Image source="assets/images/mailBg04.png" x="34" y="253"/>
		<mx:TextInput keyboardtype="0" fontSize="26" autorow="true" id="feedbackText_input" clickclear="true" maxchars="1024" backgroundAlpha="0" fontSize="22" y="282" leading="23" text="请输入内容" width="608" x="58" styleName="brown01" height="679"/>
		<mx:Image source="assets/images/bar01.png" y="1000"/>
		<mx:Button styleName="btn08" label="下一步" y="1020" x="192" setts="1" onclick="feedbackText_btnClick"/>
		
	</mx:Canvas>
	
]]
function feedbackText_show()
	print("feedbackText_show")
	local arg = {}
	flextodiv(div_feedbackText_str,arg ,"frame_more",nil,nil,{5,nil,{g_dTouchX,g_dTouchY}}   )	
end

function feedbackText_btnClick(a)
	local nindex = tonumber(a.pBase:getts() )
	print("feedbackText_btnClick nindex:"..nindex)
	if nindex == 0 then
		deldiv("frame_more","feedbackText_main")
	elseif nindex == 1 then
		local div = getid2("main","feedbackText_input")
		if div ~= nil then
			g_feedback_arg[7] = chatlink_checkContent(div:gettext()) 
		end
		feedbackCheck_show()
	end
end
-- -------------------------------------------------------------------------------------------------------------------
-- -------------------------------------------------------------------------------------------------------------------
local div_feedbackCheck_str = [[
	{
	local afeedbackArg = arg[1]
	}
	<mx:Canvas id="feedbackCheck_main" width="720" height="1280">
		<mx:Canvas width="720" height="112">
			<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
			<mx:Label id="frameTop_txt" text="设置" width="720" textAlign="center" y="35"/>
			<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" setts="0" onclick="feedbackCheck_btnClick"/>
		</mx:Canvas>
		
		<mx:Image source="assets/images/bg01.jpg" width="720" height="990" y="111"/>
		<mx:Label text="确认反馈" fontSize="30" styleName="green01" y="129" x="107" width="505" textAlign="center"/>
		<mx:Image source="assets/images/line01.png" y="175" x="37"/>
		<mx:VBox verticalGap="20" fontSize="26" styleName="brown01" y="200" x="55">
			{local str = string.format(CData:GetTranlang("报告类别：%s"), CData:GetTranlang( feedback_getCurTypeText() ) ) }
			<mx:Label text="${str}" styleName="brown01"/>
			{local str = string.format(CData:GetTranlang("服务器：%s"), afeedbackArg[2] ) }
			<mx:Label text="${str}" styleName="brown01"/>
			{local str = string.format(CData:GetTranlang("邮箱：%s"), afeedbackArg[3] ) }
			<mx:Label text="${str}" styleName="brown01"/>
			{local str = string.format(CData:GetTranlang("手机厂商：%s"), afeedbackArg[4] ) }
			<!mx:Label text="${str}" styleName="brown01"/>
			{local str = string.format(CData:GetTranlang("手机型号：%s"), afeedbackArg[5] ) }
			<mx:Label text="${str}" styleName="brown01"/>
			{local str = string.format(CData:GetTranlang("操作系统：%s"), afeedbackArg[6] ) }
			<mx:Label text="${str}" styleName="brown01"/>
			<mx:Label text="描述内容：" styleName="brown01"/>
		</mx:VBox>
		
		<mx:Image source="assets/images/mailBg05.png" x="37" y="547"/>
		<mx:Text fontSize="22" y="576" leading="23" text="${afeedbackArg[7]}" width="608" x="61" styleName="brown01" height="358"/>
		<mx:Image source="assets/images/bar01.png" y="1000"/>
		<mx:Button id="feedbackCheck_btnSend" styleName="btn08" label="发送" y="1020" x="192" setts="1" onclick="feedbackCheck_btnClick"/>
		
	</mx:Canvas>	
]]
function feedbackCheck_show()
	print("feedbackCheck_show")
	local arg = {g_feedback_arg }
	flextodiv(div_feedbackCheck_str,arg ,"frame_more",nil,nil,{5,nil,{g_dTouchX,g_dTouchY}})	
end

function feedbackCheck_btnClick(a) 
	local nindex = tonumber(a.pBase:getts() )
	print("feedbackCheck_btnClick nindex:"..nindex)
	if nindex == 0 then
		deldiv("frame_more","feedbackCheck_main")
	elseif nindex == 1 then
		local ntime = feedback_checkSqliteTime()
		if ntime <= 0 then
			local div = getid2("main","feedbackCheck_btnSend")
			if div ~= nil then
				div:enabled("false")
			end
			btnloading_show()
			feedback_send()
		else
			--您反馈太频繁了，请稍后再试
			showClum({"您反馈太频繁了，请稍后再试",1})			
		end
	end
end
-- -----------------------------------------------------------------------------------------------------------
-- -----------------------------------------------------------------------------------------------------------
--网络请求
local g_feedback_host = "http://192.168.1.43:8080/warReport/report?"
if g_system ~= 4 then--DP_PLATFORM_WIN32
	g_feedback_host = "http://23.253.33.207:8080/warReport/report?"
end

--[[
1,--报告类别,1 游戏闪退,2 界面错乱 ,3 数据错误 ,4 数据丢失 ,5 文字错误 ,6 操作无效 ,7 其他
"",--服务器
"",--邮箱
"",--手机厂商
"",--手机型号
"",--系统版本
"",--描述内容
]]
function feedback_send()
	--验证大小,特殊字符
	local sn = account_getSN()--""
--	if g_system ~= 4 then--DP_PLATFORM_WIN32
--		sn = getplatformdeviceid() --硬件码
--		print("dipan_callback_socialtolua a")
--	else
--		sn = get_login_mac()
--		print("dipan_callback_socialtolua b")
--	end
	local str= "dipan"..sn
	print("str:"..str)
	local sc = 	getmd5(str )
	
	local arg = g_feedback_arg
	--local text= g_feedback_typeText[arg[1] ]
	--if text == nil then text = g_feedback_typeText[1] end	
	--arg[1] = text
	local reporter = "aaa"
	local server_id= 1
	local strsource = string.format("%ssn=%s&sc=%s&id=%s&reporter=%s&server_id=%d&report_type=%s&mail=%s&factory=%s&model=%s&version=%s&content=%s",
		g_feedback_host,sn,sc,account_getArg()[1],urlTran_getStr(reporter),server_id,arg[1],urlTran_getStr(arg[3]),arg[4],urlTran_getStr(arg[5]),urlTran_getStr(arg[6]),urlTran_getStr(arg[7]) )
	
	local funcback = "feedback_sendCmping"
	
	print("feedback_send strsource:"..strsource)
	--updatebacktype 0写入文件 1返回字符串
	local supdate =  [[
	{local res = arg[1]
	local funcback = arg[2]
	}
	<mx:UpdateDiv id="feedbackSend_main" onloadcmp="feedbackSend_getHttpLoadcmp"  onupdatecmping="${funcback}">
		<mx:UpdateFile source="${res}" updatebacktype="1"/>
	</mx:UpdateDiv>]]
	local arg = {strsource ,funcback}
	
	delid2("main","feedbackSend_main")--防止 替换
	
	flextodiv( supdate , arg  ,"main" )
	
	
end

function feedbackSend_getHttpLoadcmp(a)
	print("feedbackSend_getHttpLoadcmp")
	deldiv("main","feedbackSend_main") 
end

function feedback_sendCmping(id,path,size,maxsize,str )--cmp( id , 更新文件路径 , 已下载长度 ,总长度 ) 
	print("feedback_sendCmping 1")
	local div = getid2("main","feedbackCheck_btnSend")
	if div ~= nil then
		div:enabled("true")
	end
	btnloading_del()
	if str ~= nil then
		--print("account_getAccountCmping str:"..str)
		--str = "ret:0,id:20003,lastLoginTime:1388475844,serverid:1,ip:192.168.0.1,port:9999,gameKey:abcd"
		local str = string.split(str,",")
		local arg = {}
		for i = 1 ,#str do
			local num = string.split(str[i],":")
			if #num >= 2 then
				arg[num[1] ] = num[2]
			elseif #num >= 1 then
				arg[num[1] ] = ""
			end
		end
		feedback_sendBack(arg )		
	else
		print("err feedback_sendCmping str == nil ")	
		showClum({"网络不流畅，请重试",1,notfloat = true})	
	end
end

function feedback_sendBack(arg )--
	if arg["ret"] == nil then
		print("err feedback_sendBack arg[\"ret\"] == nil")
		
		--g_account_arg={"","","","","", "","","","",""}--账号清空
		--account_setsql()
		showClum({"网络不流畅，请重试",1,notfloat = true})	
	elseif tonumber(arg["ret"]) ~= 0 then
		print("err feedback_sendBack arg[\"ret\"]:"..arg["ret"] )
		local aret = {
			a0   = "成功",
			a1   = "失败",
			a10  = "硬件码空值或者验证码错误",
			a16  = "server_id错误",
		}
		local strErr = ""
		local nret = tonumber( arg["ret"] )
		if nret < 0 then
			nret = nret * -1
			strErr  = aret["a"..nret ]
			if strErr == nil then
				strErr = string.format("未知错误%d",nret)
			end
		end
		print("err feedback_sendBack arg[\"ret\"]:"..arg["ret"] )
		strErr = CData:GetTranlang("Feedback.")..CData:GetTranlang(strErr)
		--g_account_arg={"","","","","", "","","","",""}--账号清空
		--account_setsql()
		--showClum({strErr,1,{"确定"}},{account_luareset})
		showClum({strErr,1,notfloat = true})	
	else--0
		print("feedback_sendBack arg:"..tabletostring(arg ))
		
		deldiv("main","feedbackSend_main")
		
		feedback_setSqlite()
		
		showClum({"反馈信息成功",1,notfloat = true})	
		
		deldiv("frame_more","feedback_main")
		deldiv("frame_more","feedbackMail_main")
		deldiv("frame_more","feedbackText_main")
		deldiv("frame_more","feedbackCheck_main")
	end
end
