--giftRechargeAddTotal
local _adata = {}
function giftRechargeAddTotal_del()
	obj_delid("giftRechargeAddTotal_main")
end
function giftRechargeAddTotal_recMsgSNEvtSumTopup(arg)
	_adata = arg
	giftRechargeAddTotal_ref()
end

function giftRechargeAddTotal_getList()
	local alist,npoint = {},0
	if 1 == giftRechargeAddTotal_getEnabled() then 
		print("giftRechargeAddTotal_getList _adata:"..tabletostring(_adata))
		if #_adata >  0 then 
			npoint 		= _adata[4]
			alist 		= _adata[5]
		end
	end
	print("giftRechargeAddTotal_getList ret alist,npoint:"..tabletostring({alist,npoint}))
	return alist,npoint
end

function giftRechargeAddTotal_getTime()
	local ntime = 0
	if #_adata >  0 then 
		local ntimeEnd		= _adata[3]
		ntime = ntimeEnd
	end
	
	return ntime
end

function giftRechargeAddTotal_getEnabled()
	if #_adata >  0 then 
		local ntimeBegin 	= _adata[2]
		local ntimeEnd		= _adata[3]
		local npoint 		= _adata[4]
		local alist 		= _adata[5]
		local now 			= getCurTime()
		if now >= ntimeBegin and now < ntimeEnd then 
			return 1
		end
	end
	return 0
end

function giftRechargeAddTotal_getVisible()
	local szvisible = "true"
	if 0 == giftRechargeAddTotal_getEnabled() then 
		szvisible = "false"
	end
	return szvisible
end

function giftRechargeAddTotal_getItemDivParam(v)
	local npoint ,szgift = v[1],v[2]
	local arr = CUserData:getAwardTableByStr(szgift ) -- 名称，数量，图片
	local str = jdgetlang("活动期间累计充值获得{0}充值积分，可获得以下奖励：")
	
	local str2 = newStringFormat({str,getNumStr(npoint,2)})
	
	return npoint,arr,str2
end

function giftRechargeAddTotal_ref()
	local div = obj_query("giftRechargeAddTotal_main")
	if div ~= nil then 
		giftRechargeAddTotal_show()
	end
end

function giftRechargeAddTotal_Timer()
	local div = obj_query("giftRechargeAddTotal_timetext")
	if div ~= nil then 
		local ntime = giftRechargeAddTotal_getTime()
		local nnow = getCurTime()
		div:changetext(formatTime(ntime - nnow ,1))
		
		settimer(TIMER_ID_GIFT_RECHARGE_ADD_TOTAL,1000,"giftRechargeAddTotal_Timer()",1)
		
	end
end

function giftRechargeAddTotal_show()
	local strtemp = [[
	{
	local alist,ncurPoint = giftRechargeAddTotal_getList()
	}
	<mx:Canvas id="giftRechargeAddTotal_main" onloadcmp="giftRechargeAddTotal_Timer()" width="611" height="861" horizontalCenter="0" verticalCenter="0" mouseThrough="false">
		<mx:Image source="assets/images/bg02Fsb.png"/>
		
		<mx:Button styleName="btn02Close" id="closebtn" x="520" y="39" onclick="giftRechargeAddTotal_del()"/>
		<!mx:Image source="assets/images/ttl01Fsb.png" x="155" y="0"/>
		<mx:Text text="累计充值奖励" fontSize="24" color="0xeac9ae" horizontalCenter="0" y="20"/>
		
		<mx:Image source="assets/images/ic25.png" x="73" y="92"/>
		<mx:Text id="giftRechargeAddTotal_timetext" text="2d 31h 14m 15s" fontSize="30" color="0x735c3d" x="173" y="100"/>
		
		<mx:Image visible="false" source="assets/images/bar01Fsb.png" x="12" y="162"/>
		<mx:Image visible="false" source="assets/images/ic26.png" x="10" y="165"/>
		<mx:Canvas visible="false" setslidetype="1" height="40" width="500"  x="67" y="170">
			<mx:Text mouseThrough="true" text="累计充值奖励描述" width="500" fontSize="18" color="0xeac9ae"/>
		</mx:Canvas>
		
		<mx:Canvas x="20" y="${230-65}" width="575" height="100" mouseThrough="true" styleName="block23">
			<mx:HBox x="20" y="30">
				<mx:Text text="当前积分:" fontSize="20" color="0x311612" mouseThrough="true"/>
				<mx:Text text="${getNumStr(ncurPoint,2)} " fontSize="20" color="0x311612" mouseThrough="true"/>
			</mx:HBox>
			<mx:Image source="assets/images/line14.png" x="25" y="68" mouseThrough="true"/>
		</mx:Canvas>	
			
		<mx:Canvas x="20" y="${230+100-65}" setslidetype="1" width="669" height="${620-100+65}">
			<mx:VBox verticalGap="5" mouseThrough="true" verticalScrollPolicy="off">
				{for i=1,#alist do
					
					local npoint,arr,str2 = giftRechargeAddTotal_getItemDivParam(alist[i] )
					
					}
					
					<mx:Canvas width="575" minHeight="230" mouseThrough="true" styleName="block23">
						<mx:Text text="${str2}" fontSize="20" color="0x311612" x="45" y="10" width="500" mouseThrough="true"/>
						<mx:Image source="assets/images/line14.png" x="25" y="68" mouseThrough="true"/>
						
						<mx:VBox horizontalCenter="0" width="570">
							<mx:Tile width="570" horizontalGap="0" verticalGap="0" x="45" y="100">
								{for j=1,#arr do}
									<mx:Canvas width="190" height="65">
										<mx:Image source="${arr[j][3]}" width="65" height="65" mouseThrough="true"/>
										<mx:Text text="×${CUserData:getNumStr(arr[j][2] ,1)}" fontSize="24" color="0x3d1f05" x="70" verticalCenter="0" mouseThrough="true"/>
									</mx:Canvas>
								{end}
							</mx:Tile>
							<mx:Canvas width="10" height="10"/>
						</mx:VBox>
							
						{if ncurPoint >= npoint then}	
							<mx:Image source="assets/images/ic01Right.png" x="45" y="90" mouseThrough="true"/>
						{end}
					</mx:Canvas>
					
				{end}
			</mx:VBox>			
		</mx:Canvas>
	</mx:Canvas>]]
	
	local arg = {}
	flextodiv(strtemp , arg , "frame_more")
end
