--godsRelicList
G_DE_GODS_RELIC_LIIST_TYPE_CITY = 0
G_DE_GODS_RELIC_LIIST_TYPE_MAP  = 1

local _divType = 0

function godsRelicList_btn1OnClick(a)--合成
	local nid = jdtonumber(a.pBase:getts())
	godsRelicIntegrade_show(nid)
end
function godsRelicList_btn2OnClick(a)--强化
	local nid = jdtonumber(a.pBase:getts())
	godsRelicUpgrade_show(nid)
end
function godsRelicList_btn3OnClick(a)--激活
	local nid = jdtonumber(a.pBase:getts())
	
	local list = {8305,8307,8308}--众神圣物8305、8307、8308（这次新增）互斥规则：任何一个使用并未失效前，其它2个不能使用
	local nFind = 0 
	for _,v in pairs(list) do
		if v == nid then 
			nFind = 1
			break
		end
	end
	if nFind == 1 then 
		local szListName = ""
		for _,v in pairs(list) do
			if szListName ~= "" then 
				szListName = szListName .. ","
			end
			szListName = szListName .. jdgetlang( cfgmgr_queryValue(G_DE_CFG_ITEM,v,"F2") )
		end
		for _,v in pairs(list) do
			local nid2,szpic,szname,szdetail,szfunc,sztime,szvisiblIntegarade,szvisiblUpgarde,szvisiblAcitve,szvisiblTime,szactiveTime,szvisiblAcitveTime,szvisiblItem,nUsedCount,nCanCount,nitemCount = godsRelicList_getItemDivParam(v)
			--if szvisiblTime == "true" then 
			if szvisiblTime == "true" and (nCanCount-nUsedCount) > 0 then 
				showClum({newStringFormat({jdgetlang("{0}不能同时生效"),szListName}) ,1})
				return
			end
		end
	end
	
	godsRelic_Active(nid)
end

function godsRelicList_onIntegrade(nid)
	godsRelicList_refItem(nid)
end

function godsRelicList_onUpgrade(nid)
	godsRelicList_refItem(nid)
end

function godsRelicList_onActive(nid)
	godsRelicList_refItem(nid)
end

function godsRelicList_refItem(nid)
	print("godsRelicList_refItem nid:"..nid)
	local div = obj_query("godsRelicList_main")
	if div ~= nil then 
		local strtemp = [[
		{
		local v = arg[1]
		}
		]]..godsRelicList_getItemDivStr()
		
		local arg = {nid}
		flextodiv(strtemp , arg , "godsRelicList_content")
	end
end

function godsRelicList_onloadcmp()
	godsRelicList_timer()
end

function godsRelicList_timer()
	--print("godsRelicList_timer")
	local function _objSetHidden(szid,szvisible)
		if "true" == szvisible then 
			obj_sethidden(szid,0)
		else
			obj_sethidden(szid,1)
		end
	end
	
	local div = obj_query("godsRelicList_main")
	if div ~= nil then 
		local alist = godsRelicList_getDivParam()
		for _,v in pairs(alist) do
			--local nid,szpic,szname,szdetail,szfunc,sztime,szvisiblIntegarade,szvisiblUpgarde,szvisiblAcitve,szvisiblTime,szactiveTime,szvisiblAcitveTime = godsRelicList_getItemDivParam(v)
			local nid,szpic,szname,szdetail,szfunc,sztime,szvisiblIntegarade,szvisiblUpgarde,szvisiblAcitve,szvisiblTime,szactiveTime,szvisiblAcitveTime,szvisiblItem,nUsedCount,nCanCount,nitemCount = godsRelicList_getItemDivParam(v)
			--print("godsRelicList_timer nid:"..nid..",sztime,szvisiblIntegarade,szvisiblUpgarde,szvisiblAcitve,szvisiblTime:"..tabletostring({sztime,szvisiblIntegarade,szvisiblUpgarde,szvisiblAcitve,szvisiblTime})) 
			
			_objSetHidden("godsRelicList_btnIntegrade"..nid,szvisiblIntegarade)
			_objSetHidden("godsRelicList_btnUpgrade"..nid,szvisiblUpgarde)
			_objSetHidden("godsRelicList_btnActive"..nid,szvisiblAcitve)
			_objSetHidden("godsRelicList_time"..nid,szvisiblTime)
			_objSetHidden("godsRelicList_activeTime"..nid,szvisiblAcitveTime)
			
			obj_changetext("godsRelicList_timeText"..nid,sztime)
			obj_changetext("godsRelicList_activeTimeText"..nid,szactiveTime)
			
			if szvisiblTime == "true" then 
				obj_changetext("godsRelicList_leftCount_"..nid,(nCanCount-nUsedCount))
			else
				obj_changetext("godsRelicList_leftCount_"..nid,0)
			end
		end
		
		local list = {8305,8307,8308}--众神圣物8305、8307、8308（这次新增）互斥规则：任何一个使用并未失效前，其它2个不能使用
		local nFind = 0 
		for _,vv in pairs(list) do
--			local nid,szpic,szname,szdetail,szfunc,sztime,szvisiblIntegarade,szvisiblUpgarde,szvisiblAcitve,szvisiblTime,szactiveTime,szvisiblAcitveTime = godsRelicList_getItemDivParam(vv)
			local nid,szpic,szname,szdetail,szfunc,sztime,szvisiblIntegarade,szvisiblUpgarde,szvisiblAcitve,szvisiblTime,szactiveTime,szvisiblAcitveTime,szvisiblItem,nUsedCount,nCanCount,nitemCount = godsRelicList_getItemDivParam(vv)
			if szvisiblTime == "true" and (nCanCount-nUsedCount) > 0 then 
				nFind = 1
				break
			end
		end
		for _,vv in pairs(list) do
			local divBtn = getid2("main","godsRelicList_btnActive"..vv)
			if divBtn ~= nil then 
				if nFind == 1 then 
					divBtn:setenabled(0)
				else
					divBtn:setenabled(1)
				end
			end
		end
		
		settimer(TIMER_ID_GODS_RELIC_LIST,1*1000,"godsRelicList_timer",1)
	end
	
--	local div = getid2("main","godsRelicList_itemTime8305")
--	if div ~= nil then 
--		local nnow 		 = CUserData:getCurServerTime()
--		local nend       = 1518415200 --北京时间2-12 14:00
--		
--		
--		div:changetext( formatTime(nend - nnow,1) )
--	end
end

function godsRelicList_getItemDivParam(nid)
	local szpic,szname,szdetail,szfunc,ncurGrade,ncurCD,sztime,szactiveTime = "","","","",0,0,"",""
	local acfg = cfgmgr_query(G_DE_CFG_ITEM,nid)
	if acfg ~= nil then 
		szpic = "assets/item/"..jdassign(acfg["F1"],"")..".png"
		szname = jdassign(acfg["F2"],"")
		szdetail = jdassign(acfg["F3"],"")
		
	end
	
--	参数2：已用次数
--	参数3：可用次数
	local nUsedCount = 0
	local nCanCount = 0
	
	local nitemCount = 0
	local v = godsRelic_getGodsRelic(nid)
	if #v > 0 then 
		local nid,ngrade,nCD,ntechParam1,ntechParam2,ntechParam3,ntechParam4,ntempParam1,ntempParam2,ntempParam3 = godsRelic_tableSplit(v)
		ncurGrade = ngrade
		nitemCount = 1
		ncurCD = nCD
		nUsedCount = ntechParam2
		nCanCount  = ntechParam3
		
		local nnow = CUserData:getCurServerTime()
		if ntechParam3 > nnow then 
		
			szactiveTime = formatTime(ntechParam3 - nnow ,true)
		end
	end	
	local ngradeSql = ncurGrade
	if ngradeSql == 0 then 
		ngradeSql = 1
	end
	local acfg = cfgmgr_query2(G_DE_CFG_GODS_RELIC_UPG,nid,ngradeSql)
	if acfg ~= nil then 
		local nbuffId = jdtonumber(acfg["F4"])
		local nbuffVal= jdtonumber(acfg["F5"])
		if nbuffId > 0 then 
			if nid == 8311 then 
				nbuffVal= jdtonumber(acfg["F13"]) / 3600
			end
			if ncurGrade == 0 then 
				nbuffVal = 0
			end
			
--			local str,nnum = funcList_get(nbuffId,nbuffVal)
--			szfunc = str.." "..nnum
			if 8309 == nid then 
				local vvv = godsRelic_getGodsRelic(nid)
				if #vvv > 0 then 
					local vv = godsRelic_getGodsRelicDetail(nid)
					if #vv > 0 then 
						local alist = vv[2]
						for i=1,#alist do
							local nlv,npreVal,ncurVal,ntempParam1,ntempParam2,ntempParam3 = godsRelic_detailTableSplit(alist[i] )
							nbuffVal = nbuffVal + ncurVal
						end
					end
				end
			end
			
			local str,nnum,str2 = funcList_getNewParam(nbuffId,nbuffVal)
			szfunc = str2
			
			--print("godsRelicList_getItemDivParam nbuffId:" .. nbuffId.. ",nbuffVal:" .. nbuffVal .. ",ncurGrade:" .. ncurGrade)
			
			if 8302 == nid then 
				szfunc = szfunc .. " +"..chubing_getItemBuff8302()
			elseif 8303 == nid then 
				szfunc = szfunc .. " +"..( chamber_getGodsRelicBuffVal(0) / 10 ) .. "%"
			end 
		end
	end
--	nitemCount = 1
	
	local szvisiblIntegarade = "true"
	local szvisiblUpgarde 	 = "false"
	local szvisiblAcitve 	 = "false"
	local szvisiblTime 	 	= "false"
	local szvisiblAcitveTime = "false"
	local szvisiblLeftCount  = "false"
	if nitemCount > 0 then 
		szvisiblIntegarade 	 = "false"
		szvisiblUpgarde 	 = "true"
		szvisiblAcitve 	 	 = "true"
		szvisiblLeftCount  = "true"
		local nnow = CUserData:getCurServerTime()
		if ncurCD > nnow then 
			szvisiblAcitve 	 	 = "false"
			szvisiblTime 	 	 = "true"
			sztime = formatTime(ncurCD - nnow ,true)
		end
	end
	
--	sztime = "11d 00:00:00"
--	if sztime ~= "" then 
--		szvisiblAcitve 	 	 = "false"
--		szvisiblTime 	 	 = "true"
--	end
	
--	szactiveTime = "11d 00:00:00"
	if szactiveTime ~= "" then 
		szvisiblAcitveTime = "true"
	end
--	szvisiblTime 	 	 = "true"
--	sztime = "99d 99:99:99"
	
	local szvisiblItem = "true"
	if _divType == G_DE_GODS_RELIC_LIIST_TYPE_MAP then 
		if nitemCount <= 0 then 
			szvisiblItem = "false"
		end
	end
	
	if 8305 == nid then --拉克西斯的生命线
--		local nnow 		 = CUserData:getCurServerTime()
--		local nend       = 1518415200 --北京时间2-12 14:00
--		if nnow < nend then 
--			szvisiblItem = "false"
--		end
	end	
	return nid,szpic,szname,szdetail,szfunc,sztime,szvisiblIntegarade,szvisiblUpgarde,szvisiblAcitve,szvisiblTime,szactiveTime,szvisiblAcitveTime,szvisiblItem,nUsedCount,nCanCount,nitemCount
end

function godsRelicList_getItemDivStr()
	local strtemp = [[
	{
	local nid,szpic,szname,szdetail,szfunc,sztime,szvisiblIntegarade,szvisiblUpgarde,szvisiblAcitve,szvisiblTime,szactiveTime,szvisiblAcitveTime,szvisiblItem,nUsedCount,nCanCount,nitemCount = godsRelicList_getItemDivParam(v)
	}
	<mx:Canvas id="godsRelicList_item${nid}" styleName="win_bg_1" mouseThrough="true" visible="${szvisiblItem}" horizontalCenter="0" width="674" minHeight="329">
		<!mx:Image source="assets/images/godsRelicList_bg01.png" mouseThrough="true"/>
		
		<mx:Canvas x="30" y="70" width="152" height="139">
			<mx:Image source="assets/images/skillShen.png" mouseThrough="true"/>
			{if nid == 8308 then}
				<mx:Image width="105" height="105" horizontalCenter="0" verticalCenter="0" source="${szpic}" mouseThrough="true"/>
			{elseif nid == 8309 or nid == 8311 then}	
				<mx:Image width="105" height="105" horizontalCenter="0" verticalCenter="0" source="${szpic}" mouseThrough="true"/>
			{else}
				<mx:Image width="70" height="70" horizontalCenter="0" verticalCenter="0" source="${szpic}" mouseThrough="true"/>
			{end}
		</mx:Canvas>
		
		<mx:Label text="${szname}" fontSize="18" textAlign="center" y="20" width="674" mouseThrough="true"/>
		{
		local nOffsetW = 100
		}	
		<mx:VBox y="80" x="${200-20-nOffsetW}" width="${430+40+nOffsetW}">
			<mx:VBox x="${nOffsetW}" verticalGap="-1" width="${430+40}">
				<mx:Canvas styleName="text_bg_1" width="${430+40}" minHeight="100" mouseThrough="true">
					<mx:VBox x="20" y="20" verticalGap="0" width="${430+40}">
						<mx:Label text="${szdetail}" fontSize="18" width="430" mouseThrough="true"/>
						<mx:Canvas width="10" height="10" mouseThrough="true"/>
					</mx:VBox>
				</mx:Canvas>
				
				<mx:Canvas styleName="text_bg_1" width="${430+40}" minHeight="60" mouseThrough="true">
					<mx:VBox x="20" y="20" verticalGap="0" width="${430+40}">
						<mx:Label text="${szfunc}" fontSize="18" width="430" mouseThrough="true"/>
						<mx:Canvas width="10" height="10" mouseThrough="true"/>
					</mx:VBox>
				</mx:Canvas>
			</mx:VBox>
			
			<mx:HBox horizontalCenter="0">
				<mx:Button id="godsRelicList_btnIntegrade${nid}" visible="${szvisiblIntegarade}" styleName="godsRelicBtn01" label="合成" sound="assets/sound/419.ogg" setts="${nid}" onclick="godsRelicList_btn1OnClick" mouseThrough="true"/>
				<mx:Button id="godsRelicList_btnUpgrade${nid}" visible="${szvisiblUpgarde}" styleName="godsRelicBtn01" label="强化" sound="assets/sound/419.ogg" setts="${nid}" onclick="godsRelicList_btn2OnClick" mouseThrough="true"/>
				<mx:Button id="godsRelicList_btnActive${nid}" visible="${szvisiblAcitve}" styleName="godsRelicBtn01" label="激活" sound="assets/sound/419.ogg" setts="${nid}" onclick="godsRelicList_btn3OnClick" mouseThrough="true"/>
				<mx:Canvas id="godsRelicList_time${nid}" visible="${szvisiblTime}" width="200" height="60">
					<mx:HBox horizontalGap="0" y="15" horizontalCenter="0">
						<mx:Label styleName="brown01" text="CD:" fontSize="18" mouseThrough="true"/>
						<mx:Label id="godsRelicList_timeText${nid}" styleName="brown01" text="${sztime}" fontSize="18" mouseThrough="true"/>
					</mx:HBox>
				</mx:Canvas>
				<mx:Canvas id="godsRelicList_activeTime${nid}" visible="${szvisiblAcitveTime}" width="200" height="60">
					<mx:HBox horizontalGap="0" y="15" horizontalCenter="0">
						<mx:Label styleName="brown01" text="有效:" fontSize="18" mouseThrough="true"/>
						<mx:Label id="godsRelicList_activeTimeText${nid}" styleName="brown01" text="${szactiveTime}" fontSize="18" mouseThrough="true"/>
					</mx:HBox>
				</mx:Canvas>
			</mx:HBox>
			
			<mx:Canvas width="10" height="10" mouseThrough="true"/>
		</mx:VBox>
			
		{if nid == 8305 then}
			<!mx:Label id="godsRelicList_itemTime8305" text="" fontSize="18" textAlign="center" x="0" y="0" width="674" mouseThrough="true"/>
		{end}	
		{if nid == 8307 then}
			<mx:VBox visible="true" verticalGap="-5" x="0" y="215">
				<mx:HBox x="40">
					<mx:Label text="剩余次数" fontSize="18" color="0x000000" textAlign="center" mouseThrough="true"/>
					<mx:Label id="godsRelicList_leftCount_${nid}" text="${nCanCount-nUsedCount}" fontSize="18" color="0x000000" textAlign="center" mouseThrough="true"/>
				</mx:HBox>
				<!mx:HBox x="40">
					<mx:Label text="可用次数" fontSize="18" color="0x000000" textAlign="center" mouseThrough="true"/>
					<mx:Label text="${nCanCount}" fontSize="18" color="0x000000" textAlign="center" mouseThrough="true"/>
				</mx:HBox>
				<mx:Canvas width="10" height="10" mouseThrough="true"/>
				{if nitemCount > 0 then}
					<mx:Button styleName="godsRelicBtn01" label="防御" sound="assets/sound/419.ogg" x="20" onclick="armyPreset_show()" mouseThrough="true"/>
				{else}
					<mx:Button styleName="godsRelicDisableBtn01" label="防御" sound="assets/sound/419.ogg" x="20" onclick="godsRelicList_errTips()" mouseThrough="true"/>
				{end}
			</mx:VBox>
		{end}
		{if nid == 8308 then}
			<mx:VBox visible="true" verticalGap="-5" x="0" y="215">
				<mx:HBox x="40">
					<mx:Label text="剩余次数" fontSize="18" color="0x000000" textAlign="center" mouseThrough="true"/>
					<mx:Label id="godsRelicList_leftCount_${nid}" text="${nCanCount-nUsedCount}" fontSize="18" color="0x000000" textAlign="center" mouseThrough="true"/>
				</mx:HBox>
				<!mx:HBox x="40">
					<mx:Label text="可用次数" fontSize="18" color="0x000000" textAlign="center" mouseThrough="true"/>
					<mx:Label text="${nCanCount}" fontSize="18" color="0x000000" textAlign="center" mouseThrough="true"/>
				</mx:HBox>
				<mx:Canvas width="10" height="10" mouseThrough="true"/>
				{if nitemCount > 0 then}
					<!mx:Button styleName="godsRelicBtn01" label="防御" sound="assets/sound/419.ogg" x="20" onclick="armyPreset_show()" mouseThrough="true"/>
				{else}
					<!mx:Button styleName="godsRelicDisableBtn01" label="防御" sound="assets/sound/419.ogg" x="20" onclick="godsRelicList_errTips()" mouseThrough="true"/>
				{end}
			</mx:VBox>
		{end}
	</mx:Canvas>
	]]
	return strtemp
end

function godsRelicList_errTips()
	showClum({"合成圣物后可使用该功能。",1})
end

function godsRelicList_getDivParam()
	local alist = {}
	local acfg = cfgmgr_querylist(G_DE_CFG_GODS_RELIC)
	if acfg ~= nil then 
		for _,v in pairs(acfg) do
			tabmgr_insert(alist,jdtonumber(v["F0"]) )
		end
		local function _compare(a,b)
			return a < b
		end
		table.sort(alist,_compare)
	end
	
	return alist
end

function godsRelicList_btnCloseOnClick()
	deldiv("frame_more","godsRelicList_main")
end

function godsRelicList_show(ndivType)
	print("godsRelicList_show")
	_divType = ndivType
	
	local strtemp = [[
	{
	local alist = godsRelicList_getDivParam()
	}
	<mx:Canvas id="godsRelicList_main" width="720" height="1280" onloadcmp="godsRelicList_onloadcmp">
		<mx:Canvas width="720" height="112">
			<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
			<mx:Label text="众神" width="720" textAlign="center" y="35"/>
			<mx:Button styleName="btn01Back" id="fane_btnClose" x="27" y="18" setts="4" onclick="godsRelicList_btnCloseOnClick"/>
		</mx:Canvas>
		<mx:Image source="assets/images/bg03.jpg" width="720" height="1189" y="91"/>
		<mx:Image visible="false" source="assets/images/bar04.png" y="111"/>
		<mx:Canvas x="0" y="110" setslidetype="1" width="720" height="${1280-110}">
			<mx:VBox id="godsRelicList_content" horizontalCenter="0" width="674" >
				{for _,v in pairs(alist) do}
					]]..godsRelicList_getItemDivStr()..[[
				{end}
			</mx:VBox>
		</mx:Canvas>
		
		
		<mx:Image source="assets/images/ic01Christmas.png" onclick="godsRelicList_infoShow" width="60" height="60" y="10" right="10"/>
	
	</mx:Canvas>
	]]
	local arg = {}
	flextodiv(strtemp , arg , "frame_more")
end

--
function godsRelicList_detailclose()
	print("godsRelicList_detailclose")
	deldiv("main","godsRelicList_infoMain")
end

function godsRelicList_infoShow()
	local strtemp = [[
		<mx:Canvas id="godsRelicList_infoMain" width="720" height="1280" onclick="godsRelicList_detailclose">
			<mx:Canvas horizontalCenter="0" verticalCenter="0" backgroundColor="0x0" backgroundAlpha="0.8" width="600" height="500">
				<mx:Canvas horizontalCenter="0" verticalCenter="0" width="550" height="450">
					<mx:VBox>
						{for i=1,#arg do}
							<mx:Label text="${arg[i] }" width="550" mouseThrough="true" color="0xffffff" fontSize="22"/>
						{end}
					</mx:VBox>
				</mx:Canvas>
				<mx:Canvas width="100" height="100" right="0" top="0" onclick="godsRelicList_detailclose">
					<mx:Label text="X" y="0" right="0" mouseThrough="true" color="0xffffff"  fontSize="40"/>
				</mx:Canvas>
			</mx:Canvas>
			
			<mx:Button visible="false" styleName="btn01Back" id="closeBtn1" x="27" y="18" setts="2" onclick="godsRelicList_detailclose"/>
		</mx:Canvas>
	]]
	local arg = {
	"Rules：",
	"1. 众神圣物无需装备，就能使用。",
	"2. 强化以后解锁洗炼条，每升一级解锁一个。只有洗炼以后才能获得额外属性",
	"3. 每次洗炼成功会增加属性，失败会扣除一定属性。使用神圣花环，可以选择回到洗炼之前的属性。",
	"4. 强化和洗炼所需要的材料可以通过活动奖励获得",
	}	
	flextodiv(strtemp ,arg  , "frame_more")
	
end
