--提示通告
local div_noticeTip_str = [[
	{local ntype = arg[2]
	if ntype == 0 then }
	<mx:Canvas id="noticeTip_main" setts="0" width="720" height="1280" backgroundAlpha="0" systemload="1" mouseThrough="true" onloadcmp="noticeTip_onloadcmp" x="-720">
	{else}
	<mx:Canvas id="noticeTip_main" setts="1" width="720" height="1280" backgroundAlpha="0" systemload="1" mouseThrough="true" onloadcmp="noticeTip_onloadcmp" x="-720">
	{end}
		<mx:Canvas width="720" height="107" horizontalCenter="0" y="267" backgroundAlpha="0" mouseThrough="false"  onclick="noticeTip_btnClick">
			<mx:Image source="assets/images/bar26.png" backgroundAlpha="0" mouseThrough="true"/>
			<mx:Label text="${arg[1]}" fontSize="26" styleName="white01" textAlign="center" width="450" x="180" verticalCenter="0" backgroundAlpha="0" mouseThrough="true"/>
		</mx:Canvas>	
	</mx:Canvas>	
]]
local g_noticeTip_showState = 0 --空闲 ，1 忙碌
local g_noticeTip_showType  = 0 --ntype 0 ,普通提示 ,1 more 提示
function noticeTip_show(str ,ntype) --ntype 0 ,普通提示 ,1 more 提示,点击后需要跳出more界面, 不点击则不会自动消失
	if ntype == nil then ntype = 0 end
	print("announcePop_show str:"..str )
	print("announcePop_show state:"..g_noticeTip_showState )
	--界面已经存在，则 丢弃掉后加的通告
	if str ~= "" then
		local div = getid2("main","noticeTip_main")
		if div == nil or g_noticeTip_showState == 0 then
			local arg = {str ,ntype}
			flextodiv(div_noticeTip_str , arg ,"frame_top")		
			g_noticeTip_showState = 1
		else
			print("err announcePop_show div ~= nil ")
			noticeTip_showPush(str ,ntype)
		end
	end
end

function noticeTip_onloadcmp(a)
	print("noticeTip_onloadcmp")
	g_noticeTip_showType = tonumber(a.pBase:getts())
	--TIMER_ID_NOTICE_TIP_DEL
	local div = getid2("main","noticeTip_main")
	if div ~= nil then
		addaction3( {actionid="noticeTip_action",id="main",over="noticeTip_MoveToOver"
								, {id="noticeTip_main",time=0.1,tox=100 }
								, {id="noticeTip_main",time=0.2,tox=0}
								} )
	end			
end
function noticeTip_MoveToOver(a)
	print("noticeTip_MoveToOver type:"..g_noticeTip_showType)
	if g_noticeTip_showType == 0 then
		settimer(TIMER_ID_NOTICE_TIP_DEL,2*1000,"noticeTip_MoveToOver2",1)
	end
end
function noticeTip_MoveToOver2(a)
	print("noticeTip_MoveToOver2")
	local div = getid2("main","noticeTip_main")
	if div ~= nil then
		addaction3( {actionid="noticeTip_action",id="main",over="noticeTip_MoveToOver3"							
							, {id="noticeTip_main",time=0.1,toalpha=0}
							} )
	end
end
function noticeTip_MoveToOver3(a)
	print("noticeTip_MoveToOver3")
	g_noticeTip_showState = 0
	local str,ntype = noticeTip_showPop()
	if str == "" then
		print("noticeTip_MoveToOver3 delid2")
		delid2("frame_top","noticeTip_main")		
	else
		noticeTip_show(str,ntype)
	end
end

function noticeTip_btnClick(a)
	print("noticeTip_btnClick")
	if g_noticeTip_showType == 1 then
		showAnnounce()
		noticeTip_MoveToOver3()
	end
end
--通告显示队列
local g_noticeTip_showArg = {}
function noticeTip_showPush(str ,ntype) --ntype 0 ,普通提示 ,1 more 提示,
	if ntype == nil then ntype = 0 end
	print("noticeTip_showPush str:"..str)
	table.insert(g_noticeTip_showArg,{str,ntype} )
end
function noticeTip_showPop()
	local str = ""
	local ntype = 0
	if #g_noticeTip_showArg >= 1 then
		str   = g_noticeTip_showArg[1][1]
		ntype = g_noticeTip_showArg[1][2]
		table.remove(g_noticeTip_showArg,1)
	end
	print("noticeTip_showPop arg total:"..(#g_noticeTip_showArg ))
	print("noticeTip_showPop ret str:"..str)
	return str,ntype
end

--定时数据部分
local g_noticeTip_index = 0
local g_noticeTip_arg   = {}--nindex,str,nsec,ntype
function noticeTip_getIndex()
	g_noticeTip_index = g_noticeTip_index + 1
	return g_noticeTip_index
end

function noticeTip_push(str,nsec,ntype) --ntype 0 ,普通提示 ,1 more 提示,
	if ntype == nil then ntype = 0 end
	--print(string.format("noticeTip_push %s,%d",str,nsec ) )
	if str ~= "" and nsec > 0 then
		local ncurIndex = 0
		for i = 1 ,#g_noticeTip_arg do
			local v = g_noticeTip_arg[i]
			if v[2] == str then
				ncurIndex = v[1]
				v[3]      = nsec
				break
			end
		end
		if ncurIndex == 0 then
			ncurIndex = noticeTip_getIndex()
			table.insert(g_noticeTip_arg,{ncurIndex,str,nsec,ntype} )
		end
		
		settimer(TIMER_ID_NOTICE_TIP + ncurIndex,nsec*1000,"noticeTip_timer",1)
	else
		--print(string.format("err noticeTip_push %s,%d",str,nsec ) )
	end
end

function noticeTip_timer(a)
	print("noticeTip_timer=================================================")
	local nseqno =  a.nSeqno
	nseqno = nseqno % TIMER_ID_NOTICE_TIP
	local ainfo = nil	
	for i = 1 ,#g_noticeTip_arg do
		local v = g_noticeTip_arg[i]
		if v[1] == nseqno then
			ainfo = copytable( v)
			table.remove(g_noticeTip_arg,i)
			break
		end
	end
	if ainfo ~= nil then
		noticeTip_show(ainfo[2],ainfo[4] )
	end
end

function noticeTip_pushActionList(arg )
	local actionList = copytable(arg )
	local ncurtime = CUserData:getCurServerTime() --os.time()
	for i=1,#actionList do
		local targetID=actionList[i][4]		
		if targetID>0 then
			local list2=CUserData:getActionTargetConfigByid(targetID)
			if list2~=nil then
				--通告提示 
				local aActionConfig = CUserData:getActionConfigByid(actionList[i][2] )
				if aActionConfig ~= nil then
					local nend   = actionList[i][3]
					local nbegin = actionList[i][6]
					if nbegin < ncurtime then--活动开始提示、15 10 5
						local nsec1 = nbegin - ncurtime - 15 * 60
						local nsec2 = nbegin - ncurtime - 10 * 60
						local nsec3 = nbegin - ncurtime -  5 * 60
						local str1  = string.format(CData:GetTranlang("%s活动15分钟之后开启。"),CData:GetTranlang(aActionConfig["F1"]) )
						local str2  = string.format(CData:GetTranlang("%s活动10分钟之后开启。"),CData:GetTranlang(aActionConfig["F1"]) )
						local str3  = string.format(CData:GetTranlang("%s活动5分钟之后开启。"),CData:GetTranlang(aActionConfig["F1"])  )
						noticeTip_push(str1,nsec1)
						noticeTip_push(str2,nsec2)
						noticeTip_push(str3,nsec3)
					else--活动结束提示 15 10 5
						local nsec1 = nend - ncurtime - 15 * 60
						local nsec2 = nend - ncurtime - 10 * 60
						local nsec3 = nend - ncurtime -  5 * 60
						local str1  = string.format(CData:GetTranlang("%s活动15分钟之后关闭。"),CData:GetTranlang(aActionConfig["F1"]) )
						local str2  = string.format(CData:GetTranlang("%s活动10分钟之后关闭。"),CData:GetTranlang(aActionConfig["F1"]) )
						local str3  = string.format(CData:GetTranlang("%s活动5分钟之后关闭。"),CData:GetTranlang(aActionConfig["F1"])  )
						noticeTip_push(str1,nsec1)
						noticeTip_push(str2,nsec2)
						noticeTip_push(str3,nsec3)					
					end
				end
			end
		end
	end
end
