--签到
local str = [[
<mx:Canvas id="qiandaodiv" width="720" height="1280" backgroundColor="0x000000" backgroundAlpha="0" mouseEnabled="false" systemload="1">
<mx:Canvas horizontalCenter="0" verticalCenter="0">
	<mx:Image source="assets/images/qiandaoBG.png"/>
	<mx:Button styleName="btn02Close" id="qiandaoBtn" sound="assets/sound/414.ogg" right="20" y="16" onclick="qiandaoClose_btnClick"/>
	<mx:Canvas x="50" y="40" width="560" onslideleft="qiandaoLeft_btnClick" onslideright="qiandaoRight_btnClick" slidewith="50">
	<mx:HBox id="qiandaoItemList" x="${-(arg.curID-2)*(162+40)}" mouseThrough="true" horizontalGap="40" horizontalScrollPolicy="off">
		{for i = 1 , #arg do}
		{if i==arg.curID then}
		<mx:Canvas id="qiandaoItem${arg[i].day}" scale="1.2">
		{else}
		<mx:Canvas id="qiandaoItem${arg[i].day}" scale=".8">
		{end}
			<mx:Image source="assets/images/qiandaoDay.png" mouseThrough="true"/>
			<mx:Label fontSize="28" styleName="black01" text="${arg[i].dayMSG}" x="0" y="20" width="162" textAlign="center" mouseThrough="true"/>
		</mx:Canvas>
		{end}
	</mx:HBox>
	</mx:Canvas>
	<mx:Canvas x="60" y="250">
		<mx:Image source="assets/images/qiandaoAwardBG.png"/>
		{local str = ""
		if arg.curDay == 1 or arg.curDay == 2 or arg.curDay == 3 then
			str = string.format("第%d天的奖励",arg.curDay) --第1,2,3 天 , 先组织好再翻译
		else
			str = string.format(CData:GetTranlang("第%d天的奖励"),arg.curDay)--第4天及大于第4天的,可以一起翻译掉
		end}
		<mx:Label fontSize="24" styleName="white01" text="${str}" width="540" textAlign="center"/>
		<mx:Canvas x="18" y="50" height="200" setslidetype="1">
			<mx:VBox>
			{for j = 1 , #arg[arg.curID] do}
			<mx:Canvas>
				<mx:Image source="assets/images/headerBg04.png" x="10" y="3" mouseThrough="true"/>
				<mx:Image source="${arg[arg.curID][j][3]}" x="14" y="7" width="55" height="55" mouseThrough="true"/>
				<mx:Label text="×${arg[arg.curID][j][2]}" fontSize="28" styleName="white03" x="400" y="20" mouseThrough="true"/>
				<mx:Image source="assets/images/line08.png" y="70" width="500" mouseThrough="true"/>
			</mx:Canvas>
			{end}
			</mx:VBox>
		</mx:Canvas>
	</mx:Canvas>
	<mx:Canvas x="60" y="550">
		<mx:Image source="assets/images/qiandaoAwardBG.png"/>
		<mx:Label fontSize="24" styleName="white01" text="今天的奖励" width="540" textAlign="center"/>
		<mx:Canvas x="18" y="50" height="200" setslidetype="1">
			<mx:VBox>
			{for j = 1 , #arg[arg.todayID] do}
			<mx:Canvas>
				<mx:Image source="assets/images/headerBg04.png" x="10" y="3" mouseThrough="true"/>
				<mx:Image source="${arg[arg.todayID][j][3]}" x="14" y="7" width="55" height="55" mouseThrough="true"/>
				<mx:Label text="×${arg[arg.todayID][j][2]}" fontSize="28" styleName="white03" x="400" y="20" mouseThrough="true"/>
				<mx:Image source="assets/images/line08.png" y="70" width="500" mouseThrough="true"/>
			</mx:Canvas>
			{end}
			</mx:VBox>
		</mx:Canvas>
		<mx:Button label="领取" enabled="${arg.canGetAward}" styleName="btn03" x="150" y="270" width="240"  sound="assets/sound/407.ogg" onclick="qiandaoGetAward_btnClick"/>
	</mx:Canvas>
</mx:Canvas>
</mx:Canvas>
]]

local titleMSG={"1st","2nd","3rd","4th","5th","6th","7th","10th","15th"}
local dayTable={1,2,3,4,5,6,7,10,15}

local function getNextID(n)
	if n==#dayTable then
		return n
	else
		return n+1
	end
end
local function getPrevID(n)
	if n==1 then
		return n
	else
		return n-1
	end
end
local function getCurID(n)
	for i = #dayTable , 1 , -1 do
		if dayTable[i]<=n then
			return i
		end
	end
	return 0
end
local function canGetAward()
	for i = 1 , #dayTable do
		if dayTable[i]==CUserData.nGameAge then
			return true
		end
	end
	return false
end
function qiandaoClose_btnClick()
	deldiv("frame_more","qiandaodiv")
end

local isMoving=false
local curDay=0
local curIndex=0
function qiandaoShow()
	if 1 == 1 then
		loginGift_show()
		return
	end
	isMoving=false
	local arg={}
	arg.todayID=getCurID(CUserData.nGameAge)
	if curIndex==0 then
		curIndex=getNextID(arg.todayID)
		curDay=dayTable[curIndex]
	end
	local tb=CUserData:getAllAttendanceConfig()
	for i = 1 , #tb do
		local a=CUserData:getAwardTableByStr(tb[i].F1)
		a.day=tonumber(tb[i].F0)
		a.dayMSG=titleMSG[i]
		table.insert(arg,a)
	end
	if canGetAward() and CUserData.nGameAge ~= CUserData.nAttendancedDay then
		arg.canGetAward=1
	else
		arg.canGetAward=0
	end
	arg.curID=curIndex
	arg.curDay=curDay
	flextodiv(str,arg,"frame_more",nil,nil,{5,nil,{360,640}})
end

function qiandaoLeft_btnClick(arg)
	if curDay<15 and isMoving==false then
		isMoving=true
		local div=nil
		if curDay~=0 then
			div=getid2("qiandaodiv","qiandaoItem"..curDay)
			addaction( div , DE_ACTION_ANISALCE , .5 , .8)
		end
		curIndex=getNextID(curIndex)
		curDay=dayTable[curIndex]
		div=getid2("qiandaodiv","qiandaoItem"..curDay)
		addaction( div , DE_ACTION_ANISALCE , .5 , 1.2)
		div=getid2("qiandaodiv","qiandaoItemList")
		addaction( div , DE_ACTION_SELF_X , .5 , -(getCurID(curDay)-2)*(162+40), DE_LISTEN_ACTION_OVER , "qiandaoShow")
	end
end

function qiandaoRight_btnClick(arg)
	if curDay>1 and isMoving==false then
		isMoving=true
		local div=nil
		if curDay~=0 then
			div=getid2("qiandaodiv","qiandaoItem"..curDay)
			addaction( div , DE_ACTION_ANISALCE , .5 , .8)
		end
		curIndex=getPrevID(curIndex)
		curDay=dayTable[curIndex]
		div=getid2("qiandaodiv","qiandaoItem"..curDay)
		addaction( div , DE_ACTION_ANISALCE , .5 , 1.2)
		div=getid2("qiandaodiv","qiandaoItemList")
		addaction( div , DE_ACTION_SELF_X , .5 , -(getCurID(curDay)-2)*(162+40), DE_LISTEN_ACTION_OVER , "qiandaoShow")
	end
end

function qiandaoGetAward_btnClick()
	--httpsend( 1 , 0x0000013b , 0 , {CUserData.m_nUserID},"qiandaoGetAwardBackFun","httpdp_svrStatusLogin")
	httpsend( 1 , 0x00000163 , 0 , {CUserData.m_nUserID,1},"qiandaoGetAwardBackFun","httpdp_svrStatusLogin")
end

function qiandaoGetAwardBackFun(ntype , nseqno , nret , arg)
	http_getdata(ntype , nseqno , nret , arg)
	print(string.format("httpdp_revMsgLogin ntype:%x ：nseqno:%d nret:%d",ntype , nseqno , nret) )
	if nret ~= 0 then --表示处理消息失败
		return
	end
	table.insert(arg,1,nret)
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s httpdp_revMsgLogin" , ntype , nseqno , nret, tabletostring(arg) ) )
	
	CUserData.nGameAge = arg[2]--游戏天数
	CUserData.nAttendancedDay = arg[3]--上次签到
	CUserData.nAttendancedEnd = arg[4]--活动截止时间
	CUserData.nAttendancedGift= arg[5]--奖励配置
	
	qiandaoClose_btnClick()
	qiandaoButtonShow()
end