--searchMonsterDetail
local _adata = {}

function searchMonsterDetail_onBtnGoToClick(a)
	local nseqno = jdtonumber(a.pBase:getts())
	local nx,ny=getMapXYByDataID(nseqno)
	
	searchMonsterDetail_del()
	searchMonster_del()
	map_show(nx,ny,0)
	
end

function searchMonsterDetail_getItemDivParam(v,nnpcId)
	local nseqno,nparam1,nparam2,nparam3,nparam4=v[1],v[2],v[3],v[4]
	local nx,ny=getMapXYByDataID(nseqno)
	local szpos = "x:"..nx..",y"..ny
	
	return nseqno,szpos
end

function searchMonsterDetail_getItemDivStr()
	local strtemp = [[
	{
	local nseqno,szpos = searchMonsterDetail_getItemDivParam(v,nnpcId)
	}
	<mx:Canvas setts="${nseqno}" onclick="searchMonsterDetail_onBtnGoToClick" width="563" height="161">
		<mx:Image mouseThrough="true" source="assets/images/searchMonster_bg01.png" height="200" y="0"/>
		<mx:Canvas x="20" verticalCenter="0" width="125" height="128">
			<mx:Image mouseThrough="true" source="assets/images/headerBg01.png" y="0"/>
			<mx:Canvas verticalCenter="0" horizontalCenter="0" width="105" height="105">
				<mx:Image mouseThrough="true" source="${szpic}" y="0"/>
				
			</mx:Canvas>
		</mx:Canvas>
		<mx:VBox x="180" y="25">
			<mx:Label mouseThrough="true" text="${szname}" fontSize="18" styleName="brown01" width="550"/>
			<mx:HBox >
				<mx:Label mouseThrough="true" text="坐标" fontSize="18" styleName="brown01" />
				<mx:Label mouseThrough="true" text=":" fontSize="18" styleName="brown01" />
				<mx:Label mouseThrough="true" text="(" fontSize="18" styleName="brown01" />
				<mx:Label mouseThrough="true" text="${szpos}" fontSize="18" styleName="green01" />
				<mx:Label mouseThrough="true" text=")" fontSize="18" styleName="brown01" />
			</mx:HBox>
			<mx:HBox>
				<mx:Label mouseThrough="true" text="距离:" fontSize="18" styleName="brown01" />
				<mx:Label mouseThrough="true" text="${ndis}" fontSize="18" styleName="brown01" />
			</mx:HBox>
		</mx:VBox>
		
		<mx:Image right="20" verticalCenter="0" mouseThrough="true" source="assets/images/arr01.png"/>
	</mx:Canvas>
	]]
	return strtemp
end

function searchMonsterDetail_del()
	print("searchMonsterDetail_del")
	deldiv("frame_more","searchMonsterDetail_main")
end

function searchMonsterDetail_getDivPram()
	local nnpcId,alist = 0,{}
	local szname,szpic = "",""
	if #_adata >= 8 then 
		nnpcId = _adata[2]
		local alist2 = _adata[8]
		local np1 = map_getCurMapDataID()
		local nx,ny=getMapXYByDataID(np1)
		
		for _,v in pairs(alist2) do
			local nseqno	= v[1]
			local nx2,ny2	=getMapXYByDataID(nseqno)
			local ndis 		= math.ceil(math.pow( math.pow(nx-nx2,2) + math.pow(ny-ny2,2) ,0.5 ))
			table.insert(alist,{v,ndis})
		end
		local function _compare(a,b)
			return a[2] < b[2]
		end
		table.sort(alist,_compare)
		
		
		
		
		local acfg = cfgmgr_query(G_DE_CFG_NPC_TROOP,nnpcId)
		if acfg ~= nil then 
			szpic = "assets/fane/"..acfg["F2"]..".png"
			szname= acfg["F1"]
			local nlv = jdtonumber(acfg["F6"])
			if nlv > 0 then 
				szname = jdgetlang(szname) .. " Lv."..nlv
			end
		end
		
	end
	print("searchMonsterDetail_getDivPram ret szpic:"..szpic..",#alist:"..(#alist))
	return nnpcId,alist,szname,szpic
end
function searchMonsterDetail_onBtnSearchClick()
	if #_adata >= 8 then 
		local nnpcId = _adata[2]
		local nrule  = _adata[3]
		
		httpsend( 1 , 0x0177 , 0 , {CUserData.m_nUserID,nnpcId,nrule,0,0,0,0 },"searchMonster_revMsg","httpdp_svrStatus"  )
		
		btnloading_show()
	end	
end
function searchMonsterDetail_getDivStr()
	local strtemp = [[
	{
	local nnpcId,alist,szname,szpic = searchMonsterDetail_getDivPram()
	}
	<mx:Canvas id="searchMonsterDetail_main" onclick="searchMonsterDetail_del" width="720" height="1280" backgroundColor="0x000000" backgroundAlpha="0.6" mouseThrough="false" systemload="1">
		<mx:Canvas width="623" height="763" horizontalCenter="0" verticalCenter="0">
			<mx:Image source="assets/images/popBg04.png" width="623" height="763"/>
			<mx:Button styleName="btn02Close" id="closeBtn" x="538" y="0" onclick="searchMonsterDetail_del"/>
			<mx:Label mouseThrough="true" y="50" x="30" text="搜索地图上的活动怪物" fontSize="18" styleName="brown01" width="550"/>
			
			<mx:Canvas setslidetype="1" width="563" height="550" horizontalCenter="0" y="100" >
				<mx:VBox y="0">
					{for i=1,#alist do
						local v = alist[i][1]
						local ndis = alist[i][2]
						}
						]]..searchMonsterDetail_getItemDivStr()..[[
					{end}
				</mx:VBox>
			</mx:Canvas>
			
			<mx:Button onclick="searchMonsterDetail_onBtnSearchClick" horizontalCenter="0" y="680" styleName="godsRelicBtn02" label="重新侦查" sound="assets/sound/419.ogg"/>
		
		</mx:Canvas>
	</mx:Canvas>
	]]
	return strtemp
end

function searchMonsterDetail_show(adata)
	print("searchMonsterDetail_show")
	_adata = adata
	local strtemp = searchMonsterDetail_getDivStr()
	
	local arg = {}
	flextodiv(strtemp , arg , "frame_more")
end
