--设置声音
local div_setSound_str = [[
<mx:Canvas id="setSound_main" width="720" height="1280">
	<mx:Canvas width="720" height="112">
		<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
		<mx:Label id="frameTop_txt" text="设置声音" width="720" textAlign="center" y="35"/>
		<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" onclick="setSound_btnCloseClick"/>
	</mx:Canvas>
	{soundOpen,soundEffOpen,soundX,soundEffX=arg[1],arg[2],arg[3],arg[4]}
	<mx:Image source="assets/images/bg01.jpg" width="720" height="990" y="111"/>
	<mx:Label text="音乐" styleName="brown01" x="199" y="165"/>
	{if soundOpen==1 then}
	<mx:Button styleName="btn02switch" x="339" y="146" onclick="setSound_btnClick"/>
	{else}
	<mx:Button styleName="btn01switch" x="339" y="146" onclick="setSound_btnClick"/>
	{end}
	<!-- 关闭按钮时，下面对应的滑动条按钮全变成不可按，同时滑块移动到最左边 -->
	<mx:Label text="音效" styleName="brown01" x="199" y="261"/>
	{if soundEffOpen==1 then}
	<mx:Button styleName="btn02switch" x="339" y="242" onclick="setSoundEff_btnClick"/>
	{else}
	<mx:Button styleName="btn01switch" x="339" y="242" onclick="setSoundEff_btnClick"/>
	{end}
	<mx:Image source="assets/images/line01.png" y="336" x="34"/>
	
	<mx:Label text="音乐" styleName="brown01" x="327" y="360" fontSize="30"/>
	<mx:Label text="Min" styleName="brown01" x="57" y="418" fontSize="36"/>
	<mx:Label text="Max" styleName="brown01" x="599" y="418" fontSize="36"/>
	<mx:Image source="assets/images/sliderBar01.png" x="137" y="431" onmove="sound_btnMove" onbegin="sound_btnBegin" onend="sound_btnEnd"/>
	<mx:Button styleName="btnAdd01" x="121" y="418" enabled="${soundOpen}" onclick="soundMin_btnClick"/>
	<mx:Button styleName="btnAdd02" x="553" y="418" enabled="${soundOpen}" onclick="soundMax_btnClick"/>
	<mx:Button id="soundDragBtn" styleName="btn01Slider" y="406" x="${soundX}" enabled="${soundOpen}" onmove="sound_btnMove" onbegin="sound_btnBegin" onend="sound_btnEnd"/>
	<!-- x坐标从160到500-->
	
	<mx:Label text="音效" styleName="brown01" x="327" y="526" fontSize="30"/>
	<mx:Label text="Min" styleName="brown01" x="57" y="584" fontSize="36"/>
	<mx:Label text="Max" styleName="brown01" x="599" y="584" fontSize="36"/>
	<mx:Image source="assets/images/sliderBar01.png" x="137" y="597" onmove="soundEff_btnMove" onbegin="sound_btnBegin" onend="sound_btnEnd"/>
	<mx:Button styleName="btnAdd01" x="121" y="584" enabled="${soundEffOpen}" onclick="soundEffMin_btnClick"/>
	<mx:Button styleName="btnAdd02" x="553" y="584" enabled="${soundEffOpen}" onclick="soundEffMax_btnClick"/>
	<mx:Button id="soundEffDragBtn" styleName="btn01Slider" y="572" x="${soundEffX}" enabled="${soundEffOpen}" onmove="soundEff_btnMove" onbegin="sound_btnBegin" onend="sound_btnEnd"/>
	<!-- x坐标从160到500-->
</mx:Canvas>
]]

local dragConfig = 
{
	offsetx = 0,
	left   	= 160,
	right   = 500,
	len		= 500-160
}
--
local soundOpen=1
local soundEffOpen=1
local soundValue=1
local soundEffValue=1
function setSound_show()
	local t=getSoundsql()
	if t~=nil then
		soundOpen=tonumber(t.a)
		soundEffOpen=tonumber(t.b)
		soundValue=tonumber(t.c)
		soundEffValue=tonumber(t.d)
	end
	local arg = {soundOpen,soundEffOpen}
	if soundOpen==1 then
		table.insert(arg,soundValue*dragConfig.len+dragConfig.left)
	else
		table.insert(arg,dragConfig.left)
	end
	if soundEffOpen==1 then
		table.insert(arg,soundEffValue*dragConfig.len+dragConfig.left)
	else
		table.insert(arg,dragConfig.left)
	end
	flextodiv(div_setSound_str,arg ,"frame_more",nil,nil,{3})
end

function setSysSound()
--	local t=getSoundsql()
--	if t~=nil then
--		soundOpen=tonumber(t.a)
--		soundEffOpen=tonumber(t.b)
--		soundValue=tonumber(t.c)
--		soundEffValue=tonumber(t.d)
--		if soundOpen==0 then
--			setmusicvolume(soundOpen)
--		else
--			setmusicvolume(soundValue)
--		end
--		if soundEffOpen==0 then
--			seteffectvolume(soundEffOpen)
--		else
--			seteffectvolume(soundEffValue)
--		end
--	end	
	local arglang = setLanguage_getsql()
	if tonumber(arglang[2] ) ~= nil then
		--arg[3] =  tonumber(arglang[2] )--3,音乐    1 打开,0 关闭
		if tonumber(arglang[2] ) == 0 then
			setmusicvolume(0)
		else
			setmusicvolume(1)
		end
	else
		setmusicvolume(1)
	end
	if tonumber(arglang[3] ) ~= nil then
		--arg[4] =  tonumber(arglang[3] )--4,音效    1 打开,0 关闭
		if tonumber(arglang[3] ) == 0 then
			seteffectvolume(0)
		else	
			seteffectvolume(1)
		end
	else
		seteffectvolume(1)
	end
end

function setSound_btnCloseClick(a)
	deldiv("frame_more","setSound_main",{3})
end

function setSound_btnClick(a)
	if soundOpen==1 then
		soundOpen=0
	else
		soundOpen=1
	end
	setSoundsql()
	if soundOpen==0 then
		setmusicvolume(soundOpen)
	else
		setmusicvolume(soundValue)
	end
	setSound_show()
end

function setSoundEff_btnClick(a)
	if soundEffOpen==1 then
		soundEffOpen=0
	else
		soundEffOpen=1
	end
	setSoundsql()
	if soundEffOpen==0 then
		seteffectvolume(soundEffOpen)
	else
		seteffectvolume(soundEffValue)
	end
	setSound_show()
end

----滑动条功能----
local function setDragButtonPos(id,value)
	local div = getid2("setSound_main",id)
	if div ~= nil then
		local arg = dragConfig
		if value==0 then
			div:sx(arg.left)
		elseif value==-1 then
			div:sx(arg.right)
		else
			div:sx(value*arg.len+arg.left)
		end
	end
end
function sound_btnMove(a)
	if	soundOpen==1 and a.nType==DE_LISTEN_TOUCH_MOVE then
		local div = getid2("setSound_main","soundDragBtn")
		if div ~= nil then
			local divWidth = div:w()/2
			local x = a.dTouchX-main_get_xoffset()-dragConfig.left-dragConfig.offsetx-divWidth
			x=math.min(math.max(x,0),dragConfig.len)
			div:sx(x+dragConfig.left)
			soundValue=x/dragConfig.len
			setmusicvolume(soundValue)
		end
	end
end
function soundEff_btnMove(a)
	if	soundEffOpen==1 and a.nType==DE_LISTEN_TOUCH_MOVE then
		local div = getid2("setSound_main","soundEffDragBtn")
		if div ~= nil then
			local divWidth = div:w()/2
			local x = a.dTouchX-main_get_xoffset()-dragConfig.left-dragConfig.offsetx-divWidth
			x=math.min(math.max(x,0),dragConfig.len)
			div:sx(x+dragConfig.left)
			soundEffValue=x/dragConfig.len
			seteffectvolume(soundEffValue)
		end
	end
end
function soundMin_btnClick(a)
	setDragButtonPos("soundDragBtn",0)
	soundValue=0
	setmusicvolume(soundValue)
	setSoundsql()
end
function soundMax_btnClick(a)
	setDragButtonPos("soundDragBtn",-1)
	soundValue=1
	setmusicvolume(soundValue)
	setSoundsql()
end
function soundEffMin_btnClick(a)
	setDragButtonPos("soundEffDragBtn",0)
	soundEffValue=0
	seteffectvolume(soundEffValue)
	setSoundsql()
end
function soundEffMax_btnClick(a)
	setDragButtonPos("soundEffDragBtn",-1)
	soundEffValue=1
	seteffectvolume(soundEffValue)
	setSoundsql()
end
--
local hasBegin=false
function sound_btnBegin(a)
	hasBegin=true
end
function sound_btnEnd(a)
	if hasBegin then
		setSoundsql()
		hasBegin=false
	end
end

function createSoundTable()    --建表
	print("createSoundTable")
	changeDataToSql("CREATE TABLE IF NOT EXISTS sound (a integer,b integer,c integer,d integer)" )
end

function getSoundsql()
	print("getSoundsql")
	createSoundTable()
	local vv = getDataForSql("mb6", "select * from sound ")
	if vv ~= nil and type(vv) == "table" then
		return vv[1]
	else
		changeDataToSql("INSERT INTO sound VALUES(1,1,1,1);")
		return nil
	end
end

function setSoundsql()
	print("setSoundsql")
	local str = "update sound set a="..soundOpen..",b="..soundEffOpen..",c="..soundValue..",d="..soundEffValue
	changeDataToSql( str )
end