--starchart
local div_starchart_str1 = [[
	{
	local apos 		= arg[1]
	local ncurindex	= arg[2]
	local nindex	= arg[3]
	local ncount6021= arg[4]
	local nneedcount= arg[5]
	local szbuffstr = arg[6]
	local nmaxindex = arg[7]
	
	local ncurid	= arg[8]
	local abufflist = arg[9]
	local nitemcount= arg[10]
	local ncount6022= arg[11]
	}
	<mx:Canvas id="starchart_main" width="720" height="1280">
		<mx:Image source="assets/images/bg06.jpg" y="111"/>
		<mx:Image source="assets/images/bar06.png" x="8" y="111"/>
		<mx:Button styleName="btn01Detail" y="111" x="652" setts="1" onclick="starchart_btnDetailClick"/>
		
		<mx:Image source="assets/images/ic03Star.png" y="175" x="508"/>
		<mx:Label text="${CUserData:getNumStr(ncount6021,2)}" x="566" y="196" color="0xd8eceb" fontSize="25"/>
		
		{
		local noffsety = 70
		}
		<mx:Image source="assets/item/1306022.png" width="60" height="60" y="${175+noffsety}" x="508"/>
		<mx:Label text="${CUserData:getNumStr(ncount6022,2)}" x="566" y="${196+noffsety}" color="0xd8eceb" fontSize="25"/>
		
		<mx:Canvas width="720" height="100" setslidetype="1" x="99" y="1161">
			<mx:VBox width="470" mouseThrough="true" horizontalGap="30" verticalGap="20">
				{for i=1,#abufflist do}
					<mx:Label text="${abufflist[i][3] }" width="470" mouseThrough="true" color="0x311612" fontSize="22"/>
				{end}
			</mx:VBox>
		</mx:Canvas>
		
		<mx:Canvas id="starchart_content" width="${720*nmaxindex}" height="1280">
			{for ntuid=1,nmaxindex do
				local nxx = 720*(ntuid-1)
				--print("nxx:"..nxx..",ntuid:"..ntuid)
				local sznmae,nnextneednum = starchart_getconfigname(ntuid) 
				}
				<mx:Canvas id="starchart_contentsub_${ntuid}" x="${nxx}" width="720" height="1280">
					<!mx:Label text="${szbuffstr}" x="99" y="1161" color="0x311612" fontSize="22"/>
					
					<mx:Image source="assets/images/bg0${ntuid}Star.png" y="369" x="0"/>
					
					<mx:Label text="${sznmae }" y="200" horizontalCenter="0" mouseThrough="true" color="0xffffff" fontSize="40"/>
					
					<mx:VBox x="40" y="250">
						<mx:HBox>
							<mx:Label text="当前拥有节日圣物数量:" color="0xd8eceb" fontSize="25"/>
							<mx:Label text="${nitemcount}" color="0xd8eceb" fontSize="25"/>
						</mx:HBox>
						<mx:HBox>
							<mx:Label text="解锁下个星图所需:" color="0xd8eceb" fontSize="25"/>
							{if nmaxindex == ntuid then}
								<mx:Label text="暂未开放" color="0xd8eceb" fontSize="25"/>
							{else}
								<mx:Label text="${nnextneednum}" color="0xd8eceb" fontSize="25"/>
							{end}
						</mx:HBox>
					</mx:VBox>
					
					{for i=1,10 do
						local nx,ny = starchart_getxy(ntuid,i)
						--print("ntuid:"..ntuid..",i:"..i..",nx:"..nx..",ny:"..ny)
						}
						
						{if ntuid*100+ i < ncurid then}
							<mx:Image source="assets/images/ic01Star.png" onclick="starchart_infor(${ntuid*100+ i})" y="${ny}" x="${nx}"/>
						{elseif ntuid*100+ i == ncurid then}
							<mx:Image source="assets/images/btn01Star.png" onclick="starchart_infor(${ntuid*100+ i})" y="${ny}" x="${nx}"/>
						{elseif ntuid*100+ i > ncurid then}
							<mx:Image source="assets/images/ic02Star.png" onclick="starchart_infor(${ntuid*100+ i})" y="${ny}" x="${nx}"/>
						{end} 
						
						<mx:Label visible="false" text="${i}" y="${ny}" x="${nx}" color="0xfffff" fontSize="25"/>
					{end}
				</mx:Canvas>
			{end}
		</mx:Canvas>
		
		<mx:Canvas width="720" height="112">
			<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
			<mx:Label id="frameTop_txt" text="星图" width="720" textAlign="center" y="35"/>
			<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" setts="2" onclick="starchart_btncloseclick"/>
		</mx:Canvas>
		
		
		<mx:Button mouseThrough="true" id="pageBtn1" styleName="arr05" x="34" y="350" setts="-1" visible="true" onclick="starchart_btnpageclick"/>
		<mx:Button mouseThrough="true" id="pageBtn2" styleName="arr01" x="600" y="350" setts="1" visible="true" onclick="starchart_btnpageclick"/>
		
	</mx:Canvas>
]]
local g_starchart_curid = 0
local g_starchart_itemcount = 0

local g_starchart_leftmax 	= 5 --4 --3
local g_starchart_left 		= 1
function starchart_btnpageclick(a)
	local t = tonumber(a.pBase:getts())
	print("starchart_btnpageclick t:"..t)
	local hbox = getid2("starchart_main","starchart_content")
	if hbox ~= nil then 
		local nval = g_starchart_left + t 
		if nval <= g_starchart_leftmax and nval >= 1 then 
		
			local ncurindex = math.floor(g_starchart_curid/100) 
			
			local sznmae,nnextneednum = starchart_getconfigname(nval-1)
			
			if nval <= ncurindex and g_starchart_itemcount >= nnextneednum then 
				print("starchart_btnpageclick nval:"..nval..",ncurindex:"..ncurindex..",g_starchart_itemcount:"..g_starchart_itemcount..",nnextneednum:"..nnextneednum)
				
				g_starchart_left = nval
				
				local x = 720 * (nval-1) * -1
				
				addaction( hbox , DE_ACTION_SELF_X , 0.1 , x)
			else
				print("err starchart_btnpageclick nval:"..nval..",ncurindex:"..ncurindex..",g_starchart_itemcount:"..g_starchart_itemcount..",nnextneednum:"..nnextneednum)
				showClum({"未满足解锁条件",1})		
			end
		end
	end
	print("starchart_btnpageclick end g_starchart_left:"..g_starchart_left)
end

function starchart_getxy(ntuid,nindex)
	local aconfig = {
		a1 = {--assets/images/bg01Star.png
		{145,541},{231,651},{54,700},{136,833},{305,781},
		
		{441,878},{471,713},{598,637},{441,541},{378,385},
		},
		a2 = {--assets/images/bg02Star.png
		{105,513},{270,425},{218,611},{48,662},
		
		{218,757},{278,876},{349,683},{468,790},{580,639},	{431,507},
		},
		a3 = {--assets/images/bg03Star.png
		{156,509},{77,644},{261,657},{154,785},
		
		{320.5,836},{454,794},{414,660},{545,570},{458,485},{343,423},
		},
		a4 = {--assets/images/bg04Star.png
		{261,560},{77,544},{69,704},{239,768},
		
		{295.5,890},{403,677},{459,850},{581,761},{578,599},{432,450},
		},
		a5 = {--assets/images/bg04Star.png
		{80,610},
		{190,190+369},{279,87+369},{474,216+369},
--		
		{270,225+369},{216,340+369},{53,460+369},{210,498+369},{320,360+369},{370,480+369},
		},
	}
	local nx = 0
	local ny = 0
	if aconfig["a"..ntuid] ~= nil then 
		for i=1,#aconfig["a"..ntuid] do
			if i == nindex then 
				nx = aconfig["a"..ntuid][i][1]
				ny = aconfig["a"..ntuid][i][2]	
				break
			end
		end
	end
	return nx,ny
end
function starchart_getconfigname(ntuid)
	local sznmae = ""
	local nnextneednum = 0
	local aconfig = CUserData:getstarChartConfigByid(ntuid*100+1)
	if aconfig ~= nil then 
		sznmae = aconfig["F1"]
	end
	local aconfig = CUserData:getstarChartConfigByid((ntuid+1)*100+1)
	if aconfig ~= nil then 
		nnextneednum = tonumber( aconfig["F2"])
		if nnextneednum == nil then nnextneednum = 0 end
	end
	return sznmae,nnextneednum
end
function starchart_show(nref)
	if nref == nil then nref = 0 end
	print("starchart_show CUserData.m_nstarchart:"..CUserData.m_nstarchart..",nref:"..nref)
	if nref == 1 then 
		local div = getid2("main","starchart_main")
		if div == nil then 
			return
		end
	end
	local nmaxindex = g_starchart_leftmax
	--CUserData.m_nstarchart = 201
	local nval = CUserData.m_nstarchart
	--nval 0 101-110 201-210 301-310 401-410
	local nindex 	= 101
	local nconfindex= 1
	local ncurindex = 1
	if nval > 0 then 
		nconfindex = math.floor(nval/100)
		ncurindex  = nval%100
		if ncurindex == 10 then 
			nconfindex = nconfindex + 1
			ncurindex = 1
		else
			ncurindex = ncurindex + 1 
		end
	end
	
	local apos = {}
	local ncount6021 = CUserData:getItemByid(6021,2)
	local ncount6022 = CUserData:getItemByid(6022,2)
	
	--star_chart
	local nneedcount = 0
	local szbuffstr	 = ""
	local ncurid	 = nconfindex*100+ncurindex
	
	g_starchart_curid= ncurid 
	local aconfig = CUserData:getstarChartConfigByid(ncurid)
	if aconfig ~= nil then 
		nneedcount = tonumber(aconfig["F3"])
		if nneedcount == nil then nneedcount = 0 end
		
		local nbuffid 	= tonumber(aconfig["F4"])
		local nbuffval  = tonumber(aconfig["F5"])	
		if nbuffid ~= nil and nbuffval ~= nil then 
			local abuffconfig = CUserData:getFuncListByid(nbuffid)
			if abuffconfig ~= nil then 
				if abuffconfig["F5"] == "10" then 
					nbuffval = nbuffval / 10
				end
				
			end
			szbuffstr = CUserData:format({CData:GetTranlang(abuffconfig["F1"]),nbuffval})
		end
	end
	
	local abufflist = {}
	local nval = CUserData.m_nstarchart
	if nval > 0 then 
		local nbreak = 0
		for i=1,g_starchart_leftmax do
			for j=1,10 do
				local ncur = i * 100 + j 
				local aconfig = CUserData:getstarChartConfigByid(ncur)
				if aconfig ~= nil then 
					local nbuffid 	= tonumber(aconfig["F4"])
					local nbuffval  = tonumber(aconfig["F5"])	
					if nbuffid ~= nil and nbuffval ~= nil then 
						
						local nfind = 0
						for aa=1,#abufflist do
							if abufflist[aa][1] == nbuffid then 
								abufflist[aa][2] = abufflist[aa][2] + nbuffval
								nfind = 1
								break
							end
						end
						if nfind == 0 then 
							table.insert(abufflist,{nbuffid,nbuffval})
						end
					end
				end
				if ncur == nval then 
					nbreak = 1
					break
				end
			end	
			if nbreak == 1 then 
				break
			end	
		end
	end
	for aa=1,#abufflist do
		--print("abufflist v:"..tabletostring(abufflist[aa]))
		local nbuffid = abufflist[aa][1]
		local nbuffval= abufflist[aa][2]
		local szbuffstr=""
		local abuffconfig = CUserData:getFuncListByid(nbuffid)
		if abuffconfig ~= nil then 
			if abuffconfig["F5"] == "10" then 
				nbuffval = nbuffval / 10
			end
			
		end
		szbuffstr = CUserData:format({CData:GetTranlang(abuffconfig["F1"]),nbuffval})
		
		--print("abufflist szbuffstr:"..szbuffstr )
		abufflist[aa][3] = szbuffstr
	end
	
	local nitemcount = 0
	local aitemid = {8204,8210,8211,8212,8213,8214,8215,8216,8217,8218,8219,8220,8221,8222,8223,8224,8225,8226,8227,8228,8229,8230,8231,8232,8233,8234,8235}
	for i=1,#aitemid do
		if CUserData:getItemByid(aitemid[i],2) > 0 then 
			nitemcount = nitemcount + 1
		else
			for j=1,#CUserData.m_aFaneItem do
				if CUserData.m_aFaneItem[j] == aitemid[i] then 
					nitemcount = nitemcount + 1	
					break	
				end
			end
		end
	end
	g_starchart_itemcount = nitemcount
	
	local arg = {apos,ncurindex,nindex,ncount6021,nneedcount,szbuffstr,nmaxindex,ncurid,abufflist,nitemcount,ncount6022}
	--分别是8204 8210 8211 8212 8213 8214
	--6021
	if nref == 0 then 
		g_starchart_left = 1
	end
	flextodiv(div_starchart_str1 ,arg  , "frame_more")
end
function starchart_btncloseclick()
	print("starchart_btncloseclick")
	deldiv("main","starchart_main")
end
function starchart_btnclick()
	print("starchart_btnclick")
	--0x0000001a
	btnloading_show()
	httpsend( 1 , 0x0000001a , 0 , {CUserData.m_nUserID},"starchart_recMsg","httpdp_svrStatusLogin"  )
end
function starchart_recMsg(ntype , nseqno , nret , arg )--
	btnloading_del()
	http_getdata(ntype , nseqno , nret , arg)
	print(string.format("httpdp_revMsgLogin ntype:%x ：nseqno:%d nret:%d",ntype , nseqno , nret) )
	if nret ~= 0 then --表示处理消息失败
		return
	end
	table.insert(arg,1,nret)
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s loginGift_revMsg" , ntype , nseqno , nret, tabletostring(arg) ) )
	
	CUserData.m_nstarchart = arg[2]
	if arg[3] > 0 then 
		CUserData:updateItemCount(arg[3] , arg[4])
	end
	if arg[5] > 0 then 
		CUserData:updateItemCount(arg[5] , arg[6])
	end
	starchart_show(1)
	
	starchart_inforclose()
end
local div_starchart_detailstr1 = [[
	<mx:Canvas id="starchart_detailmain" width="720" height="1280" onclick="starchart_btnDetailclose">
		<mx:Canvas horizontalCenter="0" verticalCenter="0" backgroundColor="0xffffff" backgroundAlpha="0.2" width="600" height="300">
			<mx:Canvas horizontalCenter="0" verticalCenter="0" width="550" height="250">
				<mx:VBox>
					{for i=1,#arg do}
						<mx:Label text="${arg[i] }" width="550" mouseThrough="true" color="0xffffff" fontSize="22"/>
					{end}
				</mx:VBox>
			</mx:Canvas>
			<mx:Canvas width="100" height="100" right="0" top="0" onclick="starchart_btnDetailclose">
				<mx:Label text="X" y="0" right="0" mouseThrough="true" color="0xffffff"  fontSize="40"/>
			</mx:Canvas>
		</mx:Canvas>
		
		<mx:Button visible="false" styleName="btn01Back" id="closeBtn1" x="27" y="18" setts="2" onclick="starchart_btnDetailclose"/>
	</mx:Canvas>
]]
function starchart_btnDetailClick()
	print("starchart_btnDetailClick")
	local arg = {
	"规则说明：",
	"1、激活星图需消耗星魂；",
	"2、星魂可通过使用节日圣物材料获得；",
	"3、激活当前星图所有星星并且拥有一定数量节日圣物可解锁下一星图。",
	}
	flextodiv(div_starchart_detailstr1 ,arg  , "frame_more")
end
function starchart_btnDetailclose()
	print("starchart_btnDetailclose")
	deldiv("main","starchart_detailmain")
end
local div_starchart_inforstr1 = [[
	<mx:Canvas id="starchart_informain" width="720" height="1280" onclick="starchart_inforclose">
		<mx:Canvas horizontalCenter="0" verticalCenter="0" backgroundColor="0xffffff" backgroundAlpha="0.2" width="600" height="300">
			<mx:Canvas horizontalCenter="0" verticalCenter="0" width="550" height="250">
				<mx:VBox>
					<mx:Label text="${arg[1] }" width="550" mouseThrough="true" color="0xffffff" fontSize="22"/>
					<mx:HBox>
						<mx:HBox>
							<mx:Label text="消耗:" verticalCenter="0" mouseThrough="true" color="0xffffff"  fontSize="22"/>
							<mx:Image source="assets/images/ic03Star.png"/>	
							<mx:Label text="X${CUserData:getNumStr(arg[2],2)}" verticalCenter="0" mouseThrough="true" color="0xffffff"  fontSize="22"/>
						</mx:HBox>
						{if arg[4] > 0 then}
							<mx:HBox height="74">
								<mx:Label text="消耗:" verticalCenter="0" mouseThrough="true" color="0xffffff" visible="false" fontSize="22"/>
								<mx:Image source="assets/item/1306022.png" width="60" height="60"/>	
								<mx:Label text="X${CUserData:getNumStr(arg[4],2)}" verticalCenter="0" mouseThrough="true" color="0xffffff"  fontSize="22"/>
							</mx:HBox>
						{end}
					</mx:HBox>
					{if arg[3] == 1 then}
						<mx:Button styleName="btn11" visible="true" label="激活" setts="1" onclick="starchart_btnclick()"/>
					{end}
				</mx:VBox>
			</mx:Canvas>
			
			<mx:Canvas width="100" height="100" right="0" top="0" onclick="starchart_inforclose">
				<mx:Label text="X" y="0" right="0" mouseThrough="true" color="0xffffff"  fontSize="40"/>
			</mx:Canvas>
		</mx:Canvas>
		
		<mx:Button visible="false" styleName="btn01Back" id="closeBtn1" x="27" y="18" setts="2" onclick="starchart_inforclose"/>
	</mx:Canvas>
]]	
function starchart_infor(nid)
	print("starchart_infor nid:"..nid)
	local nneedcount = 0
	local nneedcount2 = 0
	local szbuffstr	 = ""
	local ncurid	 = nid
	local aconfig = CUserData:getstarChartConfigByid(ncurid)
	if aconfig ~= nil then 
		nneedcount = tonumber(aconfig["F3"])
		if nneedcount == nil then nneedcount = 0 end
		
		nneedcount2 = tonumber(aconfig["F6"])
		if nneedcount2 == nil then nneedcount2 = 0 end
		
		local nbuffid 	= tonumber(aconfig["F4"])
		local nbuffval  = tonumber(aconfig["F5"])	
		if nbuffid ~= nil and nbuffval ~= nil then 
			local abuffconfig = CUserData:getFuncListByid(nbuffid)
			if abuffconfig ~= nil then 
				if abuffconfig["F5"] == "10" then 
					nbuffval = nbuffval / 10
				end
				
			end
			szbuffstr = CUserData:format({CData:GetTranlang(abuffconfig["F1"]),nbuffval})
		end
	end
	local nclick = 0
	if g_starchart_curid == nid then 
		nclick = 1
	end
	local arg = {szbuffstr,nneedcount,nclick,nneedcount2}
	
	flextodiv(div_starchart_inforstr1 ,arg  , "frame_more")
end

function starchart_inforclose()
	deldiv("main","starchart_informain")
end