--任务
local div_task_str = [[
<mx:Canvas id="div_task_id" width="720" height="1280" systemload="2" onloadcmp="div_task_comp">
	<mx:Canvas width="720" height="112">
		<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
		<mx:Label id="frameTop_txt" text="任务" width="720" textAlign="center" y="35"/>
		<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" onclick="task_btnCloseClick"/>
	</mx:Canvas>
	<mx:Image source="assets/images/bg02.jpg" width="720" height="990" x="0" y="111"/>
	<mx:Image source="assets/images/bar04.png" x="0" y="111"/>
	<mx:Button styleName="navi02" label="内政任务" enabled="false" x="12" y="118" sound="assets/sound/421.ogg"/>
	<mx:Button styleName="navi02" label="${CData:GetTranlang("英雄任务")}(${CUserData.m_aTaskDailyCount})" x="244" y="118" sound="assets/sound/421.ogg" onclick="taskHeroTask_btnClick"/>
	<mx:Button styleName="navi02" label="${CData:GetTranlang("联盟任务")}(${CUserData.m_aTaskUnionCount})" x="478" y="118" sound="assets/sound/421.ogg" onclick="taskUnionTask_btnClick"/>
	<mx:Image source="assets/images/block06.png" width="706" height="171" x="9" y="217"/>
	<mx:Canvas backgroundColor="0xFFFFFF" x="9" y="217" width="706" height="171" alpha="0" mouseThrough="true" onbegin="clickEffectShow" onend="clickEffectHide" setts="${arg[1][1]}" sound="defalut" onclick="taskDetails_btnClick"/>
	<mx:Image source="${arg[1][2]}" x="38" y="229" mouseThrough="true" width="167" height="134"/>
	<mx:Label text="${arg[1][3]}" fontSize="30" styleName="black01" x="224" y="256" mouseThrough="true"/>
	<mx:Text text="${arg[1][4]}" fontSize="24" styleName="brown01" x="224" y="299" width="380" mouseThrough="true"/>
	<mx:Image source="assets/images/arr01.png" x="613" y="272" mouseThrough="true"/>
	<mx:Canvas x="10" y="387" height="710" setslidetype="1">
	<mx:VBox verticalGap="0" mouseThrough="true">
		<mx:Canvas visible="${(#arg[2]>0 and "true" or "false")}" mouseChildren="false" mouseThrough="true">
			<mx:Image source="assets/images/bar06.png"/>
			<mx:Image source="assets/images/taskCompIcon.png" x="5" y="2"/>
			<mx:Label text="已完成任务" fontSize="30" styleName="white02" x="66" y="11"/>
		</mx:Canvas>
		{for i = 1 , #arg[2] do}
		<mx:Canvas width="708" height="85" mouseThrough="true">
			<mx:Image source="assets/images/block14.png" x="10" mouseThrough="true"/>
			<mx:Label text="${arg[2][i][2]}" fontSize="26" styleName="black01" x="40" y="10" mouseThrough="true"/>
			<mx:Label text="${arg[2][i][3]}" fontSize="22" styleName="brown01" x="40" y="43" mouseThrough="true"/>
			<mx:Button id="taskCompButton${i}" styleName="btn03" label="完成" x="495" y="10" setts="${arg[2][i][1]}_${i}" onclick="taskComp_btnClick" mouseThrough="true"/>
		</mx:Canvas>
		{end}
		{for i = 1 , #arg[3] do}
		<mx:Canvas mouseChildren="false" mouseThrough="true">
			<mx:Image source="assets/images/bar06.png"/>
			<mx:Image source="assets/images/taskIcon${i}.png" x="5" y="2"/>
			<mx:Label text="${arg[3][i][1]}" fontSize="30" styleName="white02" x="66" y="11"/>
		</mx:Canvas>
			{for j = 2 , #arg[3][i] do}
			<mx:Canvas width="708" height="85" setts="${arg[3][i][j][1]}" sound="defalut" onclick="taskDetails_btnClick" mouseThrough="true">
				<mx:Image source="assets/images/block14.png" x="10" y="0" mouseThrough="true"/>
				<mx:Canvas backgroundColor="0xFFFFFF" x="10" y="0" width="685" height="85" alpha="0" mouseThrough="true" onbegin="clickEffectShow" onend="clickEffectHide"/>
				<mx:Label text="${arg[3][i][j][2]}" fontSize="26" styleName="black01" x="40" y="10" mouseThrough="true"/>
				<mx:Label text="${arg[3][i][j][3]}" fontSize="22" styleName="brown01" x="40" y="43" mouseThrough="true"/>
				<mx:Image source="assets/images/arr01.png" x="616" y="11" setts="${arg[3][i][j][1]}" sound="defalut" onclick="taskDetails_btnClick" mouseThrough="true"/>
			</mx:Canvas>
			{end}
		{end}
	</mx:VBox>
	</mx:Canvas>
</mx:Canvas>
]]

local taskType={"训练","建筑","科技1","杂项"}
local g_task_arg = {}
function task_getArg()
	return g_task_arg
end

local function getTaskMSGTable(id)
	local taskList=CUserData:getTaskConfigByid(id)
	if	taskList~=nil then
		local msg=taskList.F6
		msg=CUserData:format({CData:GetTranlang(msg),taskList.F10})
		return {id,taskList.F5,msg}
	end
	return {id,"",""}
end
local function getCurTaskMSGTable(id)
	local image="assets/images/btn01Task.png"
	local taskList=CUserData:getTaskConfigByid(id)
	if	taskList~=nil then
--		任务类型（1训练2建筑3科技4杂项……）
		local type=tonumber(taskList.F3)
		if type==2 then
			image="assets/building/"..taskList.F4..".png"
		elseif type==3 then
			image="assets/tech/"..taskList.F4..".png"
		end
		local msg=taskList.F6
		msg=CUserData:format({CData:GetTranlang(msg),taskList.F10})
		return {id,image,taskList.F5,msg}
	end
	return {id,image,"无推荐任务",""}
end

function getTuijianTaskID()
--1＝训练
--2＝建造
--3＝科技
--4＝杂项
	
	local curID=0
	local temp=0
	local tuijianID=100000000
	local taskDataTable=CUserData.m_nTaskList
	local id=taskDataTable[2]
	if id>0 then
		temp=tonumber(CUserData:getTaskConfigByid(id,1))
		if temp<tuijianID then
			tuijianID=temp
			curID=id
		end
	end
	id=taskDataTable[12]
	if id>0 then
		temp=tonumber(CUserData:getTaskConfigByid(id,1))
		if temp<tuijianID then
			tuijianID=temp
			curID=id
		end
	end
	id=taskDataTable[13]
	if id>0 then
		temp=tonumber(CUserData:getTaskConfigByid(id,1))
		if temp<tuijianID then
			tuijianID=temp
			curID=id
		end
	end
	id=taskDataTable[14]
	if id>0 then
		temp=tonumber(CUserData:getTaskConfigByid(id,1))
		if temp<tuijianID then
			tuijianID=temp
			curID=id
		end
	end
	return curID
end

function task_show(eff)
	if eff==nil then
		eff=false
	end
	local taskDataTable=CUserData.m_nTaskList
	local compTable={}
	local taskID=taskDataTable[8]
	if taskID>0 then
		table.insert(compTable,getTaskMSGTable(taskID))
	end
	taskID=taskDataTable[9]
	if taskID>0 then
		table.insert(compTable,getTaskMSGTable(taskID))
	end
	taskID=taskDataTable[10]
	if taskID>0 then
		table.insert(compTable,getTaskMSGTable(taskID))
	end
	taskID=taskDataTable[11]
	if taskID>0 then
		table.insert(compTable,getTaskMSGTable(taskID))
	end
	local undoTable={}
	local t=taskDataTable[15]
	for i = 1 , #t do
		local titleID=t[i][1]
		local temp={taskType[titleID]}
		taskID=t[i][2]
		if taskID>0 then
			table.insert(temp,getTaskMSGTable(taskID))
		end
		taskID=t[i][3]
		if taskID>0 then
			table.insert(temp,getTaskMSGTable(taskID))
		end
		taskID=t[i][4]
		if taskID>0 then
			table.insert(temp,getTaskMSGTable(taskID))
		end
		taskID=t[i][5]
		if taskID>0 then
			table.insert(temp,getTaskMSGTable(taskID))
		end
		table.insert(undoTable,temp)
	end
	taskID=getTuijianTaskID()
	local arg = {getCurTaskMSGTable(taskID),compTable,undoTable}
	g_task_arg = arg 
	flextodiv(div_task_str,arg ,"frame_more",nil,nil,(eff and {} or {1,"div_task_comp"}))
	CUserData.indexTable.task=1
end

local loadingButtonTable={}
function div_task_comp()
	for i=#loadingButtonTable,1,-1 do
		local buttonID=table.remove(loadingButtonTable,1)
		btnloading_del(buttonID)
		global_enabled("main",buttonID,1)
	end
	deldiv("main","div_taskDaily_id")
	--guide_showHotRect({11,18})
	guideNew_showHotRect({1,{14}})
end

function taskComp_btnClick(a)
	local t=string.split(a.pBase:getts(),"_")
	local taskID=tonumber(t[1])
	local buttonID="taskCompButton"..t[2]
	btnloading_show(buttonID)
	global_enabled("main",buttonID,0)
	table.insert(loadingButtonTable,buttonID)
	print("insert:"..buttonID)
	httpsend( 1 , 0x00000122 , 0 , {CUserData.m_nUserID,taskID},"httpdp_taskCompBack","httpdp_svrStatusLogin"  )
end
function httpdp_taskCompBack(ntype , nseqno , nret , arg)
	for i=#loadingButtonTable,1,-1 do
		local buttonID=table.remove(loadingButtonTable,1)
		print("remove:"..buttonID)
		btnloading_del(buttonID)
		global_enabled("main",buttonID,1)
	end
	
	http_getdata(ntype , nseqno , nret , arg)
	print(string.format("httpdp_revMsgLogin ntype:%x ：nseqno:%d nret:%d",ntype , nseqno , nret) )
	if nret ~= 0 then --表示处理消息失败
		return
	end
	table.insert(arg,1,nret)
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s httpdp_revMsgLogin" , ntype , nseqno , nret, tabletostring(arg) ) )
	
	playSound(404)--playSound(115)
	
	CUserData.m_nTaskList[2]=arg[9]
	CUserData.m_nTaskList[7]=arg[4]
	CUserData.m_nTaskList[8]=arg[5]
	CUserData.m_nTaskList[9]=arg[6]
	CUserData.m_nTaskList[10]=arg[7]
	CUserData.m_nTaskList[11]=arg[8]
	CUserData.m_nTaskList[12]=arg[10]
	CUserData.m_nTaskList[13]=arg[11]
	CUserData.m_nTaskList[14]=arg[12]
	
	local div = getid2("main","div_task_id")
	if div ~= nil then
		task_show()
	end
	
	frame_changetext("m_aTaskCompImage")
	
	local taskID=arg[2]
	--showClue(string.format(CData:GetTranlang("领取奖励成功，获得%s"),CUserData:getAwardStringByStr(CUserData:getTaskConfigByid(taskID,11))))
end
function taskDetails_btnClick(a)
	local taskID=tonumber(a.pBase:getts())
	if taskID>0 then
		taskDetails_show(taskID)
	end
end
function taskHeroTask_btnClick(a)
	taskDaily_show(1)
end
function taskUnionTask_btnClick(a)
	if CUserData.m_nAllyID>0 then
		taskDaily_show(2)
	else
		showClue( "您尚未加入联盟！" )
	end
end

function task_btnCloseClick()
	CUserData.indexTable.task=0
--	deldiv("main","div_task_id")
--	frame_clearbtnstate()
	frame_CityOrMapBtnClick()
end