--任务详情
local div_taskDetails_str = [[
<mx:Canvas id="div_taskDetails_id" width="720" height="1280">
	<mx:Canvas width="720" height="112">
		<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
		<mx:Label id="frameTop_txt" text="任务详情" width="720" textAlign="center" y="35"/>
		<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" onclick="taskDetails_btnCloseClick"/>
	</mx:Canvas>
	<mx:Image source="assets/images/bg01.jpg" width="720" height="990" x="0" y="111"/>
	<mx:Image source="assets/images/bar06.png" x="8" y="111"/>
	<mx:Label text="${arg[3]}" x="132" y="123" width="423" textAlign="center"/>
	<mx:Image source="assets/images/block06.png" width="706" height="171" y="173" x="10"/>
	<mx:Image source="${arg[2]}" x="38" y="188" width="167" height="134"/>
	<mx:Label text="${arg[3]}" fontSize="30" styleName="black01" x="224" y="215"/>
	<mx:Label text="${arg[4]}" fontSize="24" styleName="brown01" x="224" y="258"/>
	<mx:Label fontSize="30" styleName="brown01" text="任务奖励" x="150" y="369" width="400" textAlign="center"/>
	<mx:Image source="assets/images/ttl01.png" x="150" y="408"/>
	<mx:VBox y="461" verticalGap="0" mouseThrough="true">
		{for i = 1 , #arg[5] do}
		<mx:Canvas height="60" clipContent="false">
			{if arg[8]~=4 then}
			<mx:Image source="${arg[5][i][3]}" x="160" mouseThrough="true"/>
			{else}
			<mx:Image source="${arg[5][i][3]}" x="120" y="-40" mouseThrough="true"/>
			<mx:Label text="${arg[5][i][1]}" fontSize="20" styleName="brown01" x="200"/>
			{end}
			<mx:Label text="${arg[5][i][2]}" fontSize="20" styleName="brown01" x="450" width="100" textAlign="right"/>
			<mx:Image source="assets/images/line01.png" y="46" x="36"/>
		</mx:Canvas>
		{end}
	</mx:VBox>
	{local str = (arg[7]==0 and "前往" or "完成")}
	<!mx:Button styleName="btn03" visible="${arg[6]}" label="${str}" x="280" y="1020" onclick="taskDetailsComp_btnClick"/>
	<mx:Button styleName="btn03" label="${str}" x="280" y="1020" onclick="taskDetailsComp_btnClick"/>
</mx:Canvas>
]]

local taskID=0
local taskTargetType=0
local taskTargetID=0
local taskState=0
local taskType=0
local function getCurTaskMSGTable(id)
	local buttonVisible=1
	local image="assets/images/btn01Task.png"
	local taskList=CUserData:getTaskConfigByid(id)
	if	taskList~=nil then
		taskTargetType=tonumber(taskList.F8)
		taskTargetID=tonumber(taskList.F9)
--		任务类型（1训练2建筑3科技4杂项……）
		taskType=tonumber(taskList.F3)
		if taskType==2 then
			image="assets/building/"..taskList.F4..".png"
		elseif taskType==3 then
			image="assets/tech/"..taskList.F4..".png"
		elseif taskType==4 then
			buttonVisible=0
		end
		local msg=taskList.F7
		msg=CUserData:format({CData:GetTranlang(msg),taskList.F10})
		return {id,image,taskList.F5,msg,CUserData:getAwardTableByStr(taskList.F11,1),buttonVisible,taskState,taskType}
	end
	return {id,image,"","",{},buttonVisible,taskState,taskType}
end

function taskDetails_show(id,effType)
	if effType==nil then
		effType=3
	end
	taskID=id
	taskType=0
	flextodiv(div_taskDetails_str,getCurTaskMSGTable(taskID) ,"frame_more",nil,nil,{effType})
end

function taskDetails_btnCloseClick()
	deldiv("frame_more","div_taskDetails_id",{3})
end

function taskDetailsComp_btnClick()
	gotoBuildingAndOpenPanel(1)
end

function gotoBuildingAndOpenPanel(openBuildPanel,id)
	if id~=nil then
		local taskList=CUserData:getTaskConfigByid(id)
		taskTargetType=tonumber(taskList.F8)
		taskTargetID=tonumber(taskList.F9)
		taskType=tonumber(taskList.F3)
	end
	--	任务类型（1训练2建筑3科技4杂项……）
	if taskType==1 then
		local buildType=1
		local n=math.modf(taskTargetID/100)
		if n==1 then
			buildType=2
		end
		--buildType 1 兵营,2 城墙 ,3 医院	,
		local nenabled = 1
		if buildType == 1 then--21
			nenabled = guideNew_getTaskBuildingEnable(21)
		elseif buildType == 2 then--5
			nenabled = guideNew_getTaskBuildingEnable(5)
		elseif buildType == 3 then--22
			nenabled = guideNew_getTaskBuildingEnable(22)
		end
		if nenabled == 1 then
			camp_show(buildType,-1,1,taskTargetID)
		else
			local str = string.format(CData:GetTranlang("新手阶段该建筑暂时不开放") )
			showClum({str,1})	
		end
	elseif taskType==2 then
		city_gotoByBuildingType(taskTargetID,openBuildPanel)
	elseif taskType==3 then --学院建筑类型：11
		techUpgrade_show(taskTargetID,1)
	elseif taskType==4 then
		if taskTargetType==5 then--竞技场建筑类型：12
			if guideNew_getTaskBuildingEnable(12) == 1 then
				heroBoosts_btnClick()
			else
				showClum({string.format(CData:GetTranlang("新手阶段该建筑暂时不开放") ) ,1})	
			end
		elseif taskTargetType==6 then--铁匠铺建筑类型：4
			if guideNew_getTaskBuildingEnable(4) == 1 then
				equipForg_show(taskTargetID)
			else
				showClum({string.format(CData:GetTranlang("新手阶段该建筑暂时不开放") ) ,1})	
			end
		elseif taskTargetType==7 then
			unionHelp_show()
		elseif taskTargetType==8 then
			if taskTargetID==2 then
				taskDaily_show(1,false)
			else
				taskDaily_show(2,false)
			end
		elseif taskTargetType==9 then--铁匠铺建筑类型：4
			if guideNew_getTaskBuildingEnable(4) == 1 then
				--equipStuff_show(2)
				gemCompose_show()
			else
				showClum({string.format(CData:GetTranlang("新手阶段该建筑暂时不开放") ) ,1})	
			end
--			equipStuffPop_show(taskTargetID)
		elseif taskTargetType==10 then--铁匠铺建筑类型：4
			if guideNew_getTaskBuildingEnable(4) == 1 then
				equipComp_show(1)
			else
				showClum({string.format(CData:GetTranlang("新手阶段该建筑暂时不开放") ) ,1})	
			end
		elseif taskTargetType==11 then
			power_changeNameShow(2)
		end
	end
	--taskDetails_btnCloseClick()
	frame_clearbtnstate()
end
