--队列加速
local div_teamAddSpeed_str = [[
<mx:Canvas id="div_teamAddSpeed_id" onloadcmp="div_teamAddSpeed_comp" width="720" height="1280">
	<mx:Canvas width="720" height="112">
		<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
		<mx:Label id="frameTop_txt" text="${arg.title}" width="720" textAlign="center" y="35"/>
		<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" onclick="teamAddSpeed_btnCloseClick"/>
	</mx:Canvas>
	<mx:Image source="assets/images/bg02.jpg" width="720" height="990" x="0" y="111"/>
	<mx:Image source="assets/images/bar02.png" y="115" x="3"/>
	<mx:Image x="66" y="138" source="assets/images/progBg01.png"/>
	<mx:Canvas id="coolTimeBar6" visible="0" styleName="prog06" width="1" height="31" y="143" x="71"/>
	<mx:Canvas id="coolTimeBar7" visible="0" styleName="prog07" width="1" height="31" y="143" x="71"/>
	<mx:Label id="coolTime" x="60" y="142" width="400" fontSize="24" styleName="white01" textAlign="center"/>
	<mx:Button id="coolTimeBtn" enabled="false" styleName="btn03" label="免费" x="500" y="125" onclick="teamAddSpeedFree_btnClick"/>
	<mx:Canvas x="20" y="200" height="895" setslidetype="1">
		<mx:VBox verticalGap="0" verticalScrollPolicy="off" mouseThrough="true">
			{for i = 1 , #arg do
				if arg[i].num>0 or arg[i].money >0 then
					}
					<mx:Canvas width="685" height="180" mouseThrough="true">
						<mx:Image source="assets/images/block10.png" mouseThrough="true"/>
						<mx:Image source="assets/images/headerBg03.png" x="34" y="12"/>
						<mx:Image source="assets/item/${arg[i].F1}.png" x="43" y="21"/>
						{local str = string.format(CData:GetTranlang("数量：%d"),arg[i].num)}
						<mx:Label text="${str}" fontSize="24" styleName="brown01" x="16" y="140" width="164" textAlign="center" mouseThrough="true"/>
						<mx:Label text="${arg[i].F2}" fontSize="24" styleName="brown01" x="166" y="20" mouseThrough="true"/>
						<mx:Text fontSize="20" styleName="brown01" x="168" y="50" text="${arg[i].F3}" width="303" mouseThrough="true"/>
						{if arg[i].num>0 then}
							<mx:Button id="teamAddSpeed_btnGetUser_${arg[i].F0}" label="使用" styleName="btn05" x="475" y="51" setts="${arg[i].F0}" onclick="teamAddSpeed_btnClick" mouseThrough="true"/>
						{elseif arg[i].money > 0 then}
							<mx:Button id="teamAddSpeed_btnGetUser_${arg[i].F0}" styleName="btn05speedbuild" x="475" y="51" setts="${arg[i].F0}" sound="assets/sound/419.ogg" onclick="teamAddSpeed_btnClick" mouseThrough="true"/>
							<mx:Label text="${arg[i].money}" styleName="white01" fontSize="20" x="490" y="57" width="160" textAlign="center" mouseThrough="true"/>
							<mx:Label text="购买并使用" styleName="white01" fontSize="20" x="490" y="81" width="160" textAlign="center" mouseThrough="true"/>
						{end}
					</mx:Canvas>
				{
				else
					print("err div_teamAddSpeed_str itemId:"..arg[i].F0)
				end
			end}
		</mx:VBox>
	</mx:Canvas>
</mx:Canvas>
]]

local curAddSpeedType=0
local curArmyID=0
local g_teamAddSpeed_arg = {}
function teamAddSpeed_getArg()
	return g_teamAddSpeed_arg
end
--
local propArg=nil
local function getPropList(time)
	if propArg==nil then
		propArg=CUserData:getItemByListIDAndTypeID(12,6)
	end
	local temp=nil
	local arg={}
	for i=#propArg,1,-1 do
		local list=propArg[i]
		if tonumber(list.F8)>=time then
			temp=list
		else
			table.insert(arg,list)
		end
	end
	if temp~=nil then
		table.insert(arg,1,temp)
	end
	return arg
end
local propArg_2=nil
local function getPropList_2(time)
	if propArg_2==nil then
		propArg_2=CUserData:getItemByListIDAndTypeID(12,12)
	end
	local temp=nil
	local arg={}
	for i=#propArg_2,1,-1 do
		local list=propArg_2[i]
		if tonumber(list.F8)>=time then
			temp=list
		else
			table.insert(arg,list)
		end
	end
	if temp~=nil then
		table.insert(arg,1,temp)
	end
	return arg
end
--
local teamTitle={"建筑","科技","士兵","城防","","英雄任务","联盟任务","装备","治疗","卫队","兵种科技"}
--teamID:队列id
--teamID<100为普通队列(不用传军队ID)，==100为行军队列(需传军队ID)
local curPropArg=nil
function teamAddSpeed_show(teamID,armyID)
	curAddSpeedType=teamID
	curArmyID=armyID
	
	local arg = nil
	if curAddSpeedType==100 then
		arg = CUserData:getItemByListIDAndTypeID(12,7)
		arg.title="行军加速"
	else
		local t=CUserData:getQueueInfoByid(curAddSpeedType)
		if t==nil then
			return
		end
		local time=CUserData:getLeavingsTime(tonumber(t[3]))
		arg=getPropList(time)
		if 9 == curAddSpeedType then 
			local temp2=getPropList_2(time)
			for i=1,#temp2 do
				table.insert(arg,temp2[i] )
				
			end
			
		end
		
		arg.title=teamTitle[teamID]
		curPropArg=arg
	end
	
	for i = 1 , #arg do
		local propID=tonumber(arg[i].F0)
		arg[i].num=CUserData:getItemByid(propID,2)
		arg[i].money=CUserData:getItemPirce(propID)
	end
	g_teamAddSpeed_arg = arg
	flextodiv(div_teamAddSpeed_str,arg ,"frame_more")
end

local freeTime=0
local loadingButtonTable={}
function div_teamAddSpeed_comp()
	for i=#loadingButtonTable,1,-1 do
		local buttonID=table.remove(loadingButtonTable,1)
		btnloading_del(buttonID)
		global_enabled("main",buttonID,1)
	end
	freeTime=CUserData:getFreeTime()
	teamAddSpeedTimer()
	guide_showHotRect({24})
	guideNew_showHotRect({2,{19}})
end

function teamAddSpeedTimer()
	local begTime=0
	local endTime=0
	if curAddSpeedType==100 then
		for i = 1 , #CUserData.m_aTroop do
			if CUserData.m_aTroop[i][1]==curArmyID then
				begTime=CUserData.m_aTroop[i][6]
				endTime=CUserData.m_aTroop[i][7]
				break
			end
		end
	else
		local t=CUserData:getQueueInfoByid(curAddSpeedType)
		if t==nil then
			teamAddSpeed_btnCloseClick()
			return
		end
		begTime=t[2]
		endTime=t[3]
	end
	local time=CUserData:getLeavingsTime(endTime)
	if time==0 then
		teamAddSpeed_btnCloseClick()
		return
	end
	
	if curAddSpeedType~=100 then
		local temp=getPropList(time)
		if 9 == curAddSpeedType then 
			local temp2=getPropList_2(time)
			for i=1,#temp2 do
				table.insert(temp,temp2[i] )
				
			end
			
		end
		if curPropArg~=nil and #curPropArg~=#temp then
			teamAddSpeed_show(curAddSpeedType,curArmyID)
			return
		end
	end
	
	local coolTimeBtn=getid2("div_teamAddSpeed_id","coolTimeBtn")
	if coolTimeBtn~=nil then
		freeTime=CUserData:getFreeTime()
		if (curAddSpeedType==1 or curAddSpeedType==2) and time<=freeTime then
			coolTimeBtn:enabled("true")
		else
			coolTimeBtn:enabled("false")
		end
	end
	local coolTime=getid2("div_teamAddSpeed_id","coolTime")
	if coolTime~=nil then
		coolTime:changetext(formatTime(time))
		local coolTimeBar6=getid2("div_teamAddSpeed_id","coolTimeBar6")
		local coolTimeBar7=getid2("div_teamAddSpeed_id","coolTimeBar7")
		freeTime=CUserData:getFreeTime()
		if (curAddSpeedType==1 or curAddSpeedType==2) and time<=freeTime then
			coolTimeBar6:sethidden(0)
			coolTimeBar7:sethidden(1)
		else
			coolTimeBar6:sethidden(1)
			coolTimeBar7:sethidden(0)
		end
		coolTimeBar6:sw(377-time/(endTime-begTime)*377)
		coolTimeBar7:sw(377-time/(endTime-begTime)*377)
		settimer(TIMER_ID_FOR_TEAM_UPG,1*1000,"teamAddSpeedTimer",1)
	end
end

function teamAddSpeedFree_btnClick(a)
	btnloading_show()
	httpsend( 1 , 0x00000104 , 0 , {CUserData.m_nUserID,0,0,curAddSpeedType},"httpdp_teamAddSpeedBack","httpdp_svrStatusLogin"  )
end

local g_teamAddSpeed_temp = 0
local g_teamAddSpeed_temp = 0
local g_teamAddSpeed_temp = 0

function teamAddSpeed_batUseItems(nitemId,nitemNum)
	print("teamAddSpeed_batUseItems nitemId,nitemNum:"..tabletostring({nitemId,nitemNum}))
	local temp 		= g_teamAddSpeed_temp
	local propID 	= nitemId
	httpsend( 1 , 0x0000016f , 0 , {CUserData.m_nUserID,temp,propID,curAddSpeedType,nitemNum},"httpdp_teamAddSpeedBack","httpdp_svrStatusLogin"  )
end

function teamAddSpeed_btnClick(a)
	local propID= tonumber( a.pBase:getts() )
	local buttonID="teamAddSpeed_btnGetUser_"..propID
	table.insert(loadingButtonTable,buttonID)
	local num = CUserData:getItemByid(propID,2)
	print("teamAddSpeed_btnClick num:"..num)
	local temp=CUserData:getItemByid(propID,2)>0 and 1 or 2
	if curAddSpeedType~=100 then
		local nshow = 0
		local v = tabmgr_query(CUserData.m_aQueue,curAddSpeedType) 
		if v ~= nil then 
			local nnow = CUserData:getCurServerTime()
			local nend = v[3]
			local ndis = nend - nnow
			if ndis > 0 then 
				local vv = CUserData:getItemConfigByid(propID,8)
				if vv ~= nil then 
					local ntime = jdtonumber(vv,0)
					local nneedNum = math.ceil(ndis / ntime)
					if ntime > 0 and nneedNum >= 3 and num >= 3 then 
						nshow  = 1
						local nmax = nneedNum
						if nmax > num then 
							nmax = num
						end
						g_teamAddSpeed_temp = temp
						batUseItems_show(propID,nmax,teamAddSpeed_batUseItems)
					end
				end
			end
		end
		if nshow  == 0 then 
			httpsend( 1 , 0x00000104 , 0 , {CUserData.m_nUserID,temp,propID,curAddSpeedType},"httpdp_teamAddSpeedBack","httpdp_svrStatusLogin"  )
		end
	else
		httpsend( 1 , 0x0000012f , 0 , {CUserData.m_nUserID,temp,curArmyID,propID},"httpdp_teamAddSpeedBack2","httpdp_svrStatusLogin"  )
		btnloading_show(buttonID)
		global_enabled("main",buttonID,0)
	end
end

function httpdp_teamAddSpeedBack(ntype , nseqno , nret , arg)
	btnloading_del()
	for i=#loadingButtonTable,1,-1 do
		local buttonID=table.remove(loadingButtonTable,1)
		btnloading_del(buttonID)
		global_enabled("main",buttonID,1)
	end
	
	http_getdata(ntype , nseqno , nret , arg)
	print(string.format("httpdp_revMsgLogin ntype:%x ：nseqno:%d nret:%d",ntype , nseqno , nret) )
	if nret ~= 0 then --表示处理消息失败
		return
	end	
	table.insert(arg,1,nret)	
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s httpdp_revMsgLogin" , ntype , nseqno , nret, tabletostring(arg) ) )
	
	CUserData:onQueueAction(arg )
	if getid2("main","div_teamAddSpeed_id") ~= nil then
		teamAddSpeed_show(curAddSpeedType)
	end
	local typeID=arg[2]
	local propID=arg[3]
	if propID>0 then
		local str=""
		if typeID==1 then
			str="使用%s"
		elseif typeID==2 then
			str="购买并使用%s"	
		end
		showClue(string.format(CData:GetTranlang(str),CData:GetTranlang(CUserData:getItemConfigByid(propID,2)).."×1"))
	end
	
	playSound(404)--playSound(110)
end

function httpdp_teamAddSpeedBack2(ntype , nseqno , nret , arg)
	btnloading_del()
	http_getdata(ntype , nseqno , nret , arg)
	--print(string.format("httpdp_revMsgLogin ntype:%x ：nseqno:%d nret:%d",ntype , nseqno , nret) )
	if nret ~= 0 then --表示处理消息失败
		return
	end
	table.insert(arg,1,nret)
	--print( string.format("接受消息 0x%x nseqno=%d ret=%d %s httpdp_revMsgLogin" , ntype , nseqno , nret, tabletostring(arg) ) )
	
	local typeID=arg[2]
	local propID=arg[3]
	
	--CUserData.m_nGold = arg[5]
	CUserData:updateGold(arg[5])
	--更改道具数量
	CUserData:updateItemCount(arg[3],arg[4])
	--更改当前队列help状态
	table.remove(arg,1)
	table.remove(arg,1)
	table.remove(arg,1)
	table.remove(arg,1)
	table.remove(arg,1)
	--print(tabletostring(arg))
	arg.serviceid = (arg[4] > 0 and 0 or -1)
--	arg[4] = math.abs(arg[4])
--	arg[5] = math.abs(arg[5])
	for i,v in pairs(CUserData.m_aTroop) do
		if arg[1] == v[1] then
			CUserData.m_aTroop[i] = arg
			queue_updatedata(0,queue_formatdata(2,arg))
			break
		end
	end
	
	teamAddSpeed_show(curAddSpeedType,curArmyID)
	if propID>0 then
		local str=""
		if typeID==1 then
			str="使用%s"
		elseif typeID==2 then
			str="购买并使用%s"	
		end
		showClue(string.format(CData:GetTranlang(str),CData:GetTranlang(CUserData:getItemConfigByid(propID,2)).."×1"))
	end
	
	playSound(404)--playSound(110)
end

function teamAddSpeed_btnCloseClick(a)
	deldiv("frame_more","div_teamAddSpeed_id",{3})
end

