--unionShopHistory
local _adata = {}
local _alist = {}
function unionShopHistory_getData(nbegin,nmax,nnet)
	print("unionShopHistory_getData nbegin,nmax,nnet:"..tabletostring({nbegin,nmax,nnet}))
	local alist = {}
	for i=nbegin,nbegin+nmax-1 do
		if i <= #_adata then 
			table.insert(alist,_adata[i])
		end
	end
	if nnet == 1 and #alist < nmax then 
		local nseqno = 0
		local ncount = #_adata	
		if ncount > 0 then 
			nseqno	= _adata[ncount][1]
		end
		httpsend( 1 , 0x0058 , 0 , {CUserData.m_nUserID,nseqno},"unionShopHistory_revMsgGetAllyStoreLog"  )
		
	end
	print("unionShopHistory_getData ret #alist:"..(#alist))
	return alist 
end
function unionShopHistory_revMsgGetAllyStoreLog(ntype , nseqno , nret , arg )--登陆时，处理服务器消息	
	print(string.format("unionShopHistory_revMsgGetAllyStoreLog ntype:%x ：nseqno:%d nret:%d",ntype , nseqno , nret) )
	http_getdata(ntype , nseqno , nret , arg)
	if nret ~= 0 then --表示处理消息失败
		return
	end

	table.insert(arg,1,nret)

	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s httpdp_revMsgLogin" , ntype , nseqno , nret, tabletostring(arg) ) )
	local nseqno = 0
	local ncount = #_adata	
	if ncount > 0 then 
		nseqno	= _adata[ncount][1]
	end
	if #arg[2] > 0 then 
		if arg[2][1][1] < nseqno or nseqno == 0 then 
			for i=1,#arg[2] do
				
				table.insert(_adata,arg[2][i])
			end
		end
	end
	unionShopHistory_add(2)
end

function unionShopHistory_getTimeString(ntime )--
	local nnow = CUserData:getCurServerTime() --getCurtime()
	local nsec = nnow - ntime
	--os.date("%c", os.time())
--	print("mail_getTimeString nnow:"..os.date("%c",nnow ))
--	print("mail_getTimeString ntime:"..os.date("%c",ntime ))
--	print("mail_getTimeString nsec:"..nsec )
--	
	
	local str  = ""
	if nsec >= 12 * 30 * 24 * 60 * 60 then
		local nval =  math.floor(nsec / (12 * 30 * 24 * 60 * 60)  )
		str = nval.." year ago"
	elseif nsec >= 30 * 24 * 60 * 60 then
		local nval =  math.floor(nsec / (30 * 24 * 60 * 60)  )
		str = nval.." mon ago"
	elseif nsec >= 24 * 60 * 60 then 
		local nval  =  math.floor(nsec / (24 * 60 * 60)  )
		str = nval.." day ago"
	elseif nsec >= 60 * 60 then 
		local nval  =  math.floor(nsec / (60 * 60)  )
		str = nval.." hour ago"
	elseif nsec >= 60 then 
		local nval  =  math.floor(nsec / (60)  )
		str = nval.." min ago"
	elseif nsec >= 1 then 
		local nval  =  nsec
		--str = nval.." sec ago"
		local nmin = 1
		str = nmin.." min ago"
	else
		--str = "now"
		local nmin = 1
		str = nmin.." min ago"
	end
	return str 
end

--	
function unionShopHistory_btnCloseClick()
	deldiv("frame_more","unionShopHistory_main")
end
local _unionShopHistory_str = [[
	<mx:Canvas id="unionShopHistory_main" width="720" height="1280" mouseThrough="false" systemload="1" onclick="unionShopHistory_btnCloseClick" onloadcmp="unionShopHistory_cmp">
		
		<mx:Canvas horizontalCenter="0" verticalCenter="0" styleName="popBg07" width="678" height="700">
			<mx:Image source="assets/images/nameBg02.png" horizontalCenter="0" y="70"/>
			<mx:Label text="联盟商店历史" fontSize="24" styleName="white03" horizontalCenter="0" width="358" textAlign="center" y="70"/>
			<mx:Button styleName="btn02Close" id="closeBtn" onclick="unionShopHistory_btnCloseClick" x="591" y="-4"/>
			
			<mx:Image source="assets/images/line02.png" horizontalCenter="0" y="150" mouseThrough="true"/>
			
			<mx:Canvas onslideborder="unionShopHistory_contentSlidetop" horizontalCenter="0" y="180" setslidetype="1" width="600" height="500">
				<mx:VBox id="unionShopHistory_contentBox" verticalGap="15" width="600">
					
				</mx:VBox>
			</mx:Canvas>
			
		</mx:Canvas>
	</mx:Canvas>
	]]
function unionShopHistory_cmp()
	print("unionShopHistory_cmp")
	unionShopHistory_add(1)
end
function unionShopHistory_show()
	print("unionShopHistory_show")
	_adata = {}
	_alist = {}
	
	local arg = {}
	flextodiv(_unionShopHistory_str,arg ,"frame_more",nil,nil)
end
function unionShopHistory_getItemDivParam(v)
	local nid = v[1]
	local sztime = unionShopHistory_getTimeString(v[3] )
	local szuser = v[5]
	if v[4] == -2 then 
		szuser = szuser.."("..jdgetlang("已删号")..")"
	elseif v[4] == -1 then 
		szuser = szuser.."("..jdgetlang("已退盟")..")"
	end
	local szopt = "#color:0x66790a="..jdgetlang("进货").."#"
	if v[2] == 1 then 
		szopt = "#color:0xff0000="..jdgetlang("购买").."#"
	end
	local nitemid    = v[6]
	local nitemcount = v[7]
	local szitemname = jdgetlang(jdassign(cfgmgr_queryValue(G_DE_CFG_ITEM,nitemid,"F2"),""))
	local szuseitem	 = jdgetlang("消耗") 	
	if v[2] == 0 then 
		szuseitem = szuseitem.." ".. jdgetlang("联盟基金").." X "
	else
		szuseitem = szuseitem.." ".. jdgetlang("联盟贡献").." X "
	end
	szuseitem = szuseitem ..v[8]
	
	local szdetail = szuser.." "..szopt.." "..szitemname.." X " ..nitemcount
	local szdetail2 = szuseitem
	
	return nid,sztime,szdetail,szdetail2
end
function unionShopHistory_add(nparam)--nparam 1 opt,2 net
	print("unionShopHistory_add nparam:"..nparam)
	local nnet = 1 
	if nparam == 2 then 
		nnet = 0
	end
	local nbegin = #_alist + 1
	local nmax	 = 10
	local alist = unionShopHistory_getData(nbegin,nmax,nnet)
	print("unionShopHistory_add alist:"..tabletostring(alist))
	if #alist > 0 then 
		local strtemp = [[
		{
		local alist = arg[1]
		for i=1,#alist do
			local v = alist[i]
			local nid,sztime,szdetail,szdetail2 = unionShopHistory_getItemDivParam(v) }
			<mx:Canvas id="unionShopHistory_item${nid}" width="600" minHeight="30">
				<mx:Canvas x="0" y="12" backgroundColor="0x311612" mouseThrough="true" width="10" height="10" />
				<mx:VBox verticalGap="-5" y="0" x="20">
					<mx:Label x="0" text="${szdetail}" texthtml="true" mouseThrough="true" width="400" fontSize="24" styleName="brown01"/>
					<mx:Canvas width="580">
						<mx:Label x="0" text="${szdetail2}" texthtml="true" mouseThrough="true" width="350" fontSize="24" styleName="brown01"/>
						<mx:Label right="0" text="${sztime}" mouseThrough="true" fontSize="18" color="0x5d5c55" />
					</mx:Canvas>
				</mx:VBox>
			</mx:Canvas>
		{end}
		]]
		for i=1,#alist do
			table.insert(_alist,alist[i])
		end
		
		local arg = {alist}
		flextodiv(strtemp,arg ,"unionShopHistory_contentBox")
	end
end

function unionShopHistory_contentSlidetop(a)
	print("unionShopHistory_contentSlidetop a.nActionType:"..a.nActionType)
	if a.nActionType == 2 then 
		
		--加载历史聊天记录
		unionShopHistory_add(1)
	end
end


