--联盟退位/离开/解散
local div_unionWarning_str = [[
<mx:Canvas id="div_unionWarning_id" onloadcmp="div_unionWarning_comp" width="720" height="1280">
	<mx:Canvas width="720" height="112">
		<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
		<mx:Label id="frameTop_txt" text="提示" width="720" textAlign="center" y="35"/>
		<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" setts="4" onclick="unionWarningClose_btnClick"/>
	</mx:Canvas>
	<mx:Image source="assets/images/bg02.jpg" width="720" height="990" x="0" y="111"/>
	<mx:Canvas id="div_unionWarning_content" width="${670+27*2}" y="-50">
		<mx:Image source="assets/images/warningBg01.png" width="670" height="1004" x="27" y="160"/>
		<mx:Label text="Warning!" fontSize="38" fontFamily="Arial" styleName="white01" horizontalCenter="0" y="278"/>
		<mx:Text fontSize="20" styleName="white03" text="${arg[3]}" x="109" y="366" width="500"/>
		{if arg[1]==2 then}
		<mx:Label text="继位人" styleName="yellow01" fontSize="24" x="244" y="813" width="232" textAlign="center"/>
		<mx:Image id="unionWarningUserNameBG" source="assets/images/bg09Input.png" x="163" y="856"/>
		<mx:TextInput id="unionWarningUserName" Tranlang="false" clickclear="true" maxChars="16" text="" backgroundAlpha="0" borderStyle="none" styleName="white01" fontSize="24" x="172" y="863" width="373" height="28" textAlign="center"/>
		{end}
		<mx:Button label="${arg[2]}" styleName="btn04" x="223" y="947" width="274" onclick="unionWarning_btnClick"/>
	</mx:Canvas>
</mx:Canvas>
]]

function div_unionWarning_comp()
	local unionWarningUserName=getid2("div_unionWarning_id","unionWarningUserName")
	if unionWarningUserName~=nil then
		unionWarningUserName:addlisten("unionWarningUserNameInputBack",DE_LISTEN_KEY_INPUT)
	end
end

function unionWarningUserNameInputBack(a)
	local div=getid2("frame_more","div_unionWarning_content")
	if div~=nil then
		if a.nActionType == 1 then     --展开
			div:sy(-350)
		elseif a.nActionType == 2 then --关闭
			div:sy(-50)
		end
	end
end

function unionWarningClose_btnClick(a)
	deldiv("frame_more","div_unionWarning_id",{3})
end

local curType=0
function unionWarning_show(type)
	curType=type
	local btnLabel=""
	local msg=""
	if curType==2 then
		btnLabel="退位"
		msg="我们希望你在使用这项功能时说明你的继位者是一位积极且合格的继承者。当你实施这项功能时你将从你的位置上下来，变成RANK1的成员，同时你将不再拥有以前的各种功能和权利，总之希望你已经准备好了才按下这个按钮。"
	elseif curType==3 then
		btnLabel="解散联盟"
		msg="很不幸，当你准备执行这项操作时你应该是承受了不必要的痛苦（或者完全是为了好玩）。总之你们的盟友们是否知道了你即将这么做，否则他们一觉醒来时发现一切都变了。"
	elseif curType==4 then
		btnLabel="离开联盟"
		msg="这是一项需要慎重考虑的信息，离开联盟后你将完全抹去你在联盟中的所有痕迹，包括你在联盟中曾经留下过的任何文字和信息。所以，希望你能金属的使用这项功能。"
	end
	flextodiv(div_unionWarning_str,{curType,btnLabel,msg},"frame_more",nil,nil,{3})
end

function unionWarning_btnClick(a)
	if curType==2 then
		local unionWarningUserName=getid2("div_unionWarning_id","unionWarningUserName")
		if unionWarningUserName~=nil then
			local name = unionWarningUserName:gettext()
			print(name)
			showClum({"你确定要退位吗？",3,{"确定","取消"}},{unionWarningYes,name})
		end
	elseif curType==3 then
		showClum({"你确定要解散联盟吗？",3,{"确定","取消"}},{unionWarningYes})
	elseif curType==4 then
		showClum({"你确定要离开联盟吗？",3,{"确定","取消"}},{unionWarningYes})
	end
end

function unionWarningYes(t,arg)
	if t == 1 then
		if curType==2 then
			httpsend( 1 , 0x0000012b , 0 , {CUserData.m_nUserID,{16,arg}},"AllyLeaderChangeBack","httpdp_svrStatusLogin")
		elseif curType==3 then
			httpsend( 1 , 0x00000114 , 0 , {CUserData.m_nUserID},"AllyDismissBack","httpdp_svrStatusLogin")
		elseif curType==4 then
			httpsend( 1 , 0x00000119 , 0 , {CUserData.m_nUserID},"AllyQuitBack","httpdp_svrStatusLogin")
		end
	end
end

function AllyDismissBack(ntype , nseqno , nret , arg)
	http_getdata(ntype , nseqno , nret , arg)
	print(string.format("httpdp_revMsgLogin ntype:%x ：nseqno:%d nret:%d",ntype , nseqno , nret) )
	if nret ~= 0 then --表示处理消息失败
		return
	end
	table.insert(arg,1,nret)
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s httpdp_revMsgLogin" , ntype , nseqno , nret, tabletostring(arg) ) )
	--
--	unionMainClose_btnClick()
--	unionWarningClose_btnClick()
--	unionMenuClose_btnClick()
	
end

function AllyQuitBack(ntype , nseqno , nret , arg)
	http_getdata(ntype , nseqno , nret , arg)
	print(string.format("httpdp_revMsgLogin ntype:%x ：nseqno:%d nret:%d",ntype , nseqno , nret) )
	if nret ~= 0 then --表示处理消息失败
		return
	end
	table.insert(arg,1,nret)
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s httpdp_revMsgLogin" , ntype , nseqno , nret, tabletostring(arg) ) )
	--
	CUserData.m_nAllyID=arg[2]--所属联盟
	CUserData.m_nAllyOfficial=arg[3]--联盟官职
	CUserData.m_nAllyPoint=arg[4]--联盟贡献
	--
	unionMainClose_btnClick()
--	unionWarningClose_btnClick()
--	unionMenuClose_btnClick()
	
	joinUnionButtonShow()

	CUserData:updateMyFortress(nil)
	httpdp_MapQuery(true)
	
	frame_changetext("m_aUnionReqCount")--退出联盟时移除角标显示
end

function AllyLeaderChangeBack(ntype , nseqno , nret , arg)
	http_getdata(ntype , nseqno , nret , arg)
	print(string.format("httpdp_revMsgLogin ntype:%x ：nseqno:%d nret:%d",ntype , nseqno , nret) )
	if nret ~= 0 then --表示处理消息失败
		return
	end
	table.insert(arg,1,nret)
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s httpdp_revMsgLogin" , ntype , nseqno , nret, tabletostring(arg) ) )
	--
	unionWarningClose_btnClick()
	unionMenu_show()
end