


-- ------------------------------------------------------------------------------------------------------------------
-- 建筑说明公共部分----------------------------------------------------------------------------------------------------------
-- ------------------------------------------------------------------------------------------------------------------

--建筑详情
div_buildInfoItem_str = [[
	<mx:Canvas id="buildInfo_main" width="720" height="1280" onloadcmp="buildInfo_onloadcmp">
	<mx:Image source="assets/images/popBg02.png" width="720" height="1280"/>
	<mx:Button styleName="btn02Close" id="closebtn" x="627" y="49" onclick="buildInfo_btnClick"/>
		${getBulidstr(arg[1][1])}
	<mx:Label text="${arg[1][2]}" styleName="brown01" x="168" y="59" fontSize="30" width="340" textAlign="center"/>
	<mx:VBox verticalGap="0" verticalScrollPolicy="off" x="17" y="${1173 - arg[1][3]}">
			<mx:Canvas mouseThrough="true">
				<mx:Image source="assets/images/th.png" mouseThrough="true"/>
				{local tier = arg[1][4]}
				{if #tier == 2 then --两列数据}
					<mx:Label text="${tier[1]}" fontSize="24" styleName="white02" x="95" mouseThrough="true"/>
					<mx:Label text="${tier[2]}" fontSize="24" styleName="white02" textAlign="right" x="385" width="212" mouseThrough="true"/>
				{elseif #tier == 3 then  --三列数据}
					<mx:Label text="${tier[1]}" fontSize="24" styleName="white02" x="95" mouseThrough="true"/>
					<mx:Label text="${tier[2]}" fontSize="24" styleName="white02" textAlign="center" x="240" width="212" mouseThrough="true"/>
					<mx:Label text="${tier[3]}" fontSize="24" styleName="white02" textAlign="right" x="385" width="242" mouseThrough="true"/>
				{elseif #tier == 4 then --四列数据}
					<mx:Label text="${tier[1]}" fontSize="24" styleName="white02" x="95" mouseThrough="true"/>
					<mx:Label text="${tier[2]}" fontSize="24" styleName="white02" textAlign="center" x="190" width="150" mouseThrough="true"/>
					<mx:Label text="${tier[3]}" fontSize="24" styleName="white02" textAlign="center" x="350" width="150" mouseThrough="true"/>
					<mx:Label text="${tier[4]}" fontSize="24" styleName="white02" textAlign="right" x="385" width="212" mouseThrough="true"/>
				{end}
				<mx:Canvas y="45" mouseChildren="false" mouseThrough="true" setslidetype="1" height="${arg[1][3]}">
					<mx:VBox verticalGap="0" mouseChildren="false" mouseThrough="true">
						
					
						{
						local aupconfall	= arg[2][1]
						local nTotalCcolNum = arg[2][2]
						local strTopLvFunc  = arg[2][3]
						local nCurLevel     = arg[2][4]
						local axpos			= arg[2][5]
						local aaxpos = axpos["a"..(nTotalCcolNum + 1) ]
						if aaxpos == nil then
							aaxpos = axpos["a4"]
						end
						print("nTotalCcolNum:"..nTotalCcolNum)
						print("aaxpos:"..tabletostring(aaxpos) )
						for i = 1 ,#aupconfall do
							local aconf = aupconfall[i] }
							
							<mx:Canvas height="35">
								{if nCurLevel == i then}
									<mx:Image source="assets/images/td2.png"/><!-- 当前等级显示黄色的条 -->	
								{elseif i % 2 == 0 then}				
									<mx:Image source="assets/images/td.png"/>
								{end}
								<mx:Label text="${i}" styleName="brown01" fontSize="24" x="107" y="1"/>
								
								{local ncount = 1
								for j = 16 , 20 , 2 do
									if aconf["F"..j] ~= "0" and aconf["F"..j] ~= 0 then
										ncount = ncount + 1 
										if ncount <= nTotalCcolNum + 1 then
											local nx = aaxpos[ncount] 
					--						print("ncount:"..ncount)
					--						print("nx:"..nx)
											}
											{if tonumber(aconf["F"..j]) == nil then}
											<mx:Label text="${string.format(arg[1][5][ncount],aconf["F"..j])}" styleName="brown01" fontSize="24" x="${nx -100}" y="1" width="312" textAlign="right"/>
											{else}		
											<mx:Label text="${string.format(arg[1][5][ncount],CUserData:getNumStr(tonumber(aconf["F"..j])/tonumber(CUserData:getFuncListByid(aconf["F"..(j-1)],5)),2))}" styleName="brown01" fontSize="24" x="${ nx}" y="1" width="212" textAlign="right"/>
											{end}
										{end }
									{end }
								{end }
							</mx:Canvas>
						
						{end}
						{print("strTopLvFunc::",strTopLvFunc)
						if strTopLvFunc ~= "" then}
						<mx:Canvas height="35">
							<mx:Image source="assets/images/line01.png" x="23"/>
							{if arg[1][1] == 12 then}
								<mx:Label text="31" styleName="brown01" fontSize="24" x="107" y="1"/>
							{else}
								<mx:Label text="${(#aupconfall == 31 and 31 or  "31~"..#aupconfall)}" styleName="brown01" fontSize="24" x="107" y="1"/>
							{end}
							<mx:Label text="${strTopLvFunc}" styleName="brown01" fontSize="24" x="235" y="1" width="362" textAlign="right"/>
						</mx:Canvas>		
						{end}
			</mx:VBox>
		</mx:Canvas>
	</mx:Canvas>
</mx:VBox>	
</mx:Canvas>
]]

--建筑类型，建筑名,等级列表高度,列名集{列名，宽，x坐标,对齐方式[left/center/right]},如：{14,'大使馆',435,{"等级","增援"}}
local bulid_config_for_info = {
							a1 = {1,'议院',473,{"等级","出战数","军队"},{"","%s","%s"}},
							a2 = {2,'宝库',1043,{"等级","保护量"},{"","%s"}},
							a3 = {3,'瞭望塔',1043,{"等级","反侦查"},{"","%s"}},
							a4 = {4,'铁匠铺',1043,{"等级","锻造速度"},{"","+%s%%"}},
							a5 = {5,'城墙',1043,{"等级","城防上限"},{"","%s"}},
							a11 = {11,'学院',1043,{"等级","研发速度"},{"","+%s%%"}},
							a12 = {12,'竞技场',1043,{"等级","经验加成","被捕"},{"","+%s%%","-%s%%"}},
							a13 = {13,'监狱',1043,{"等级","捕获率","保护俘虏量"},{"","+%s%%","%s"}},
							a14 = {14,'大使馆',435,{"等级","增援"},{"","%s"}},
							a15 = {15,'战争会所',473,{"等级","集结士兵"},{"","%s"}},
							
							a16 = {16,'交易所',1043,{"等级","宝石等级"},{"","%s"}},
							
							a21 = {21,'兵营',353,{"等级","训练速度"},{"","+%s%%"}},
							a22 = {22,'医院',490,{"等级","治疗量"},{"","%s"}},
							a23 = {23,'采石场',1043,{"等级","产值","产能"},{"","%s/h","%s"}},
							a24 = {24,'伐木场',1043,{"等级","产值","产能"},{"","%s/h","%s"}},
							a25 = {25,'铁矿场',1043,{"等级","产值","产能"},{"","%s/h","%s"}},
							a26 = {26,'农庄',1043,{"等级","产值","产能"},{"","%s/h","%s"}},
							a27 = {27,'民居',1043,{"等级","产值","产能","训练"},{"","%s/h","%s","+%s"}},
							
							a31 = {31,'水晶矿场',1043,{"等级","产值","产能"},{"","%s/h","%s"}},
							a32 = {32,'制皮所',1043,{"等级","产值","产能"},{"","%s/h","%s"}},
							a33 = {33,'织布厂',1043,{"等级","产值","产能"},{"","%s/h","%s"}},
							a34 = {34,'酿酒厂',1043,{"等级","产值","产能"},{"","%s/h","%s"}},
							}
local bulid_str = {
				a1 = [[<mx:Image source="assets/images/img01Help08.png" width="641" height="511" x="39.5" y="168"/>
		<mx:Label text="如果建筑等级很低" fontSize="24" styleName="brown03" x="81" y="146" width="560.2" textAlign="center"/>
		<mx:Label text="升级后" fontSize="24" styleName="brown03" x="79.9" y="380" width="560.2" textAlign="center"/>]],
		a2 = [[]],
		a3 = [[]],
		a12 = [[]],
		a13 = [[]],
		a14 = [[]],
		a15 = [[<mx:Image source="assets/images/img01Help09.png" width="561" height="347" x="79.5" y="241"/>
		<mx:Text text="当你的敌人过于强大时，你可以召集队友发送联合攻击" fontSize="24" styleName="brown03" x="81" y="146" width="560"/>
		]],
		a16 = [[]],
		a21 = [[
		<mx:Canvas x="15" width="690">
			<mx:Canvas id="campHelp_content" x="0" width="2880">
				<mx:Canvas x="0">
					<mx:Image source="assets/images/img04Help02.png" width="494" height="595" x="94" y="189"/>
					<mx:Label text="兵种相克性" fontSize="24" styleName="brown03" x="234" y="146" width="252" textAlign="center"/>
					<mx:Image source="assets/images/arr01.png" x="631" y="401" setts="1" onclick="campHelp_btnClick"/>
					
				</mx:Canvas>
				<mx:Canvas x="720">
					<mx:Image source="assets/images/img01Help02.png" width="547" height="670" x="83" y="125"/>
					<mx:Label text="如何训练" fontSize="24" styleName="brown03" x="190" y="134"/>
					<mx:Image source="assets/images/arr01.png" x="631" y="401" setts="2" onclick="campHelp_btnClick"/>
					<mx:Image source="assets/images/arr05.png" x="33" y="401" setts="3" onclick="campHelp_btnClick"/>
				</mx:Canvas>
				<mx:Canvas x="1440">
					<mx:Image source="assets/images/img02Help02.png" width="547" height="670" x="83" y="125"/>
					<mx:Label text="如何训练" fontSize="24" styleName="brown03" x="241" y="134"/>
					<mx:Image source="assets/images/arr01.png" x="631" y="401" setts="4" onclick="campHelp_btnClick"/>
					<mx:Image source="assets/images/arr05.png" x="33" y="401" setts="5" onclick="campHelp_btnClick"/>
				</mx:Canvas>
				<mx:Canvas x="2160">
					<mx:Image source="assets/images/img03Help02.png" width="547" height="670" x="83" y="125"/>
					<mx:Label text="如何训练" fontSize="24" styleName="brown03" x="290" y="135"/>
					<mx:Image source="assets/images/arr05.png" x="33" y="401" setts="6" onclick="campHelp_btnClick"/>
				</mx:Canvas>
				
			</mx:Canvas>
		</mx:Canvas>
		]],
		a22 = [[<mx:Image source="assets/images/img01Help07.png" width="606" height="400" x="57" y="198"/>
		<mx:Label text="当你的城市被攻击时" fontSize="24" styleName="brown03" x="81" y="146" width="560.2" textAlign="center"/>
		<mx:Label text="你的士兵在战斗中受伤会进入医院" fontSize="24" styleName="brown03" x="79.9" y="380" width="560.2" textAlign="center"/>
		]],
		a23 = [[]],
		a24 = [[]],
		a25 = [[]],
		a26 = [[]],
		a27 = [[]],
				a14 = [[<mx:Image source="assets/images/img01Help03.png" width="568" height="474" x="76" y="235"/>
		<mx:Text fontSize="24" styleName="brown03" y="135" text="当你一个人无法应对过多的敌人时，大使馆可以帮助你召集盟友共同对抗敌人。" x="63" width="592"/>]]
					}
				
--[[
1、策划文档优先
2、如果是百分比的前面加  "+"
3、如果非百分比的则就显示数据
--数值显示类型:
1,20     只显示数值
2,+7%    加百分比
3,-7%    减百分比
4,300/H  每小时产量
5,+30    加数值
]]
function buildInfo_show( pos )--建筑类型
	local ainfo = CUserData:getBuildBypos(pos )
	if ainfo == nil then
		return
	end
	
	local nbuildingtype = ainfo[2]
	local nCurLevel = ainfo[3]
	print("buildInfo_show nbuildingtype:"..nbuildingtype)
	local aconf = CUserData:getbuildingConfigByid(nbuildingtype )
	local arg = {}
	
	local aupconfall = {}	--升级配置表表集合	
	local nTotalCcolNum = 0
	local strTopLvFunc = ""
	if aconf ~= nil then
		local nid = nbuildingtype
		local nlv = 0
		local flag = true		
		repeat
			nlv = nlv + 1		
			local nupid = nid * 10000 + nlv--(F0)建筑编号×10000＋等级			
			local aupconf = CUserData:getbuildingUpgConfigByid(nupid ) --F15 17 19 21 	,读取兵营升级配置表			
			if aupconf ~= nil then
				if nbuildingtype == 16 then
					aupconf.F16 = market_getdes(aupconf["F16"])
				end			
				table.insert(aupconfall,aupconf )
				 			
			else
				flag = false--找不到升级配置记录则退出循环	
			end
		until flag == false
		-- 15 17 19 --建筑功能
		local aupconf = aupconfall[1]
		nTotalCcolNum = getBulidUpFunNum(aupconf)
		
		
		
		aupconf = aupconfall[#aupconfall ]
		local lastTotalnum = getBulidUpFunNum(aupconf)
		print("nTotalCcolNum,lastTotalnum",nTotalCcolNum,lastTotalnum)
		if aupconf ~= nil and nTotalCcolNum ~= lastTotalnum then
			local str = "0"
			for i = 20 ,16 , -2 do
				print("F-----",i,aupconf["F"..i])
				if aupconf["F"..i] ~= "0" then
					str = aupconf["F"..i]
					break
				end
			end
			print("str---",str)
			local nnum = tonumber( str )
			print("nnum---",nnum)
			if nnum == nil then
				nnum = 0		
			end
			if nbuildingtype == 1 then--1议院:行军速度 +15%
				nnum = nnum / 10
				strTopLvFunc = 	CData:GetTranlang("行军速度")
				strTopLvFunc = strTopLvFunc.." +"..nnum.."%"				
			elseif nbuildingtype == 3 then--3瞭望塔:攻击你城池的军队攻击力降低 10%
				strTopLvFunc = 	CData:GetTranlang("攻击你城池的军队攻击力")
				strTopLvFunc = strTopLvFunc.." -"..(nnum/10).."%"
			elseif nbuildingtype == 5 then--5城墙:城防攻击 +10%
				strTopLvFunc = 	CData:GetTranlang("城防攻击")
				strTopLvFunc = strTopLvFunc.." +"..(nnum/10).."%"
			elseif nbuildingtype == 12 then--12竞技场:英雄技能点+30
				strTopLvFunc = 	CData:GetTranlang("英雄技能点")
				strTopLvFunc = strTopLvFunc.." +"..nnum..""
			elseif nbuildingtype == 14 then--14大使馆:防守时攻击力度 +10%
				nnum = nnum / 10
				strTopLvFunc = 	CData:GetTranlang("防守时攻击力")
				strTopLvFunc = strTopLvFunc.." +"..nnum.."%"
			elseif nbuildingtype == 15 then--15战争会所:联合攻击攻击力+10%	
				nnum = nnum / 10
				strTopLvFunc = 	CData:GetTranlang("联合攻击攻击力")
				strTopLvFunc = strTopLvFunc.." +"..nnum.."%"
			end
		elseif nbuildingtype == 2 then--2宝库：银币可以被保护				
			strTopLvFunc = 	CData:GetTranlang("银币可以被保护")	
		end	
	end
	local axpos = {
	a2 = {107,385},
	a3 = {107,160,385},
	a4 = {107,80,245,385}
	}
	arg = {aupconfall,nTotalCcolNum,strTopLvFunc,nCurLevel,axpos}
	
	arg =  {bulid_config_for_info["a"..nbuildingtype],arg}
	flextodiv(div_buildInfoItem_str,arg,"frame_more",nil,nil,{5,nil,{g_dTouchX,g_dTouchY}})
end

function getBulidstr(type)
	local str = bulid_str["a"..type]
	if str == nil then
		str = ""
	end
	return str
end

function getBulidUpFunNum(aupconf)--返回建筑等级对应的功能数
	local nTotalCcolNum = 0
	if aupconf ~= nil then
		for i = 16 ,20 , 2 do
			if aupconf["F"..i] ~= "0" then
				nTotalCcolNum = nTotalCcolNum + 1
			end
		end
	end
	return nTotalCcolNum
end

function buildInfo_btnClick(a)
	deldiv("frame_more","buildInfo_main")
end

function buildInfo_onloadcmp(a)
	print("buildInfo_onloadcmp" )
	guideNew_showHotRect({1,{60}})
end


local g_campHelp_contentMoveState = 0 --1移动中,0 否

function campHelp_btnClick(a)
	local nindex = tonumber(a.pBase:getts() )
	print("campHelp_btnClick nindex:"..nindex)
	if nindex == 0 then
		deldiv("frame_more","buildInfo_main")
	elseif nindex == 1 then--1 Right
		campHelp_contentMoveTo(2)
	elseif nindex == 2 then--2 Right
		campHelp_contentMoveTo(3)
	elseif nindex == 3 then--2 Left
		campHelp_contentMoveTo(1)
	elseif nindex == 4 then--3 R
		campHelp_contentMoveTo(4)
	elseif nindex == 5 then--3 L
		campHelp_contentMoveTo(2)
	elseif nindex == 6 then--4 L
		campHelp_contentMoveTo(3)	
	end
end

function campHelp_onloadcmp(a)
	print("campHelp_onloadcmp" )
	
end

function campHelp_contentMoveTo(nindex )
	print("campHelp_contentMoveTo nindex:"..nindex )
	if g_campHelp_contentMoveState == 1 then
		print("err campHelp_contentMoveTo State == 1")
		return
	end
	local aendx = {0,-720,-1440,-2160}
	local nendx = aendx[nindex]
	if nendx ~= nil then
		local div = getid2("frame_more","campHelp_content")
		if div ~= nil then
			if div:x() ~= nendx then
				g_campHelp_contentMoveState = 1
				local ndifx = nendx - div:x()
				
				addaction3( {actionid="campHelp_content_action",id="buildInfo_main",over="campHelp_contentMoveToOver"
							, {id="campHelp_content",time=0.1,tox=nendx+ndifx/10 }
							, {id="campHelp_content",time=0.1,tox=nendx}
							
							} )
			end
		end
	end
end

function campHelp_contentMoveToOver(a)
	print("campHelp_contentMoveToOver")
	g_campHelp_contentMoveState = 0
end
