--建筑列表
local div_buildList_str = [[ 
	{
	local aconf = arg[1]
	}
	<mx:Canvas id="buildList_main" width="720" height="1280" onloadcmp="buildList_onloadcmp">
		<mx:Canvas width="720" height="112">
			<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
			<mx:Label id="frameTop_txt" text="建筑列表" width="720" textAlign="center" y="35"/>
			<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" onclick="buildList_btnCloseClick"/>
		</mx:Canvas>
		<mx:Image source="assets/images/bg01.jpg" width="720" height="990" y="111"/>
		<mx:Canvas height="960" y="115" setslidetype="1">
			<mx:VBox verticalGap="0" x="35"   verticalScrollPolicy="off" mouseThrough="true">
				{for i = 1 , #aconf do
					local v 	= aconf[i][1]
					local flag 	= aconf[i][2] 
					local aupconf = aconf[i][3] }
					<mx:Canvas width="645" height="160" mouseChildren="false" mouseThrough="true" setts="${v["F0"]}" sound="defalut" onclick="buildList_btnItemClick">
						<mx:Image source="assets/images/line01.png" y="156"/>
						<mx:Image source="${CUserData:getbuildingConfigByid(v["F0"],2) }" x="22" y="13" width="150" height="140"/>
						<mx:Label text="${v["F1"]}" fontSize="30" styleName="black01" x="202" y="16"/>
						<mx:Label text="${v["F3"]}" styleName="black01" fontSize="22" x="203" y="53" width="420"/>
						{if flag == 0 then
							local nlv1 = CUserData:getBuildMaxLvByid(tonumber(aupconf["F2"]))
							local nlv2 = CUserData:getBuildMaxLvByid(tonumber(aupconf["F4"]))
							local str = ""
							if tonumber(aupconf["F2"]) ~= 0 then
								local aconf = CUserData:getbuildingConfigByid(tonumber(aupconf["F2"]) )
								if aconf ~= nil then
									if nlv1 < tonumber(aupconf["F3"]) then
										str = str ..string.format(CData:GetTranlang("%s 建筑(等级:%d)").."   ",CData:GetTranlang(aconf["F1"]),tonumber(aupconf["F3"]) ) 
									end
								end
							end
							if tonumber(aupconf["F4"]) ~= 0 then
								local aconf = CUserData:getbuildingConfigByid(tonumber(aupconf["F4"]) )
								if aconf ~= nil then
									if nlv2 < tonumber(aupconf["F5"]) then
										str = str ..string.format(CData:GetTranlang("%s 建筑(等级:%d)"),CData:GetTranlang(aconf["F1"]),tonumber(aupconf["F5"]) ) 
									end
								end
							end
							}
							<!mx:Label text="Requirements Not Met" styleName="red01" fontSize="22" x="203" y="103"/>
							<mx:Label text="${str}" styleName="red01" fontSize="22" x="203" y="123"/>
						{end}
					</mx:Canvas>
				{end}
			</mx:VBox>
		</mx:Canvas>
	</mx:Canvas>
]]
--[[
	外城 224 225 226 229 230 233 234 236 
	以上8块地只能造特产建筑,
	特产建筑类型:31 32 33 34
]]
local g_buildList_type = 1
local g_buildList_pos  = nil
function buildList_show(ntype,pos)--ntype:1 内城 , 2 外城
	playSound(114)
	g_buildList_type = ntype
	g_buildList_pos  = pos
	local aconf = CUserData:getbuildingConfigAll()
	local aspepos  = {224,225,226,229,230,233,234,236}--特产地块
	local aspebuild= {31,32,33,34}--特产建筑类型
	
	--新手阶段 aGuideNewArea 可建类型,
	--如果该建筑类型已有建筑了，则不能再建筑
	local aGuideNewArea= guideNew_getCityArea()--新手阶段开放的地块及对应建筑类型,如果是空table,则表示全部开放
	local afindGuideNewArea = 0 --新手限制是否有效
	local afindGuideBuild   = {} --新手限制中允许的建筑类型
	for i = 1 ,#aGuideNewArea do
		afindGuideNewArea = 1 		
		local nmaxlv = CUserData:getBuildMaxLvByid(aGuideNewArea[i][2] )
		local nenabled = 0
		if nmaxlv == 0 then
			--建筑是否正在建造
			local aqueue = CUserData:getQueueInfoByid(1 )
			if aqueue ~= nil then
				local ainfo = CUserData:getBuildBypos(aqueue[4])
				if ainfo[2] == aGuideNewArea[i][2]  then
					nenabled = 0			
				else
					nenabled = 1		
				end	
			else
				nenabled = 1			
			end
		else
			nenabled = 0
		end
		if nenabled == 1 then
			table.insert(afindGuideBuild,aGuideNewArea[i][2] )
		end
	end
	
	--1、建筑上限已到的,则不在建造列表中出现了
	--2、前置建筑等级不足 
	local aconf2 = {}
	for i = 1 ,#aconf do
		local v = aconf[i]		
		if ntype == tonumber( v["F8"])  then--ntype:1 内城 , 2 外城
			local ncount = CUserData:getBuildCountByid(tonumber(v["F0"]))
			if ncount < tonumber( v["F7"]) then
				local nspefind = -1 --是否是特产地块区域
				if ntype == 2 then
					nspefind = 0 
					for kk = 1 ,#aspepos do
						if aspepos[kk] == pos then
							nspefind = 1	
							break
						end
					end
				end				
				local nenabled = 0 --该地块是否显示
				if nspefind == -1 then--内存
					nenabled = 1
				elseif nspefind == 0 then--外城 非特产区域
					local nfind = 0
					for kk = 1 , #aspebuild do
						if aspebuild[kk] == tonumber(v["F0"] ) then
							nfind = 1 
							break
						end
					end 
					if nfind == 0 then
						nenabled = 1
					end
				elseif nspefind == 1 then--外城 特产区域
					local nfind = 0
					for kk = 1 , #aspebuild do
						if aspebuild[kk] == tonumber(v["F0"] ) then
							nfind = 1 
							break
						end
					end 					
					if nfind == 1 then
						nenabled = 1
					end
				end
				if nenabled == 1 then
					if afindGuideNewArea == 1 then--新手阶段开放的地块及对应建筑类型
						local nfind = 0
						for i = 1 ,#afindGuideBuild do
							if afindGuideBuild[i] == tonumber(v["F0"] ) then
								nfind = 1
								break
							end
						end
						if nfind == 0 then
							nenabled = 0
						end
					end	
				end
				if nenabled == 1 then
					local aupid   = v["F0"] * 10000 + 1
					local aupconf = CUserData:getbuildingUpgConfigByid(aupid)
					if aupconf ~= nil then
						local nlv1 = CUserData:getBuildMaxLvByid(tonumber(aupconf["F2"]))
						local nlv2 = CUserData:getBuildMaxLvByid(tonumber(aupconf["F4"]))
						if nlv1 >= tonumber(aupconf["F3"]) and nlv2 >= tonumber(aupconf["F5"]) then --前置建筑条件
							table.insert(aconf2, {aconf[i],1,aupconf} )	
						else
							table.insert(aconf2, {aconf[i],0,aupconf} )	
						end		
					end
				end
			end
		end
	end
	local arg = {aconf2 }
	flextodiv(div_buildList_str,arg ,"frame_more",nil,nil,{5,"buildList_onloadcmp",{g_dTouchX,g_dTouchY}})
	--frame_TopPushId({1,"buildList_main","建筑列表"} )
end

function buildList_btnClick(a)
	local nindex = tonumber( a.pBase:getts() )
	if nindex == 1 then
		deldiv("buildList_main")	
	elseif nindex == 2 then
	
	end
end

function buildList_btnItemClick(a)
	local nindex = tonumber(a.pBase:getts() )
	
	--测试数据 找到一个未使用过的pos
	--[[
	城内：101～129
	议院：101（大型）
	城墙：0
	城外：201～236
	交易所：201（大型）
	]]
	local pos = 101
	local aconf = CUserData:getbuildingConfigByid(nindex )
	local abuild= copytable(CUserData.m_aBuild )
	if aconf ~= nil then
		local ntype = tonumber(aconf["F8"] ) 
		if ntype == 2 then
			pos = 201
		end
		local flag = true
		repeat 
			local nfind = 0
			for i = 1 ,#abuild do
				if abuild[i][1] == pos then
					nfind = 1
					break
				end
			end
			if nfind == 0 then
				flag = false
			else
				pos = pos + 1 
			end			
		until flag == false
	end
	local pos2 = g_buildList_pos
	if pos2 == nil then
		pos2 = pos
	end
	buildUpgrade_show(pos2,nindex,false)
end

function buildList_onloadcmp(a)
	--guide_showHotRect({7,14})
	guideNew_showHotRect({1,{6,18,45}})
end	

function buildList_btnCloseClick(a)
	deldiv("frame_more","buildList_main",{3})
end

