--建筑升级 buildUpgrade
local div_buildUpgrade_str = [[
	{
	local ainfo = arg[1]
	local aconf = arg[2]
	local aupgconf = arg[3]
	local aqueue = arg[4]
	local astuff = arg[5]
	local pvebuilding = arg[6]
	local afuncstr = arg[7]
	local buildingpos = arg[8]
	local szid = arg[9]	
	local ncanup = arg[10]--该建筑是否可以升级
	local nismaxlv = arg[11]--该建筑是否满级
	local nisprobuild = arg[12]--前置建筑是否满足
	local nbuildinglv = arg[13]
	local nchamberCanUp = arg[14]
	local pveTech = arg[15]
	}
	<mx:Canvas id="buildUpgrade_main" width="720" height="1280" onloadcmp="buildUpgrade_onloadcmp" systemload="2">
		<mx:Canvas width="720" height="112">
			<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
			{local str = string.format("%s LV.%d",CData:GetTranlang(aconf["F1"]),nbuildinglv) 
			if g_main_apptype == 1 then 
				str = string.format("%s 레벨 %d",CData:GetTranlang(aconf["F1"]),nbuildinglv) 
			end
			}
			<mx:Label id="frameTop_txt" text="${str }" width="720" textAlign="center" y="35"/>
			<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" setts="4" onclick="buildUpgrade_btnCloseClick"/>
		</mx:Canvas>
		<mx:Image source="assets/images/bg01.jpg" width="720" height="990" y="111"/>
		<mx:Image source="assets/images/bar04.png" y="111"/>
		<mx:Button onclick="city_btnTopClick" setts="${buildingpos}|1" styleName="navi01" label="功能" sound="assets/sound/421.ogg" enabled="true" x="24" y="122" id="city_btnBuildingTop1"/>
		<mx:Button onclick="city_btnTopClick" setts="${buildingpos}|2" styleName="navi01" label="升级" sound="assets/sound/421.ogg" enabled="false" x="366" y="122" id="city_btnBuildUpgradeTop2" />
		
		<mx:Image source="assets/images/block09.png" width="706" height="234" x="8" y="216"/>
		<mx:Image source="assets/building/${aconf["F2"]}.png" x="49" y="240" width="136" height="98"/>		
		{if g_main_apptype == 1 then}
			<mx:Label text="레벨 ${ainfo[3]}" fontSize="24" styleName="brown01" x="311" y="231"/>
		{else}
			<mx:Label text="Level ${ainfo[3]}" fontSize="24" styleName="brown01" x="311" y="231"/>
		{end}
		<mx:Text fontSize="18" styleName="brown01" text="${aconf["F3"]}" x="188" y="261" width="480"/>
		<mx:Image source="assets/images/box01.png" x="42" y="346"/>
		
		{if g_main_apptype == 1 then}
			<mx:Text text="다음" fontSize="24" styleName="green01" textAlign="center" x="49" y="365" width="110"/>
			<mx:Text text="레벨" fontSize="24" styleName="green01" textAlign="center" x="49" y="390" width="110"/>
		{else}
			<mx:Text text="Next" fontSize="24" styleName="green01" textAlign="center" x="49" y="365" width="110"/>
			<mx:Text text="Level" fontSize="24" styleName="green01" textAlign="center" x="49" y="390" width="110"/>
		{end}
		<mx:Image source="assets/images/box02.png" x="184" y="346"/>
		<mx:Canvas x="198" y="360" width="400" height="50" setslidetype="1">
			<mx:VBox  mouseThrough="true" verticalGap="-7">
				{for i = 1 , #afuncstr do}
					<mx:Text fontSize="18" styleName="white03" leading="10" text="${afuncstr[i]}" width="400" mouseThrough="true"/>		
				{end}
				{if tonumber(aconf["F0"]) == 3 and #afuncstr == 0 then }
					<mx:Text fontSize="18" styleName="white03" leading="10" text="可以更有效获取敌方的进攻信息" width="400" mouseThrough="true"/>		
					<mx:Text fontSize="18" styleName="white03" leading="10" text="更好的减少敌人对你的侦查风险" width="400" mouseThrough="true"/>		
				{end}
			</mx:VBox>
		</mx:Canvas>
		<mx:Button id="buildUpgrade_btnDetail" styleName="btn01Detail" y="356" x="623" setts="6" onclick="buildUpgrade_btnClick"/>
		
		
		<mx:Image source="assets/images/bar02.png" y="448" x="3"/>
		{if #aqueue >= 1 then}
			<!-- 以下升级中显示 -->			
			{
				local dismax = aqueue[3] - aqueue[2]
				local discur = CUserData:getLeavingsTime(aqueue[3])
				local strtime= formatTime(discur)
				if dismax == 0 then dismax = 1 end
				local dispro = 377 * (1- discur / dismax )
				local protext = string.format(CData:GetTranlang("升级中%s"),strtime) 
				if ainfo[3] == 0 then --建造
					protext = string.format(CData:GetTranlang("建造中%s"),strtime) 
				end
				if aqueue[5] == 2 then
					protext = string.format(CData:GetTranlang("拆除中%s"),strtime) 
				end
			}
			<mx:Image source="assets/images/progBg01.png" y="471" x="109"/>
			
			<mx:Button styleName="btn01Close" x="45" y="463" setts="1" onclick="buildUpgrade_btnClick"/>
			{if buildUpgrade_getstate(aqueue ) == 0 then
				buildUpgrade_setQueueType(0 ) }
				<mx:Canvas id="buildUpgrade_prog" styleName="prog07" width="${dispro}" height="31" y="476" x="114"/>
				<mx:Button enabled="true" styleName="btn05" width="187" height="70" label="加速" x="503" y="458" setts="2" id="buildUpgrade_btn_2" onclick="buildUpgrade_btnClick"/>
			{elseif buildUpgrade_getstate(aqueue ) == 1 then--help
				buildUpgrade_setQueueType(1 ) }
				<mx:Canvas id="buildUpgrade_prog" styleName="prog05" width="${dispro}" height="31" y="476" x="114"/>
				<mx:Button enabled="true" styleName="btn14" width="187" height="70" label="帮助" x="503" y="458" setts="7" id="buildUpgrade_btn_7" onclick="buildUpgrade_btnClick"/>
			{elseif buildUpgrade_getstate(aqueue ) == 2 then--free
				buildUpgrade_setQueueType(2 ) }
				<mx:Canvas id="buildUpgrade_prog" styleName="prog06" width="${dispro}" height="31" y="476" x="114"/>
				<mx:Button enabled="true" styleName="btn03" width="187" height="70" label="免费" x="503" y="458" setts="8" id="buildUpgrade_btn_8" onclick="buildUpgrade_btnClick"/>
			{end}
			<mx:Label id="buildUpgrade_progtext" text="${protext}" fontSize="24" styleName="white01" x="124" y="475" width="357" textAlign="center" mouseThrough="true"/>
			
			<!-- 以上升级中显示 -->
		{else
			local btn1text = "立刻升级"
			local btn2text = "升级"
			if ainfo[3] == 0 then --建造
				btn1text = "立刻建造"
			 	btn2text = "建造"
			end
			local ngold,ntime,nenough = buildUpgrade_getGoldUp()
			if nenough == 0 then--资源不足
				if ainfo[3] == 0 then
					btn1text = "购买建造"
				else
					btn1text = "购买升级"
				end
			end
			--建筑升级时间=建筑基础升级时间/(1+41)
			ntime = ntime / ( 1 + CUserData:getFuncData(41)/1000 )
			if ntime % 1 > 0 then
				ntime = ntime + 1
			end
			ntime = ntime - ntime % 1 
			local strtime = formatTime(ntime)
			--建筑升级时间=建筑基础升级时间/(1+41)
			
			
			local strgold = string.format("%d",ngold)
			
			--是否可以升级
			local strenabled = "true"
			if ncanup == 0 then
				strenabled = "false"
			end
			--是否可以拆除
			local strEnabledRemove = "true"
			if tonumber( aconf["F5"]) == 0 then
				strEnabledRemove = "false"
			end
			--是否可以立刻升级
			local strEnabledSpeed = "false"
			if nismaxlv == 0 and nisprobuild == 1 then
				strEnabledSpeed = "true"
			end
			}
			<!-- 以下升级完成显示 -->
			{if ainfo[3] ~= 0 then}
				<mx:Button enabled="${strEnabledRemove}" styleName="btn04" label="拆除" x="42" y="458" setts="3" id="buildUpgrade_btn_3" onclick="buildUpgrade_btnClick"/>
			{end}
			{if nchamberCanUp == 0 then
				strEnabledSpeed = "false"
				strenabled = "false"
			end
			}
			<mx:Button enabled="${strEnabledSpeed}" styleName="btn05speedbuild" x="262" y="458" setts="4" id="buildUpgrade_btn_4" onclick="buildUpgrade_btnClick"/>
			<mx:Label id="buildUpgrade_btn_4_gold" text="${strgold}" styleName="white01" fontSize="20" x="277" y="470" width="160" textAlign="center" mouseThrough="true"/>
			<mx:Label id="buildUpgrade_btn_4_text" text="${btn1text}" styleName="white01" fontSize="20" x="277" y="488" width="160" textAlign="center" mouseThrough="true"/>
			<mx:Button enabled="${strenabled}" styleName="btn03" x="486" y="458" setts="5" id="buildUpgrade_btn_5" onclick="buildUpgrade_btnClick"/>
			{local ntime = 0
			if aupgconf["F10"] ~= nil then
				ntime = aupgconf["F10"]
			end
			ntime = tonumber(ntime )
			if ntime == nil then ntime = 0 end
			ntime = ntime / (1+CUserData:getFuncData(41)/1000)
			}
			<mx:Label id="buildUpgrade_btn_5_time" text="${formatTime( ntime )}" styleName="white01" fontSize="20" x="499" y="470" width="160" textAlign="center" mouseThrough="true"/>
			<mx:Label text="${btn2text}" styleName="white01" fontSize="20" x="499" y="488" width="160" textAlign="center" mouseThrough="true"/>
			<!-- 以上升级完成显示 -->
		{end}
		
		<mx:Canvas  y="561" height="510" setslidetype="1">
			<mx:VBox>
				<mx:Canvas>
					<mx:Label fontSize="30" styleName="brown01" text="需求" x="296.5" y="0" width="136" textAlign="center"/>
					<mx:Image source="assets/images/ttl01.png" x="159.5" y="40"/>
					<mx:Image source="assets/images/th.png" x="16.5" y="70"/>
					<mx:Label text="类型" fontSize="20" styleName="white02" x="82" y="70"/>
					<mx:Label text="需要" fontSize="20" styleName="white02" x="297" y="70"/>
					<mx:Label text="实际" fontSize="20" styleName="white02" x="484" y="70"/>
				</mx:Canvas>
				<mx:VBox verticalGap="0" x="22" mouseChildren="true" mouseThrough="true">
					{for i = 1 , #pvebuilding do--前置建筑信息
						local v = pvebuilding[i] }
						<mx:Canvas mouseThrough="true">
							<mx:Label text="${v[1]["F1"]}" fontSize="20" styleName="brown01" x="60" y="16" mouseThrough="true"/>
							<mx:Label text="${string.format(CData:GetTranlang("等级：%d"),tonumber(v[2]))}" fontSize="20" styleName="brown01" x="215" width="173" textAlign="center" y="16" mouseThrough="true"/>			
							{if tonumber(v[2]) > tonumber(v[3]) then}
								<mx:Label text="${string.format(CData:GetTranlang("等级：%d"),tonumber(v[3]))}" fontSize="20" styleName="red01" x="417" width="125" textAlign="center" y="16" mouseThrough="true"/>
								<!mx:Label text="not" fontSize="20" styleName="red01" x="571" y="7"/>
								<mx:Button styleName="btn10" label="查看" setts="${v[1]["F0"]}" x="538" y="5" onclick="buildUpgrade_btnPreBuildClick"/>
							{else}
								<mx:Label text="${string.format(CData:GetTranlang("等级：%d"),tonumber(v[3]))}" fontSize="20" styleName="brown01" x="417" width="125" textAlign="center" y="16" mouseThrough="true"/>
								<mx:Label text="have" fontSize="20" styleName="green01" x="571" y="16" mouseThrough="true"/>
							{end}
							<mx:Image source="assets/images/line01.png" y="56"/>
						</mx:Canvas>
					{end}
					{for i = 1 , #pveTech do--前置科技信息
						local v = pveTech[i] 
						print("v[5]::",v[5])}
						<mx:Canvas mouseThrough="true">
							<mx:Label text="${v[2]}" fontSize="20" styleName="brown01" x="60" y="16" mouseThrough="true"/>
							<mx:Label text="${string.format(CData:GetTranlang("等级：%d"),tonumber(v[3]))}" fontSize="20" styleName="brown01" x="215" width="173" textAlign="center" y="16" mouseThrough="true"/>			
							{if v[5] == 0 then}
								{if v[1] > 0 then}
								<mx:Label text="${string.format(CData:GetTranlang("等级：%d"),tonumber(v[4]))}" fontSize="20" styleName="red01" x="417" width="125" textAlign="center" y="16" mouseThrough="true"/>
								{else}
								<mx:Label text="未达到" fontSize="20" styleName="red01" x="417" width="125" textAlign="center" y="16" mouseThrough="true"/>
								{end}
								<!mx:Label text="not" fontSize="20" styleName="red01" x="571" y="7"/>
								<mx:Button styleName="btn10" label="查看" setts="${v[1]}" x="538" y="5" onclick="buildUpgrade_toTech"/>
							{else}
								{if v[1] > 0 then}
								<mx:Label text="${string.format(CData:GetTranlang("等级：%d"),tonumber(v[3]))}" fontSize="20" styleName="brown01" x="417" width="125" textAlign="center" y="16" mouseThrough="true"/>
								{else}
								<mx:Label text="--" fontSize="20" styleName="brown01" x="417" width="125" textAlign="center" y="16" mouseThrough="true"/>
								{end}
								<mx:Label text="have" fontSize="20" styleName="green01" x="571" y="16" mouseThrough="true"/>
							{end}
							<mx:Image source="assets/images/line01.png" y="56"/>
						</mx:Canvas>
					{end}
					{if aupgconf["F6"] ~= nil then}
						<mx:Canvas mouseThrough="true">
							<!mx:Label text="石" fontSize="20" styleName="brown01" x="60" y="7"/>
							
							<mx:Image width="33" height="28" source="assets/images/ico1_stone.png" x="60" y="16" mouseThrough="true"/>
							
							<mx:Label text="${CUserData:getNumStr(tonumber( aupgconf["F6"] ),1 ) }" fontSize="20" styleName="brown01" x="215" width="173" textAlign="center" y="16" mouseThrough="true"/>			
							{if tonumber(aupgconf["F6"]) > tonumber(astuff[1]) then}
								<mx:Label text="${CUserData:getNumStr(tonumber(astuff[1]),1)}" fontSize="20" styleName="red01" x="417" width="125" textAlign="center" y="16" mouseThrough="true"/>
								<!mx:Label text="not" fontSize="20" styleName="red01" x="571" y="7" mouseThrough="true"/>
								<mx:Button styleName="btn11" label="购买" x="538" y="5" setts="1" onclick="buildUpgrade_btnResGainClick"/>
							{else}
								<mx:Label text="${CUserData:getNumStr(tonumber(astuff[1]),1)}" fontSize="20" styleName="brown01" x="417" width="125" textAlign="center" y="16" mouseThrough="true"/>
								<mx:Label text="have" fontSize="20" styleName="green01" x="571" y="16" mouseThrough="true"/>
							{end}
							<mx:Image source="assets/images/line01.png" y="56" mouseThrough="true"/>
						</mx:Canvas>
						<mx:Canvas mouseThrough="true">
							<!mx:Label text="木" fontSize="20" styleName="brown01" x="60" y="7"/>
							
							<mx:Image width="33" height="28" source="assets/images/ico1_wood.png" x="60" y="16" mouseThrough="true"/>
							<mx:Label text="${CUserData:getNumStr(tonumber(aupgconf["F7"]),1)}" fontSize="20" styleName="brown01" x="215" width="173" textAlign="center" y="16" mouseThrough="true"/>				
							{if tonumber(aupgconf["F7"]) > astuff[2] then}
								<mx:Label text="${CUserData:getNumStr(tonumber(astuff[2]),1)}" fontSize="20" styleName="red01" x="417" width="125" textAlign="center" y="16" mouseThrough="true"/>
								<!mx:Label text="not" fontSize="20" styleName="red01" x="571" y="7"/>
								<mx:Button styleName="btn11" label="购买" x="538" y="5" setts="2" onclick="buildUpgrade_btnResGainClick"/>
							{else}
								<mx:Label text="${CUserData:getNumStr(tonumber(astuff[2]),1)}" fontSize="20" styleName="brown01" x="417" width="125" textAlign="center" y="16" mouseThrough="true"/>
								<mx:Label text="have" fontSize="20" styleName="green01" x="571" y="16" mouseThrough="true"/>
							{end}
							<mx:Image source="assets/images/line01.png" y="56" mouseThrough="true"/>
						</mx:Canvas>
						<mx:Canvas>
							<!mx:Label text="铁" fontSize="20" styleName="brown01" x="60" y="7"/>
							<mx:Image width="33" height="28" source="assets/images/ico1_iron.png" x="60" y="16" mouseThrough="true"/>
							<mx:Label text="${CUserData:getNumStr(tonumber(aupgconf["F8"]),1)}" fontSize="20" styleName="brown01" x="215" width="173" textAlign="center" y="16" mouseThrough="true"/>			
							{if tonumber(aupgconf["F8"]) > astuff[3] then}
								<mx:Label text="${CUserData:getNumStr(astuff[3],1)}" fontSize="20" styleName="red01" x="417" width="125" textAlign="center" y="16" mouseThrough="true"/>
								<!mx:Label text="not" fontSize="20" styleName="red01" x="571" y="7"/>
								<mx:Button styleName="btn11" label="购买" x="538" y="5" setts="3" onclick="buildUpgrade_btnResGainClick"/>
							{else}
								<mx:Label text="${CUserData:getNumStr(astuff[3],1)}" fontSize="20" styleName="brown01" x="417" width="125" textAlign="center" y="16" mouseThrough="true"/>
								<mx:Label text="have" fontSize="20" styleName="green01" x="571" y="16" mouseThrough="true"/>
							{end}
							<mx:Image source="assets/images/line01.png" y="56" mouseThrough="true"/>
						</mx:Canvas>
						<mx:Canvas mouseThrough="true">
							<!mx:Label text="粮" fontSize="20" styleName="brown01" x="60" y="7"/>
							<mx:Image width="33" height="28" source="assets/images/ico1_food.png" x="60" y="16" mouseThrough="true"/>
							<mx:Label text="${CUserData:getNumStr(tonumber(aupgconf["F9"]),1)}" fontSize="20" styleName="brown01" x="215" width="173" textAlign="center" y="16" mouseThrough="true"/>				
							{if tonumber(aupgconf["F9"]) > astuff[4] then}
								<mx:Label text="${CUserData:getNumStr(astuff[4],1)}" fontSize="20" styleName="red01" x="417" width="125" textAlign="center" y="16" mouseThrough="true"/>
								<!mx:Label text="not" fontSize="20" styleName="red01" x="571" y="7"/>
								<mx:Button styleName="btn11" label="购买" x="538" y="5" setts="4" onclick="buildUpgrade_btnResGainClick"/>
							{else}
								<mx:Label text="${CUserData:getNumStr(astuff[4],1)}" fontSize="20" styleName="brown01" x="417" width="125" textAlign="center" y="16" mouseThrough="true"/>
								<mx:Label text="have" fontSize="20" styleName="green01" x="571" y="16" mouseThrough="true"/>
							{end}
							<mx:Image source="assets/images/line01.png" y="56" mouseThrough="true"/>
						</mx:Canvas>
						{
						--道具
						local nitemid = tonumber(aupgconf["F11"])
						local ntiemnum= tonumber(aupgconf["F12"])
						if nitemid ~= 0 then
							local aitemCurNum 	= CUserData:getItemByid(nitemid,2)
							local aitemconf 	= CUserData:getItemConfigByid(nitemid )
							if aitemconf ~= nil then}
								<mx:Canvas mouseThrough="true">
									<!mx:Label text="${aitemconf["F2"]}" fontSize="20" styleName="brown01" x="60" y="7"/>
									<mx:Image width="33" height="28" source="${CUserData:getItemConfigByid(nitemid,1)}" x="60" y="16" mouseThrough="true"/>
									<mx:Label text="${CUserData:getNumStr(ntiemnum,1)}" fontSize="20" styleName="brown01" x="215" width="173" textAlign="center" y="16" mouseThrough="true"/>				
									{if ntiemnum > aitemCurNum then}
										<mx:Label text="${CUserData:getNumStr(aitemCurNum,1)}" fontSize="20" styleName="red01" x="417" width="125" textAlign="center" y="16" mouseThrough="true"/>
										<!mx:Label text="not" fontSize="20" styleName="red01" x="571" y="16"/>
										<mx:Button styleName="btn11" label="购买" x="538" y="5" setts="${nitemid}" onclick="buildUpgrade_btnResGainClick"/>
									{else}
										<mx:Label text="${CUserData:getNumStr(aitemCurNum,1)}" fontSize="20" styleName="brown01" x="417" width="125" textAlign="center" y="16" mouseThrough="true"/>
										<mx:Label text="have" fontSize="20" styleName="green01" x="571" y="16" mouseThrough="true"/>
									{end}
									<mx:Image source="assets/images/line01.png" y="56" mouseThrough="true"/>
								</mx:Canvas>
								
							{end
						end
						}
						
					{else}
						<mx:Label text="建筑已经满级" fontSize="20" styleName="brown01" x="47" width="525" textAlign="center" y="60"/>
					{end}
				</mx:VBox>
				
				<mx:Canvas>
					<mx:Label fontSize="30" styleName="brown01" text="奖励" x="296.5" y="0" width="126" textAlign="center"/>
					<mx:Image source="assets/images/ttl01.png" x="159.5" y="40"/>
					<mx:Image source="assets/images/th.png" x="16.5" y="70"/>
					<mx:Label text="类型" fontSize="20" styleName="white02" x="81.5" y="70"/>
					<mx:Label text="数量" fontSize="20" styleName="white02" x="484" y="70"/>
				</mx:Canvas>
				<mx:VBox x="21.5">
					<!mx:Canvas>
						<mx:Label text="英雄经验" fontSize="20" styleName="brown01" x="60" y="7"/>
						<!mx:Image width="33" height="28" source="assets/images/ico2_heroexp.png" x="60" y="7" mouseThrough="true"/>
						<mx:Label text="" fontSize="20" styleName="brown01" x="215" width="173" textAlign="center" y="7"/>
						{local nexp = 0
						if aupgconf["F13"] ~= nil then
							nexp = tonumber(aupgconf["F13"])
						end}
						<mx:Label text="${ nexp }" fontSize="20" styleName="brown01" x="417" width="125" textAlign="center" y="7"/>
						<mx:Image source="assets/images/line01.png" y="36"/>
					</mx:Canvas>
					<mx:Canvas> 
						<mx:Image width="33" height="28" source="assets/images/ico1_power.png" x="60" y="7" mouseThrough="true"/>
						<!mx:Label text="主公战力" fontSize="20" styleName="brown01" x="60" y="7"/>
						<!mx:Image width="33" height="28" source="assets/images/ico2_power.png" x="60" y="7" mouseThrough="true"/>
						<mx:Label text="" fontSize="20" styleName="brown01" x="215" width="173" textAlign="center" y="7"/>
						{local nnum = 0
						if aupgconf["F14"] ~= nil then
							nnum = tonumber(aupgconf["F14"])
						end}
						<mx:Label text="${nnum }" fontSize="20" styleName="brown01" x="417" width="125" textAlign="center" y="7"/>
						<mx:Image source="assets/images/line01.png" y="36"/>
					</mx:Canvas>
				</mx:VBox>
			</mx:VBox>
		</mx:Canvas>
		
		
		
	</mx:Canvas>
]]
local g_statusChangePop_arg = {}
function buildUpgrade_doStatusChangePop()
	print("buildUpgrade_doStatusChangePop")
	if #g_statusChangePop_arg >= 3 then
		httpsend( 1 , 0x0103 , 0 , {CUserData.m_nUserID,g_statusChangePop_arg[1],g_statusChangePop_arg[2],g_statusChangePop_arg[3] },"buildUpgrade_revMsg","httpdp_svrStatus"  )--
		btnloading_show()
	end
end
local g_buildUpgrade_queue_type = 0 -- 0 speed up, 1 help,2 free
function buildUpgrade_setQueueType(ntype )
	g_buildUpgrade_queue_type = ntype
end
function buildUpgrade_getQueueType()
	return g_buildUpgrade_queue_type
end
local g_buildUpgrade_arg = {}
local buildUpgrade_buildingpos = 0
local g_buildUpgrade_szid = ""
function buildUpgrade_show(npos,nbuildingtype,notuseopeneffect)--npos	建筑位子,nbuildingtype 建造种类,szid divid,notuseopeneffect 不使用打开效果:true
	--测试数据
--	CUserData.m_aBuild={{1,1,3,1} }--建筑  {建筑位置,建筑类型,建筑等级,建筑状态(0普通,1升级)}
--	CUserData.m_nStone=10--石料
--	CUserData.m_nWood=20--木材
--	CUserData.m_nIron=300000--铁矿
--	CUserData.m_nFood=60000--食物
	--[[
	free help speedup
	
	如果材料不足
	]]
	if notuseopeneffect == nil then--不使用打开效果
		notuseopeneffect = true
	end
	local specialty_main = getid2("main","specialty_main")
	if specialty_main ~= nil then
		print("specialty_main ~= nil")
	else
		print("specialty_main ~= nil")
	end
	
	local nbuildenabled = 0
	local szid = ""
	buildUpgrade_buildingpos = npos
	print("buildUpgrade_show npos:"..npos)
	--print("buildUpgrade_show nbuildingtype:"..nbuildingtype)
	if npos == nil then return end
	local ainfo = CUserData:getBuildBypos(npos)
	--print("buildUpgrade_show ainfo:"..tabletostring(ainfo) )
	local nid		= 0
	local nlevel	= 0	
	local nbuildinglv = 0
	if ainfo ~= nil then
--		print("ainfo 1:"..ainfo[1])
--		print("ainfo 2:"..ainfo[2])
--		print("ainfo 3:"..ainfo[3])
		nid   = ainfo[2]
		nlevel= ainfo[3] + 1
		szid  = buildUpgrade_getbuildingid(nid)
		nbuildinglv = ainfo[3]
	elseif nbuildingtype ~= nil then
		--监狱暂时未开发
--		if nbuildingtype == 13 then
--			showClum({"此建筑暂时未开放",1})	
--			return
--		end
		nid   = nbuildingtype
		nlevel= 1 -- 					==1     新建, 	>1      升级
		ainfo = {npos,nid,0,0}
		szid  = buildUpgrade_getbuildingid(nid)		
	end
	if szid == "" then 
		szid = "buildUpgrade_main"
	end
	local oldszid = g_buildUpgrade_szid
	g_buildUpgrade_szid = szid
	print("buildUpgrade_show nid:"..nid)
	print("buildUpgrade_show szid:"..szid)
	
	--资源数值信息
	local ares = {CUserData:getResourceValue(1),CUserData:getResourceValue(2),CUserData:getResourceValue(3),CUserData:getResourceValue(4),CUserData:getResourceValue(5) }
	--是否可以升级
	local ncanup = 1
	local function buildUpgrade_localsetcanup(nvalue)
		if ncanup == 1 then --在可用状态下,可以设置该值
			ncanup = nvalue
		end
	end	
	--是否满级
	local nismaxlv = 0
	--前置建筑是否满足
	local nisprobuild = 0
	if nid ~= 0 then
		local aconf 	= CUserData:getbuildingConfigByid(nid)      --建筑表
		local upid = nid * 10000 + nlevel--(F0)建筑编号×10000＋等级
		local aupgconf =CUserData:getbuildingUpgConfigByid(upid)	--建筑升级表
		if aconf ~= nil then
			--if aupgconf ~= nil then			
				--排程
				local aqueue = CUserData:getQueueBytype(1,npos)--type 1:建筑类型
				--测试数据
				if aqueue == nil then
					aqueue = {} 
				else--检查 时间是否已经到了,防止没有队列通知消息 丢包
					--只处理显示问题,不处理数据	
					local discur = CUserData:getLeavingsTime(aqueue[3])
					if discur <= 0 then
						aqueue = {} 
					end
				end
--				print("aqueue:"..tabletostring(aqueue) )
				local astuff = {CUserData:getResourceValue(1),CUserData:getResourceValue(2),CUserData:getResourceValue(3),CUserData:getResourceValue(4)}
				--下一级的描述
				local afuncstr = {}
				local pvebuilding = {}
				local pveTech = {}
				if aupgconf ~= nil then		
					local nlv1 = CUserData:getBuildMaxLvByid(tonumber(aupgconf["F2"]))
					local apre1= CUserData:getbuildingConfigByid(aupgconf["F2"])     
					local nlv2 = CUserData:getBuildMaxLvByid(tonumber(aupgconf["F4"]))
					local apre2= CUserData:getbuildingConfigByid(aupgconf["F4"])     
					if tonumber( aupgconf["F2"]) > 0 and apre1 ~= nil then
						table.insert(pvebuilding,{apre1,tonumber(aupgconf["F3"]),nlv1})
					end 
					if tonumber( aupgconf["F4"]) > 0 and apre2 ~= nil then
						table.insert(pvebuilding,{apre2,tonumber(aupgconf["F5"]),nlv2})
					end
					
					if nlv1 >= tonumber(aupgconf["F3"]) and nlv2 >= tonumber(aupgconf["F5"]) then --前置建筑条件
						buildUpgrade_localsetcanup(1)
						nisprobuild = 1
					else--前置条件不满足
						buildUpgrade_localsetcanup(0)
						nisprobuild = 0
					end
					
					--科技条件
					--fx 2014-9-22
					
					local enght = 1
					if tonumber(aupgconf["F21"]) == -1 then
						local techlist = CUserData:getAllTechList()
						for _,v in pairs(techlist) do
							if tonumber(v["F0"]) ~= 123 and tonumber(v["F0"]) ~= 124 then
								if CUserData:getTechByid(tonumber(v["F0"]),2) < tonumber(aupgconf["F22"]) then
									enght = 0
									break
								end
							end
						end
						table.insert(pveTech,{tonumber(aupgconf["F21"]),"全部科技",tonumber(aupgconf["F22"]),0,enght})
					elseif tonumber(aupgconf["F21"]) ~= 0 then
						local techlv = CUserData:getTechByid(tonumber(aupgconf["F21"]),2)
						enght = (techlv >= tonumber(aupgconf["F22"]) and 1 or 0)
						table.insert(pveTech,{tonumber(aupgconf["F21"]),CUserData:getTechListByid(tonumber(aupgconf["F21"]),1),tonumber(aupgconf["F22"]),techlv,enght})
					end
					
					if enght then --前置科技条件
						buildUpgrade_localsetcanup(1)
						nisprobuild = 1
					else--前置条件不满足
						buildUpgrade_localsetcanup(0)
						nisprobuild = 0
					end
					
					
					
					--判断资源是否满足
					local nresEnough = 1
					local nresIndex = 1
					for k = 6 ,9 do
						if tonumber( aupgconf["F"..k]) > ares[nresIndex] then
							--print("err res :"..nresIndex..","..tonumber( aupconf["F"..k])..","..ares[nresIndex])
							nresEnough = 0
							break
						end
						nresIndex = nresIndex + 1
					end
					if nresEnough == 1 then
						--判断道具是否满足
						local nitemid = tonumber(aupgconf["F11"])
						local ntiemnum= tonumber(aupgconf["F12"])
						if nitemid ~= 0 then							
							if ntiemnum <= CUserData:getItemByid(nitemid,2) then
								buildUpgrade_localsetcanup(1)
							else--道具不满足
								--print("err 5 ")
								buildUpgrade_localsetcanup(0)
							end
						else--道具ID== 0 ,不需要判断道具需求
							buildUpgrade_localsetcanup(1)
						end
					else--资源不满足
						--print("err 4 ")
						buildUpgrade_localsetcanup(0)
					end
						
					for i = 15, 19 , 2 do --15 17 19 
						if tonumber(aupgconf["F"..i] ) ~= 0 then
							local arg1 = CUserData:getFuncListByid(tonumber(aupgconf["F"..i] ),1)
							local nbase= CUserData:getFuncListByid(tonumber(aupgconf["F"..i] ),5) 
							if nbase == 0 then nbase = 1 end
							local arg2 = tonumber(aupgconf["F"..(i+1)] ) / nbase
							print("arg1:"..arg1)
							print("arg2:"..arg2)
							local str = CUserData:format({CData:GetTranlang(arg1),arg2} )
							if nid == 16 then
								str = market_getdes(arg2)
							end					
							if str ~= "" then
								--752 增加英雄技能点
								--如果是 罗马竞技场，当升到31级之后 ，则不需要了
								if tonumber(aupgconf["F"..i] ) == 752 and nid == 12 and (nlevel - 1) >= 31  then 
								
								else
									table.insert(afuncstr,str)
								end
							end
						end
					end
				else
					aupgconf = {}
					--升级表配置未找到,建筑已经满级
					buildUpgrade_localsetcanup(0)
					nismaxlv = 1
				end
				
				--议院,新手阶段,不能升到6级
				local nchamberCanUp = 1
				if guideNew_getstate() == 1 then--新手
					if nid == 1 then--议院
						if nlevel >= 6 then--新手阶段议院禁止升级到6级以上
							nchamberCanUp = 0
						end		
						
						--目标在第3章前,议院禁止升级到5级以上
						if guideNew_getMode() <= 3 and nlevel >= 5 then
							--nchamberCanUp = 0
						end								
					end
				end
				
				
				
				local arg = {ainfo,aconf,aupgconf,aqueue,astuff,pvebuilding,afuncstr,buildUpgrade_buildingpos,szid,ncanup,nismaxlv,nisprobuild,nbuildinglv,nchamberCanUp,pveTech}
--				print("buildUpgrade_show aconf:"..tabletostring(aconf ) )
--				print("buildUpgrade_show aupgconf:"..tabletostring(aupgconf ) )
				print("buildUpgrade_show arg:"..tabletostring(arg ) )
				g_buildUpgrade_arg = arg
				
				setSalceframeViewId(szid)
				if notuseopeneffect == false then
					print("buildUpgrade_show notuseopeneffect:--",notuseopeneffect)
				else
					print("buildUpgrade_show notuseopeneffect:--",notuseopeneffect)
				end				
				flextodiv(div_buildUpgrade_str,arg ,"frame_more",nil,nil,(notuseopeneffect and {} or {5,"buildUpgrade_onloadcmp",{g_dTouchX,g_dTouchY}}))
				print("buildUpgrade_show :"..szid)
				--frame_TopPushId({1,szid,string.format("%s",aconf["F1"] ) } )
				nbuildenabled = 1
--			else
--				print("err buildUpgrade_show aupgconf == nil ",upid)	
--			end
		else
			print("err buildUpgrade_show aconf == nil ")	
		end	
	else
		print("err buildUpgrade_show nid == nil ")		
	end
	if nbuildenabled == 0 then
--		deldiv("main",oldszid )
--		deldiv("main",szid )				
	end
end
--[[
11＝建造
12＝金币速建
21＝升级
22＝金币速升
91＝拆除
92＝金币速拆
]]
function buildUpgrade_btnClick(a)
	g_dTouchX = a.dTouchX
	g_dTouchY = a.dTouchY
	local nindex = tonumber( a.pBase:getts() )
	print("buildUpgrade_btnClick nindex:"..nindex )
	local ainfo = g_buildUpgrade_arg[1]
	if nindex == 1 then	    --取消升级排程
		showClum({"您确认要取消该排程吗?",3,{"确定","取消"}},{buildUpgrade_cancelQueue})
		
		--httpsend( 1 , 0x00000104 , 0 , {CUserData.m_nUserID,9,0,1},"httpdp_teamAddSpeedBack","httpdp_svrStatusLogin"  )
	elseif nindex == 2 then --加速升级排程
		teamAddSpeed_show(1)
	elseif nindex == 3 then --拆除
		buildUpgradeRemove_show()
--		if ainfo[3] == 0 then           --新建
--		
--		else                            --升级
--			httpsend( 1 , 0x0103 , 0 , {CUserData.m_nUserID,91,ainfo[1],ainfo[2] },"buildUpgrade_revMsg","httpdp_svrStatus"  )--	
--		end
--		local id = a.pBase:getid()
--		btnloading_show(id)
	elseif nindex == 4 then --立即升级
		local nprice = 0
		--showClum({string.format("您需要消耗%d金币来购买这个道具",nprice),3,{"确定","取消"}},{itemShop_btnBuyBack,nindex})
		
		if ainfo[3] == 0 then           --新建
			httpsend( 1 , 0x0103 , 0 , {CUserData.m_nUserID,12,ainfo[1],ainfo[2] },"buildUpgrade_revMsg","httpdp_svrStatus"  )--
		else							--升级
			--statusChangePop_show()
			--玩家处于新手保护阶段, 议院升级9 到 10的,提示 将出新手保护的提示
			local nshow = 0
			
			if CUserData:getStatus() == 1 then
				if ainfo[2] == 1 and ainfo[3] == 9 then--议院升级9 到 10的
					nshow = 1
				end
			end
			if nshow == 1 then
				g_statusChangePop_arg = {22,ainfo[1],ainfo[2]}
				statusChangePop_show(buildUpgrade_doStatusChangePop ,a.dTouchX,a.dTouchY)
			else
--				if guideNew_getMode() <= 3 and ainfo[2] == 1 and ainfo[3] >= 4 then--议院在新手目标第三阶段 4升级到5 屏蔽
--					showClum({"请先完成目标。",1})	
--					target_show()	
--				else				
					httpsend( 1 , 0x0103 , 0 , {CUserData.m_nUserID,22,ainfo[1],ainfo[2] },"buildUpgrade_revMsg","httpdp_svrStatus"  )--
					local id = a.pBase:getid()
					btnloading_show(id)
					global_enabled("main",id,0)
					
					
									
--				end
			end
		end
		deldiv("main","buildList_main")
	elseif nindex == 5 then --升级
		local aqueue = CUserData:getQueueInfoByid(1)
		if aqueue ~= nil then--建筑排程已经存在
			buildUpgradePop_show(1)
		else
			if ainfo[3] == 0 then           --新建
				httpsend( 1 , 0x0103 , 0 , {CUserData.m_nUserID,11,ainfo[1],ainfo[2] },"buildUpgrade_revMsg","httpdp_svrStatus"  )--
			else							--升级
				--statusChangePop_show()
				--玩家处于新手保护阶段, 议院升级9 到 10的,提示 将出新手保护的提示
				print("CUserData:getStatus():"..CUserData:getStatus() )
				print("ainfo:"..tabletostring(ainfo) )
				local nshow = 0
				if CUserData:getStatus() == 1 then
					if ainfo[2] == 1 and ainfo[3] == 9 then--议院升级9 到 10的
						nshow = 1
					end
				end
				if nshow == 1 then
					g_statusChangePop_arg = {21,ainfo[1],ainfo[2] }
					statusChangePop_show(buildUpgrade_doStatusChangePop ,a.dTouchX,a.dTouchY)
				else
--					if guideNew_getMode() <= 3 and ainfo[2] == 1 and ainfo[3] >= 4 then--议院在新手目标第三阶段 4升级到5 屏蔽
--						target_show()		
--						showClum({"请先完成目标。",1})	
						
--					else				
						httpsend( 1 , 0x0103 , 0 , {CUserData.m_nUserID,21,ainfo[1],ainfo[2] },"buildUpgrade_revMsg","httpdp_svrStatus"  )--
						local id = a.pBase:getid()
						btnloading_show(id)
						global_enabled("main",id,0)
--					end
				end
			end
			deldiv("main","buildList_main")
		end
	elseif nindex == 6 then --详情
		local ainfo = CUserData:getBuildBypos(buildUpgrade_buildingpos )
		if ainfo ~= nil then
			local nbuildtype = ainfo[2]
			buildInfo_show(buildUpgrade_buildingpos)
		end		
	elseif nindex == 7 then --help
		httpsend( 1 , 0x0000011c , 0 , {CUserData.m_nUserID,1},"buildUpgrade_helpBack","httpdp_svrStatusLogin"  )
		local id = a.pBase:getid()
		btnloading_show(id)
		global_enabled("main",id,0)
		deldiv("main","buildList_main")
	elseif nindex == 8 then --free
		httpsend( 1 , 0x00000104 , 0 , {CUserData.m_nUserID,0,0,1},"buildUpgrade_speedUpBack","httpdp_svrStatusLogin"  )
		local id = a.pBase:getid()
		btnloading_show(id)
		global_enabled("main",id,0)
		deldiv("main","buildList_main")
	end
end

function buildUpgrade_cancelQueue(a)--取消排程
	if a == 1 then
		httpsend( 1 , 0x00000104 , 0 , {CUserData.m_nUserID,9,0,1},"httpdp_teamAddSpeedBack","httpdp_svrStatusLogin"  )
	end
end

function buildUpgrade_helpBack(ntype , nseqno , nret , arg )
	btnloading_del("buildUpgrade_btn_7")
	global_enabled("main","buildUpgrade_btn_7",1)--升级
	queue_helpBack(ntype , nseqno , nret , arg)
end

function buildUpgrade_speedUpBack(ntype , nseqno , nret , arg )
	btnloading_del("buildUpgrade_btn_8")
	global_enabled("main","buildUpgrade_btn_8",1)--升级
	queue_speedUpBack(ntype , nseqno , nret , arg)
	
	playSound(404)-- playSound(110)
end

function buildUpgrade_revMsg(ntype , nseqno , nret , arg )--
	print("ntype: nseqno: nret: arg:",ntype,nseqno,nret,tabletostring(arg))
	http_getdata(ntype , nseqno , nret , arg)
	--对btn loading的处理
	btnloading_del("buildUpgrade_btn_3")
	btnloading_del("buildUpgrade_btn_4")
	btnloading_del("buildUpgrade_btn_5")
	global_enabled("main","buildUpgrade_btn_4",1)--立即升级
	global_enabled("main","buildUpgrade_btn_5",1)--升级
	global_enabled("main","buildUpgrade_btn_7",1)--help
	global_enabled("main","buildUpgrade_btn_8",1)--free
	if nret ~= 0 then 	
		return 
	end 
	table.insert(arg,1,nret)
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s buildUpgrade_revMsg" , ntype , nseqno , nret, tabletostring(arg) ) )
	--检查如果是升级议院6到7,则跳出评分界面
	if arg[2] == 21 or arg[2] == 22 then--21升级,22金币升级
		if arg[4] == 1 then
			local alan = setLanguage_getArg()
			local ncount   = tonumber(alan[5])--评分界面弹出次数
			local nokcount = tonumber(alan[6])--评分界面点击ok次数
			if ncount == nil then
				ncount = 0
			end
			if nokcount == nil then
				nokcount = 0
			end
		
			local nMansionLv   = CUserData:getBuildMaxLvByid(1)
			if nMansionLv == 6 or nMansionLv == 8 or nMansionLv == 10 or nMansionLv == 12 then
				if nokcount <= 0 then 
					pingjiaShow()
				end
			elseif nMansionLv >= 13 then
				if ncount <= 0 then
					pingjiaShow()
				end	
			end
			if nMansionLv == 1 then
				conenttosocial(9 , "5|TJC_FINISH_TUTORIAL_ACTION_1" )--9 统计信息 conent:[登陆游戏: "1|账号id"],[充值成功: "2|充值额度(美金)"],[主城升级:"3|主城当前等级"]
			elseif nMansionLv == 2 then
				conenttosocial(9 , "5|TJC_FINISH_TUTORIAL_ACTION_2" )
			elseif nMansionLv == 4 then
				conenttosocial(9 , "5|TJC_FINISH_TUTORIAL_ACTION_5" )
			elseif nMansionLv == 5 then
				conenttosocial(9 , "5|TJC_FINISH_TUTORIAL_ACTION_6" )
			end
			
		end
		
		local ntype = arg[2]
		local npos  = arg[3]
		local ngid  = arg[4]
		account_setGoogleIndexByUpBuild(ntype,npos,ngid)
	end	
	--数据刷新
	CUserData:onBuildingAction(arg)
	--界面刷新
	--deldiv("main","buildUpgrade_main")
	if arg[2] == 92 then --道具/Get&Use速拆
		deldiv("main","buildUpgrade_main")
	else
--		local ainfo = g_buildUpgrade_arg[1]
--		buildUpgrade_show(ainfo[1])
		buildUpgrade_refByQueueInfo()
	end
	--city_show()
	city_ref()--2014080101xp
	
	playSound(409)--playSound(408)--playSound(106)
	
	statistics_setInfo()
end

function buildUpgrade_btnCloseClick(a)
	local arg = g_buildUpgrade_arg
	local ainfo = arg[1]
	local szid  = buildUpgrade_getbuildingid(ainfo[2] ) 
	--deldiv("main",szid )
	--deldiv("main","buildUpgrade_main")
	frame_CityOrMapBtnClick()
end

function buildUpgrade_getbuildingid(ntype)
	local ret = ""
	if ntype == 1 then--议院
		ret= "mansion_main"
	elseif ntype == 2 then--宝库
		ret= "storage_main"		
	elseif ntype == 3 then--瞭望塔
		ret= "tower_main"		
	elseif ntype == 4 then--铁匠铺
		ret= "equip_main"		
	elseif ntype == 5 then--城墙
		ret= "camp_main"		
	elseif ntype == 11 then--学院
		ret= "tech_main"		
	elseif ntype == 12 then--竞技场
		ret= "hero_main"		
	elseif ntype == 13 then--监狱
		ret= "prison_main"		
	elseif ntype == 14 then--大使馆
		ret= "embassy_main"		
	elseif ntype == 15 then--战争会所
		ret= "chamber_main"		
	elseif ntype == 16 then--交易所
		ret= "market_main"		
	elseif ntype == 21 then--兵营
		ret= "camp_main"		
	elseif ntype == 22 then--医院
		ret= "camp_main"		
	elseif ntype == 23 then--采石厂
		ret= "res_main"		
		--deldiv("main","res_main")
	elseif ntype == 24 then--伐木场
		ret= "res_main"		
	elseif ntype == 25 then--铁矿场
		ret= "res_main"		
	elseif ntype == 26 then--农庄 
		ret= "res_main"		
	elseif ntype == 27 then--民居
		ret= "res_main"		
	elseif ntype == 31 then--制陶器
		ret= "specialty_main"		
	elseif ntype == 32 then--制皮所
		ret= "specialty_main"	
	elseif ntype == 33 then--制布厂
		ret= "specialty_main"		
	elseif ntype == 34 then--酒厂
		ret= "specialty_main"		
	end		
	return ret
end

function buildUpgrade_onloadcmp(a)
	print("buildUpgrade_onloadcmp")
	buildUpgrade_refUpTime()
	deldiv("main","buildList_main")
	deldiv("main",g_buildUpgrade_szid) 
	deldiv("main","div_techUpgrade_id") 
	--buildUpgrade_setBtnText()
	--guide_showHotRect({8,15})
	guideNew_showHotRect({1,{7,19,23,46,59}})
end

function buildUpgrade_refUpTime()
	--print("buildUpgrade_refUpTime")
	--检查是否需要显示倒计时
	local ainfo = g_buildUpgrade_arg[1]
	local buildingpos = g_buildUpgrade_arg[8]
	--print("ainfo:"..tabletostring(ainfo ) )
	if ainfo[4] == 1 or ainfo[4] == 2 then
		local aqueue = g_buildUpgrade_arg[4]
		if #aqueue > 1 then
			if buildUpgrade_getQueueType() == buildUpgrade_getstate(aqueue ) then			
				local dismax = aqueue[3] - aqueue[2]
				local discur = CUserData:getLeavingsTime(aqueue[3])
				local strtime= formatTime(discur)
				if dismax == 0 then dismax = 1 end
				local dispro = 377 * (1- discur / dismax)
	--			print("discur:"..discur)
	--			print("dismax:"..dismax)
	--			print("dispro:"..dispro)
	--			print("----------------")
				if discur > 0 and getid2("main","buildUpgrade_prog") ~= nil then
					global_sw("main","buildUpgrade_prog",dispro)		
					
					global_changetext("main","buildUpgrade_progtext",string.format(CData:GetTranlang("升级中%s"),strtime))
					if ainfo[3] == 0 then --建造
						global_changetext("main","buildUpgrade_progtext",string.format(CData:GetTranlang("建造中%s"),strtime))
					end
					if aqueue[5] == 2 then
						global_changetext("main","buildUpgrade_progtext",string.format(CData:GetTranlang("拆除中%s"),strtime))
					end
					
					settimer(TIMER_ID_BUILDUPG,1*1000,"buildUpgrade_refUpTime",1)
				else--排程时间到了要重新刷新
					--buildUpgrade_show(buildingpos )
					buildUpgrade_refByQueueInfo()
				end				
			else
				print("buildUpgrade_refUpTime b")
				--buildUpgrade_show(buildingpos )
				buildUpgrade_refByQueueInfo()
			end
		end
	end
end

function buildUpgrade_showClumByQueueInfo(aQueue,abuildinginfo )
	print("buildUpgrade_refByQueueInfo")
	local str = ""
	if #abuildinginfo > 0 and #aQueue > 0 then
		local aconf = CUserData:getbuildingConfigByid(abuildinginfo[2] )
		if aconf ~= nil then
			str = string.format(CData:GetTranlang("%s 建筑 "),CData:GetTranlang(aconf["F1"]) )
			if aQueue[5] == 1 then--升级		
				str = str ..CData:GetTranlang("已经升级")
			elseif aQueue[5] == 2 then--拆除	
				str = str ..CData:GetTranlang("已经拆除")
				
				--检查该建筑功能界面/升级界面是否打开并删掉
				--类型1建筑:可以多个同类建筑的是21 ~ 34
				--类型2建筑:最多一个同类建筑的是1~16
				if aQueue[4] <= 16 then--类型2建筑
					local strid = buildUpgrade_getbuildingid(abuildinginfo[2] )
					deldiv("main", strid )
				end
				--
				local btn2 = getid2("main","city_btnBuildingTop1")--类型1建筑功能/升级界面功能按钮的id,city_btnBuildingTop1
				if btn2 ~= nil then
					local arg 	= string.split( btn2:getts(),"|" )
					local npos	= tonumber( arg[1] )
					local ntype	= tonumber( arg[2] )
					if aQueue[4] == npos then
						deldiv("main","buildUpgrade_main")
						local strid = buildUpgrade_getbuildingid(abuildinginfo[2] )
						deldiv("main", strid )
						
						print("abuildinginfo:"..tabletostring(abuildinginfo) )
						print("strid:"..strid )
						
					end
				end
			
			
			end
			showClum({str ,1})		
			
				
		end
		
	end	
end
function buildUpgrade_refByQueueInfo()
	--界面刷新
	local div =getid2("main","city_btnBuildUpgradeTop2")
	if div ~= nil then		
		local ainfo = g_buildUpgrade_arg[1]
		buildUpgrade_show(ainfo[1])
	end
	buildUpgradePop_refByQueueInfo()
end

function buildUpgrade_getstate(aqueue ) --1free,2,help,3,speedup	
	--if aqueue[1] == 1 then
		if tonumber(CUserData:getVipListByLevel()["F3"]) >= CUserData:getLeavingsTime(aqueue[3]) then
			--free
			return 2
		elseif CUserData:getUnionHelpState(aqueue[1]) == 0 then
			--Help
			return 1	
		end	
	--end	
	--speedup
	return 0
end

--设置中间按钮 立刻升级/购买升级
--立刻升级按钮的金币、升级按钮的时间
function buildUpgrade_setBtnText()
	local btn4 		= getid2("main","buildUpgrade_btn_4_gold")		--金币
	local btn4text 	= getid2("main","buildUpgrade_btn_4_text")	--立刻升级/购买升级
	local btn5 		= getid2("main","buildUpgrade_btn_5_time")		--时间
	
	if btn4 ~= nil and btn4text ~= nil and  btn5 ~= nil then
		--ngold 金币数,ntime 时间 , nenough 资源和道具是否满足
		local ngold,ntime,nenough = buildUpgrade_getGoldUp()
		if nenough == 1 then
			btn4text:changetext("立即升级")
		else
			btn4text:changetext("购买升级")
		end
		local strtime = formatTime(ntime)
		btn5:changetext(strtime)
		local strgold = string.format("%d",ngold)
		btn4:changetext(strgold)
	end
end
function buildUpgrade_getGoldUp()
	local arg = g_buildUpgrade_arg
	
	local ainfo = arg[1]
	local aconf = arg[2]
	local aupgconf = arg[3]    --有可能是空的,已经满级的情况
	local aqueue = arg[4]
	local astuff = arg[5]
	local pvebuilding = arg[6]
	local afuncstr = arg[7]
	local buildingpos = arg[8]
	local szid = arg[9]	
	local ngold = 0
	local ntime = 0		--升级时间
	local nenough = 1	--资源和道具是否满足
	if aupgconf["F0"] ~= nil then
		
		--资源
		local n1 = tonumber( aupgconf["F6"]) - CUserData:getResourceValue(1)
		local n2 = tonumber( aupgconf["F7"]) - CUserData:getResourceValue(2)
		local n3 = tonumber( aupgconf["F8"]) - CUserData:getResourceValue(3)
		local n4 = tonumber( aupgconf["F9"]) - CUserData:getResourceValue(4)
		local n5 = 0
		print(string.format("buildUpgrade_getGoldUp res %d,%d,%d,%d,%d",n1,n2,n3,n4,n5 ) )
		if n1 > 0 or n2 > 0 or n3 > 0 or n4 > 0 or n5 > 0 then
			nenough = 0
			--print("nenough == 0")
		end
		ngold = ngold + CUserData:getGoldOfResource(1,n1)
		ngold = ngold + CUserData:getGoldOfResource(2,n2)
		ngold = ngold + CUserData:getGoldOfResource(3,n3)
		ngold = ngold + CUserData:getGoldOfResource(4,n4)
		ngold = ngold + CUserData:getGoldOfResource(5,n5)
		--时间
		ntime = tonumber( aupgconf["F10"])	
		ntime = math.ceil(   ntime / (1+CUserData:getFuncData(41)/1000)	 )
		ngold = ngold + CUserData:getGoldOfTime(ntime) --建筑：配置时间/（1＋plus_41/1000），向上取整
		--道具
		local aitemid 	= tonumber( aupgconf["F11"])		
		local aitemnum 	= tonumber( aupgconf["F12"])		
		if aitemid ~= 0 then
			aitemnum = aitemnum - CUserData:getItemByid(aitemid,2)
		else
			aitemnum = 0
		end
		if aitemnum < 0 then
			nenough = 0
		end
		ngold = ngold + CUserData:getGoldOfItem(aitemid,aitemnum)
		
	else--满级情况
	end
	if ngold % 1 > 0 then  --向上取整
		ngold = ngold + 1
	end	
	ngold = ngold - ngold % 1
	
	return ngold,ntime,nenough
end

function buildUpgrade_getNotUseOpeneffect()
	local notuseopeneffect = false --不需要打开效果
	local div = getid2("main","buildUpgrade_main") 
	if div ~= nil then
		notuseopeneffect = true
	end
	return notuseopeneffect
end


function buildUpgrade_btnPreBuildClick(a)
	local nindex = tonumber(a.pBase:getts())
	print("buildUpgrade_btnPreBuildClick nindex:"..nindex)
	local ainfo = CUserData:getMaxLvBuildByid(nindex )
	if ainfo ~= nil then
		--buildUpgrade_show(npos,0)
		buildUpgrade_show(ainfo[1],0)
	else--不存在该建筑
		local aconfall = CUserData:getbuildingConfigAll()
		local strname = ""
		if aconfall ~= nil then
			for i = 1 ,#aconfall do
				if tonumber( aconfall[i]["F0"] ) == nindex then
					strname = CData:GetTranlang(aconfall[i]["F1"]) 
					break
				end
			end
		end
		if strname == "" then
			strname = "建筑不存在"
		else
			strname = string.format(CData:GetTranlang("%s不存在"),strname) 
		end 
		showClum({strname ,1})	
	end	
end

function buildUpgrade_btnResGainClick(a)
	local nindex = tonumber(a.pBase:getts())
	print("buildUpgrade_btnResGainClick nindex:"..nindex)
	local arg = g_buildUpgrade_arg
	local aupgconf = arg[3]
	if nindex == 1 then
		resGainGuide_show(nindex,tonumber(aupgconf["F6"]) )
	elseif nindex == 2 then
		resGainGuide_show(nindex,tonumber(aupgconf["F7"]) )
	elseif nindex == 3 then
		resGainGuide_show(nindex,tonumber(aupgconf["F8"]) )
	elseif nindex == 4 then
		resGainGuide_show(nindex,tonumber(aupgconf["F9"]) )
	else
		local ntiemnum= tonumber(aupgconf["F12"])
		resGainGuide_show(nindex,ntiemnum )
	--	print("err buildUpgrade_btnResGainClick nindex ~= 1 ~4 ")
	end	
end
-- --------------------------------------------------------------------------------------------
local div_buildUpgradeRemove_str = [[
{
local ainfo =arg[1]
local aconf =arg[2]
}
<mx:Canvas id="buildUpgradeRemove_main" width="720" height="1280" backgroundColor="0x000000"  backgroundAlpha="0.6" mouseEnabled="false" systemload="1">

	<mx:Canvas width="678" height="677" horizontalCenter="0" verticalCenter="0">
		<mx:Image source="assets/images/popBg07.png"/>
		<mx:Button styleName="btn02Close" id="closeBtn" x="591" y="-4" onclick="buildUpgradeRemove_btnCloseClick"/>
		
		<mx:Image source="assets/images/delBg01.png" x="34" y="85"/>
		{local str = string.format(CData:GetTranlang("使用道具%s可以将建筑瞬间完全拆除"),CData:GetTranlang(aconf["F2"]) ) }
		<mx:Text fontSize="22" styleName="white03" text="${str}" x="51" y="105" width="259"/>
		
		<mx:Canvas x="108" y="270" width="124" height="127">
			<mx:Image source="assets/images/headerBg03.png"/>
			<mx:Image source="${CUserData:getItemConfigByid(ainfo[1],1)}" x="9" y="9"/>
			<!-- 以下仓库里时显示 -->
			<!mx:Image source="assets/images/numBg01.png" x="77" y="83"/>
			<!mx:Label text="${ainfo[2]}" fontSize="20" styleName="white01" textAlign="center" x="79" y="87" width="39"/>
			<!-- 以上仓库里时显示 -->
		</mx:Canvas>
		{local str = string.format(CData:GetTranlang("数量:%d"),ainfo[2])}
		<mx:Label text="${str}" fontSize="22" styleName="black03" x="115" y="408"/>
		{if ainfo[2] > 0 then }
			<mx:Button styleName="btn03" label="使用" x="79" y="503" setts="1" id="buildUpgradeRemove_btn_1" onclick="buildUpgradeRemove_btnClick"/>
		{else}
			<mx:Button styleName="btn05" label="购买并使用" x="79" y="503" setts="1" id="buildUpgradeRemove_btn_1" onclick="buildUpgradeRemove_btnClick"/>
		{end}
		<mx:Image source="assets/images/delBg01.png" x="352" y="85"/>
		<mx:Text fontSize="22" styleName="white03" text="普通拆除需要一定的时间，执行后将完全拆除建筑。" x="369" y="105" width="259"/>
		<mx:Image source="assets/images/img01Del.png" x="413" y="261"/>
		<mx:Button styleName="btn03" label="确定" x="400" y="503" setts="2" id="buildUpgradeRemove_btn_2" onclick="buildUpgradeRemove_btnClick"/>
	</mx:Canvas>	
</mx:Canvas>	
]]
local g_buildUpgradeRemove_arg = {}
function buildUpgradeRemove_show()
	print("buildUpgradeRemove_show")
	local nitemid = 1009--1009	1301009	摧毁符文	立即将一个建筑完全拆除
	local nitemnum= CUserData:getItemByid(nitemid,2)
	local ainfo = {nitemid,nitemnum}
	local aconf = CUserData:getItemConfigByid(nitemid )
	if aconf ~= nil then
		local arg = {ainfo,aconf}
		g_buildUpgradeRemove_arg = arg 
		flextodiv(div_buildUpgradeRemove_str,arg ,"frame_more")
	end
end	

function buildUpgradeRemove_btnClick(a)
	local nindex = tonumber(a.pBase:getts() )
	print("buildUpgradeRemove_btnClick nindex:"..nindex)
	local arg = g_buildUpgradeRemove_arg
	local ainfo =arg[1]--道具信息
	local aconf =arg[2]--道具配置
	local abuildingarg = g_buildUpgrade_arg
	local abuildinginfo = abuildingarg[1]--道具信息
	local abuildingconf = abuildingarg[2]--道具配置
	if nindex == 1 then		--使用
		if ainfo[2] > 0 then--使用 道具
			--httpsend( 1 , 0x010a , 0 , {CUserData.m_nUserID,ainfo[1],1,0 },"buildUpgradeRemove_revMsgUseItem","httpdp_svrStatus"  )	
			httpsend( 1 , 0x0103 , 0 , {CUserData.m_nUserID,92,abuildinginfo[1],abuildinginfo[2] },"buildUpgradeRemove_revMsg","httpdp_svrStatus"  )	
		else				--金币拆除
			httpsend( 1 , 0x0103 , 0 , {CUserData.m_nUserID,92,abuildinginfo[1],abuildinginfo[2] },"buildUpgradeRemove_revMsg","httpdp_svrStatus"  )
		end
		local id = a.pBase:getid()
		btnloading_show(id)
		global_enabled("main",id,0)
		global_enabled("main","buildUpgradeRemove_btn_2",0)
	elseif nindex == 2 then	--确定      普通拆除
		local aqueue = CUserData:getQueueInfoByid(1)
		if aqueue ~= nil then--建筑排程已经存在
			buildUpgradePop_show(1)
		else
			httpsend( 1 , 0x0103 , 0 , {CUserData.m_nUserID,91,abuildinginfo[1],abuildinginfo[2] },"buildUpgradeRemove_revMsg","httpdp_svrStatus"  )
			local id = a.pBase:getid()
			btnloading_show(id)
			global_enabled("main",id,0)	
			global_enabled("main","buildUpgradeRemove_btn_1",0)	
		end
	end
end

function buildUpgradeRemove_revMsgUseItem(ntype , nseqno , nret , arg )
	btnloading_del("buildUpgradeRemove_btn_2")
	global_enabled("main","buildUpgradeRemove_btn_1",1)--
	
	btnloading_del("buildUpgradeRemove_btn_2")
	global_enabled("main","buildUpgradeRemove_btn_2",1)--
	
	deldiv("main","buildUpgradeRemove_main")
	
	itemShop_revMsgUseItem(ntype , nseqno , nret , arg )
	
	playSound(409)--playSound(408)--playSound(106)
end

function buildUpgradeRemove_revMsg(ntype , nseqno , nret , arg )
	btnloading_del("buildUpgradeRemove_btn_1")
	global_enabled("main","buildUpgradeRemove_btn_1",1)--
	
	btnloading_del("buildUpgradeRemove_btn_2")
	global_enabled("main","buildUpgradeRemove_btn_2",1)--
	
	deldiv("main","buildUpgradeRemove_main")
	
	buildUpgrade_revMsg(ntype , nseqno , nret , arg )
end

function buildUpgradeRemove_btnCloseClick(a)
	deldiv("main","buildUpgradeRemove_main")
end

function buildUpgrade_toTech()
	tech_show()
end

