--资源建筑
local div_res_str = [[
{
local buildingpos = arg[1]
local ainfo = arg[2]
local aconf = arg[3]
local ncount = arg[4]
local aupconf = arg[5]
local nadd = arg[6]
local nbuildinglv =arg[7]
local imgico = arg[8]
local nUpperLimit = arg[9]
local nResOut = arg[10]
}
<mx:Canvas id="res_main" width="720" height="1280" onloadcmp="res_onloadcmp">
	<mx:Canvas width="720" height="112">
		<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
		{local str = string.format("%s LV.%d",CData:GetTranlang(aconf["F1"]),nbuildinglv)
		if g_main_apptype == 1 then 
			str = string.format("%s 레벨 %d",CData:GetTranlang(aconf["F1"]),nbuildinglv)
		end
		}
		<mx:Label id="frameTop_txt" text="${str}" width="720" textAlign="center" y="35"/>
		<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" onclick="res_btnCloseClick"/>
	</mx:Canvas>
	<mx:Image source="assets/images/bg01.jpg" width="720" height="990" y="111"/>
	<mx:Image source="assets/images/baokuTop.png" y="111"/>
	<mx:Label visible="false" text="当资源超过生产上限时无法再继续生产" styleName="white02" y="220" x="32" width="593" textAlign="center"/>
	<mx:Button styleName="btn01Detail" y="211" x="652" setts="1" onclick="res_btnClick"/>
	<mx:Button onclick="city_btnTopClick" setts="${buildingpos}|1" styleName="navi01" label="功能" sound="assets/sound/421.ogg" enabled="false" x="24" y="118" id="city_btnBuildingTop1"/>
	<mx:Button onclick="city_btnTopClick" setts="${buildingpos}|2" styleName="navi01" label="升级" sound="assets/sound/421.ogg" x="366" y="118"/>
	
	<mx:Image source="assets/images/block01Info.png" x="254" y="309"/>
	<mx:Image source="assets/images/${imgico}" x="300" y="320"/>
	<mx:Image source="assets/images/block01InfoT.png" x="295" y="320"/>
	
	<mx:VBox y="550">
		<mx:Canvas>
			<mx:Label text="产量" styleName="brown01" x="118" y="0" width="482" textAlign="center"/>
			<mx:Image source="assets/images/bg06Input.png" x="118" y="44"/>
			<mx:Label text="${ CUserData:getNumStr( tonumber(nResOut ),1 )  }/h" fontSize="24" styleName="white01" x="134" y="64" width="452" textAlign="center"/>
		</mx:Canvas>
		{if tonumber( aconf["F0"] ) == 26 then}
			<mx:Canvas>
				<mx:Label text="维持" styleName="brown01" x="118" y="0" width="482" textAlign="center"/>
				<mx:Image source="assets/images/bg06Input.png" x="118" y="44"/>
				<mx:Label text="${nadd}/h" fontSize="24" styleName="white01" x="134" y="64" width="452" textAlign="center"/>
			</mx:Canvas>
		{end}
		<mx:Canvas>
			<mx:Label text="生产上限" styleName="brown01" x="119" y="0" width="482" textAlign="center"/>
			<mx:Image source="assets/images/bg06Input.png" x="119" y="44"/>
			<mx:Label text="${CUserData:getNumStr( nUpperLimit,1 ) }" fontSize="24" styleName="white01" x="135" y="64" width="452" textAlign="center"/>
		</mx:Canvas>
		
		<mx:Canvas>
			<mx:Label text="现有" styleName="brown01" x="119" y="0" width="482" textAlign="center"/>
			<mx:Image source="assets/images/bg06Input.png" x="119" y="44"/>
			<mx:Label text="${ncount}" fontSize="24" styleName="white01" x="135" y="64" width="452" textAlign="center"/>
		</mx:Canvas>
		
		{if tonumber( aconf["F0"] ) == 27 then
			local nnum = aupconf["F20"] 
			if nnum == nil then nnum = 0 end}
			<mx:Canvas>
				<mx:Label text="征兵数量" styleName="brown01" x="118" y="0" width="482" textAlign="center"/>
				<mx:Image source="assets/images/bg06Input.png" x="118" y="44"/>
				<mx:Label text="${nnum }" fontSize="24" styleName="white01" x="134" y="64" width="452" textAlign="center"/>
			</mx:Canvas>
		{end}
	</mx:VBox>
</mx:Canvas>
]]
--只有农庄界面有 维持 项
local g_storage_buildingpos = 0
function res_show(npos)
	g_storage_buildingpos = npos
	--[[23 then--采石厂 
		24 then--伐木场
		25 then--铁矿场
		26 then--农庄 
		27 then--民居 银币
	CUserData.m_nStone=0--石料
	CUserData.m_nWood=0--木材
	CUserData.m_nIron=0--铁矿
	CUserData.m_nFood=0--食物
	CUserData.m_nSilver=0--银币
	]]
	local ainfo = CUserData:getBuildBypos(npos)
	if ainfo ~= nil then
		playSound(117)
		local aconf = CUserData:getbuildingConfigByid(ainfo[2])
		if aconf ~= nil then
			local ncount = -1 
			local nadd   = 0 --维持
			local imgico = ""--图标
			local nUpperLimit = 0 
			local nResOut = 0 
			if tonumber( aconf["F0"] ) == 23 then		--采石厂
				ncount = CUserData:getNumStr(CUserData:getStone(),1)-- CUserData.m_nStone
				imgico = "ico3_stone.png"
				nUpperLimit = CUserData:getResourceUpperLimit(1)
				nResOut = CUserData:getResourceOut(1)
			elseif tonumber( aconf["F0"] ) == 24 then	--伐木场	
				ncount = CUserData:getNumStr(CUserData:getWood(),1)--CUserData.m_nWood
				imgico = "ico3_wood.png"
				nUpperLimit = CUserData:getResourceUpperLimit(2)
				nResOut = CUserData:getResourceOut(2)
			elseif tonumber( aconf["F0"] ) == 25 then	--铁矿场
				ncount = CUserData:getNumStr(CUserData:getIron(),1)--CUserData.m_nIron
				imgico = "ico3_iron.png"
				nUpperLimit = CUserData:getResourceUpperLimit(3)
				nResOut = CUserData:getResourceOut(3)
			elseif tonumber( aconf["F0"] ) == 26 then	--农庄
				ncount = CUserData:getNumStr(CUserData:getFood(),1)--CUserData.m_nFood
				nadd = CUserData:getNumStr(CUserData.m_nFoodUpKeep,1)
				imgico = "ico3_food.png"
				nUpperLimit = CUserData:getResourceUpperLimit(4)
				nResOut = CUserData:getResourceOut(4)
			elseif tonumber( aconf["F0"] ) == 27 then	--民居
				ncount = CUserData:getNumStr(CUserData:getSilver(),1)--CUserData.m_nSilver
				imgico = "ico3_silver.png"
				nUpperLimit = CUserData:getResourceUpperLimit(5)
				nResOut = CUserData:getResourceOut(5)
			end
			local aupconf = CUserData:getbuildingUpgConfigByid(ainfo[2] * 10000 + ainfo[3] )
			if ncount ~= -1 and aupconf ~= nil then
				local nbuildinglv = ainfo[3]
				local arg = {g_storage_buildingpos,ainfo,aconf,ncount,aupconf,nadd,nbuildinglv,imgico,nUpperLimit,nResOut}
				local notuseopeneffect = buildUpgrade_getNotUseOpeneffect()
				--,nil,nil,notuseopeneffect
				flextodiv(div_res_str,arg ,"frame_more",nil,nil,(notuseopeneffect and {} or {5,"res_onloadcmp",{g_dTouchX,g_dTouchY}}))				
			end
		end
	end
end

function res_btnClick(a)
	g_dTouchX = a.dTouchX
	g_dTouchY = a.dTouchY
	local nindex = tonumber(a.pBase:getts() )
	if nindex == 1 then
		buildInfo_show(g_storage_buildingpos)
	end
end

function res_onloadcmp(a)
	deldiv("main","buildUpgrade_main")
end	

function res_btnCloseClick(a)
	--deldiv("main","res_main")
	frame_CityOrMapBtnClick()
end





