--瞭望塔
local div_tower_str = [[
	{
	local buildingpos = arg[1]
	local atower = arg[2]
	local nbuildinglv =arg[3]
	}
	<mx:Canvas id="tower_main" width="720" height="1280" onloadcmp="tower_onloadcmp">
		<mx:Canvas width="720" height="112">
			<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
			{local str = string.format("%s LV.%d",CData:GetTranlang("瞭望塔"),nbuildinglv)
			if g_main_apptype == 1 then 
				str = string.format("%s 레벨 %d",CData:GetTranlang("瞭望塔"),nbuildinglv)
			end
			}
			<mx:Label id="frameTop_txt" text="${str}" width="720" textAlign="center" y="35"/>
			<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" onclick="tower_btnCloseClick"/>
		</mx:Canvas>
		<mx:Image source="assets/images/bg02.jpg" width="720" height="990" y="111"/>
		<mx:Image source="assets/images/baokuTop.png" y="111"/>
		<mx:Label visible="false" text="等级越高可以获得更高级的信息" styleName="white02" y="222" x="32" width="593" textAlign="center"/>
		<mx:Button styleName="btn01Detail" y="211" x="652" setts="1" onclick="tower_btnClick"/>
		<mx:Button onclick="city_btnTopClick" setts="${buildingpos}|1" styleName="navi01" label="功能" sound="assets/sound/421.ogg" enabled="false" x="24" y="118"/>
		<mx:Button onclick="city_btnTopClick" setts="${buildingpos}|2" styleName="navi01" label="升级" sound="assets/sound/421.ogg" x="366" y="118"/>
		<mx:Canvas y="277" height="818" width="720" setslidetype="1">
			<mx:VBox verticalGap="5" x="10" y="0" verticalScrollPolicy="off">
				{for i = 1 , #atower do
					local v = atower[i]
					print("v:"..tabletostring(v) )
					local x1, y1 = getMapXYByDataID(v[3],true)
					local x2, y2 = getMapXYByDataID(v[4],true)	
					local strgroup = ""
					local strhero = ""
					if v[7] == "" then
						strgroup = "???"
					else
						strgroup = v[7]
					end
					if v[8] == "" then
						strhero = "???"
					else
						strhero = v[8]
					end 
					
					print("div_tower_str a")
					local dispro = 297
					local strsec = ""
					if v[6] == 0 then
						strsec = "???"
						print("div_tower_str b")
					else
						print("div_tower_str c")
						strsec = formatTime(CUserData:getLeavingsTime(v[6]) )
						local dismax = v[6] - v[5]
						local discur = CUserData:getLeavingsTime(v[6])
						dispro = 297 * (1- discur / dismax)
						strsec = formatTime(discur )
						print("div_tower_str d")
					end
					}
					<mx:Canvas width="706" height="171" mouseThrough="true" setts="${atower[i][1]}|${atower[i][2]}" sound="defalut" onclick="tower_btnItemClick" mouseChildren="false" mouseThrough="true">
						<mx:Image source="assets/images/block06.png" width="706" height="171" mouseThrough="true"/>
						{if v[2] == 0 then}
							<mx:Label text="??? 有部队正在逼近" fontSize="20" styleName="brown01" x="148" y="70" width="380" mouseThrough="true"/>
						{else}
							{if nbuildinglv >= 20 or v[2] == 4 or v[2] == 11 then}
								{print("???????????",tabletostring(v))
								local state = v[2] }
								<mx:Image source="assets/map/mapTroopState${state}.png" x="503" y="92" mouseThrough="true"/>
								<mx:Image source="assets/images/arr01.png" x="623" y="52" mouseThrough="true"/>
							{end}
							<mx:Image source="${CUserData:getTowerArmyTypeImg(v[2])}" x="45" y="36" mouseThrough="true"/>
							{local str = string.format(CData:GetTranlang("%s (X %d，Y %d ),驻扎点"),CData:GetTranlang(tower_getStateStr(state)),x2,y2 ) }
							<mx:Label text="${str}" fontSize="20" styleName="brown01" x="148" y="23" width="380" mouseThrough="true"/>
							{local str = string.format("[%s] %s (X %d, Y %d)",strgroup,strhero,x1,y1 )		}
							<mx:Label text="${str}" fontSize="20" styleName="brown01" x="148" y="59" width="380" mouseThrough="true"/>
							<mx:Image source="assets/images/progBg02.png" x="152" y="102" mouseThrough="true"/>
							<mx:Canvas id="tower_prog_${i}" styleName="prog02" width="${dispro}" height="24" y="106" x="158" mouseThrough="true"/>
							<mx:Label id="tower_progtext_${i}" text="${strsec}" fontSize="24" styleName="white01" x="130" y="105" width="357" textAlign="center" mouseThrough="true"/>
							{print("div_tower_str e")}
						{end}
					</mx:Canvas>				
				{end}
				
			</mx:VBox>
			{if #atower <= 0 then}
				<mx:Image source="assets/images/bg01.jpg" width="720" height="990" y="0"/>
				<mx:Label text="没有任何军队" fontSize="30" styleName="brown01" horizontalCenter="0" y="300"/>
			{end}
		</mx:Canvas>
	</mx:Canvas>
]]
--[[瞭望塔的权限规则
	1：占领（资源、空地、帐篷）
	2：攻击（城池、NPC）
	3：侦查
	4：增援
	5：联盟战争

]]
function tower_getStateStr(nstate)
	local astr = {"占领","攻击","侦查","增援","联盟战争"} 
	local str  = astr[nstate]
	if str == nil then
		str = ""
	end
	return str
end
local g_tower_buildingpos = 0
local g_tower_arg = {}
function tower_show(npos)
	print("tower_show npos:"..npos)
	if npos == -1 then --npos == 1 ,则 赋值该建筑最大值
		local ainfo = CUserData:getMaxLvBuildByid(3)--瞭望塔 类型3
		if ainfo ~= nil then
			npos = 	ainfo[1]	
		end
	end
	
	g_tower_buildingpos = npos
	local atower = copytable( CUserData.m_aWatchTower )
	
--	--测试数据
--	atower = {
--		{1 ,1,100,200,os.time(),os.time()+3600,"AA","AA"},
--		{2 ,1,100,200,os.time(),os.time()+3600,"CC","CC"},
--		{3 ,1,100,200,os.time(),os.time()+3600,"DD","DD"},
--		{4 ,1,100,200,os.time(),os.time()+3600,"EE","EE"},
--		{5 ,1,100,200,os.time(),os.time()+3600,"FF","FF"},
--		{6 ,1,100,200,os.time(),os.time()+3600,"GG","GG"},
--		{7 ,1,100,200,os.time(),os.time()+3600,"HH","HH"},
--		{8 ,1,100,200,os.time(),os.time()+3600,"II","II"},
--		{9 ,1,100,200,os.time(),os.time()+3600,"JJ","JJ"},
--		{10,1,100,200,os.time(),os.time()+3600,"KK","KK"},
--		{11,1,100,200,os.time(),os.time()+3600,"LL","LL"},
--		{12,1,100,200,os.time(),os.time()+3600,"MM","MM"},
--		{13,1,100,200,os.time(),os.time()+3600,"NN","NN"},
--	}
	
	local nbuildinglv = CUserData:getBuildBypos(npos,3)
	local arg = {g_tower_buildingpos,atower ,nbuildinglv}
	g_tower_arg = arg 
	local notuseopeneffect = buildUpgrade_getNotUseOpeneffect()
	--,nil,nil,notuseopeneffect
	print("tower_show atower:"..tabletostring(arg ) )
	flextodiv(div_tower_str,arg ,"frame_more",nil,nil,(notuseopeneffect and {} or {5,"tower_onloadcmp",{g_dTouchX,g_dTouchY}}))	
end

function tower_btnClick(a)
	g_dTouchX = a.dTouchX
	g_dTouchY = a.dTouchY
	local nindex = tonumber(a.pBase:getts() )
	if nindex == 1 then
		buildInfo_show(g_tower_buildingpos)
	end	
end

function tower_refBySNWatchTower()
	print("tower_refBySNWatchTower")
	local div = getid2("main","tower_main")
	if div ~= nil then
		tower_show(g_tower_buildingpos)
	else
		print("tower_refBySNWatchTower  div == nil")
	end
end

function tower_btnItemClick(a)
	local arr = string.split(a.pBase:getts(),"|")
	local nindex = tonumber( arr[1] )
	print("tower_btnItemClick nindex:"..nindex)
	--判断建筑等级是否到20,20级才能查清详情
	local arg = g_tower_arg  
	local buildingpos = arg[1]
	local atower = arg[2]
	local nbuildinglv =arg[3]
	if nbuildinglv >= 20 or tonumber(arr[2]) == 4 or tonumber(arr[2]) == 11 then
		towerArmyDetail_show(g_tower_buildingpos,nindex )
	else
		showClum({"看军队详情功能需要瞭望塔建筑到达20级",1})	
	end
end	

function tower_btnCloseClick(a)
	--deldiv("main","tower_main")
	frame_CityOrMapBtnClick()
end

function tower_onloadcmp(a)
	deldiv("main","buildUpgrade_main")
	tower_refUpTime()
end

function tower_refUpTime()
	print("tower_refUpTime")
	--检查是否需要显示倒计时
	local arg = g_tower_arg
	
	local buildingpos = arg[1]
	local atower = arg[2]
	local nbuildinglv =arg[3]
	
	local ncount = 0
	for i = 1 , #atower do
	
		local v = atower[i]
--		print("v:"..tabletostring(v) )
		local x1, y1 = getMapXYByDataID(v[3],true)
		local x2, y2 = getMapXYByDataID(v[4],true)	
	
		local strsec = ""
		if v[6] == 0 then
			strsec = "???"
		else
--			print("v[5]:"..v[5])
--			print("v[6]:"..v[6])
			local dismax = v[6] - v[5]
			local discur = CUserData:getLeavingsTime(v[6])
			local dispro = 297 * (1- discur / dismax)
			strsec = formatTime(discur )
			if discur > 0 then
				if discur >= 0 and getid2("main","tower_prog_"..i) ~= nil then
					global_sw("main","tower_prog_"..i,dispro)		
					
					global_changetext("main","tower_progtext_"..i,strsec )
					
					ncount = ncount + 1
					
				end			
			else
			end
		end
	end
	if ncount > 0 then
		settimer(TIMER_ID_TOWER,1*1000,"tower_refUpTime",1)
	end
end


