string.split = function(inputstr, sep)
	--print(inputstr,sep)
	if sep == nil then
		sep = "%s"
	end
		t={} ; i=1
	for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
		t[i] = str
		i = i + 1
	end
	return t
end

function ismapnull( aa )
	for i,v in pairs(aa) do
		return 0
	end
	return 1
end

function maplen(aa)
	local len = 0
	for i,v in pairs(aa) do
		len = len + 1
	end
	return len
end

function utfstrlen(str)
	local len = #str
	local left = len
	local cnt = 0
	local arr = {0,0xc0,0xe0,0xf0,0xf8,0xfc}
	while left ~= 0 do
		local tmp = string.byte(str,-left)
		local i=#arr
		while arr[i] do
			if tmp >= arr[i] then 
				left=left-i	
				break
			end
			i = i -1
		end
		cnt = cnt + 1
	end
	return cnt
end

function tabletostring(v,kkk,mark)
	if mark == nil then
		mark = "\""
	end
	if v == nil and type(v) ~= "table" then
		return "v 不是一个table" .. type(v)
	end
	local ret = ""
	if kkk ~= nil and type(kkk) ~= "number" then ret = ret .. kkk.."=" end
	ret = ret .. "{"
	local i = 1
	for  k, v1 in pairs(v) do
		if i > 1 then
			ret = ret .. ","
		end
		if type(v1) == "table" then
			ret = ret .. tabletostring(v1,k)
		elseif type(k) == "number" then
			--ret = ret .. k ..":"
			if type(v1) == "boolean" then
				ret = ret .. tostring(v1)
			elseif type(v1) ~= "number" then
				ret = ret .. mark .. v1 .. mark
			else
				ret = ret .. v1
			end
		else
			ret = ret .. k .. "="
			if type(v1) == "boolean" then
				ret = ret .. tostring(v1)
			elseif type(v1) ~= "number" then
				ret = ret .. mark .. v1 .. mark
			else
				ret = ret .. v1
			end
		end
		i = i + 1
   end
   return ret .. "}"
end


function copytable(object)
    local lookup_table = {}
    local function _copy(object)
        if type(object) ~= "table" then
            return object
        elseif lookup_table[object] then
            return lookup_table[object]
        end  -- if
        local new_table = {}
        lookup_table[object] = new_table
        for index, value in pairs(object) do
            new_table[_copy(index)] = _copy(value)
        end-- for
        return setmetatable(new_table, getmetatable(object))
    end  -- function _copy
    return _copy(object)
end  -- function deepcopy


function formatTime(sec,day)--格式化剩余时间 00:00:00
	local str = "--:--:--"
	if sec == nil or sec < 0 then
		return str
	end
	local h = sec / 3600 
	h = h - h % 1
	sec = sec - h * 3600
	local m = sec / 60
	m = m - m % 1
	sec = sec - m * 60
	local d = math.floor(h/24)
	if day then
		h = h%24
	end
	if h < 10 then
		h = string.format("0%d",h)
	else
		h = string.format("%d",h)
	end
	if m < 10 then
		m = string.format("0%d",m)
	else
		m = string.format("%d",m)
	end
	if sec < 10 then
		sec = string.format("0%d",sec)
	else
		sec = string.format("%d",sec)
	end
	if day and d > 0 then
		str = string.format("%dd %s:%s:%s",d,h,m,sec)
	else
		str = string.format("%s:%s:%s",h,m,sec)
	end
	if more then
		return d,h,m,sec
	end
	return str 
end

--格式化时间:例formatDate("%Y年%m月%d日 %H时%M分",1377759258)
	--%a 英文简写星期
	--%A 英文全名星期
	--%b 英文简写月份
	--%B 英文全名月份
	--%c 08/29/13 14:54:18
	--%d day[01-31]
	--%H 24hour
	--%I 12hour
	--%M minute
	--%m month
	--%p am/pm
	--%S second
	--%w weekday
	--%x date
	--%X time
	--%y 简年
	--%Y 全年
	--%% 转义%号
function formatDate(format , date)
	if date == nil then
		date = os.time()
	end
	if date == 0 then
		return "~"
	end
	if format == nil then
		return os.date("%c",date)
	end
	
--	local timezone = g_timezone --客户端0点时间
--	if timezone == nil then
--		timezone = 8*3600--默认北京时区
--	end
--	if CData.m_tTodayZero == nil or CData.m_tTodayZero == 0 then
--		CData.m_tTodayZero = 8*3600--服务器0点时间
--	end
	
--	local date = date + ( timezone - CData.m_tTodayZero )--服务器date时间对应  客户端的时间
	
	return os.date(CData:GetTranlang(format),date)
end

function formatNum(num,isimg,comma)--数值，是否用图片，是否用逗号
	if num == nil then
		return 0
	end
	if isimg then
		local str = ""
		local arr = {}
		while num > 0 do
			table.insert(arr ,1,string.format([[<mx:Image source="assets/images/num%d.png"  mouseThrough="true"/>]],num%10))
			num = math.floor(num/10)
			if num > 0 and #arr%3 == 0 and comma then
				table.insert(arr ,1,[[<mx:Image source="assets/images/num00.png" mouseThrough="true"/>]] )
			end
		end
		for _,v in pairs(arr) do
			str = str .. v
		end
		return str
	else
		if comma then
			local str = ""
			local arr = {}
			while num > 0 do
				table.insert(arr ,1,num%10)
				num = math.floor(num/10)
				if num > 0 and #arr%3 == 0 then
					table.insert(arr ,1,"," )
				end
			end
			for _,v in pairs(arr) do
				str = str .. v
			end
			return str
		end
	end
		
	return num
end

--需转义内容
local needChangeWord={"%[","%]","%/","%{","%}","%<","%>","%-","%$","%'","%!",'%\\',"%\%"}
--转义输入文本
function changeInputText(str)
	--print("changeInputText start:",str)
	for i=1 , #needChangeWord do
		str=string.gsub(str,needChangeWord[i],"\\\\\\"..needChangeWord[i])
	end
	str=string.gsub(str,'%"',"")
	--print("changeInputText end:",str)
	
	return str
end


function checkStr(str)
	if string.lower(str) == "infinity" then
		str = str .. "."
	end
	return
end

--判断当前是不是聊天表情
function checkIsFace(str)
	local _,_,v = string.find(str  , '^@f(%d-)$')
	if v then
		return v
	end
	return 0
end


--判断是不是奖品格式
function checkIsReward(str,sep)
	local _,_,v,v1,v2 = string.find(str  , '^(%d+)%^(%d+)%^(%d+)')
	if v then
		return CUserData:getAwardStringByStr(str ,sep)
	end
	return str
end

local reformatarr = {sharepoint=".-%(X:(%d-) Y:(%d-)\%)",sharereport=".-%(X:(%d-) Y:(%d-)\%)",sharerose=".-%(X:(%d-) Y:(%d-)\%)"}
--解析字符串
function reformat(str)--返回：标示，显示字符串，参数1，参数2...
	--print("reformat start::",str)
	for k,v in pairs(reformatarr) do
		--print(k,v)
		local s,e,a1,a2,a3,a4,a5,a6,a7 = string.find(str  , '^@'..k..'@'..v)--查找以标志开始的固定语句
		if s then
			local arr = {a1,a2,a3,a4,a5,a6,a7}
			local setstr = k
			for _,v in pairs(arr) do
				if v ~= nil then
					setstr = setstr .. "|" ..v
				else
					break
				end
			end
--			if k ~= "sharereport" then
--				str = string.gsub(str,'@'..k..'@',"")
--			else
--				str = string.gsub(str,'@'..k..'@',"")
--				str = string.gsub(str,"%(X:(%d-) Y:(%d-)\%)","")
--			end

			if k == "sharepoint" then
				str = string.gsub(str,'@'..k..'@',"")
			elseif k == "sharereport" then 
				str = string.gsub(str,'@'..k..'@',"")
				str = string.gsub(str,"%(X:(%d-) Y:(%d-)\%)","")
			elseif k == "sharerose" then
				str = string.gsub(str,'@'..k..'@',"")
				str = string.gsub(str,"%(X:(%d-) Y:(%d-)\%)","")
				str = CData:GetTranlang(str)
			end
			
			return {k,str,setstr}
		end
	end
	
	--print("reformat end::",str)
	return str
end


--用于邮件简介
--取第一行且字符个数不超过len
function cutString(str,len)
	--print("cutString--------",str)
	local s,e = string.find(str,"/n")
	--print(s,e)
	if s then
		str = string.sub(str,1,s-1)
	end
--	str = string.sub(str,1,31)
--	local str = string.split(str,"%/n")[1]
--	local v = ""
--	for i = 1 ,#str do
--		v = v .. string.sub(str,i,1)
--		if utfstrlen(v) >= len then
--			return v
--		end
--	end
	--print("cutString--------",str)
	return str
end

--去掉颜色定义
function cutColorStr(str)
	--print("cutColorStr::",str)
	str = string.gsub(str,'#color:.-$',"")
	--print("cutColorStr::",str)
	return str
end


--获取游戏时间，即进入游戏到现在经历的时间，秒数
function gettimer()
	if CData.m_comeinCurTime == 0 then CData.m_comeinCurTime = os.time() end
	return os.time() - CData.m_comeinCurTime
end

function curtimer()--当前服务器时间
	return gettimer() + CData.m_ticketServerTime
end


--返回字符串语言，以设备语言为准
--setLanguage_getPlatparms()--{"US","en"}
function getStrLanguage(str)
	local lang = setLanguage_getPlatparms()
	if lang[2] == "zh" then
		if lang[1] == "TW" then
			lang[2] = "zh-CHT" --繁体中文
		else
			lang[2] = "zh-CHS"
		end
	end
	return lang[2]
end

--可以翻译的语言
local canSwatLange = {"ar"
,"bg"
,"ca"
,"zh-CHS"
,"zh-CHT"
,"cs"
,"da"
,"nl"
,"en"
,"et"
,"fi"
,"fr"
,"de"
,"el"
,"ht"
,"he"
,"hi"
,"mww"
,"hu"
,"id"
,"it"
,"ja"
,"tlh"
,"tlh-Qaak"
,"ko"
,"lv"
,"lt"
,"ms"
,"mt"
,"no"
,"fa"
,"pl"
,"pt"
,"ro"
,"ru"
,"sk"
,"sl"
,"es"
,"sv"
,"th"
,"tr"
,"uk"
,"ur"
,"vi"
,"cy"}
--判断语言为lang的字符串是否要翻译
function IsNeedSwatLanguage(lang)
	print("tans to lang::",setLanguage_getArg()[7])
	if lang == nil or lang == "" or setLanguage_getArg()[7] == lang then--设置的翻译目标语言与字符串一致
		return false --不需要翻译
	end
	for _,v in pairs(canSwatLange) do
		if v == lang then
			return true
		end
	end
	return false--不能翻译
end


--//----------------------滚动条相关------------------------------
 function global_scoll_div_move(aa)
 	local preid = "" --父级id
 	if type(aa) == "string" then
 		preid = aa
 	else
 		preid = aa.pBase:getts()
 	end
 	local vbox = getid2(preid,"div_vbox")
	local scroll = getid2(preid,"scrollBar")
	local parentdiv = getid2(preid,"div_vbox_parent")
	if vbox == nil or scroll == nil or parentdiv == nil then
		return 
	end
	local nscrollheight = (parentdiv:h()-scroll:h())
	local nheight = vbox:getmaxheight() - parentdiv:h() -- 滚动条最大高度
	if nheight > 0 then
		local ntop = vbox:y()*-1 --向上移动了多少，则滚动条按比例移动多少
		local x  = (ntop / nheight) * nscrollheight
		if x < 0 then x = 0 end
		if x > nscrollheight then x = nscrollheight end
		--scroll:sy( x + 90  ) --fx
		scroll:sy( x + parentdiv:y() + 3  )
	end
 end
 
 function global_scoll_div_cmp(aa)
 	local preid = "" --父级id
 	if type(aa) == "string" then
 		preid = aa
 	else
 		preid = aa.pBase:getts()
 	end
	local vbox = getid2(preid,"div_vbox")
	local scroll = getid2(preid,"scrollBar")
	local parentdiv = getid2(preid,"div_vbox_parent")
	if vbox == nil or scroll == nil or parentdiv == nil then
		return 
	end
	local nheight = vbox:getmaxheight()
	--local aan = nheight/580
	local aan = nheight/parentdiv:h()
	if aan < 1 then
		scroll:sh(0)
		local div_vbox_parent = getid2(preid , "div_vbox_parent" )
		if div_vbox_parent then
			div_vbox_parent:setslidetype(-1)
		end
	else
		scroll:sh( (parentdiv:h() / vbox:h()) * parentdiv:h() )
		local div_vbox_parent = getid2(preid , "div_vbox_parent" )
		if div_vbox_parent then
			div_vbox_parent:setslidetype(1)
		end
	end
	
	global_scoll_div_move(aa)
end

--
function global_sx(baseid,divid,x)
	local div = getid2(baseid,divid)
	if div ~= nil then	div:sx(x)	end
end
function global_sy(baseid,divid,y)
	local div = getid2(baseid,divid)
	if div ~= nil then	div:sy(y)	end
end
function global_sw(baseid,divid,w)
	local div = getid2(baseid,divid)
	if div ~= nil then	div:sw(w)	end
end
function global_sh(baseid,divid,h)
	local div = getid2(baseid,divid)
	if div ~= nil then	div:sh(h)	end
end
function global_changetext(baseid,divid,sztext)
	local div = getid2(baseid,divid)
	if div ~= nil then	div:changetext(sztext)	end
end
function global_sethidden(baseid,divid,nhidden)
	local div = getid2(baseid,divid)
	if div ~= nil then	div:sethidden(nhidden)	end
end
function global_enabled(baseid,divid,nenabled)
	local div = getid2(baseid,divid)
	if div ~= nil then	div:enabled(nenabled)	end
end

--btn loading
local div_btnloading_str = [[
	{if arg[2] == -1 then}
		<mx:MovieDiv id="${arg[1]}" mouseThrough="true" showone="0" horizontalCenter="0" verticalCenter="0">
			<mx:Movie id="mapMoveFriend" source="assets/moive/moive_btnwaiting.png" mouseThrough="true" playnum="-1"/>
		</mx:MovieDiv>
	{else}
		<mx:MovieDiv id="${arg[1]}" mouseThrough="true" showone="0" x="${arg[2]}" y="${arg[3]}">
			<mx:Movie id="mapMoveFriend" source="assets/moive/moive_btnwaiting.png" mouseThrough="true" playnum="-1"/>
		</mx:MovieDiv>
	{end}
]]

function btnloading_show(szidbase,x,y)--szidbase
--	if x == nil then x = -1 end
--	if y == nil then y = -1 end
--	local divbase = getid2("main",szidbase)
--	if divbase ~= nil then
--		local id= "btnloading"..szidbase
--		local arg = {id,x,y}
--		flextodiv(div_btnloading_str,arg ,szidbase)
--	end

	settimer(TIMER_ID_NETLOADING,6000,"btnloading_del",1)
	local div = getid2("main","gameLoading")
	if div ~= nil then
		div:sethidden(0)
	end
end

function btnloading_del(szidbase)--szidbase
	settimer(TIMER_ID_NETLOADING,6000,"btnloading_del",0)
	local div = getid2("main","gameLoading")
	if div ~= nil then
		div:sethidden(1)
	end
end

--btn loading
local div_viewMarkLoading_str = [[
	<mx:Canvas width="720" height="1280" backgroundColor="0x000000" id="${arg[1]}" backgroundAlpha="0.0" mouseEnabled="false" systemload="1">
		<mx:Movie source="assets/moive/moive_btnwaiting.png" playnum="-1" visible="true" horizontalCenter="0" verticalCenter="0"/>
	</mx:Canvas>
]]
function viewMarkLoading_show(szidbase)
	local divbase = getid2("main",szidbase)
	if divbase ~= nil then
		local id= "viewMarkLoading"..szidbase
		local arg = {id}
		flextodiv(div_viewMarkLoading_str,arg ,szidbase)
	end
end
function viewMarkLoading_del(szidbase)
	deldiv(szidbase,"viewMarkLoading"..szidbase)
end


--返回键控制
function dipan_callback_hardware_button(x,y)--系统调用返回函数
	print("dipan_callback_hardware_button")
	if guideNew_getDivExist() == 1 then
		exit_show()--退也游戏弹窗
		return
	end
	local more = getid2("main","frame_more")
	local other = getid2("main","frame_other")
	local ncomein = false                          --遇到加载未完成时就调用的情况
	if CData ~= nil and CData.m_comein ~= nil then
		ncomein = CData.m_comein
	end
	if ncomein == true then
		local count = other:count()
		local child
		local viewid
		local closebtn
		if count > 0 then
			for i=count-1,0,-1 do
				closebtn = nil
				--print("i:--------",i)
				child = other:getchild(i)
				viewid = child:getid()
				--g_viewCloseArr[viewid] = "lotteryCloseBtn"
				if g_viewCloseArr[viewid] then
					if viewid ~= g_viewCloseArr[viewid] then
						closebtn = getid2(viewid,g_viewCloseArr[viewid])
					else
						closebtn = getid2("main",viewid)
					end
					if closebtn then
						closebtn:addevent(DE_LISTEN_CLICK , 1 , 0 , 0 )
					end
				end
				break
			end
		else
			count = more:count()
			if count > 0 then
				for i=count-1,0,-1 do
					closebtn = nil
					--print("i:--------",i)
					child = more:getchild(i)
					viewid = child:getid()
					--print(viewid)
					--g_viewCloseArr[viewid] = "lotteryCloseBtn"
					if g_viewCloseArr[viewid] then
						if viewid ~= g_viewCloseArr[viewid] then
							closebtn = getid2(viewid,g_viewCloseArr[viewid])
						else
							closebtn = getid2("main",viewid)
						end
						if closebtn then
							--print("closebtn exist",closebtn:getid())
							closebtn:addevent(DE_LISTEN_CLICK , 1 , 0 , 0 )
						else
							--print("closebtn not exist")
						end
					end
					break
				end
			else
				--print("----------exit game")
				--appalertbox(4 , 0,0, 0 ,"" )--退也游戏弹窗
				exit_show()
			end
		end
	else
		--appalertbox(4 , 0,0, 0 ,"" )--退也游戏弹窗
		exit_show()
	end
	
end
