--//--------------------------------数据库操作--------------------------------

local dataForSql= nil
--从数据库获取数据
--sqlname:数据库名
--sqldictate : 执行的SQL查询语句
--key:字段名，如果key == nil则返回全部数据，反之返回一条数据key对应的值
function getDataForSql( sqlname , sqldictate , key )
	--print("getDataForSql",sqlname , sqldictate , key)
	if sqlname == nil or sqldictate == nil then
		return nil
	end 
	local i,j = string.find(sqlname,".sqlite")
	if i == nil then
		sqlname = sqlname .. ".sqlite"
	end
	if g_main_readFileMode == 1 then
		sqlname=string.gsub(sqlname,'/',"@")
	end
	sqlopen(sqlname)
	
	sqlgettable( 1 , "getDataForSqlBack" , sqldictate)
	
	sqlclose()
	if key ~= nil and #dataForSql == 1 then
		return dataForSql[1][key]
	end
	if #dataForSql == 0 then
		return nil
	end
	return dataForSql
end

function getDataForSqlBack( nseqno , arg )
	--print("getDataForSqlBack",tabletostring(arg))
	dataForSql = arg
end

--更改数据库
--sqlname:数据库名
--sqldictate : 执行的SQL查询语句
function changeDataToSql(sqldictate , sqlname)
	if sqlname == nil then
		sqlname = "mb6.sqlite"
	end
	local i,j = string.find(sqlname,".sqlite")
	if i == nil then
		sqlname = sqlname .. ".sqlite"
	end
	local ret = nil
	sqlopen(sqlname)
	ret = sqlexec( sqldictate )
	sqlclose()
	if ret == nil then ret = 1 end
	--print(string.format("changeDataToSql ret: %s",ret) )
	if sqlname == "mb6.sqlite" and ret ~= 0 then
		account_getSDKSqlite()
	end
	return ret
end
--//--------------------------------数据库操作end--------------------------------