div_fortressrank_str = [[
<mx:Canvas id="fortressrankdiv" width="720" height="1280" systemload="1">
	<mx:Image source="assets/images/bg04.jpg" width="720" y="111"  height="800"/>
	<mx:Image source="assets/images/bar07.png" x="14" y="111"/>
	{local lv = CUserData.m_aFortress[2]}
	<mx:Canvas x="87" width="550" y="118"   {if lv > 3 then} setslidetype="2" {end}>
		{local x = -190*(arg[1] - 2)
		if arg[1] == 1 then
			x = 0
		elseif arg[1] == lv then
			x = -190*(lv - 3)
		end
		}
		<mx:HBox horizontalGap="20" horizontalScrollPolicy="off" {if lv <= 3 then} horizontalCenter="0" {else} x="${x}" {end}>
			{
			for i=1,lv do}
				{if g_main_apptype == 1 then}
				<mx:Button styleName="nv01" label="레벨 ${i}" enabled="${(i == arg[1] and 'false' or 'true')}" width="170" setts="${i}" onclick="fortressRank_tab" mouseThrough="true"/>
				{else}
				<mx:Button styleName="nv01" label="LV${i}" enabled="${(i == arg[1] and 'false' or 'true')}" width="170" setts="${i}" onclick="fortressRank_tab" mouseThrough="true"/>
				{end}
			{end}
		</mx:HBox>
	</mx:Canvas>
	<!mx:Button id="leftbtn" styleName="arr01" y="124" x="645" visible="" setts="1" onclick="fortressRank_titleMove"/>
	<!mx:Button id="rightbtn" styleName="arr05" y="125" x="25" visible="" setts="2" onclick="fortressRank_titleMove"/>
	
	<mx:Image source="assets/images/th.png" x="17.5" y="203"/>
	<mx:Canvas y="206" x="62">
		<mx:Label text="名次" fontSize="20" color="0xeac9ae" x="60"/>
		<mx:Label text="名称" fontSize="20" color="0xeac9ae" x="215" width="173" textAlign="center"/>
		<mx:Label text="积分" fontSize="20" color="0xeac9ae" x="417" width="125" textAlign="center"/>
	</mx:Canvas>
	<mx:Canvas height="640" y="251" setslidetype="1">
		<mx:VBox verticalGap="0" x="37.5">
			{for _,v in pairs(arg[2]) do}
			<mx:Canvas mouseThrough="true" width="650">
				<mx:Label text="${v[1]}" fontSize="20" styleName="brown01" x="85" y="7" mouseThrough="true"/>
				<mx:HBox horizontalGap="0" horizontalScrollPolicy="off" horizontalCenter="0" y="7" mouseThrough="true">
					<!mx:Image source="${CUserData:getUnionTitleImg( v[5] , false, v[6])}" width="30" height="30" mouseThrough="true"/>
					<mx:Label text="${v[3]}" fontSize="20" styleName="brown01" mouseThrough="true"/>
				</mx:HBox>
				<mx:Label text="${v[7]}" fontSize="20" styleName="brown01" right="30" width="125" y="7" mouseThrough="true"/>
				<mx:Button styleName="img01Cj" right="20"  width="43" height="32" setts="${arg[1]}|${v[1]}" onclick="fortressRank_gift"/>
				<mx:Image source="assets/images/line01.png" y="36" mouseThrough="true"/>
			</mx:Canvas>
			{end}
		</mx:VBox>
	</mx:Canvas>
	
	<mx:Canvas width="720" height="112">
		<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
		<mx:Label id="frameTop_txt" text="贡献排名" width="720" textAlign="center" y="35"/>
		<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18"  onclick="fortressRank_close"/>
	</mx:Canvas>
</mx:Canvas>

]]

--要塞积分排名
local fortressLv = 1
local fortresslist = {}
function fortressRank(lv)
	if lv then
		fortressLv = lv
	else
		fortressLv = CUserData.m_aFortress[2]
	end
	flextodiv(div_fortressrank_str,{fortressLv,fortresslist},"frame_more")
	
	if lv == nil then
		FTToRank(fortressLv)
	end
end

function FTToRank(lv)
	btnloading_show()
	httpsend( 1 , 0x00000014 , 0 , {CUserData.m_nUserID,lv},"FTToRankBack")
end

function FTToRankBack(ntype , nseqno , nret , arg)
	btnloading_del()
	if nret ~= 0 then --表示处理消息失败
		return
	end
	print("ntype: nseqno: nret: arg:",ntype,nseqno,nret,tabletostring(arg))
	fortressLv = arg[1]
	fortresslist = arg[2]
	fortressRank(fortressLv)
end

function fortressRank_tab(a)
	local lv = tonumber(a.pBase:getts())
	FTToRank(lv)
end

function fortressRank_titleMove(a)
	local t = tonumber(a.pBase:getts())
	
end

function fortressRank_gift(a)
	local arr = string.split(a.pBase:getts(),"|")
	local lv = tonumber(arr[1])
	local no = tonumber(arr[2])
	if no > 5 then
		no = 1
	else
		no = no + 1
	end
	
	local str = CUserData:getForGiftConfigByLv(lv,no)
	print(lv,no,str)
	local gift = CUserData:getAwardTableByStr(str)
	if #gift then
		g_dTouchX,g_dTouchY=a.dTouchX,a.dTouchY + 200
		tip3_show(gift )
	end
end

function fortressRank_close()
	deldiv("frame_more","fortressrankdiv")
	fortressMain_tab(1)
end

