--英雄技能
local div_heroSkill_str = [[
<mx:Canvas id="div_heroSkill_id" width="720" height="1280">
	<mx:Canvas width="720" height="112">
		<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
		<mx:Label id="frameTop_txt" text="英雄技能" width="720" textAlign="center" y="35"/>
		<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" setts="4" onclick="heroSkill_btnCloseClick"/>
	</mx:Canvas>
	<mx:Image source="assets/images/bg01.jpg" width="720" height="990" x="0" y="111"/>
	<mx:Canvas y="120" height="880" setslidetype="1">
		<mx:Canvas>
			{for i = 1 , #arg do}
			{if arg[i].preImage~="" then}
				<mx:Image source="assets/images/${arg[i].preImage}.png" mouseThrough="true" x="${arg[i].xpos+arg[i].preImagex}" y="${arg[i].ypos+arg[i].preImagey}"/>
			{end}
			{end}
		</mx:Canvas>
		<mx:Canvas>
			{for i = 1 , #arg do}
			<mx:Canvas x="${arg[i].xpos}" y="${arg[i].ypos}" mouseThrough="true" setts="${arg[i].F0}" sound="defalut" onclick="skillUpgrade_btnClick">
				<mx:Image source="assets/images/skillBg01.png" mouseThrough="true" x="0" y="0"/>
				<mx:Image source="assets/skill/${CUserData:getSkillListByid(arg[i].F0,3)}.png" x="0" y="-5" mouseThrough="true"/>
				<mx:Image visible="${arg[i].isLock}" source="assets/images/ico_camplock.png" x="32" y="18" mouseThrough="true" width="105" height="105"/><!-- 锁住状态时显示 -->
				<mx:Canvas width="${arg[i].bar}" height="20" styleName="prog04" x="26" y="131" mouseThrough="true"/>
				<mx:Label text="${arg[i].curLevel}/${arg[i].totalLevel}" fontSize="24" styleName="white01" x="33" y="129" width="105" textAlign="center" mouseThrough="true"/>
				<mx:Label text="${arg[i].F1}" fontSize="20" styleName="black03" x="0" y="160" width="200" textAlign="center" mouseThrough="true"/>
			</mx:Canvas>
			{end}
		</mx:Canvas>
	</mx:Canvas>
	<mx:Image source="assets/images/bar01.png" y="997"/>
	<mx:Button styleName="btn03" label="重置" y="1018" x="284" width="150" onclick="heroSkillReset_btnClick"/>
</mx:Canvas>
]]

local function checkPreSkill(id)
	local id=tonumber(id)
	local level=id%100
	id=math.modf(id/100)
	local curLevel=CUserData:getSkillByid(id,2)
	return curLevel<level
end

local function skillDrawLine(x,y,preID)
	local prexpos=preID%10
	local preypos=math.modf(preID/10)
	if x==prexpos then
		return 3,60,-130
	elseif y==preypos then
		if x>prexpos then
			return 4,-135,54
		else
			return 2,172,54
		end
	end
	return 0
end

local leftx=20
local disx=250
local disy=320
function heroSkill_show()
	local arg={}
	local t=CUserData:getSkillList()
	for i = 1 , #t do
		local id=tonumber(t[i].F0)
		local xpos=id%10
		local ypos=math.modf(id/10)
		
		t[i].xpos=(xpos-1)*disx+leftx
		t[i].ypos=(ypos-1)*disy
		local lv=CUserData:getSkillByid(id,2)
		local total=tonumber(t[i].F2)
		t[i].curLevel=lv
		t[i].totalLevel=total
		t[i].bar=lv/total*120
		
		local preID=tonumber(t[i].F5)
		local lockStr=""
		local isLock="false"
		local temp=CUserData:getSkillUpgListByid(id,1)
		if checkPreSkill(temp.F1) or checkPreSkill(temp.F2) or checkPreSkill(temp.F3) then
			isLock="true"
			lockStr="Off"
		end
		t[i].isLock=isLock
		if preID==0 then
			t[i].preImage=""
		else
			local img,x,y=skillDrawLine(xpos,ypos,preID)
			t[i].preImage="ic0"..img.."Tree"..lockStr
			t[i].preImagex=x
			t[i].preImagey=y
		end
	end
	flextodiv(div_heroSkill_str,t ,"frame_more")
end

function skillUpgrade_btnClick(a)
	local id=tonumber(a.pBase:getts())
	heroSkillUpgrade_show(id)
end

local function heroSkillResetBack(num,arg)
	httpsend( 1 , 0x00000109 , 0 , {CUserData.m_nUserID,9,0},"httpdp_heroSkillUpgradeBack","httpdp_svrStatusLogin"  )
end
function heroSkillReset_btnClick()
	useItemShow({1015 , "","","重置"},{heroSkillResetBack})
end

function httpdp_heroSkillUpgradeBack(ntype , nseqno , nret , arg)
	http_getdata(ntype , nseqno , nret , arg)
	print(string.format("httpdp_revMsgLogin ntype:%x ：nseqno:%d nret:%d",ntype , nseqno , nret) )
	if nret ~= 0 then --表示处理消息失败
		return
	end
	table.insert(arg,1,nret)
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s httpdp_revMsgLogin" , ntype , nseqno , nret, tabletostring(arg) ) )
	
	CUserData:setItemInfo(arg,3)
	CUserData:updateGold(arg[7])
	
	local type=arg[2]
	if type==9 then
		CUserData.m_aSkill={}
	elseif type==1 or type==2 or type==3 then
		CUserData:setSkillInfo(arg,5)
	end
	heroSkill_show()
	refreshHeroSkillPoint()
	local heroSkillUpgrade=getid2("frame_more","div_heroSkillUpgrade_id")
	if heroSkillUpgrade~=nil then
		heroSkillUpgrade_show(curSkillID)
	end
end

function heroSkill_btnCloseClick(a)
	deldiv("frame_more","div_heroSkill_id",{3})
end
