local str = 
[[
<mx:Canvas id="div_mapMini_id" width="720" height="1280" backgroundColor="0x000000" backgroundAlpha="0.6" mouseEnabled="false" systemload="1">
<mx:Canvas width="698" height="752" horizontalCenter="0" verticalCenter="0">
	<mx:Image source="assets/images/miniMapBg01.png" width="698" height="752"/>
	{if g_main_apptype == 1 then }
		<mx:Label text="지도" fontSize="30" styleName="white01" x="222" y="13" width="250" textAlign="center"/>
	{else}
		<mx:Label text="Map" fontSize="30" styleName="white01" x="222" y="13" width="250" textAlign="center"/>
	{end}
	<mx:Button styleName="btn02Close" id="closebtn" x="618" y="0" onclick="mapMiniClose_btnClick"/>
	<mx:Canvas x="22" y="78" width="654" height="654">
	{
	local tx,ty=0,0
	if getMapServiceid() == 0 then
		tx,ty=654/2-arg[6][1],654/2-arg[6][2]
		tx=math.min(math.max(tx,654-1638),0)
		ty=math.min(math.max(ty,654-1638),0)
	end
	}
	<mx:Canvas id="div_mapMini_view" x="${tx}" y="${ty}" {if getMapServiceid() == 0 then} onbegin="div_mapMini_content_move" onend="div_mapMini_content_move" onmove="div_mapMini_content_move"{end}>
		{if getMapServiceid() == 0 then}
		<mx:Image source="assets/images/Rome_map.png" mouseThrough="true" width="1638" height="1638"/>
		{else}
		<mx:Image source="assets/images/cross_map.png" mouseThrough="true" width="653" height="654"/>
		{end}
		{for i=1,#arg do}
			{local type=arg[i][4]}
			<mx:Button styleName="btn0${type}MiniMap" Stroke="2" label="" x="${arg[i][1]}" y="${arg[i][2]}" setts="${arg[i][3]}" onclick="gotoMapPos_btnClick"/>
			{
			local color="#385090"
			if type>=3 then
				color="#ffffff"
			end		
			}
			{if g_main_apptype == 1 then}
				<mx:Label color="${color}" Stroke="1" text="${arg[i][5]}" width="180" textAlign="center"  x="${arg[i][1]-30}" y="${arg[i][2]+60}"/>
			{else}
				<mx:Label color="${color}" Stroke="1" text="${arg[i][5]}" width="140" textAlign="center"  x="${arg[i][1]-10}" y="${arg[i][2]+60}"/>
			{end}
		{end}
	</mx:Canvas>
	</mx:Canvas>
</mx:Canvas>
</mx:Canvas>
]]
--
local function getMapMiniPos(pos,type,title)
	local tx,ty=getMapXYByDataID(pos)
	local det = 1500
	
	if getMapServiceid() == -1 then
		det = 600
	end
	tx=tx/mapGetGRIDHNUM()*det+70
	ty=ty/mapGetGRIDVNUM()*det+80
	if type==1 then
		if getMapServiceid() == 0 then
			tx=tx-30
			ty=ty-30
		else
			tx=tx-30 - 45
			ty=ty-30 - 50
		end
	elseif type==2 then
		tx=tx-60
		ty=ty-45
	elseif type==3 then
		tx=tx-60
		ty=ty-45
	elseif type==4 then
		tx=tx-60
		ty=ty-48
	end
	return {tx,ty,pos,type,title}
end
--
function mapMiniClose_btnClick()
	deldiv("frame_more","div_mapMini_id")
end
--
function gotoMapPos_btnClick(a)
	mapMiniClose_btnClick()
	local pos=tonumber(a.pBase:getts())
	map_refush(pos)
end
--
function mapMini_show()
	if getMapServiceid() == -1 then
		local arg=MapMiniGetCommon()
		flextodiv(str,arg,"frame_more")
	else
		httpsend( 1 , 0x00000038 , 0 , {CUserData.m_nUserID},"getMapAllyBaseListBack","httpdp_svrStatusLogin")
	end
end
--
function getMapAllyBaseListBack(ntype , nseqno , nret , arg)
	http_getdata(ntype , nseqno , nret , arg)
	print(string.format("httpdp_revMsgLogin ntype:%x ：nseqno:%d nret:%d",ntype , nseqno , nret) )
	if nret ~= 0 then --表示处理消息失败
		return
	end
	table.insert(arg,1,nret)
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s httpdp_revMsgLogin" , ntype , nseqno , nret, tabletostring(arg) ) )

	local temp=MapMiniGetCommon()
	arg=arg[2]
	for i=1,#arg do
--		联盟排名
--		联盟编号
--		联盟简称
--		联盟图腾
--		地图坐标
--		显示信息
		local title="R"..arg[i][1].."["..arg[i][3].."]"
		table.insert(temp,getMapMiniPos(arg[i][5],2,title))
	end
	flextodiv(str,temp,"frame_more")
end

function MapMiniGetCommon()
	local temp={}
	if getMapServiceid() == 0 then
		if g_main_apptype == 1 then 
			table.insert(temp,{765,775,130306,3,"로마"})
			table.insert(temp,{351,321,32194,4,"울프 요새"})
			table.insert(temp,{1229,321,32578,4,"유니콘 요새"})
			table.insert(temp,{351,1247,228034,4,"라이온 요새"})
			table.insert(temp,{1229,1247,228418,4,"이글 요새"})
		else
			table.insert(temp,{765,775,130306,3,"Rome"})
			table.insert(temp,{351,321,32194,4,"Naples"})
			table.insert(temp,{1229,321,32578,4,"Alexander"})
			table.insert(temp,{351,1247,228034,4,"Palermo"})
			table.insert(temp,{1229,1247,228418,4,"Vienna"})
		end
	else
		table.insert(temp,{269,300,32385,3,map_getBeachHeadName(1)})
		table.insert(temp,{109,138,13528,4,map_getBeachHeadName(2)})
		table.insert(temp,{451,129,12899,4,map_getBeachHeadName(3)})
		table.insert(temp,{91,500,49589,4,map_getBeachHeadName(4)})
		table.insert(temp,{425,518,51497,4,map_getBeachHeadName(5)})
		for i,w in pairs(temp) do 
			local ower = 1
			for _,v in pairs(CUserData.m_aCrossHeachHead) do
				if v[1] == w[3] then
					if v[3] > 0 or v[5] >0 then
						w[5] = CUserData:getUserNameString(v[6],v[4],v[3])
					end
					break
				end
			end
		end
		
	end
	if getMapState() == 0 then
		table.insert(temp,getMapMiniPos(math.abs(CUserData.m_nMapID),1,""))
	end
	return temp
end
--
local function setMapMiniViewPos(x,y)
	x=math.min(math.max(x,654-1638),0)
	y=math.min(math.max(y,654-1638),0)
	return x,y
end
local recordx=0
local recordy=0
local hasBegin=false
function div_mapMini_content_move(a)
	local mapContent=getid2("div_mapMini_id","div_mapMini_view")                          
	if a.nType == DE_LISTEN_TOUCH_END then
		if hasBegin then
			hasBegin=false
			local tx,ty=setMapMiniViewPos(a.dTouchX-recordx,a.dTouchY-recordy)
			mapContent:sx(tx)
			mapContent:sy(ty)
		end
	elseif a.nType == DE_LISTEN_TOUCH_BEGIN then
		hasBegin=true
		recordx=a.dTouchX-mapContent:x()
		recordy=a.dTouchY-mapContent:y()
	elseif a.nType == DE_LISTEN_TOUCH_MOVE then
		if hasBegin then
			local tx,ty=setMapMiniViewPos(a.dTouchX-recordx,a.dTouchY-recordy)
			mapContent:sx(tx)
			mapContent:sy(ty)
		end
		recordx=a.dTouchX-mapContent:x()
		recordy=a.dTouchY-mapContent:y()
	end
end