--小据点
local div_mapSmallBeach_item_str = [[<mx:VBox id="listbox" verticalGap="5" x="45">
					{for  _,v in pairs(arg.rank) do}
					<mx:Canvas fontSize="24" mouseThrough="true">
						<mx:Image source="assets/images/line20.png" y="40" mouseThrough="true"/>
						<mx:Image source="assets/images/img0${v[6] - 100}_jd.png" x="5" y="0" width="45" height="45" mouseThrough="true"/>
						<mx:Label text="[${v[3]}]" x="48" y="0" styleName="white01" mouseThrough="true"/>
						{if g_main_apptype == 1 then}
							<mx:Label text="${v[7]}" horizontalCenter="0" y="0" styleName="white01" mouseThrough="true"/>
						{else}
							<mx:Label text="${v[7]}" x="218" y="0" styleName="white01" mouseThrough="true"/>
						{end}
						<mx:Label text="${v[1]}" right="44" y="0" styleName="white01" textAlign="center" mouseThrough="true"/>
					</mx:Canvas>
					{end}
				</mx:VBox>]]

local div_mapSmallBeach_str = [[
<mx:Canvas  id="div_mapSmallBeach_id" onloadcmp="div_mapSmallBeach_comp" width="720" height="1280" mouseThrough="false" systemload="1">
	<mx:Canvas width="620"  horizontalCenter="0" verticalCenter="0">
		<mx:Canvas width="620" height="905" styleName="popBg07" y="80">
			<mx:Button styleName="btn02Close" id="closeid" x="530" y="32" onclick="mapSmallBeachButton_close"/>
			<mx:Label text="${arg.title}${arg.posMSG}" styleName="green01" fontSize="26" x="212" y="94"/>
			<mx:Image source="assets/images/line07.png" x="26" y="138"/>
			<mx:Canvas id="unionBox" width="620" visible="false">
				<mx:Image source="assets/images/testImg11.png" x="37" y="146"/>
				<mx:Image id="unionImg" source="" x="57" y="186"/>
				<mx:Label id="unionShortName" text="" fontSize="30" styleName="black03" x="279" y="176"/>
				<mx:Label id="unionFullName" text="" fontSize="30" styleName="black03" x="279" y="237"/>
				<mx:Image source="assets/images/line07.png" x="26" y="304"/>
				<mx:Button styleName="btn06" label="更多" width="70" right="30" y="316" setts="${arg.ID}" onclick="mapSmallBeachMore_show"/>
			</mx:Canvas>
			<mx:Label id="noTxt" text="无人占领" fontSize="30" styleName="black03" horizontalCenter="0" y="237" visible="false"/>
			
			<mx:Label id="troop" text="" fontSize="26" styleName="brown02" horizontalCenter="0" y="320"/>
			<mx:Image source="assets/images/line07.png" x="26" y="368"/>
			<mx:Image source="assets/images/block01Xjd.png" x="22" y="382"/>
			<mx:Label text="联盟" fontSize="24" color="0xf5e6d6" x="75" y="393"/>
			<mx:Label text="记录" fontSize="24" color="0xf5e6d6" x="273" y="393"/>
			<mx:Label text="排名" fontSize="24" color="0xf5e6d6" x="472" y="393"/>
			<mx:Canvas id="box" y="436" height="245" setslidetype="1">]]
				..div_mapSmallBeach_item_str..
			[[</mx:Canvas>
			<mx:Text fontSize="22" styleName="brown02" width="561" text="占领据点后每隔20分钟会有一波怪物进攻，本据点将保留你的记录直到活动结束。" x="29.5" y="700"/>
			<mx:Button id="btn" styleName="btn08" label="" x="121.5" y="801" onclick="mapSmallBeachButton_btnClick" enabled="false"/>
		</mx:Canvas>
		<mx:Image source="assets/images/iconBg02.png" x="194"/>
		<mx:Image source="assets/images/img0${(arg.ID-100)}_jd.png" x="239" y="25"/>
	</mx:Canvas>
</mx:Canvas>


]]

local troopData = nil

--
local smallBeachName = {a101="狼堡",a102="独角兽堡",a103="狮堡",a104="鹰堡"}
local smallBeachMapID = {a101=32193,a102=32577,a103=228033,a104=228417}
local smallBeachID = {a32193=101,a32577=102,a228033=103,a228417=104}

local smallBeachImage = {a101="2400001",a102="2400011",a103="2400021",a104="2400031"}

function getSmallBeachID(mapDataID)
	return smallBeachID["a"..mapDataID]
end

function getSmallBeachMapID(ID)
	return smallBeachMapID["a"..ID]
end

function getSmallBeachName(ID)
	return smallBeachName["a"..ID]
end

function getSmallBeachImage(ID)
	return smallBeachImage["a"..ID]
end

function getSmallBeachNameByMAPID(ID)
	for i,v in pairs(smallBeachMapID) do
		local d = (ID - v)
		if d == 0 or d == 1 or d ==2 or d ==-509 then
			return getSmallBeachName(getSmallBeachID(v))
		end
	end
end

local curMapTable=nil
function mapSmallBeach_show(arg)
	print("mapSmallBeach_show::",tabletostring(arg));
	curMapTable=arg
	local mapDataID =curMapTable.mapDataID
	curMapTable.ID = getSmallBeachID(mapDataID)
	
	curMapTable.title=CData:GetTranlang(getSmallBeachName(curMapTable.ID))
	curMapTable.shortName=""
	curMapTable.fullName=""
	curMapTable.posMSG=CUserData:getMapPosString(curMapTable.x,curMapTable.y)
	curMapTable.msg=""
	curMapTable.image = "assets/images/imgQi.png"
	curMapTable.rank = {};
	
	print("mapSmallBeach_show:1:",tabletostring(arg))
	flextodiv(div_mapSmallBeach_str,curMapTable,"frame_more",nil,nil,{5,nil,{g_dTouchX,g_dTouchY}})
	
	playSound(120)
end

function div_mapSmallBeach_comp()
	httpsend( 1 , 0x0045 , 0 , {CUserData.m_nUserID,curMapTable.ID},"httpdp_MapGetHeachDetailBack","httpdp_svrStatus"  )
end

function httpdp_MapGetHeachDetailBack(ntype , nseqno , nret , arg)
	http_getdata(ntype , nseqno , nret , arg)
	print(string.format("httpdp_revMsgLogin ntype:%x ：nseqno:%d nret:%d",ntype , nseqno , nret) )
	if nret ~= 0 then --表示处理消息失败
		return
	end
	table.insert(arg,1,nret)
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s httpdp_revMsgLogin" , ntype , nseqno , nret, tabletostring(arg) ) )
	if map_checkDataAvailability(getSmallBeachMapID(arg[5])) == false then
		return
	end
	local div = nil
	local btn = getid2("div_mapSmallBeach_id","btn")
	if arg[7] > 0 then--有人占领
		div = getid2("div_mapSmallBeach_id","unionShortName")
		if div~=nil then
			div:changetext("["..arg[8].."]")
		end
		div = getid2("div_mapSmallBeach_id","unionFullName")
		if div~=nil then
			div:changetext(arg[9])
		end
		div = getid2("div_mapSmallBeach_id","unionImg")
		if div~=nil then
			div:changepng("assets/union/big/"..arg[10]..".png")
		end
		
		div = getid2("div_mapSmallBeach_id","noTxt")
		if div~=nil then
			div:sethidden(1)
		end
		div = getid2("div_mapSmallBeach_id","unionBox")
		if div~=nil then
			div:sethidden(0)
		end
		
		if btn then
			if arg[7] == CUserData.m_nAllyID then
				--是自己联盟占领
				btn:changetext("增援")
				btn:setts("4")
			else
				btn:changetext("联合攻击")
				btn:setts("7")
			end
		end
	else
		div = getid2("div_mapSmallBeach_id","unionBox")
		if div~=nil then
			div:sethidden(1)
		end
		div = getid2("div_mapSmallBeach_id","noTxt")
		if div~=nil then
			div:sethidden(0)
		end
		if btn then
			btn:changetext("联合攻击")
			btn:setts("7")
		end
	end
	
	if btn then
		if arg[2] == 3 then
			btn:enabled("true")
		else
			btn:enabled("false")
		end
	end
	
	
	if arg[13]>0 and CUserData:getLeavingsTime(arg[12]) > 0 then
		troopData = {arg[11],arg[12],arg[13],arg[14]}
		mapSmallBeach_time()
		settimer(TIMER_ID_SMALLBEACH_TIMER,1*1000,"mapSmallBeach_time",1000000)
	end
	
	flextodiv(div_mapSmallBeach_item_str,{rank=arg[15]},"box",nil,"div_mapSmallBeach_id")
end

function mapSmallBeach_time()
	if troopData then
		local time = CUserData:getLeavingsTime(troopData[2])
		if time > 0 then
			local div = getid2("div_mapSmallBeach_id","troop")
			if div~=nil then
				if g_main_apptype == 1 then 
					div:changetext(string.format("%s(레벨 %d) %s",CData:GetTranlang(CUserData:getBattleNPCConfigById(troopData[3],1)),troopData[1],formatTime(time)))
				else
					div:changetext(string.format("%s(Lv%d) %s",CData:GetTranlang(CUserData:getBattleNPCConfigById(troopData[3],1)),troopData[1],formatTime(time)))
				end
			end
		else
			settimer(TIMER_ID_SMALLBEACH_TIMER,0,"mapSmallBeach_time",0)
		end
	end
end

--操作按钮
function mapSmallBeachButton_btnClick(a)
	--"4增援","7联合攻击"}
	local type=tonumber(a.pBase:getts())
	if type==4 then
		chubing_show(curMapTable.mapDataID,type,nil,nil,6)
	elseif type==7 then
		if CUserData.m_nAllyID==0 then
			showClum({"发起联合攻击需要先加入联盟！",1,{"确定"},notfloat=true})
		elseif CUserData:getMaxLvBuildByid(15)==nil then
			showClum({"发起联合攻击需要建筑[战争会所]！",1,{"确定"},notfloat=true})
		else
			chubing_show(curMapTable.mapDataID,type,nil,nil,6)
		end
	end
end


function mapSmallBeachButton_close()
	deldiv("frame_more","div_mapSmallBeach_id")
	settimer(TIMER_ID_SMALLBEACH_TIMER,0,"mapSmallBeach_time",0)
end




local div_mapSmallBeachMore_str = [[
<mx:Canvas  id="div_mapSmallBeachMore_id" onloadcmp="div_mapSmallBeachMore_comp" width="720" height="1280" mouseThrough="false" systemload="1">
	<mx:Canvas width="628" height="486" horizontalCenter="0" verticalCenter="0">
		<mx:Image source="assets/images/popBg08.png"/>
		<mx:Button styleName="btn02Close" id="closeid" x="538" y="16" onclick="mapSmallBeachMore_close"/>
		
		<mx:Image source="assets/images/block06Xjd.png" x="31" y="106"/>
		<mx:Label text="名称" fontSize="24" color="0xf5e6d6" x="84" y="112"/>
		<mx:Label text="等级" fontSize="24" color="0xf5e6d6" x="272" y="112"/>
		<mx:Label text="战斗力" fontSize="24" color="0xf5e6d6" x="365" y="112"/>
		<mx:Label text="进攻" fontSize="24" color="0xf5e6d6" x="503" y="112"/>
		<mx:Canvas y="160" height="245" setslidetype="1">
			<mx:VBox verticalGap="5" x="45">
				{for i,v in pairs(arg[2]) do}
				<mx:Canvas>
					<mx:Image source="assets/images/line22.png" y="40" mouseThrough="true"/>
					<mx:Label text="${CData:GetTranlang(CUserData:getBattleNPCConfigById(v[3],1))}" x="22" y="0" fontSize="24" color="0xf2e7dd" mouseThrough="true"/>
					<mx:Label text="Lv.${v[1]}" x="236" y="0" fontSize="24" color="0xf2e7dd" mouseThrough="true"/>
					<mx:Label text="${CUserData:getNumStr(v[4],2)}" x="301" y="0" fontSize="24" color="0xf2e7dd" textAlign="center" mouseThrough="true"/>
					<mx:Label id="troopTime_${i}" text="${formatTime(CUserData:getLeavingsTime(v[2]))}" right="2" y="0" fontSize="24" color="0xf2e7dd" textAlign="right" mouseThrough="true"/>
				</mx:Canvas>
				{end}
			</mx:VBox>
		</mx:Canvas>
	</mx:Canvas>
</mx:Canvas>
]]

local beachMore_data = nil
function mapSmallBeachMore_show(a)
	local beachId
	if type(a) == "number" then
		beachId = a
	else
		g_dTouchX = a.dTouchX
		g_dTouchY = a.dTouchY
		beachId=tonumber(a.pBase:getts())
	end
	httpsend( 1 , 0x0046 , 0 , {CUserData.m_nUserID,beachId},"httpdp_MapGetHeachDetailMoreBack","httpdp_svrStatus"  )
end

function httpdp_MapGetHeachDetailMoreBack(ntype , nseqno , nret , arg)
	print(string.format("httpdp_revMsgLogin ntype:%x ：nseqno:%d nret:%d",ntype , nseqno , nret) )
	if nret ~= 0 then --表示处理消息失败
		return
	end
	beachMore_data = arg
	flextodiv(div_mapSmallBeachMore_str,beachMore_data,"frame_more",nil,nil,{5,"div_mapSmallBeachMore_comp",{g_dTouchX,g_dTouchY}})
end


function div_mapSmallBeachMore_comp()
	settimer(TIMER_ID_FOR_ACTION_SmallBeachMore,1*1000,"mapSmallBeachMore_time",1000000)
end

function mapSmallBeachMore_time()
	local have = false
	if beachMore_data then
		for i,v in pairs(beachMore_data[2]) do
			local time = CUserData:getLeavingsTime(v[2])
			if time > 0 then
				local div = getid2("div_mapSmallBeachMore_id","troopTime"..(i))
				if div~=nil then
					div:changetext(formatTime(time))
					have = true
				end
			else
				delid2("div_mapSmallBeachMore_id","troopTime"..(i))
			end
		end
		
	end
	if have == false then
		settimer(TIMER_ID_FOR_ACTION_SmallBeachMore,0,"mapSmallBeachMore_time",0)
		if beachMore_data then
			mapSmallBeachMore_show(beachMore_data[1])
		end
	end
end


function mapSmallBeachMore_close()
	settimer(TIMER_ID_FOR_ACTION_SmallBeachMore,0,"mapSmallBeachMore_time",0)
 	deldiv("frame_more","div_mapSmallBeachMore_id",{5})
end