--appRight
local _str = {
	a1 = "Thank you for choosing Gametrend's game products. To provide quality service for you we need to collect your device IMEI, MAC address and other information as your unique identifier. We promise you that all the device information and personal information we collect are kept confidential and protected. To continue enjoying our game please tap the checkbox below and agree to our Terms of Service. If you do not agree to our terms and conditions it won't be possible to continue playing the game.",
	a2 = "Privacy Policy",
	a3 = "Agree",
	a4 = "You have to accept the agreement first",
	a5 = "I read and accept the ",
	a6 = "Privacy Policy",
}
function appRight_getStr(nindex)
	if _str["a"..nindex] ~= nil then 
		return _str["a"..nindex]
	end
	return ""
end


local _nAgreed = 0
function appRight_setAgreedFromSql(val)
	print("appRight_setAgreedFromSql val:" .. val)
	_nAgreed = jdtonumber(val)
end

function appRight_setAgreedToSql(val)
	print("appRight_setAgreedToSql val:" .. val)
	_nAgreed = val
	
--	DB_setusersql(12,val,0,0)
	appRight_setql()
end

---------------------------------------------------------------
function appRight_createTable()    --建表
	print("createSoundTable")
--	changeDataToSql("CREATE TABLE IF NOT EXISTS appRight (a integer,b integer,c integer,d integer)" )
	
	changeDataToSql( "CREATE TABLE IF NOT EXISTS appRight (seqno INTEGER PRIMARY KEY,n1 INT,n2 INT,n3 INT)" )
	
end

function appRight_getsql()
	print("appRight_getsql")
	appRight_createTable()
	local vv = getDataForSql("mb6", "select * from appRight ")
	if vv ~= nil and type(vv) == "table" then
		print("appRight_getsql vv".. tabletostring(vv))
--		return vv[1]
		appRight_setAgreedFromSql(vv[1]["n1"])
	else
		print("appRight_getsql changeDataToSql")
		changeDataToSql("INSERT INTO appRight VALUES(?,0,0,0);")
--		return nil
		appRight_setAgreedFromSql(0)
	end
end

function appRight_setql()
	print("appRight_setql")
	local str = "update appRight set n1=".._nAgreed
	changeDataToSql( str )
end
-------------------------------------------------------------------
local nTryCount = 0
local _nTempVal = 0
function appRight_try()
	print("appRight_try nTryCount:"..nTryCount)
	nTryCount=nTryCount+1
	if appRight_check(_nTempVal) == 0 then 
		account_start(_nTempVal )
	end
end

function appRight_check(nTempVal)
	print("appRight_check nTempVal:"..nTempVal..", _nAgreed:".. _nAgreed)
	_nTempVal = nTempVal
	
--	if g_system == DP_PLATFORM_IOS then 
--		print("1 appRight_check return")
--		return 0	
--	end
	local nappversion = gameClient_getVersionCodeFromPkg()
	if nappversion < 10 and nTryCount < 6 then 
		
		settimer(TIMER_ID_FOR_ACTIONTIMER,1*1000,"appRight_try",1)
		return 1
	end
	
	print("appRight_check g_system:" .. g_system .. ",nappversion:" .. nappversion .. ",_nAgreed:" .. _nAgreed)
	
	if g_system == DP_PLATFORM_ANDROID and nappversion < 35 then --83
		print("2 appRight_check return")
		return 0	
	end
	if _nAgreed == 1 then 
		print("4 appRight_check return")
		appRight_reqSN()
		return 1
	end
	
	appRight_show()
	return 1 
end

function appRight_onSetSN(str)
	print("appRight_onSetSN str:" .. str)
	if str ~= nil and str ~= "" then 
		app_setPlatformDeviceId(str)
	end
	CData.m_pszMacIn = account_getSN()
	account_start(_nTempVal)
end

function appRight_onCheckBoxClick()
	print("appRight_onCheckBoxClick")
	local div = getid2("main","appRight_checkBox01")
	if div ~= nil then 
		if div:gethidden() == 0 then 
			div:sethidden(1)
		else
			div:sethidden(0)
		end
	end
end

function appRight_onGreeClick()
	print("appRight_onGreeClick")
	local div = getid2("main","appRight_checkBox01")
	if div ~= nil then 
		div:sethidden(0)
	end
end

function appRight_reqSN()
	print("appRight_reqSN()")
	if g_system == DP_PLATFORM_WIN32 then 
		print("appRight_onBtnYesClick 3")
		dipan_callback_socialtolua(108,get_login_mac() )
	else--android
		print("appRight_onBtnYesClick 4")
		conenttosocial(108,"")
	end
end

function appRight_onBtnYesClick()
	print("appRight_onBtnYesClick")
	local div = getid2("main","appRight_checkBox01")
	if div ~= nil then 
		if div:gethidden() == 0 then 
			print("appRight_onBtnYesClick 1")
			appRight_del()
			appRight_setAgreedToSql(1)
			
			--ok
			appRight_reqSN()
		else
			print("appRight_onBtnYesClick 2")
			--err
			local divTips = getid2("main","appRight_checkBoxTips")
			if divTips ~= nil then 
				divTips:sethidden(0)
			end
		end
	end
end
function appRight_onBtnNoClick()
	print("appRight_onBtnNoClick")
	appRight_del()
end

function appRight_onDetailClick()
	print("appRight_onDetailClick")
--	conenttosocial(196,"http://vikings.d1ad.com/wp10_privacy.php|0")	
--	conenttosocial(196,"http://aow.gametrend.tech/privacy.php|0")
	conenttosocial(3 , "http://privacy.feelingtouch.com/terms.pdf" )	
end

function appRight_onDetailClick2()
	print("appRight_onDetailClick2")
--	conenttosocial(196,"http://vikings.d1ad.com/wp10_privacy.php|0")	
--	conenttosocial(196,"http://aow.gametrend.tech/privacy.php|0")
	conenttosocial(3 , "http://privacy.feelingtouch.com/feelingtouch_privacy.pdf" )	
end

function appRight_del()
	print("appRight_del")
	delid2("main","appRight_main")
end

function appRight_show()
	print("appRight_show")
	local strtemp = [[
	{
	local str = arg[1]
	}
	<mx:Canvas id="appRight_main" width="720" height="1280" mouseThrough="false"> 
		<mx:Canvas width="590" height="537" backgroundColor="0xffffff" backgroundAlpha="1.0" horizontalCenter="0" verticalCenter="-20">
			<mx:Label text="${appRight_getStr(2)} " fontsize="36" color="0x1b1b1b" mouseThrough="true" y="49" horizontalCenter="0"/>
			
			<mx:Canvas width="510" height="240" setslidetype="1" backgroundColor="0xffff00" backgroundAlpha="0.0" y="100" horizontalCenter="0">
				<mx:Label text="${appRight_getStr(1)}" fontsize="24" color="0x707070" width="510" mouseThrough="true"/>
			</mx:Canvas>
			
			<mx:Canvas onclick="appRight_onCheckBoxClick" width="60" height="60"  y="347" x="26">
				<mx:Image id="appRight_checkBox01" visible="false" horizontalCenter="0" verticalCenter="0" source="assets/images/appRight_bg02.png" mouseThrough="true"/>
				<mx:Image horizontalCenter="0" verticalCenter="0" source="assets/images/appRight_bg01.png" mouseThrough="true"/>
			</mx:Canvas>
			
			<mx:Label id="appRight_checkBoxTips" visible="false" y="330" x="90" text="${appRight_getStr(4)}" fontsize="24" color="0xff0000" mouseThrough="true"/>
			<mx:HBox y="361" x="90">
				<mx:Label onclick="appRight_onGreeClick" text="${appRight_getStr(5)}" fontsize="24" color="0x707070" mouseThrough="true"/>
				<mx:Label onclick="appRight_onDetailClick" text="${appRight_getStr(6)}" fontsize="24" color="0x00a0e9" mouseThrough="true"/>
			</mx:HBox>
			
			<mx:Image source="assets/images/appRight_bg04.png" y="407" horizontalCenter="0" />
		
			<mx:Canvas onclick="appRight_onBtnYesClick" y="409" horizontalCenter="0" backgroundColor="0xffff00" backgroundAlpha="0.0" width="590" height="125" >
				<mx:Label text="${appRight_getStr(3)}" horizontalCenter="0" verticalCenter="0" fontsize="30" color="0x707070" mouseThrough="true"/>
			</mx:Canvas>
			
		</mx:Canvas>
	</mx:Canvas>	
	]]
	
	local strtemp = [[
	{
	local str = arg[1]
	}
	<mx:Canvas id="appRight_main" width="720" height="1280" mouseThrough="false"> 
		<mx:Canvas width="590" height="270" backgroundColor="0xffffff" backgroundAlpha="1.0" horizontalCenter="0" verticalCenter="-20">
			<mx:Canvas onclick="appRight_onCheckBoxClick" width="60" height="60"  y="40" x="26">
				<mx:Image id="appRight_checkBox01" visible="false" horizontalCenter="0" verticalCenter="0" source="assets/images/appRight_bg02.png" mouseThrough="true"/>
				<mx:Image horizontalCenter="0" verticalCenter="0" source="assets/images/appRight_bg01.png" mouseThrough="true"/>
			</mx:Canvas>
			
			<mx:Label id="appRight_checkBoxTips" visible="false" y="10" x="90" text="${appRight_getStr(4)}" fontsize="24" color="0xff0000" mouseThrough="true"/>
			<mx:VBox y="50" x="90">
				<mx:HBox>
					<mx:Label onclick="appRight_onGreeClick" text="I have read and agreed to " fontsize="24" color="0x707070" mouseThrough="true"/>
					<mx:Label onclick="appRight_onDetailClick" text="User Agreement" fontsize="24" color="0x00a0e9" mouseThrough="true"/>
				</mx:HBox>
				<mx:HBox>
					<mx:Label onclick="appRight_onGreeClick" text="and" fontsize="24" color="0x707070" mouseThrough="true"/>
					<mx:Label onclick="appRight_onDetailClick2" text="Privacy Policy" fontsize="24" color="0x00a0e9" mouseThrough="true"/>
					<mx:Label onclick="appRight_onGreeClick" text=" in detail." fontsize="24" color="0x707070" mouseThrough="true"/>
				</mx:HBox>
			</mx:VBox>
			
			<mx:Image source="assets/images/appRight_bg04.png" y="150" horizontalCenter="0" />
		
			<mx:Canvas onclick="appRight_onBtnYesClick" y="150" horizontalCenter="0" backgroundColor="0xffff00" backgroundAlpha="0.0" width="590" height="125" >
				<mx:Label text="Start" horizontalCenter="0" verticalCenter="0" fontsize="30" color="0x707070" mouseThrough="true"/>
			</mx:Canvas>
			
		</mx:Canvas>
	</mx:Canvas>	
	]]
	flextodiv(strtemp,{},"frame_top")
end


appRight_getsql()
