--armyPreset
G_ArmyPreset_Handle_Query = -1
G_ArmyPreset_Handle_Infantry_First = 1
G_ArmyPreset_Handle_Cavalry_First = 2
G_ArmyPreset_Handle_Archer_First = 3
local _data = nil

function armyPreset_send(nHandle)
	print("armyPreset_send")
	if nHandle == G_ArmyPreset_Handle_Query then 
		httpsend( 1 , 0x0179 , 0 , {CUserData.m_nUserID,nHandle,0,0,0,0},"armyPreset_onRecvMsgInit","httpdp_svrStatusLogin"  )
	else
		httpsend( 1 , 0x0179 , 0 , {CUserData.m_nUserID,nHandle,0,0,0,0},"armyPreset_onRecvMsg","httpdp_svrStatusLogin"  )
	end
end

function armyPreset_onRecvMsgInit(ntype , nseqno , nret , arg)--0x0000004e
	print(string.format("httpdp_revMsgLogin ntype:%x ：nseqno:%d nret:%d",ntype , nseqno , nret) )
	if nret ~= 0 then --表示处理消息失败
		return
	end
	table.insert(arg,1,nret)
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s httpdp_revMsgLogin" , ntype , nseqno , nret, tabletostring(arg) ) )
	
	_data = arg
	
end

function armyPreset_onRecvMsg(ntype , nseqno , nret , arg)--0x0000004e
	print(string.format("httpdp_revMsgLogin ntype:%x ：nseqno:%d nret:%d",ntype , nseqno , nret) )
	if nret ~= 0 then --表示处理消息失败
		return
	end
	table.insert(arg,1,nret)
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s httpdp_revMsgLogin" , ntype , nseqno , nret, tabletostring(arg) ) )
	
	_data = arg
	
	armyPreset_ref()
	
	if arg[2] > 0 then 
		showClum({"操作成功",1})
	end
end

function armyPreset_get()
	if _data == nil then 
		return 1
	end
	return _data[2]
end


-- -------------------------------------------------------------------------------------------------------------------------------
local _nSelectIndex = 0
function armyPreset_ref()
	print("armyPreset_ref")
	local div = getid2("main","armyPreset_main")
	if div ~= nil then
		armyPreset_show()
	end	
end
function unionMeberPopedom_close()
	deldiv("frame_more","armyPreset_main")
end
function armyPreset_getDivParam(nindex)
	local list = {
	"步兵","骑兵","弓兵"
	}
	local str = ""
	if list[nindex] ~= nil then 
		str = list[nindex]
	end
	local nSelected = 0
	if _nSelectIndex == nindex then 
		nSelected = 1
	end	
	
	
	return str,nSelected
end

function armyPreset_onBtnClick(nindex)
	print("armyPreset_onBtnClick nindex")
	if _nSelectIndex ~= nindex then 
		_nSelectIndex = nindex
		for i=1, 3 do
			local str,nSelected = armyPreset_getDivParam(i)
			
			local div2 = getid2("main","select_2_"..i )
			local div1 = getid2("main","select_1_"..i )
			if div2 ~= nil and div1 ~= nil then 
				if nSelected == 1 then 
					div2:sethidden(0)
					div1:sethidden(1)
				else
					div2:sethidden(1)
					div1:sethidden(0)
				end	
			else
				print("err armyPreset_onBtnClick i"..i)	
			end
		end
	end
end

function armyPreset_onBtnSaveClick()
	print("armyPreset_onBtnSaveClick _nSelectIndex".. _nSelectIndex.. "armyPreset_get():" .. armyPreset_get())
	if _nSelectIndex == armyPreset_get() then 
		print("err armyPreset_onBtnSaveClick")
	else
		if _nSelectIndex == 0 then 
			_nSelectIndex = 1
		end
		armyPreset_send(_nSelectIndex)
	end
end

function armyPreset_show()
	print("armyPreset_show")
	_nSelectIndex = armyPreset_get()
	
	local strtemp =[[
	<mx:Canvas width="720" height="1280"  id="armyPreset_main"  mouseThrough="false" systemload="1" onloadcmp="unionMeberPopedom_cmp">
		<mx:Canvas width="616" height="597" horizontalCenter="0" verticalCenter="0">
			<mx:Image source="assets/images/popBg10.png" width="616" height="597"/>
			<mx:Button styleName="btn02Close" id="closebtn" x="540" y="0" onclick="unionMeberPopedom_close"/>
			
			<mx:VBox width="616" verticalCenter="0">
				<mx:Text x="100" text="防御时,优先出战的兵种." width="416" fontSize="24" color="0x311612" mouseThrough="true"/>
				<mx:Image source="assets/images/line14.png" horizontalCenter="0" width="600" mouseThrough="true"/>
				
				<mx:VBox verticalGap="20" width="616">
					{for i=1, 3 do
						local str,nSelected = armyPreset_getDivParam(i)
						}
						<mx:Canvas width="300" x="100" height="50" onclick="armyPreset_onBtnClick(${i})" >
							{if nSelected == 1 then }
								<mx:Image id="select_2_${i}" verticalCenter="0" mouseThrough="true" visible="true" source="assets/images/btn_select_2.png" width="40" height="42"/>
								<mx:Image id="select_1_${i}" verticalCenter="0" mouseThrough="true" visible="false" source="assets/images/btn_select_1.png" width="40" height="42"/>
							{else}
								<mx:Image id="select_2_${i}" verticalCenter="0" mouseThrough="true" visible="false" source="assets/images/btn_select_2.png" width="40" height="42"/>
								<mx:Image id="select_1_${i}" verticalCenter="0" mouseThrough="true" visible="true" source="assets/images/btn_select_1.png" width="40" height="42"/>						
							{end}
							<mx:Text x="50" text="${str}" verticalCenter="0" mouseThrough="true" fontSize="20" color="0x311612" mouseThrough="true"/>
						</mx:Canvas>
					{end}
				</mx:VBox>
				
				<mx:Image source="assets/images/line14.png" horizontalCenter="0" width="600" mouseThrough="true"/>
				<mx:Canvas width="20" height="20" />
				
				<mx:Button styleName="godsRelicBtn01" label="保存" sound="assets/sound/419.ogg" horizontalCenter="0" onclick="armyPreset_onBtnSaveClick()" mouseThrough="true"/>
			</mx:VBox>
			
		</mx:Canvas>
	</mx:Canvas>
	]]
	flextodiv(strtemp,{},"frame_more")
end

