--godsRelicTech
function godsRelicTech_getMapIcoVisible()
	local szvisibl = "false"
	if 1 == G_DE_GODS_RELIC_ENABLED then 
		local alist = godsRelicTech_getDivParam()
		for _,v in pairs(alist) do
			local vv = godsRelic_getGodsRelic(v)
			if #vv > 0 then 
				szvisibl = "true"
				break
			end
		end
	end
--	szvisibl = "true"
	return szvisibl
end

-- 
function godsRelicTech_btn1OnClick(a)--合成
	local nid = jdtonumber(a.pBase:getts())
	godsRelicIntegrade_show(nid)
end
function godsRelicTech_btn2OnClick(a)--强化
	local nid = jdtonumber(a.pBase:getts())
	godsRelicUpgrade_show(nid)
end
function godsRelicTech_btn3OnClick(a)--激活
	local nid = jdtonumber(a.pBase:getts())
	godsRelic_Active(nid)
end

function godsRelicTech_onIntegrade(nid)
	godsRelicTech_refItem(nid)
end

function godsRelicTech_onUpgrade(nid)
	godsRelicTech_refItem(nid)
end

function godsRelicTech_onActive(nid)
	godsRelicTech_refItem(nid)
end

function godsRelicTech_refItem(nid)
	local div = obj_query("godsRelicTech_main")
	if div ~= nil then 
		local strtemp = [[
		{
		local v = arg[1]
		}
		]]..godsRelicTech_getItemDivStr()
		
		local arg = {nid}
		flextodiv(strtemp , arg , "godsRelicTech_content")
	end
end

function godsRelicTech_onloadcmp()
	godsRelicTech_timer()
end

function godsRelicTech_timer()
	--print("godsRelicTech_timer")
	local function _objSetHidden(szid,szvisible)
		if "true" == szvisible then 
			obj_sethidden(szid,0)
		else
			obj_sethidden(szid,1)
		end
	end
	
	local div = obj_query("godsRelicTech_main")
	if div ~= nil then 
		local alist = godsRelicTech_getDivParam()
		for _,v in pairs(alist) do
			local nid,szpic,szname,szdetail,szfunc,sztime,szvisiblIntegarade,szvisiblUpgarde,szvisiblAcitve,szvisiblTime = godsRelicTech_getItemDivParam(v)
			
			--print("godsRelicTech_timer nid:"..nid..",sztime,szvisiblIntegarade,szvisiblUpgarde,szvisiblAcitve,szvisiblTime:"..tabletostring({sztime,szvisiblIntegarade,szvisiblUpgarde,szvisiblAcitve,szvisiblTime})) 
			
			_objSetHidden("godsRelicTech_btnIntegrade",szvisiblIntegarade)
			_objSetHidden("godsRelicTech_btnUpgrade",szvisiblUpgarde)
			_objSetHidden("godsRelicTech_btnActive"..nid,szvisiblAcitve)
			_objSetHidden("godsRelicTech_timeText"..nid,szvisiblTime)
			
			obj_changetext("godsRelicTech_timeText"..nid,sztime)
			
		end
		
		settimer(TIMER_ID_GODS_RELIC_LIST,1*1000,"godsRelicTech_timer",1)
	end
end

function godsRelicTech_getItemDivParam(nid)
	local szpic,szname,szdetail,szfunc,ncurGrade,ncurCD,sztime,szvisiblBase = "","","","",0,0,"","false"
	local acfg = cfgmgr_query(G_DE_CFG_ITEM,nid)
	if acfg ~= nil then 
		szpic = "assets/item/"..jdassign(acfg["F1"],"")..".png"
		szname = jdassign(acfg["F2"],"")
		szdetail = jdassign(acfg["F3"],"")
	end
	
	local nitemCount = 0
	local v = godsRelic_getGodsRelic(nid)
	if #v > 0 then 
		local nid,ngrade,nCD,ntechParam1,ntechParam2,ntechParam3,ntechParam4,ntempParam1,ntempParam2,ntempParam3 = godsRelic_tableSplit(v)
		ncurGrade = ngrade
		nitemCount = 1
		ncurCD = nCD
		szvisiblBase = "true"
	end	
	local ngradeSql = ncurGrade
	if ngradeSql == 0 then 
		ngradeSql = 1
	end
	local acfg = cfgmgr_query2(G_DE_CFG_GODS_RELIC_UPG,nid,ngradeSql)
	if acfg ~= nil then 
		local nbuffId = jdtonumber(acfg["F4"])
		local nbuffVal= jdtonumber(acfg["F5"])
		if nbuffId > 0 then 
			if ncurGrade == 0 then 
				nbuffVal = 0
			end
			
--			local str,nnum = funcList_get(nbuffId,nbuffVal)
--			szfunc = str.." "..nnum
			local str,nnum,str2 = funcList_getNewParam(nbuffId,nbuffVal)
			szfunc = str2
		end
	end
--	nitemCount = 1
	
	local szvisiblIntegarade = "true"
	local szvisiblUpgarde 	 = "false"
	local szvisiblAcitve 	 = "false"
	local szvisiblTime 	 	= "false"
	if nitemCount > 0 then 
		szvisiblIntegarade 	 = "false"
		szvisiblUpgarde 	 = "true"
		szvisiblAcitve 	 	 = "true"
		local nnow = CUserData:getCurServerTime()
		if ncurCD > nnow then 
			szvisiblAcitve 	 	 = "false"
			szvisiblTime 	 	 = "true"
			sztime = formatTime(ncurCD - nnow ,true)
		end
	end
	--print("godsRelicTech_getItemDivParam nid:"..nid..", szvisiblAcitve,szvisiblTime:"..tabletostring({szvisiblAcitve,szvisiblTime}))
	
--	szvisiblTime 	 	 = "true"
--	sztime = "99d 99:99:99"
	
	return nid,szpic,szname,szdetail,szfunc,sztime,szvisiblIntegarade,szvisiblUpgarde,szvisiblAcitve,szvisiblTime,szvisiblBase
end

function godsRelicTech_getItemDivStr()
	local strtemp = [[
	{
	local nid,szpic,szname,szdetail,szfunc,sztime,szvisiblIntegarade,szvisiblUpgarde,szvisiblAcitve,szvisiblTime,szvisiblBase = godsRelicTech_getItemDivParam(v)
	}
	<mx:Canvas id="godsRelicTech_item${nid}" visible="${szvisiblBase}" horizontalCenter="0" width="685" height="204">
		<mx:Image source="assets/images/godsRelicTech_bg01.png" mouseThrough="false"/>
		
		<mx:Canvas x="30" y="30" width="152" height="139">
			<mx:Image source="assets/images/skillShen.png" mouseThrough="false"/>
			<mx:Image width="70" height="70" horizontalCenter="0" verticalCenter="0" source="${szpic}" mouseThrough="false"/>
		</mx:Canvas>
		
		<mx:Label text="${szname}" styleName="brown01" fontSize="18" x="290" y="15"/>
			
		<mx:Label visible="false" text="${szdetail}" styleName="brown01" fontSize="18" width="430" y="80" x="200"/>
		
		<mx:Label text="${szfunc}" styleName="brown01" fontSize="18" width="300" y="60" x="210"/>
		
		<mx:Button x="600" y="70" id="godsRelicTech_btnActive${nid}" visible="${szvisiblAcitve}" styleName="godsRelicTech" label="激活" sound="assets/sound/419.ogg" setts="${nid}" onclick="godsRelicTech_btn3OnClick"/>
		<mx:Label y="120" right="0" id="godsRelicTech_timeText${nid}" visible="${szvisiblTime}" color="0x074408" text="${sztime}" fontSize="18" />
							
	</mx:Canvas>	
	]]
	return strtemp
end

function godsRelicTech_getDivParam()
	local alist = {}
	local acfg = cfgmgr_querylist(G_DE_CFG_GODS_RELIC)
	if acfg ~= nil then 
		for _,v in pairs(acfg) do
			tabmgr_insert(alist,jdtonumber(v["F0"]) )
		end
		local function _compare(a,b)
			return a < b
		end
		table.sort(alist,_compare)
	end
	
	return alist
end

function godsRelicTech_btnCloseOnClick()
	deldiv("frame_more","godsRelicTech_main")
end

function godsRelicTech_show()
	print("godsRelicTech_show")
	if 1 == 1 then 
		godsRelicList_show(G_DE_GODS_RELIC_LIIST_TYPE_MAP )
		
		return
	end
	local strtemp = [[
	{
	local alist = godsRelicTech_getDivParam()
	}
	<mx:Canvas id="godsRelicTech_main" width="720" height="1280" onloadcmp="godsRelicTech_onloadcmp">
		<mx:Canvas width="720" height="112">
			<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
			<mx:Label text="众神" width="720" textAlign="center" y="35"/>
			<mx:Button styleName="btn01Back" id="fane_btnClose" x="27" y="18" setts="4" onclick="godsRelicTech_btnCloseOnClick"/>
		</mx:Canvas>
		<mx:Image source="assets/images/bg03.jpg" width="720" height="1189" y="91"/>
		<mx:Image visible="false" source="assets/images/bar04.png" y="111"/>
		<mx:Canvas x="0" y="110" width="720" height="1280">
			<mx:VBox id="godsRelicTech_content" horizontalCenter="0" width="685" >
				{for _,v in pairs(alist) do}
					]]..godsRelicTech_getItemDivStr()..[[
				{end}
			</mx:VBox>
		</mx:Canvas>
	</mx:Canvas>
	]]
	local arg = {}
	flextodiv(strtemp , arg , "frame_more")
end
