--guardianList
function guardianList_getDivParam()
	local nCurHeroGuardianId = guardian_getCurHeroGuardianId()
	local list = guardian_getList()
	return nCurHeroGuardianId,list
end
function guardianList_getDivItemParam(nId)
	print("guardianList_getDivItemParam ",nId)
	
	local nGuardianId,nGuardianGrade,nParam1,nParam2,nParam3,nParam4=0,0,0,0,0,0
	local v = guardian_getGuardian(nId)
	if v ~= nil then 
		nGuardianId,nGuardianGrade,nParam1,nParam2,nParam3,nParam4=guardian_split(v)
	end
	local szName = ""
	local con = guardian_getConfig(nId,nGuardianGrade)	
	if nGuardianGrade <= 0 then 
		con = guardian_getConfig(nId,nGuardianGrade+1)			
	end
	if con ~= nil then 
		szName = jdgetlang(con["F4"])
	else
		print("err guardianList_getDivItemParam")
	end
	print("guardianList_getDivItemParam return ",nId,nGuardianGrade,szName)
	return nGuardianId,nGuardianGrade,szName
end

function guardianList_onBtnUpgrade(nId)
	if nId <= 0 then 
		return
	end
	guardianUpgrade_show(nId)
end

function guardianList_onBtnUNWear()
	guardian_sendHeroGuardianSet(0)
end

function guardianList_onBtnWear(nId)
	if nId <= 0 then 
		return
	end
	if user_getTechGrade(124) <= 0 then 
		showClum({"科技等级不足",1})		
		return
	end
	guardian_sendHeroGuardianSet(nId)
end

function guardianList_ref()
	local div = getid2("main","guardianList_main")
	if div ~= nil then 
		local strTemp = guardianList_getDivStr()
		flextodiv(strTemp,{} ,"frame_more")
	end
end

function guardianList_getDivStr()
	local strTemp = [[
	{
	local nCurHeroGuardianId,list = guardianList_getDivParam()
--	nCurHeroGuardianId = 1
	}
	<mx:Canvas id="guardianList_main" xmlns:mx="http://www.adobe.com/2006/mxml" width="720" height="1280" xmlns:common="view.common.*" xmlns:main="view.main.*">
		<mx:Canvas width="720" height="112">
			<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
			<mx:Label id="frameTop_txt" text="英雄守护灵" width="720" textAlign="center" y="35"/>
			<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" setts="4" onclick="guardianList_btnCloseClick"/>
			<mx:Image onclick="guardianDetail_detailShow()" source="assets/images/ic01Christmas.png" width="60" height="60" y="10" right="10"/>
		</mx:Canvas>
		<mx:Image source="assets/images/bg01.jpg" width="720" height="990" x="0" y="111"/>
		<mx:Canvas x="19" y="130" width="680" height="900" setslidetype="1" mouseThrough="true">
			<mx:VBox width="685" mouseThrough="true">
				<mx:Image source="assets/images/bar06.png" height="63" x="8">
					<mx:Label text="当前英雄守护灵" x="132" verticalCenter="0" width="423" textAlign="center"/>
				</mx:Image>
				{
				local nGuardianId,nGuardianGrade,szName = guardianList_getDivItemParam(nCurHeroGuardianId)
				local listBuff1,listBuff2,szTop,szBuffTotal = guardianUpgrade_getDivBuffParam(nCurHeroGuardianId)
				}
				<mx:VBox width="685" mouseThrough="true">
					
					<mx:Canvas height="${127+29}" width="685" >		
						<mx:Image source="assets/images/bar12.png" x="116" y="52" mouseThrough="true">
							<mx:Canvas verticalCenter="0" horizontalCenter="0" width="500" height="65" mouseThrough="true">
								<mx:Label text="${szBuffTotal}" width="500" fontSize="20" styleName="white02" mouseThrough="true"/>
							</mx:Canvas>
						</mx:Image>
						
						<mx:Image source="assets/images/headerBg03.png" x="${16}" y="29" mouseThrough="true">
							<mx:Image width="100" height="100" source="assets/guardian/${nGuardianId}.png" verticalCenter="0" horizontalCenter="0" mouseThrough="true"/>
						</mx:Image>
						{if nGuardianId > 0 then }
							<mx:Label text="${szName} Lv.${nGuardianGrade} ${szTop}" styleName="brown01" fontWeight="bold" fontSize="30" x="144" y="10" mouseThrough="true"/>
						{end}
					</mx:Canvas>
					
					
					{for i=1,#listBuff1 do}
						<mx:Label text="${listBuff1[i][3]}" width="${706-60}" fontSize="20" styleName="brown01" x="32" mouseThrough="true"/>
					{end}
					{for i=1,#listBuff2 do}
						<mx:Label text="${listBuff2[i][3]}" width="${706-60}" fontSize="20" styleName="brown01" x="32" mouseThrough="true"/>
					{end}
					
					{if #listBuff1 > 0 or #listBuff2 > 0 then  }
						<mx:Canvas width="10" height="10"/>
						<mx:Image source="assets/images/line01.png" x="14" mouseThrough="true"/>
						<mx:Canvas width="10" height="10"/>
					{end}
					{if nCurHeroGuardianId > 0 then }
						<mx:Button styleName="btn08" label="脱下" x="186" onclick="guardianList_onBtnUNWear()"/>
						<mx:Button styleName="btn08" label="升级" x="186" onclick="guardianList_onBtnUpgrade(${nGuardianId})"/>
					{end}
				</mx:VBox>
				
				
				<mx:Canvas width="685" height="63" >
					<mx:Image source="assets/images/bar06.png" x="8" y="0" />
					<mx:Label text="闲置英雄守护灵" x="132" y="12" width="423" textAlign="center"/>
				</mx:Canvas>
				{
				local nCount = 0 
				for i = 1 , #list do						
					local v = list[i]						
					local nGuardianId,nGuardianGrade,nParam1,nParam2,nParam3,nParam4=guardian_split(v)
					if nGuardianId ~= nCurHeroGuardianId then 
						nCount = nCount + 1
						local nGuardianId,nGuardianGrade,szName = guardianList_getDivItemParam(nGuardianId)
						local listBuff1,listBuff2,szTop,szBuffTotal = guardianUpgrade_getDivBuffParam(nGuardianId)
						}
						<mx:VBox width="685" mouseThrough="true">
							
							<mx:Canvas height="${127+29}" width="685" >		
								<mx:Image source="assets/images/bar12.png" x="116" y="52" mouseThrough="true">
									<mx:Canvas verticalCenter="0" horizontalCenter="0" width="500" height="65" mouseThrough="true">
										<mx:Label text="${szBuffTotal}" width="500" fontSize="20" styleName="white02" mouseThrough="true"/>
									</mx:Canvas>
								</mx:Image>
								
								<mx:Image source="assets/images/headerBg03.png" x="${16}" y="29" mouseThrough="true">
									<mx:Image width="100" height="100" source="assets/guardian/${nGuardianId}.png" verticalCenter="0" horizontalCenter="0" mouseThrough="true"/>
								</mx:Image>
								
								<mx:Label text="${szName} Lv.${nGuardianGrade} ${szTop}" styleName="brown01" fontWeight="bold" fontSize="30" x="144" y="10" mouseThrough="true"/>
								
							</mx:Canvas>
							
							{for i=1,#listBuff1 do}
								<mx:Label text="${listBuff1[i][3]}" width="${706-60}" fontSize="20" styleName="brown01" x="32" mouseThrough="true"/>
							{end}
							{for i=1,#listBuff2 do}
								<mx:Label text="${listBuff2[i][3]}" width="${706-60}" fontSize="20" styleName="brown01" x="32" mouseThrough="true"/>
							{end}
							
							{if #listBuff1 > 0 or #listBuff2 > 0 then  }
								<mx:Canvas width="10" height="10"/>
								<mx:Image source="assets/images/line01.png" x="14" mouseThrough="true"/>
								<mx:Canvas width="10" height="10"/>
							{end}
							<mx:Button styleName="btn08" label="装备" x="186" onclick="guardianList_onBtnWear(${nGuardianId})"/>
							<mx:Button styleName="btn08" label="升级" x="186" onclick="guardianList_onBtnUpgrade(${nGuardianId})"/>
						</mx:VBox>
					{end}
				{end}
				
				{if nCount <= 0 then }
					<mx:Canvas width="10" height="10"/>
					<mx:Label text="没有可装备的英雄守护灵！" visible="true" fontSize="26" styleName="brown01" horizontalCenter="0" width="500" textAlign="center"/>
					<mx:Canvas width="10" height="10"/>
				{end}
				
			</mx:VBox>
		</mx:Canvas>
	</mx:Canvas>
	]]
	return strTemp
end

function guardianList_show()
	print("guardianList_show")
	local strTemp = guardianList_getDivStr()
	flextodiv(strTemp,{} ,"frame_more")
end

function guardianList_btnCloseClick()
	print("guardianList_btnCloseClick")
	delid2("main","guardianList_main")
end
