--leaf
G_DE_LEAF_PIC_MAX = 6

local _nindex = 0
local _nstart = 0
function leaf_start()
	if 0 == _nstart then 
		_nstart = 1
		leaf_timer()
	end
end

function leaf_getIndex()
	_nindex = _nindex + 1
	if _nindex > 100000 then 
		_nindex = 1
	end
	return _nindex
end

function leaf_timer()
	--settimer(TIMER_ID_LEAF_HANDLE,5*60*1000,"leaf_timer",1)
	
	local nval = math.random(30,60)
	settimer(TIMER_ID_LEAF_HANDLE,nval*1000,"leaf_timer",1)
	leaf_handle()
end

function leaf_Over(szid)
	--print("leaf_Over szid:"..szid)
	delid2("main",szid)
end

function leaf_cmp(a)
	print("leaf_cmp")
	local div = a.pBase
	local nx = div:x()
	local ny = div:y()
	local szid = div:getid()
	
	local arg =  {actionid="leaf_cmp"..szid,id="main",over="leaf_Over('"..szid.."')"}
	
	local ncountMax = 10
	local ncurCount = 0
	local nyMax 	= 1024 - 200
	local ncurX 	= nx
	local ncurY 	= ny
	
	local nbreak 	= 0 
	repeat
		ncurCount = ncurCount + 1
		
		local ncurX2 = ncurX
		local ncurY2 = ncurY
		local nabsXVal = math.random(1,100)
		local nsignXVal = math.random(1,20)
		if nsignXVal > 10 then 
			ncurX2 = ncurX - nabsXVal
		else
			ncurX2 = ncurX + nabsXVal
		end
		if ncurX2 < 0 then 
			ncurX2 = ncurX + nabsXVal
		elseif ncurX2 > 720 then 
			ncurX2 = ncurX - nabsXVal
		end
		local nabsYVal = math.random(100,300)
		ncurY2 = ncurY + nabsYVal
		
		local ntime = math.pow((math.pow((ncurX2-ncurX),2)+math.pow((ncurY2-ncurY),2)), 0.5) / 100
		if ntime < 0.01 then 
			ntime = 0.01
		end
		
		table.insert(arg,{id=szid,time=ntime,tox=ncurX2,toy=ncurY2}  )
		
		ncurX 	= ncurX2
		ncurY 	= ncurY2
		if ncurY > nyMax then 
			nbreak = 1
		end
		if ncurCount >= ncountMax then 
			nbreak = 1
		end
	until nbreak == 1 
	
	
	addaction3( arg )
end

function leaf_getDivParam()
	local apic = {}
	for i=1,G_DE_LEAF_PIC_MAX do
		tabmgr_insert(apic,i)
	end
	
	local alist = {}
	local nw = 720
	local nleft = 50
	local nleaf = 100
	local ncount = math.random(1,G_DE_LEAF_PIC_MAX)
	for i=1,ncount do
		local nmax = #apic
		if nmax > 0 then 
			local nindex = math.random(1,nmax)
			if apic[nindex] ~= nil then 
				local npic = apic[nindex]
				
				tabmgr_insert(alist,{npic,0,0,leaf_getIndex() })
				
				table.remove(apic,nindex)
			end
		end
	end
	
	local ncount = #alist
	local nsub = math.floor( (nw-nleft*2) / (ncount + 1) )
	for i=1,ncount do
		local nx = nleft + nsub * i
		local ny = math.random(20,50)
		
		alist[i][2] = nx
		alist[i][3] = ny
		
	end
	
	return alist
end

function leaf_handle()
	
	local strtemp = [[
		{
		local alist = leaf_getDivParam() 
		for _,v in pairs(alist) do
			local npic,nx,ny,nindex = v[1],v[2],v[3],v[4] 
			
			}
			<mx:Movie id="leaf_main${nindex}" x="${nx}" y="${ny}" onloadcmp="leaf_cmp" frametime="5" visible="true" source="assets/moive/leaf_moive0${npic}.png" mouseThrough="true" playnum="-1"/>
		{end}
		]]
	flextodiv(strtemp,{},"frame_top")
end
