--obelisk 方尖碑
--0x0000004c
--[[
obelisk.csv --> activity.csv
obe..rank.csv --> act_rank.csv
obe..target.csv --> act_target.csv
]]
local g_obelisk_divstr = [[
{
local alist = arg[1]
}
<mx:Canvas id="obelisk_main" width="669" height="1217" horizontalCenter="0" verticalCenter="0" mouseThrough="false" onloadcmp="obelisk_cmp">
	<mx:Image source="assets/images/bg01Fsb.png"/>
	
	<mx:Button styleName="btn02Close" id="closebtn" x="582" y="42" onclick="obelisk_btncloseclick"/>
	<mx:Image source="assets/images/ttl01Fsb.png" x="174" y="0"/>
	<mx:Image source="assets/images/ic25.png" x="100" y="91"/>
	<mx:Text id="obelisk_timertext" text="2d 31h 14m 15s" fontSize="30" color="0x735c3d" x="200" y="99"/>
	<mx:Canvas setslidetype="1" height="90" width="600" x="37" y="171">
		<mx:Text fontSize="20" mouseThrough="true" styleName="black03" text="${obelisk_getDesc()}" width="600"/>
	</mx:Canvas>
	
	<mx:Canvas x="12" y="287" setslidetype="1" width="669" height="920">
		<mx:VBox verticalGap="5" mouseThrough="true" verticalScrollPolicy="off">
			{for i=1,#alist do
				local v = alist[i]
					}
				<mx:Canvas width="645" height="145" mouseThrough="true" styleName="block23">
					{if v[1] <= 3 then}
						<mx:Image source="assets/images/no${v[1]}.png" mouseThrough="true" x="15" y="24"/>
					{else}
						<mx:Text text="${v[1]}" fontSize="40" color="0x322407" x="34" y="47"/>
					{end}
					<mx:HBox x="171" y="39" width="190">
						<mx:Text text="昵称:" fontSize="20" color="0x261404" mouseThrough="true"/>
						<mx:Text text="${v[4] }" fontSize="20" color="0x462c04" mouseThrough="true"/>
					</mx:HBox>
					<mx:HBox x="171" y="74" width="190">
						<mx:Text text="联盟:" fontSize="20" color="0x261404" mouseThrough="true"/>
						<mx:Text text="${v[3]}" fontSize="20" color="0x462c04" mouseThrough="true"/>
					</mx:HBox>
					<mx:HBox x="374"  y="39" width="250">
						<mx:Text text="积分:" fontSize="20" color="0x261404" mouseThrough="true"/>
						<mx:Text text="${v[6]}" fontSize="20" color="0x462c04" mouseThrough="true"/>
					</mx:HBox>
					<mx:HBox  x="374" y="74" width="250">					
						<mx:Text text="所需时间:" fontSize="20" color="0x261404" mouseThrough="true"/>
						<mx:Text text="${formatTime(v[5],1) }" fontSize="20" color="0x462c04" mouseThrough="true"/>
					</mx:HBox>
					
					<mx:Image source="assets/role/big/${v[7]}.png" width="61" height="63" x="90" y="40" mouseThrough="true" />
					
				</mx:Canvas>
			{end}
		</mx:VBox>			
	</mx:Canvas>
</mx:Canvas>]]
function obelisk_btncloseclick()
	deldiv("frame_more","obelisk_main")
end
local g_obelisk_httptype = 1
function obelisk_sethttptype(nval)
	g_obelisk_httptype=nval
end

local g_obelisk_httptype_4c = 1
function obelisk_sethttptype_4c(nval)
	g_obelisk_httptype_4c=nval
end

local g_obelisk_id = 0
function obelisk_getDesc()
	--活动期间，玩家每升级一次议会将会获得10点活动积分，达到相应的积分目标将获得对应奖励，另外排名前300的将获得额外的排名奖励（积分相同时，按达到积分的时间先后排序）。
	local str = jdassign(cfgmgr_queryValue(G_DE_CFG_OBELISK,g_obelisk_id,"F3"),"")
	return str
end
function obelisk_show(nid)
	if nid == nil then nid = 1 end
	print("obelisk_show nid:"..nid)
	--local nid = 1
	
	httpsend( 1 , 0x004d , 0 , {CUserData.m_nUserID,nid},"obelisk_recMsgGetObeliskDetail","httpdp_svrStatusLogin"  )
	
	g_obelisk_id = nid
	
	g_obelisk_httptype = 1
	btnloading_show()
end
function obelisk_showback()
	print("obelisk_showback")
	local alist = CUserData.m_obeliskdetail[9]
	 
	flextodiv(g_obelisk_divstr , {alist } , "frame_more")
end

function obelisk_recMsgGetObeliskOverview(ntype , nseqno , nret , arg )--
	print(string.format("obelisk_recMsgGetObeliskOverview ntype:%x ：nseqno:%d nret:%d",ntype , nseqno , nret) )
	http_getdata(ntype , nseqno , nret , arg)
	btnloading_del()
	if nret ~= 0 then --表示处理消息失败
		return
	end
	table.insert(arg,1,nret)
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s httpdp_revMsgLogin" , ntype , nseqno , nret, tabletostring(arg) ) )
	
	CUserData.m_obelisk = arg 
	
	print("obelisk_recMsgGetObeliskOverview g_obelisk_httptype_4c:"..g_obelisk_httptype_4c)
	if g_obelisk_httptype_4c == 1 then 
		obelisk_listshowback()
	else 
	
	end
end
function obelisk_recMsgGetObeliskDetail(ntype , nseqno , nret , arg )--
	print(string.format("obelisk_recMsgGetObeliskDetail ntype:%x ：nseqno:%d nret:%d",ntype , nseqno , nret) )
	http_getdata(ntype , nseqno , nret , arg)
	btnloading_del()
	if nret ~= 0 then --表示处理消息失败
		return
	end
	table.insert(arg,1,nret)
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s httpdp_revMsgLogin" , ntype , nseqno , nret, tabletostring(arg) ) )
	
	CUserData.m_obeliskdetail = arg 
	if g_obelisk_httptype == 1 then 
		obelisk_showback()
	elseif g_obelisk_httptype == 2 then
		obeliskdetail_showback()
	elseif g_obelisk_httptype == 0 then--登录的时候会请求一次
	
	end
end

function obelisk_getvisible()
	--print("obelisk_getvisible CUserData.m_obelisk:"..tabletostring(CUserData.m_obelisk))
	local str = "false"
	
	if #CUserData.m_obelisk > 0 then 
		--local nnow = curtimer()
		local nnow 		 = CUserData:getCurServerTime()
		
		local alist = CUserData.m_obelisk[2]
		for i=1,#alist do
			if nnow >= alist[i][3] and nnow < alist[i][4] then 
				str = "true"
				break
			end
		end
		--print("obelisk_getvisible str:"..str..",nnow:"..nnow)
	end
	--print("obelisk_getvisible str:"..str)
	return str
end

function obelisk_cmp()
	print("obelisk_cmp")
	div_obeliskTimer()
end
--<mx:Canvas width="695" height="130"/>
local div_obelisk_list_str = [[
<mx:Canvas id="div_obelisk_list_id" onloadcmp="div_obelisk_comp" width="720" height="1280">
	<mx:Canvas width="720" height="112">
		<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
		<mx:Label id="frameTop_txt" text="活动" width="720" textAlign="center" y="35"/>
		<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" onclick="obelisk_listbtnCloseClick"/>
	</mx:Canvas>
	{local ings = 0}
	<mx:Image source="assets/images/bg03.jpg" width="720" height="1189" y="90"/>	
	<mx:Canvas y="110" y="0" x="11" width="695" height="${1130+20}" setslidetype="1">
		<mx:VBox verticalGap="10" verticalScrollPolicy="off">
			
			{for i = 1 , #arg do
				}
				{if arg[i][1] > 0 then}
					<mx:Canvas id="item${arg[i][1]}" styleName="block01Hd" width="695" mouseThrough="true" x="0">
						{
						local list=CUserData:getActionObeliskConfigByid(arg[i][1])
						}
						<mx:Image source="assets/action/${list.F2}.png" x="292" y="50" mouseThrough="true"/>
						
						<mx:Label fontSize="42" color="0x38230f" text="${CData:GetTranlang(list.F1)}" x="6" y="178" width="683" textAlign="center" mouseThrough="true"/>
						
						<mx:Label id="coolTime${arg[i][1]}" fontSize="24" styleName="red01"  text="..." x="46" y="231" width="603" textAlign="center" mouseThrough="true"/>
						
						<mx:VBox verticalGap="5" y="280" x="9">
							<mx:Canvas styleName="bar18" width="630" x="22" mouseThrough="true">
								<mx:VBox verticalGap="0"  x="12" y="12">
									<mx:Text fontSize="22" texthtml="true" styleName="yellow01" text="${CUserData:getActionObeliskConfigByid(arg[i][1],3)}" width="595" mouseThrough="true"/>
									<mx:Canvas height="10"/>
								</mx:VBox>
							</mx:Canvas>
							
							<mx:Canvas height="30" mouseThrough="true"/>
							<mx:Canvas height="40" mouseThrough="true"/>
							<mx:HBox horizontalGap="30" horizontalCenter="0">
								<mx:Button label="GO" styleName="btn05" setts="${arg[i][1]} " onclick="obelisk_btngotomapClick"/>
								<mx:Button label="查看详细" styleName="btn05" setts="${arg[i][1]} " onclick="obeliskdetail_show(${arg[i][1]})"/>
							</mx:HBox>
							<mx:Canvas height="40" mouseThrough="true"/>
							
						</mx:VBox>
						
					</mx:Canvas>
					
				{end}
			{end}
		</mx:VBox>

	</mx:Canvas>
	
</mx:Canvas>
]]
--function obelisk_listshow()
--end

function obelisk_listshow()
	httpsend( 1 , 0x004c , 0 , {CUserData.m_nUserID},"obelisk_recMsgGetObeliskOverview","httpdp_svrStatusLogin"  )
	g_obelisk_httptype_4c=1
	btnloading_show()
end
function obelisk_listshowback()
	print("obelisk_listshowback")
	
	--arg
	local nnow = CUserData:getCurServerTime()
	
--	arg = {
--	0,
--	{
--		{
--			1,1,nnow,nnow+24*3600,0,0,0,0
--		}
--	}
--	}
	
	local n=0
	actionList=CUserData.m_obelisk[2]
	
	for i=1,#actionList do
		print("obelisk_listshowback v:"..tabletostring(actionList[i]))
		
	end
	
	flextodiv(div_obelisk_list_str,actionList,"frame_more",nil,nil,{1})
end
function obelisk_listbtnCloseClick()
	deldiv("frame_more","div_obelisk_list_id")
end

function obelisk_btngotomapClick()
	print("obelisk_btngotomapClick")
	
	deldiv("frame_more","div_obelisk_list_id")
	map_show(256,512,0)
end

function div_obelisk_comp()
	print("div_obelisk_comp")
	div_obeliskTimer()
end

function div_obeliskTimer()
	local needFresh=false
	--local nnow = curtimer()
	local nnow = CUserData:getCurServerTime()
	if #CUserData.m_obelisk >= 2 then 
		local actionList = CUserData.m_obelisk[2]
		for i = #actionList , 1,-1 do
			local id=actionList[i][1]
			local time=0
			local msg=""
			if actionList[i][1] > 0 then
				if nnow < actionList[i][3] then   --未开始
					time=actionList[i][3]-nnow
					msg="准备开启:"
				elseif nnow >= actionList[i][3] and nnow <= actionList[i][4] then--进行中
					time=actionList[i][4]-nnow
					msg="进行中:"
				else--已经结束
					msg="已结束:"
				end
			end
			--print("div_obeliskTimer time:"..time..",msg:"..msg..",id:"..id..",nnow:"..nnow..",actionList[i][3]:"..actionList[i][3]..",actionList[i][4]:"..actionList[i][4])
			if time>=0 then
				local id=actionList[i][1]
				local coolTime=getid2("div_obelisk_list_id","coolTime"..id)
				if coolTime~=nil then
					needFresh=true
					coolTime:changetext(CData:GetTranlang(msg)..formatTime(time,1))
				end
				--print("obeliskdetail_getid():"..obeliskdetail_getid()..",id:"..id )
				if obeliskdetail_getid() == id then
					local div = getid2("div_obeliskdetail_id","rankCoolTime")
					if div ~= nil then 
						needFresh=true
						div:changetext(CData:GetTranlang(msg)..formatTime(time,1))
					else
						--print("err 2 div_obeliskTimer")
					end
				else
					--print("err div_obeliskTimer")
				end
				if g_obelisk_id == id then
					local div = getid2("main","obelisk_timertext")
					if div ~= nil then 
						needFresh=true
						div:changetext(CData:GetTranlang(msg)..formatTime(time,1))
					end
				end
			end
		end
		if needFresh then
			settimer(TIMER_ID_FOR_ACTIONLISTTIMER,1*1000,"div_obeliskTimer",1)
		end
	end
end

function obelisk_checkmapid(nmapid)
	local nenabled = 0
	local amaplist = {
		130303,130304,130815,130816,130817,130308,130309,129798,129797,129286,129795,129794
	}
	local nindex = 0
	for i=1,#amaplist do
		if amaplist[i] == nmapid then 
			nindex = i 
			break
		end
	end
	if nindex > 0 then 
		if #CUserData.m_obelisk >= 2 then 
			local actionList = CUserData.m_obelisk[2]
			for i = #actionList , 1,-1 do
				local id=actionList[i][1]
				if nindex == id then 
					nenabled = 1
					break
				end
			end
		end
	end
	print("obelisk_checkmapid nmapid:"..nmapid..",nenabled:"..nenabled)
	return nenabled,nindex 
end
