--runeEnch
local _npos = 1
local _nruneIndex = 1
local _ncurRuneId = 0
local _ncurEquipRuneId = 0

function runeEnch_recMsgRuneAction()
	_ncurRuneId = 0
	runeEnch_ref()
end

function runeEnch_btnDelClick()
	httpsend( 1 , 0x0171, 0 , {CUserData.m_nUserID,12,_ncurEquipRuneId,_npos,_nruneIndex,0,0,0,0 },"rune_recMsgRuneAction","httpdp_svrStatus"  )--		
	btnloading_show()
end

function runeEnch_btnAddClick()
	httpsend( 1 , 0x0171, 0 , {CUserData.m_nUserID,11,_ncurRuneId,_npos,_nruneIndex,0,0,0,0 },"rune_recMsgRuneAction","httpdp_svrStatus"  )--		
	btnloading_show()
end

function runeEnch_btnBagRuneClick(a)
	local nindex = jdtonumber(a.pBase:getts())
	if _ncurRuneId ~= nindex then 
		_ncurRuneId = nindex
		
		if _ncurRuneId > 0 then 
			local arune = rune_query(_npos)
			if arune[_nruneIndex] ~= nil and arune[_nruneIndex] > 0 then 
				_nruneIndex = 0
			end
		end
		
		runeEnch_ref()
	end
end

function runeEnch_btnRuneClick(a)
	local nindex = jdtonumber(a.pBase:getts())
	print("runeEnch_btnRuneClick nindex:"..nindex)	
	if _nruneIndex ~= nindex then 
		_nruneIndex = nindex
		
		local arune = rune_query(_npos)
		if arune[_nruneIndex] ~= nil and arune[_nruneIndex] > 0 then 
			_ncurRuneId = 0
		end
		
		runeEnch_ref()
	end
end

function runeEnch_equipBtnClick(a)
	local nindex = jdtonumber(a.pBase:getts())
	if _npos ~= nindex then 
		_npos = nindex
		_nruneIndex = 0
		
		runeEnch_ref()
	end
end

function runeEnch_ref()
	local div = getid2("main","runeEnch_content")
	if div ~= nil then 
		local strtemp = runeEnch_getContentDivStr()
		
		
		local arg = {}
		flextodiv(strtemp,arg ,"runeEnch_content")	
	end
end

function runeEnch_checkSet(arune,aset)
	print("runeEnch_checkSet arune:"..tabletostring(arune)..",aset:"..tabletostring(aset))
	local aruneCopy = copytable(arune)
	local nenabled = 1
	local ncount   = 0
	for i=1,#aset do
		local ncurId = aset[i]
		if ncurId > 0 then 
			local nfind = 0
			for j=1,#aruneCopy do
				if aruneCopy[j] == ncurId then 
					nfind = 1
					table.remove(aruneCopy,j)
					break	
				end
			end
			if nfind == 0 then 
				nenabled = 0
				break
			else
				ncount = ncount + 1
			end
		end
	end
	if ncount < 2 then 
		nenabled = 0
	end
	print("runeEnch_checkSet ret nenabled:"..nenabled)
	return nenabled
end

function runeEnch_getContentDivParma()
	local alist = {3,1,5,2,6,4,7,8}
	local npos  = _npos
	local apos  = {{145,156},{220,312},{415,312},{480,156}}
	local nruneIndex = _nruneIndex
	local ncurRuneId = _ncurRuneId
	
	local arune = rune_query(_npos)
	print("runeEnch_getContentDivParma arune:"..tabletostring(arune)..",nruneIndex:"..nruneIndex)
	local ncanDel = 0
	if arune[nruneIndex] ~= nil and arune[nruneIndex] > 0 then 
		ncanDel = 1
		_ncurEquipRuneId = arune[nruneIndex]
	else
		_ncurEquipRuneId = 0
	end
	local ncanAdd = 0
	if arune[nruneIndex] ~= nil and arune[nruneIndex] == 0 and ncurRuneId > 0  then 
		ncanAdd = 1
	else
--		print("runeEnch_getContentDivParma nruneIndex:"..nruneIndex..",arune:"..tabletostring(arune))
--		print("runeEnch_getContentDivParma rune[nruneIndex]:"..arune[nruneIndex]..",ncurRuneId:"..ncurRuneId)
	end
	
	local alistBag = {}
	local aitem = copytable( CUserData.m_aItem )
	for i=1,#aitem do
		local nid,nnum = aitem[i][1],aitem[i][2]
		local ntype = jdtonumber(cfgmgr_queryValue(G_DE_CFG_ITEM,nid,"F4") )
		if ntype == 17 then
			table.insert(alistBag,nid)
			--print("runeEnch_getContentDivParma ",nid,ntype)
		else
			--print("runeEnch_getContentDivParma ",nid,ntype)
		end
		--print("runeEnch_getContentDivParma nid:"..nid)
	end
--	print("runeEnch_getContentDivParma #alistBag:"..(#alistBag))
--	print("runeEnch_getContentDivParma CUserData.m_aItem:"..tabletostring(CUserData.m_aItem ))
--	
	local nfuncRuneId = 0 
	if _ncurEquipRuneId > 0  then 
		nfuncRuneId = _ncurEquipRuneId
	elseif ncurRuneId > 0 then 
		nfuncRuneId = ncurRuneId	
	end
	local szname = "符文属性"
	if nfuncRuneId > 0 then 
		szname = jdassign(cfgmgr_queryValue(G_DE_CFG_ITEM,nfuncRuneId,"F2"))
	end
	local afuncList = {}
	local acfg = cfgmgr_query(G_DE_CFG_RUNE,nfuncRuneId)
	if acfg ~= nil then 
		for i=1,7,2 do
			local nid  = jdtonumber(acfg["F"..i])
			if nid > 0 then 
				local nval = jdtonumber(acfg["F"..(i+1)] )
				local str,nnum = funcList_get(nid,nval)
				str = jdgetlang(str)
				str = str .." + "
				table.insert(afuncList,{str,nnum })
			end
		end
	end
	
--	print("runeEnch_getContentDivParma ret ncanAdd:"..ncanAdd)
	local asetArg  = {}
	local asetList = cfgmgr_querylist(G_DE_CFG_RUNE_SET)
	for _,v in pairs(asetList ) do
		local nsetId 		 = jdtonumber(v["F0"])
		local nsetEquipIndex = jdtonumber(v["F2"])
		if nsetEquipIndex == npos then 
			local aset = {jdtonumber(v["F3"]),jdtonumber(v["F4"]),jdtonumber(v["F5"]),jdtonumber(v["F6"]) }
			local nenabled = runeEnch_checkSet(arune,aset) 
			
			local afuncSetList  	= {}
			for i=7,13,2 do
				local nid  = jdtonumber(v["F"..i])
				if nid > 0 then 
					local nval = jdtonumber(v["F"..(i+1)] )
					local str,nnum = funcList_get(nid,nval)
					
					print("runeEnch_getContentDivParma 1 str:"..str)
					str = jdgetlang(str)
					if "战争大厅的上限增加{0}%" == str then 
						str = "战争会所的上限增加"
					end
					print("runeEnch_getContentDivParma 2 str:"..str)
					str = str .." + "
					table.insert(afuncSetList,{str,nnum })
				end
			end
			table.insert(asetArg,{nsetId,aset,afuncSetList,nenabled })	
		end
	end
	
	local function _compare(a,b)
		if a[1] > b[1] then 
			return true
		else
			return false
		end
	end
	table.sort(asetArg,_compare)
	
	return alist,npos,apos,nruneIndex,arune,ncurRuneId,ncanDel,ncanAdd,alistBag,afuncList,asetArg,nfuncRuneId,szname
end

function runeEnch_getRuneDivParam(v)
	local szpic = ""
	if v > 0 then 
		szpic = "assets/item/"..jdassign(cfgmgr_queryValue(G_DE_CFG_ITEM,v,"F1"),"")..".png"
	end
	return szpic
end

function runeEnch_getBagRuneDivParam(v)
	local szpic,nnum = "",0
	if v > 0 then 
		szpic = "assets/item/"..jdassign(cfgmgr_queryValue(G_DE_CFG_ITEM,v,"F1"),"")..".png"
		nnum = itemShop_getItemCount(v)
	end
	return szpic,nnum
end

function runeEnch_getContentDivStr()
	local strtemp = [[
	{
	local alist,npos,apos,nruneIndex,arune,ncurRuneId,ncanDel,ncanAdd,alistBag,afuncList,asetArg,nfuncRuneId,szname = runeEnch_getContentDivParma()
	}
	<mx:Canvas id="runeEnch_contentMain" visible="true" x="0" y="0" width="720" height="1280">
		<mx:Canvas visible="true" width="720" height="1280" x="0" y="30">
		
			<mx:Canvas width="720" height="1280" x="0" y="70">
				<mx:Image source="assets/images/dzBg01.png" width="720" height="564" y="20"/>
				
				<mx:Image source="assets/images/headerBg05.png" x="301" y="150" width="130" height="137"/>
			
				<mx:Image source="assets/equip/${getHeroEquipImageByPos(npos)}.png" x="313" y="161"/>
				
				<mx:VBox verticalGap="17" x="38" y="120">
					{for i=1,4 do}		
						<mx:HBox horizontalGap="478">
							{for j=1,2 do}
								{
								local nindex = (i -1 ) * 2 + j 
								if alist[nindex] ~= nil then 
									local nval = alist[nindex]
									local nlv  = CUserData["m_nItem"..nval]
									}	
									<mx:Canvas width="87" height="89">
										<mx:Image source="assets/images/headerBg03.png" width="87" height="89" x="0" y="0"/>
										<mx:Image source="assets/equip/${getHeroEquipImageByPos(nval)}.png" width="75" height="77" x="6" y="6" setts="${nval}" sound="defalut" onclick="runeEnch_equipBtnClick"/>
										<mx:Label text="Lv.${nlv}" fontSize="20" styleName="white01" mouseThrough="true" textAlign="right" x="20" y="53" width="60"/>
										<mx:Image {if npos == nval then} visible="true" {else} visible="false" {end} source="assets/images/header01On.png" width="87" height="89" x="0" y="0"/>
									</mx:Canvas>
								{end}
							{end}	
						</mx:HBox>	
					{end}
				</mx:VBox>
				
				{for i=1,#apos do
					local nx,ny = apos[i][1],apos[i][2]
					local ncurRune = arune[i]
					local szpic = runeEnch_getRuneDivParam(ncurRune )
					}
					<mx:Canvas onclick="runeEnch_btnRuneClick" setts="${i}" y="${ny}" x="${nx}" width="107" height="95" >
						<mx:Image source="assets/images/ic01Xq.png" mouseThrough="true" visible="true"/>
						{if ncurRune > 0 then}
							<mx:Image x="21" y="15" source="${szpic}" mouseThrough="true" width="65" height="65"/>	
						{end}
						{if nruneIndex == i then}
							<mx:Image source="assets/images/dzOn.png" mouseThrough="true"/>	
						{end}
					</mx:Canvas>
				{end}
			</mx:Canvas>
			
			<mx:Button styleName="btn04" label="摘除" x="158" y="576" setts="1" id="equipEnch_btn_1" onclick="runeEnch_btnDelClick" {if ncanDel == 1 then} enabled="true" {else} enabled="false" {end} />
			<mx:Button styleName="btn03" label="镶嵌" x="394" y="576" setts="2" id="equipEnch_btn_2" onclick="runeEnch_btnAddClick" {if ncanAdd == 1 then} enabled="true" {else} enabled="false" {end} />
				
			<mx:Image source="assets/images/block13.png" width="708" height="430" x="8" y="${671-30}"/>
			<mx:Image source="assets/images/bar13.png" y="652"/>
			<mx:Canvas y="666" x="10" width="700" setslidetype="2">
				<mx:HBox horizontalGap="20">
					{for i=1,#alistBag do
						local ncurBagRuneId = alistBag[i]
						local szpic,nnum = runeEnch_getBagRuneDivParam(ncurBagRuneId)
						}
						<mx:Canvas width="124" height="127" setts="${ncurBagRuneId}" sound="defalut" onclick="runeEnch_btnBagRuneClick">
							<mx:Image source="assets/images/headerBg03.png" mouseThrough="true"/>
							<mx:Image source="${szpic }" x="9" y="9" mouseThrough="true" width="105" height="105"/>
							<mx:Image source="assets/images/numBg01.png" x="77" y="83" mouseThrough="true"/>
							<mx:Label text="${nnum }" fontSize="20" styleName="white01" textAlign="center" x="79" y="87" width="39" mouseThrough="true"/>
							{if ncurRuneId == ncurBagRuneId then}
								<mx:Image source="assets/images/header01On.png" mouseThrough="true"/>
							{end}
						</mx:Canvas>
					{end}
				</mx:HBox>
			</mx:Canvas>
			
			<mx:Canvas setslidetype="1" width="720" height="${270-30}" y="818">
				<mx:VBox y="0" verticalGap="30">
					<mx:Canvas {if nfuncRuneId > 0 then} visible="true" {else} visible="false" {end} id="runeEnch_func1" x="0" width="720">
						{
						local ny = 0
						}
						<mx:Image source="assets/images/th.png" mouseThrough="true" x="16" y="${ny}"/>
						<mx:Label text="${szname}" fontSize="24" mouseThrough="true" styleName="white02" width="687" textAlign="center" x="16" y="${ny+2}"/>
						<mx:VBox id="id="runeEnch_func1_VBox" verticalGap="0" y="${ny+48}" x="36" mouseThrough="true">
							{for i = 1 ,#afuncList do}
								<mx:Canvas>
									<mx:HBox>	
										<mx:Label text="${afuncList[i][1]}" fontSize="18" mouseThrough="true" styleName="brown01" x="10" y="7"/>
										<mx:Label text="${afuncList[i][2]}" fontSize="18" mouseThrough="true" styleName="brown01" textAlign="center" y="10"/>
									</mx:HBox>	
									<mx:Image source="assets/images/line01.png" mouseThrough="true" y="36"/>
								</mx:Canvas>	
							{end}
						</mx:VBox>
					</mx:Canvas>
					{
					for aa=1,#asetArg do
						local nsetId,aset,afuncSetList,nenabled=asetArg[aa][1],asetArg[aa][2],asetArg[aa][3],asetArg[aa][4]
						if nsetId > 0 then}
							<mx:Canvas x="0" width="720">
								{
								local ny = 0
								local szenabled = ""
								if nenabled == 1 then 
									szenabled = jdgetlang("已激活")
								else
									szenabled = jdgetlang("未激活")
								end
								szenabled = "" -- "("..szenabled..")"
								}
								<mx:Image source="assets/images/th.png" mouseThrough="true" x="16" y="${ny}"/>
								<mx:HBox horizontalCenter="0" y="${ny+2}">
									<mx:Label text="符文套装" fontSize="24" mouseThrough="true" styleName="white02"/>
									<mx:Label text="${szenabled}" fontSize="24" mouseThrough="true" styleName="white02"/>
								</mx:HBox>
								
								<mx:HBox id="runeEnch_func2_HBox" x="36" y="${ny+48}">
									{for i=1,#aset do
										local ncurBagRuneId = aset[i]
										if ncurBagRuneId > 0 then
											local szpic,nnum = runeEnch_getBagRuneDivParam(ncurBagRuneId)
											}
											<mx:Canvas width="124" height="127">
												<mx:Image source="assets/images/headerBg03.png" mouseThrough="true"/>
												<mx:Image source="${szpic}" x="9" y="9" mouseThrough="true" width="105" height="105"/>
											</mx:Canvas>
										{end}
									{end}
								</mx:HBox>
								
								<mx:VBox id="runeEnch_func2_VBox" verticalGap="0" y="${ny+48+127}" x="36">
									{for i = 1 ,#afuncSetList do}
										<mx:Canvas>
											<mx:HBox>	
												<mx:Label text="${afuncSetList[i][1]}" mouseThrough="true" fontSize="18" styleName="brown01" x="10" y="7"/>
												<mx:Label text="${afuncSetList[i][2]}" mouseThrough="true" fontSize="18" styleName="brown01" textAlign="center" y="10"/>
											</mx:HBox>	
											<mx:Image source="assets/images/line01.png" mouseThrough="true" y="36"/>
										</mx:Canvas>	
									{end}
								</mx:VBox>
							</mx:Canvas>
						{end
					end}
				</mx:VBox>
			</mx:Canvas>
			
		</mx:Canvas>
			
	</mx:Canvas>
	]]
	return strtemp
end

function runeEnch_show(npos)
	if npos == nil then npos = 1 end
	_npos = npos
	_nruneIndex = 1
	_ncurRuneId = 0
	_ncurEquipRuneId = 0

	local div_equipEnch_str = [[
		{
		local nbuildinglv = 1
		}
		<mx:Canvas id="runeEnch_main" width="720" height="1280">
			<mx:Canvas width="720" height="112">
				<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
				
				<mx:Label id="frameTop_txt" text="符文" width="720" textAlign="center" y="35"/>
				<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" setts="4" onclick="runeEnch_btnCloseClick"/>
			</mx:Canvas>
			
			<mx:Image source="assets/images/bg01.jpg" width="720" height="990" y="111"/>
			
			<mx:Canvas id="runeEnch_content" visible="true" width="720" height="1280" x="0" y="0">
				]]..runeEnch_getContentDivStr()..[[
			</mx:Canvas>
			<mx:Image source="assets/images/bar04.png" y="111"/>
			<mx:HBox horizontalCenter="0" y="118">
				<mx:Button onclick="runeEnch_tabClick" setts="1" styleName="rune_tab01" label="镶嵌" sound="assets/sound/421.ogg" enabled="false" y="0"/>
				<mx:Button onclick="runeEnch_tabClick" setts="2" styleName="rune_tab01" label="合成" sound="assets/sound/421.ogg" y="0"/>
				<mx:Button onclick="runeEnch_tabClick" setts="3" styleName="rune_tab01" label="兑换" sound="assets/sound/421.ogg" y="0"/>
			</mx:HBox>
			
			<mx:Image onclick="runeDetail_detailShow()" source="assets/images/ic01Christmas.png" width="60" height="60" y="10" right="10"/>
		</mx:Canvas>
	]]
	local arg = {}
	flextodiv(div_equipEnch_str,arg ,"frame_more",nil,nil,{3})	
end

function runeEnch_btnCloseClick(a)
	deldiv("frame_more","runeEnch_main",{3})
end

function runeEnch_tabClick(a)
	local nindex = jdtonumber(a.pBase:getts())
	if nindex == 1 then 
		runeEnch_show()
	elseif nindex == 2 then 
		runeCompose_show()
	else
		runeShop_show()	
	end
end

