--设置翻译的目标语言
--默认以设备语言（如果此语言存在于设置列表中）为准
--否则，以游戏语言为准
local div_setAirLanguage_str = [[
{
local ntype = arg[1]
local alang = arg[2]
}
	<mx:Canvas id="setAirLanguage_main" width="720" height="1280">
		<mx:Canvas width="720" height="112">
			<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
			<mx:Label id="frameTop_txt" text="设置" width="720" textAlign="center" y="35"/>
			<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" onclick="setAirLanguage_btnCloseClick"/>
		</mx:Canvas>
		<mx:Image source="assets/images/bg02.jpg" width="720" height="990" y="111" />
		<mx:Canvas  y="115" height="887" setslidetype="1">
			<mx:VBox verticalGap="0" x="17">
				{for i= 1, #alang do
					local v = alang[i]
					local strenabled = "true"
					if v[1] == ntype then
						strenabled = "false"
					end}
					<mx:Button Tranlang="false" mouseThrough="true" styleName="setLanguage" setts="${v[1]}" label="${v[2]}" enabled="${strenabled}" onclick="setAirLanguage_btnItemClick"/>
				{end}
			</mx:VBox>
		</mx:Canvas>
		<mx:Image source="assets/images/bar01.png" y="1000"/>
		<mx:Button styleName="btn08" label="确认" y="1020" x="192" onclick="setAirLanguage_save"/>
		
	</mx:Canvas>
]]

local airLanguage_arr = {{"en","English"},{"ru","русский "},{"fr","Française"},{"de","Deutsch"},{"ar"," عربي "},{"ja","日本語"},
					{"pt","Português"},{"es","Español"},{"zh-CHS","简体中文"},{"zh-CHT","繁體中文"},{"ko","한국어"},{"it","Italian"},{"tr","Türkçe"},{"fr","French"},{"nl","Ingles"}}--目标语言集{"th","泰语"},
if g_main_apptype == 1 then 
	airLanguage_arr = {{"zh-CHS","简体中文"},{"zh-CHT","繁體中文"},{"ko","한국어"}}--目标语言集{"th","泰语"},
end

local g_setAirLanguage_lang = nil

--返回设备语言，前提是此语言支持翻译
function getPlatLanguage()
	local lang = setLanguage_getPlatparms()
	if lang[2] == "zh" then
		if lang[1] == "TW" then
			lang[2] = "zh-CHT" --繁体中文
		else
			lang[2] = "zh-CHS"
		end
	end
	for _,v in pairs(airLanguage_arr) do
		if v[1] == lang[2] then
			return lang[2]
		end
	end
	return nil
end

--设置语言界面的打开/刷新
function setAirLanguage_show()
	if g_setAirLanguage_lang == nil then
		g_setAirLanguage_lang = setLanguage_getArg()[7]
	end
	local arg = {g_setAirLanguage_lang ,airLanguage_arr }
	flextodiv(div_setAirLanguage_str,arg ,"frame_more",nil,nil,{3})	
end

function setAirLanguage_btnItemClick(a)
	g_setAirLanguage_lang = a.pBase:getts()
	setAirLanguage_show()
end

function setAirLanguage_save()
	setLanguage_setArgByIndex(g_setAirLanguage_lang,7)
	setLanguage_setsql()
	local txt = getid2("setting_main","airlanguagetxt")
	if txt then
		txt:changetext(setAirLanguage_getLangeName())
	end
	g_setAirLanguage_lang = nil
	
	setAirLanguage_btnCloseClick()
end

function setAirLanguage_btnCloseClick(a)
	deldiv("frame_more","setAirLanguage_main",{3})
end

function setAirLanguage_getLangeName()
	for _,v in pairs(airLanguage_arr) do
		if v[1] == setLanguage_getArg()[7] then
			return v[2]
		end
	end
	return ""
end

function setAirLanguage_getArg()
	return airLanguage_arr
end	

function setAirLanguage_init()
	if setLanguage_getArg()[7] == "" then
		
		if g_main_apptype == 1 then 
			if tonumber(setLanguage_getArg()[1]) == 11 then--11 繁体中文 xp 20140519
				setLanguage_getArg()[7] = "zh-CHT"
			elseif tonumber(setLanguage_getArg()[1]) == 13 then--13 韩语
				setLanguage_getArg()[7] = "ko"	
			else--2 中文
				setLanguage_getArg()[7] = "zh-CHS"
			end
		else 
			if tonumber(setLanguage_getArg()[1]) == 1 then--1 英文
				setLanguage_getArg()[7] = "en"
			elseif tonumber(setLanguage_getArg()[1]) == 3 then--1 西班牙语
				setLanguage_getArg()[7] = "es"
			elseif tonumber(setLanguage_getArg()[1]) == 4 then--1 西班牙语
				setLanguage_getArg()[7] = "fr"
			elseif tonumber(setLanguage_getArg()[1]) == 5 then--5 德语
				setLanguage_getArg()[7] = "de"
			elseif tonumber(setLanguage_getArg()[1]) == 6 then--1 西班牙语
				setLanguage_getArg()[7] = "it"
			elseif tonumber(setLanguage_getArg()[1]) == 8 then--8 俄罗斯语
				setLanguage_getArg()[7] = "ru"
			elseif tonumber(setLanguage_getArg()[1]) == 9 then--1 西班牙语
				setLanguage_getArg()[7] = "tr"
			elseif tonumber(setLanguage_getArg()[1]) == 10 then--10 阿拉伯语
				setLanguage_getArg()[7] = "ar"
			elseif tonumber(setLanguage_getArg()[1]) == 11 then--11 繁体中文 xp 20140519
				setLanguage_getArg()[7] = "zh-CHT"
	--		elseif tonumber(setLanguage_getArg()[1]) == 13 then--13 韩语
	--			setLanguage_getArg()[7] = "ko"	
			elseif tonumber(setLanguage_getArg()[1]) == 14 then--1 西班牙语
				setLanguage_getArg()[7] = "nl"
			else--2 中文
				setLanguage_getArg()[7] = "zh-CHS"
			end
		end
			
		local l = getPlatLanguage()
		if l then
			setLanguage_getArg()[7] = l
		end	
		setLanguage_setsql()
	end
end