--设置语言
local div_setLanguage_str = [[
{
local ntype = arg[1]
local alang = arg[2]
}
	<mx:Canvas id="setLanguage_main" width="720" height="1280">
		<mx:Canvas width="720" height="112">
			<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
			<mx:Label id="frameTop_txt" text="设置" width="720" textAlign="center" y="35"/>
			<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" onclick="setLanguage_btnCloseClick"/>
		</mx:Canvas>
		<mx:Image source="assets/images/bg02.jpg" width="720" height="990" y="111" />
		<mx:Canvas  y="115" height="887" setslidetype="1">
			<mx:VBox verticalGap="0" x="17">
				{for i= 1, #alang do
					local v = alang[i]
					local strenabled = "true"
					if v[2] == ntype then
						strenabled = "false"
					end}
					<mx:Button Tranlang="false" mouseThrough="true" styleName="setLanguage" setts="${v[2]}" label="${v[1]}" enabled="${strenabled}" onclick="setLanguage_btnItemClick"/>
				{end}
			</mx:VBox>
		</mx:Canvas>
		<mx:Image source="assets/images/bar01.png" y="1000"/>
		<mx:Button styleName="btn08" label="确认" y="1020" x="192" onclick="setLanguage_btnOkClick"/>
		
	</mx:Canvas>
]]

--[[{"it","Italian"},{"tr","Türkçe"},{"fr","French"},{"nl","Ingles"}
	英语	English en 1
	西班牙语	Español es	3
	法语	Française  fr	4*
	德语	Deutsch de	5
	意大利语	Italiano it	6*
	葡萄牙语	Português pt	7
	俄罗斯语	 русский ru	8
	土耳其语	Türk  tr	9*
	阿拉伯语	 عربي 	ar 10
	简体中文	简体中文	2
	繁体中文	繁體中文	11
	日语	日本語	ja 12
	韩语 한국어  ko 13
	荷兰语 Ingles nl 14*
	
	本地语言，国家代码，玩家设置 
]]

local g_setLanguage_platparms = ""

function setLanguage_getPlatparms()
	local aret = {"US","en"}
	if type(g_setLanguage_platparms ) == "table" then
		if #g_setLanguage_platparms >= 2 then
			if type(g_setLanguage_platparms[1] ) == "string" and type(g_setLanguage_platparms[2] ) == "string" then
				aret[1] = g_setLanguage_platparms[1]
				aret[2] = g_setLanguage_platparms[2]
			end
		end
	end
	return aret
end

local g_setLanguage_lang= {
	{"English",1},--英语
	{"Español",3},--西班牙语
	{"French",4},--法语
	{"Deutsch",5},--德语 5
	{"Italian",6},--意大利语
	{"Ingles",14},--荷兰语
	{"русский",8},--俄罗斯语 8
	{"Türkçe",9},--土耳其语
	--{" عربي ",10},--阿拉伯语
	{"简体中文",2},--简体中文
	{"繁體中文",11},--繁体中文 
--	{"한국어",13},--韩语
	
}

if g_main_apptype == 1 then --韩国版
	g_setLanguage_lang= {
--		{"English",1},--英语
--		{"Español",3},--西班牙语
--		{"French",4},--法语
--		{"Deutsch",5},--德语 5
--		{"Italian",6},--意大利语
--		{"Ingles",14},--荷兰语
--		{"русский",8},--俄罗斯语 8
--		{"Türkçe",9},--土耳其语
		--{" عربي ",10},--阿拉伯语
		{"简体中文",2},--简体中文
		{"繁體中文",11},--繁体中文 
		{"한국어",13},--韩语
		
	}
end

local g_setLanguage_arg = {
	"1",--语言 1 英文 2 中文
	"1",--预留 音乐    1 打开,0 关闭
	"1",--预留 音效    1 打开,0 关闭
	"",--预留  是否出前置登陆界面 ,1 是,0 否。 需求是清除当前账号后首次登陆
	"0",--预留  评分界面弹出次数
	"0",--预留  评分界面点击ok次数
	"en",--翻译的目标语言设置，默认为设备语言，如果设备语言不在可翻译语言列表里，则默认为英语   
	"0",--预留 facebookLike 显示时间,记录后便与XX小时内不再显示  
	"",--预留   保存触发引导信息
	"",--预留
}

function setLanguage_reSetArg()
	g_setLanguage_arg = {
		"1",--语言 1 英文 2 中文
		"1",-- 音乐    1 打开,0 关闭
		"1",-- 音效    1 打开,0 关闭
		"",-- 是否出前置登陆界面 ,1 是,0 否。 需求是清除当前账号后首次登陆
		"0",--  评分界面弹出次数
		"0",-- 评分界面点击ok次数
		"en",--翻译的目标语言设置，默认为设备语言，如果设备语言不在可翻译语言列表里，则默认为英语
		"0",--预留   facebookLike 显示时间,记录后便与XX小时内不再显示  
		"",--预留   保存触发引导信息
		"",--预留
	}
end

function setLanguage_getArg()
	return g_setLanguage_arg
end

function setLanguage_setArgByIndex(str,nindex)	
	if g_setLanguage_arg[nindex] ~= nil then
		if nindex == 1 then
			if tonumber(str ) ~= nil then
				g_setLanguage_arg[nindex] = str
			end
		else
			g_setLanguage_arg[nindex] = str
		end
	end
end

--语言参数sqlite存储建表
function setLanguage_createTable()    --建表
	print("setLanguage_createTable")
	local nsqlite = changeDataToSql("CREATE TABLE IF NOT EXISTS gameLanguage (id INTEGER PRIMARY KEY,sv1 varchar(32),sv2 varchar(32),sv3 varchar(32),sv4 varchar(32),sv5 varchar(32),sv6 varchar(32),sv7 varchar(32),sv8 varchar(32),sv9 varchar(32),sv10 varchar(32) )" )
	if nsqlite ~= 0 then
		account_getSDKSqlite()
	end
end

--读取语言参数从sqlite
function setLanguage_getsql()
	print("setLanguage_getsql")
	setLanguage_createTable()
	--print("setLanguage_getsql a")
	local vv = getDataForSql("mb6", string.format("select * from gameLanguage ")  )
	if vv ~= nil and type(vv) == "table" then
		if #vv > 0 then
			print("vv[1]:"..tabletostring(vv[1]) )
			for i = 1 ,10 do
				g_setLanguage_arg[i] = vv[1]["sv"..i]
				
			end
			--print("setLanguage_getsql setLanguage_getsql:"..tabletostring(g_setLanguage_arg))
		end
	else
		--lua_tinker::def(L, "getplatformparms", CToLua::lua_getPlatFormParms );getplatformparms()//取得跟设备等相关的信息  国家|语言|版本号|显示版本号"getotherparm", 
		--没有存语言记录,如果是中文，则显示中文，其他的则显示英文
		--语言 简体中文 CN|zh 繁体 TW|zh 英文 US|en
		local nlang = 1--语言 1 英文 2 中文 8 俄文
		local aplatstr = getplatformparms()
		print("setLanguage_getsql aplatstr:"..aplatstr)
		aplatstr = string.split( aplatstr, "|"  )
		if #aplatstr >= 4 then
			local nstrLan = aplatstr[2]--语言
			
			if nstrLan == "zh" then
				if aplatstr[1] == "CN" then
					nlang = 2
				else--繁体
					nlang = 11
				end
			elseif nstrLan == "es" then
				nlang = 3
			elseif nstrLan == "fr" then
				nlang = 4	
			elseif nstrLan == "de" then
				nlang = 5
			elseif nstrLan == "it" then
				nlang = 6
			elseif nstrLan == "ru" then
				nlang = 8
			elseif nstrLan == "tr" then
				nlang = 9	
--			elseif nstrLan == "ar" then
--				nlang = 10
--			elseif nstrLan == "ko" then
--				nlang = 13
			elseif nstrLan == "nl" then
				nlang = 14
			end
			
			if g_main_apptype == 1 then --韩国版
				if nstrLan == "zh" then
					if aplatstr[1] == "CN" then
						nlang = 2
					else--繁体
						nlang = 11
					end
				else--ko
					nlang = 13
				end
			end
		end
		if nlang == 1 then--1 英文
			g_setLanguage_arg[1] = "1"
			g_setLanguage_arg[2] = "1"
			g_setLanguage_arg[3] = "1"
			g_setLanguage_arg[7] = "en"
			--changeDataToSql( string.format( "INSERT INTO gameLanguage VALUES(?,'1','1','1','','','','','','','' );") )
		elseif nlang == 3 then--5 西班牙语
			g_setLanguage_arg[1] = "3"
			g_setLanguage_arg[2] = "1"
			g_setLanguage_arg[3] = "1"
			g_setLanguage_arg[7] = "es"	
		elseif nlang == 4 then--法语
			g_setLanguage_arg[1] = "4"
			g_setLanguage_arg[2] = "1"
			g_setLanguage_arg[3] = "1"
			g_setLanguage_arg[7] = "fr"	
		elseif nlang == 5 then--5 德语
			g_setLanguage_arg[1] = "5"
			g_setLanguage_arg[2] = "1"
			g_setLanguage_arg[3] = "1"
			g_setLanguage_arg[7] = "de"	
		elseif nlang == 6 then--意大利语
			g_setLanguage_arg[1] = "6"
			g_setLanguage_arg[2] = "1"
			g_setLanguage_arg[3] = "1"
			g_setLanguage_arg[7] = "it"	
		
		elseif nlang == 8 then--8 俄罗斯语
			g_setLanguage_arg[1] = "8"
			g_setLanguage_arg[2] = "1"
			g_setLanguage_arg[3] = "1"
			g_setLanguage_arg[7] = "ru"
			--changeDataToSql( string.format( "INSERT INTO gameLanguage VALUES(?,'8','1','1','','','','','','','' );") )
		elseif nlang == 9 then--土耳其语
			g_setLanguage_arg[1] = "9"
			g_setLanguage_arg[2] = "1"
			g_setLanguage_arg[3] = "1"
			g_setLanguage_arg[7] = "tr"
		elseif nlang == 11 then--11 繁体中文
			g_setLanguage_arg[1] = "11"
			g_setLanguage_arg[2] = "1"
			g_setLanguage_arg[3] = "1"
			g_setLanguage_arg[7] = "zh-CHT"
--		elseif nlang == 13 then--13韩语
--			g_setLanguage_arg[1] = "13"
--			g_setLanguage_arg[2] = "1"
--			g_setLanguage_arg[3] = "1"
--			g_setLanguage_arg[7] = "ko"
		elseif nlang == 14 then--荷兰语
			g_setLanguage_arg[1] = "14"
			g_setLanguage_arg[2] = "1"
			g_setLanguage_arg[3] = "1"
			g_setLanguage_arg[7] = "nl"
		else--2 中文
			g_setLanguage_arg[1] = "2"
			g_setLanguage_arg[2] = "1"
			g_setLanguage_arg[3] = "1"
			g_setLanguage_arg[7] = "zh-CHS"
			--changeDataToSql( string.format( "INSERT INTO gameLanguage VALUES(?,'2','1','1','','','','','','','' );") )
		end
		
		if g_main_apptype == 1 then --韩国版
			if nlang == 11 then--11 繁体中文
				g_setLanguage_arg[1] = "11"
				g_setLanguage_arg[2] = "1"
				g_setLanguage_arg[3] = "1"
				g_setLanguage_arg[7] = "zh-CHT"
			elseif nlang == 13 then--13韩语
				g_setLanguage_arg[1] = "13"
				g_setLanguage_arg[2] = "1"
				g_setLanguage_arg[3] = "1"
				g_setLanguage_arg[7] = "ko"
			else--2 中文
				g_setLanguage_arg[1] = "2"
				g_setLanguage_arg[2] = "1"
				g_setLanguage_arg[3] = "1"
				g_setLanguage_arg[7] = "zh-CHS"
				--changeDataToSql( string.format( "INSERT INTO gameLanguage VALUES(?,'2','1','1','','','','','','','' );") )
			end
		end
		local l = getPlatLanguage()
		if l then
			g_setLanguage_arg[7] = l
		end	
		--print("setLanguage_getsql:::",g_setLanguage_arg[7])		
		setLanguage_setsql()
	end
	--print("================================setLanguage_getsql g_setLanguage_arg:"..tabletostring(g_setLanguage_arg) )
	local aplatstr = getplatformparms()
	print("setLanguage_getsql aplatstr:"..aplatstr)
	aplatstr = string.split( aplatstr, "|"  )
	g_setLanguage_platparms = aplatstr
	
--	g_setLanguage_arg[1] = "13"
--	g_setLanguage_arg[2] = "1"
--	g_setLanguage_arg[3] = "1"
--	g_setLanguage_arg[7] = "ko"
		
	return g_setLanguage_arg
end

--设置语言的参数存入sqlite
function setLanguage_setsql()
	--删除表
	changeDataToSql( "drop table gameLanguage;" )
	--建表
	setLanguage_createTable()
	--存数据	
	if g_setLanguage_arg[1] == "1" then
		changeDataToSql( string.format( "INSERT INTO gameLanguage VALUES(?,'1','','','','','','','','','' );") )
	elseif g_setLanguage_arg[1] == "8" then
		changeDataToSql( string.format( "INSERT INTO gameLanguage VALUES(?,'8','','','','','','','','','' );") )
	else
		changeDataToSql( string.format( "INSERT INTO gameLanguage VALUES(?,'2','','','','','','','','','' );") )
	end
		
	print("setLanguage_setsql")
	local str = "update gameLanguage set "
	print("setLanguage_setsql g_setLanguage_arg:"..tabletostring(g_setLanguage_arg))
	for i = 1 ,10 do
		if i == 1 then
			str = str .. string.format(" sv%d = '%s' ",i,g_setLanguage_arg[i])
		else
			str = str .. string.format(", sv%d = '%s' ",i,g_setLanguage_arg[i])
		end
		
	end
	str = str .. ";"
	print("setLanguage_setsql:"..str)
	changeDataToSql( str )
	
	account_setSDKSqlite()
end

--设置语言界面的打开/刷新
function setLanguage_show()
	local ntype = tonumber( g_setLanguage_arg[1])
	local nreset = 0
	if ntype ~= nil then
		--local lan = g_setLanguage_lang[ntype]
		local nfind = 0
		for i = 1 ,#g_setLanguage_lang do
			if g_setLanguage_lang[i][2] == ntype then
				nfind = 1
				break
			end
		end
		
		--if lan == nil then
		if nfind == 0 then
			nreset = 1
		end
	else
		nreset = 1
	end
	if nreset == 1 then
		ntype = 1
		setLanguage_reSetArg()
		setLanguage_setsql()
	end
	
	local arg = {ntype ,g_setLanguage_lang }
	flextodiv(div_setLanguage_str,arg ,"frame_more",nil,nil,{3})	
end

function setLanguage_btnCloseClick(a)
	deldiv("frame_more","setLanguage_main",{3})
end

--语言选择的返回
function setLanguage_btnItemClick(a)
	local nindex = tonumber(a.pBase:getts() )
	print("setLanguage_btnItemClick nindex:"..nindex)
	
	g_setLanguage_arg[1] = string.format("%d",nindex)
	setLanguage_show()
end

function setLanguage_btnOkClick(a)
	print("setLanguage_btnOkClick")
	
	setLanguage_setsql()
	showClum({"语言设置成功,请重新登陆",1,{"确定"}},{setLanguage_luareset})
end

function setLanguage_luareset()
	print("setLanguage_luareset")
	luareset()
end

function setLanguage_getNameById(id)
	for _,v in pairs(g_setLanguage_lang) do
		if v[2] == id then
			return v[1]
		end
	end
	return ""
end