--tabmgr
function tabmgr_insert(atable,v)
	if type(atable) == "table" then 
		local nSubIsTable = 0
		if type(v) == "table" then nSubIsTable = 1 end
		local nfind = 0
		for i=1,#atable do	
			if (nSubIsTable == 1 and atable[i][1] == v[1]) or (nSubIsTable == 0 and atable[i] == v) then 
				atable[i] = v
				nfind = 1
				break
			end
		end
		if nfind == 0 then table.insert(atable,v) end
	end
end
function tabmgr_query(atable,key)
	local v = nil
	if type(atable) == "table" and type(key) ~= "table" then 
		if #atable > 0 then 
			local nSubIsTable = 0
			if type(atable[1]) == "table" then nSubIsTable = 1 end
			for i=1,#atable do	
				if (nSubIsTable == 1 and atable[i][1] == key) or (nSubIsTable == 0 and atable[i] == key) then 
					v = atable[i]
					break
				end
			end
		end
	end	
	return v
end
function tabmgr_query2(atable,nkey,ntabkey)
	local v = nil
	if atable["a"..ntabkey] ~= nil then 
		v = tabmgr_query(atable["a"..ntabkey],nkey)
	end
	return v
end
function tabmgr_del(atable,key)
	for i=1,#atable do
		if atable[i][1] == key then 
			table.remove(atable,i)
			break
		end
	end
end
function tabmgr_insert2(atable,v,nkey)
	if atable["a"..nkey] ~= nil then 
		tabmgr_insert(atable["a"..nkey],key)
	end
end
function tabmgr_del2(atable,nid,nkey)
	if atable["a"..nkey] ~= nil then 
		tabmgr_del(atable,nid)
	end
end
function tabmgr_inserttab(atable,v)
	if type(atable) == "table" and type(v) == "table" then 
		for i=1,#v do
			local nfind = 0 
			for j=1,#atable do
				if atable[j][1] == v[i][1] then 
					atable[j] = v[i] 
					nfind = 1
					break
				end
			end
			if nfind == 0 then 
				table.insert(atable,v[i])
			end
		end
	end
end
