--目标系统
local div_target_str = [[
	{
	local adata = arg[1]
	local atarget = arg[2]
	local nindex = arg[3]
	}
	<mx:Canvas id="target_main" width="720" height="1280" backgroundColor="0x000000" backgroundAlpha="0" mouseEnabled="false" systemload="1" onloadcmp="target_onloadcmp">
		<mx:Canvas width="611" height="836" horizontalCenter="0" verticalCenter="0">
			<mx:Image source="assets/images/bg01Mb.png" width="611" height="836"/>
			<mx:Button styleName="btn02Close" id="target_btnClose" sound="assets/sound/414.ogg" x="520" y="14" onclick="target_btnClose"/>
			<mx:Label text="目标" styleName="yellow02" fontSize="30" x="175" y="24" width="240" textAlign="center"/>
			<mx:Canvas x="29" y="140" height="468" setslidetype="1">
				<mx:VBox verticalGap="15" mouseThrough="true">
					{for i = 1, #adata do
						if adata[i][1] % 1000 ~= 0 then
							local strstyle = "block02Mb"
							if adata[i][1] % 1000 == nindex then
								strstyle = "block01Mb"
							end 
							}
							<mx:Canvas setts="${adata[i][1] % 1000 }" onclick="target_btnItemClick" styleName="${strstyle}" width="552" minHeight="70" mouseThrough="true">
								{--if adata[i][5] == 0 then}
									<!mx:Image source="assets/images/ic01MbOff.png" x="15" y="17"/>
								{if strstyle == "block01Mb" then}
									<mx:Image source="assets/images/ic02Mb.png" x="15" y="17"/>
								{else}
									<mx:Image source="assets/images/ic01Mb.png" x="15" y="17"/>
								{end}
								<mx:Text text="${adata[i][4]}" fontSize="20" styleName="black03" x="58" y="20" width="445" mouseThrough="true"/>
								{if adata[i][3] == 1 then}
									<mx:Image source="assets/images/ic02Right.png" x="477" y="16" mouseThrough="true"/>
								{else}
									<!mx:Image source="assets/images/ic02False.png" x="477" y="16" mouseThrough="true"/>
									<mx:Image source="assets/images/ic01Mark.png" x="477" y="16" mouseThrough="true" width="52" height="41"/>
								{end}
								{if strstyle == "block01Mb" then}
									<mx:VBox x="58" y="58" mouseThrough="true">
										{if atarget[5][nindex] ~= nil then 
											}
											<mx:Canvas width="467" height="37">				
												<mx:Image source="assets/images/progBg10.png"/>	
												{local nvalue  	= atarget[5][nindex][1] 
												 if nvalue < 0 then nvalue = 0 end
												 local nvaluemax= atarget[5][nindex][2] 
												 if nvaluemax == 0 then nvaluemax = 1 end
												 local nrate 	= nvalue / nvaluemax
												 if nrate < 0 then nrate = 0 end
												 if nrate > 1 then nrate = 1 end
												 local npromax 	= 463 * nrate }						
												<mx:Canvas width="${npromax}" height="31" styleName="prog01" x="2" y="3"/>
												<mx:Label text="${nvalue }/${nvaluemax }" fontSize="20" styleName="white01" width="463" textAlign="center" x="2" y="7"/>
											</mx:Canvas>
										{end}
										{if adata[i][5] == 1 then}
											{for j = 1 ,#adata[i][6] do}
												<mx:Text text="${adata[i][6][j]}" fontSize="20" styleName="black03" width="445" mouseThrough="true"/>
											{end}
											{if #adata[i][6] <= 0 then}
												<mx:Text text="前置条件已经满足" fontSize="20" styleName="black03" width="445" mouseThrough="true"/>
											{end}
										{else}
											<mx:Canvas height="5"/>
										{end}
									</mx:VBox>	
								{end}
							</mx:Canvas>
						{end}
					{end}
				</mx:VBox>
			</mx:Canvas>	
			{if atarget[3] == 1 then}
				<mx:Button id="target_btnGetGift" styleName="btn01Mb" enabled="true" x="125" y="630" onclick="target_btnClick"/>
			{else}
				<mx:Button id="target_btnGetGift" styleName="btn01Mb" enabled="false" x="125" y="630" onclick="target_btnClick"/>
				<mx:Canvas width="336" height="202" x="125" y="630" onclick="target_btnTipClick" mouseThrough="true"/>	
			{end}
		</mx:Canvas>	
	</mx:Canvas>	
]]
--[[
关于展开的需求：
建筑、造兵、科技、城防 可展开,其他的 不可展开
建筑：建筑
造兵：科技-学院
科技：学院
城防：科技-学院

1、议院4级以下,目标系统图标要按一定频率闪烁几次
2、如果有新的目标子项完成,则目标系统图标要闪烁几次
]] 
local g_target_enabled = 1 --目标系统是否开放
function target_getEnabled()
	return g_target_enabled
end

local g_target_arg = {}
local g_target_ncuridBygift = 0
function target_show(nindex )--nindex 选中的子项索引
	
	if nindex == nil then
		nindex = 0
	end
	local atarget = copytable( CUserData.m_aSNStageTask )
	
	--测试数据
	--atarget = {1,1,0,1}
	
	print("target_show atarget:"..tabletostring(atarget) )
	--读取数据表
	local aconf   = CUserData:getTaskStageByid(atarget[2] )
	if aconf ~= nil then
		--print("target_show aconf:"..tabletostring(aconf) )
		--组织数据
		local adata = target_getData()--{}--{目标编码,目标配置,目标完成情况,目标描述}
		
		for i = 1 , #adata do
			if adata[i][1] % 1000 == 0 then
				adata[i][5] = 0 --是否可以展开
				adata[i][6] = {}
			else
				local nCanOpen = 0
				local aconf = adata[i][2]
				if tonumber(aconf["F2"]) == 1 or tonumber(aconf["F2"]) == 18 or tonumber(aconf["F2"]) == 3 or tonumber(aconf["F2"]) == 19 then--建筑/造兵/科技/城防
					if adata[i][3] ~= 1 then
						nCanOpen = 1	
					end
				end
				adata[i][5] = nCanOpen --是否可以展开
				if nCanOpen == 1 then
					if adata[i][1] % 1000 == nindex then					
						local nid = tonumber(aconf["F3"])
						local nlv = tonumber(aconf["F4"])
						if tonumber(aconf["F2"]) == 1 then--建筑
							adata[i][6] = {}
							local aUpConfAll = CUserData:getbuildingUpgConfigAll()--建筑升级全部配置
							function  target_findUpConf(nUpid )
								local aconf = nil
								for j = 1 ,#aUpConfAll do
									if tonumber(aUpConfAll[j]["F0"] ) == nUpid then
										aconf = aUpConfAll[j]
										break
									end
								end
								return aconf
							end
							
							local aPre = {}--id,level,name
							function target_calcPre(nUpid )--查找不满足前置条件的建筑
								print("target_calcPre nUpid"..nUpid)
								local aUpConf = target_findUpConf(nUpid )
								local nid1 = tonumber(aUpConf["F2"])
								local nlv1 = tonumber(aUpConf["F3"])
								
								local nid2 = tonumber(aUpConf["F4"])
								local nlv2 = tonumber(aUpConf["F5"])
								
								local nmaxlv1 = CUserData:getBuildMaxLvByid(nid1 )
								if nmaxlv1 < nlv1 then--不满足建筑1条件
									local nfind = 0
									for j =1 ,#aPre do
										if aPre[j][1] == nid1 then
											nfind = 1
											break
										end
									end
									if nfind == 0 then
										table.insert(aPre,{nid1,nlv1})
									else
										print("err nfind:"..nfind)										
									end
									print("nid1:"..nid1)
									print("nlv1:"..nlv1)
									print("aPre 1:"..tabletostring(aPre ))
									
									if #aPre < 10 then--超过10次计算则不往下计算
										if nid1 ~= 1 then--议院则不往下计算
											target_calcPre(10000*nid1 + nlv1 )
										end
									else
										print("err #aPre >= 10")
									end
								else
									print("nmaxlv1:"..nmaxlv1)
									print("nlv1:"..nlv1)
								end
								
								local nmaxlv2 = CUserData:getBuildMaxLvByid(nid2 )
								if nmaxlv2 < nlv2 then--不满足建筑2条件
									local nfind = 0
									for j =1 ,#aPre do
										if aPre[j][1] == nid2 then
											nfind = 1
											break
										end
									end
									if nfind == 0 then
										table.insert(aPre,{nid2,nlv2})
									else
										print("err nfind:"..nfind)			
									end
									print("nid2:"..nid2)
									print("nlv2:"..nlv2)
									print("aPre 2:"..tabletostring(aPre ))
									
									if #aPre < 10 then--
										if nid2 ~= 1 then
											target_calcPre(10000*nid2 + nlv2 )
										end
									else
										print("err #aPre >= 10")
									end
								else
									print("nmaxlv2:"..nmaxlv2)
									print("nlv2:"..nlv2)
								end
								
							end
							target_calcPre(10000*nid + nlv )
							adata[i][6] = {}							
							if #aPre > 0 then
								local abuildConfAll = CUserData:getbuildingConfigAll()
								function  target_findBuildConf(nid )
									local aconf = nil
									for j =1 ,#abuildConfAll do
										if tonumber(abuildConfAll[j]["F0"] ) == nid then
											aconf = abuildConfAll[j]
											break
										end
									end
									return aconf
								end
								print("aPre:"..tabletostring(aPre ))
								for j = 1 ,#aPre do
									local aconf = target_findBuildConf(aPre[j][1] )
									local strbuildname = ""
									if aconf ~= nil then
										strbuildname = CData:GetTranlang( aconf["F1"] )
									end
									aPre[j][3] = strbuildname
									local str = string.format(CData:GetTranlang("%s升级%d级"),strbuildname,aPre[j][2] )
									table.insert(adata[i][6] ,str )
								end
							end							
							
						elseif  tonumber(aconf["F2"]) == 18 then--造兵
							adata[i][6] = {}			
							--nid 星级
							local aconfAll = CUserData:getSoldierConfigAll()
							for j = 1 ,#aconfAll do
								if ( tonumber( aconfAll[j]["F4"]) < 10 or tonumber( aconfAll[j]["F4"]) == 21 ) and tonumber( aconfAll[j]["F5"]) == nid then
									--F3 前置科技
									local nTechId = tonumber(aconfAll[j]["F3"] ) / 100
									nTechId = nTechId - nTechId % 1
									local nTechLv = tonumber(aconfAll[j]["F3"] ) % 100
									if nTechId ~= 0 then
										if CUserData:getTechByid(nTechId,2) < nTechLv then--科技不满足等级										
											local strname = CData:GetTranlang( CUserData:getTechListByid(nTechId,2) )
											local str = string.format(CData:GetTranlang("%s升级%d级"),strname,nTechLv )
											table.insert(adata[i][6] ,str )
													
											local aTechConf = CUserData:getTechUpgListByid(nTechId,nTechLv)
											if aTechConf ~= nil then
												local nbuildid = tonumber(aTechConf["F1"] )
												local nbuildlv = tonumber(aTechConf["F2"] )
												if CUserData:getBuildMaxLvByid(nbuildid ) < nbuildlv then--不满足建筑1条件
													local strbuildname = CData:GetTranlang( CUserData:getbuildingConfigByid(nbuildid,1) )
													local str = string.format(CData:GetTranlang("%s升级%d级"),strbuildname,nbuildlv )
													table.insert(adata[i][6] ,str )
												end
											end
										end									
									end
									break
								end
							end
						elseif  tonumber(aconf["F2"]) == 3 then--科技
							adata[i][6] = {}		
							local nTechId = nid
							local nTechLv = nlv
							if CUserData:getTechByid(nTechId,2) < nTechLv then--科技不满足等级										
								local strname = CData:GetTranlang( CUserData:getTechListByid(nTechId,2) )
								local str = string.format(CData:GetTranlang("%s升级%d级"),strname,nTechLv )
								--table.insert(adata[i][6] ,str )
										
								local aTechConf = CUserData:getTechUpgListByid(nTechId,nTechLv)
								if aTechConf ~= nil then
									local nbuildid = tonumber(aTechConf["F1"] )
									local nbuildlv = tonumber(aTechConf["F2"] )
									if CUserData:getBuildMaxLvByid(nbuildid ) < nbuildlv then--不满足建筑1条件
										local strbuildname = CData:GetTranlang( CUserData:getbuildingConfigByid(nbuildid,1) )
										local str = string.format(CData:GetTranlang("%s升级%d级"),strbuildname,nbuildlv )
										table.insert(adata[i][6] ,str )
									end
								end
							end	
						elseif  tonumber(aconf["F2"]) == 19 then--城防
							adata[i][6] = {}		
							--nid 星级
							local aconfAll = CUserData:getSoldierConfigAll()
							for j = 1 ,#aconfAll do
								if tonumber( aconfAll[j]["F4"]) >= 10 and tonumber( aconfAll[j]["F4"]) < 20 and tonumber( aconfAll[j]["F5"]) == nid then
									--F3 前置科技
									local nTechId = tonumber(aconfAll[j]["F3"] ) / 100
									nTechId = nTechId - nTechId % 1
									local nTechLv = tonumber(aconfAll[j]["F3"] ) % 100
									if nTechId ~= 0 then
										if CUserData:getTechByid(nTechId,2) < nTechLv then--科技不满足等级
											print("nTechId:"..nTechId)	
											local strname = CData:GetTranlang( CUserData:getTechListByid(nTechId,2) )
											local str = string.format(CData:GetTranlang("%s升级%d级"),strname,nTechLv )
											table.insert(adata[i][6] ,str )
													
											local aTechConf = CUserData:getTechUpgListByid(nTechId,nTechLv)
											if aTechConf ~= nil then
												local nbuildid = tonumber(aTechConf["F1"] )
												local nbuildlv = tonumber(aTechConf["F2"] )
												if CUserData:getBuildMaxLvByid(nbuildid ) < nbuildlv then--不满足建筑1条件
													local strbuildname = CData:GetTranlang( CUserData:getbuildingConfigByid(nbuildid,1) )
													local str = string.format(CData:GetTranlang("%s升级%d级"),strbuildname,nbuildlv )
													table.insert(adata[i][6] ,str )
												end
											end
										end									
									end
									break
								end
							end
						else
							adata[i][6] = {}
						end						
					else
						adata[i][6] = {}
					end
					if #adata[i][6] <= 0 then
						adata[i][5] = 0
					end
				else
					adata[i][6] = {}
				end
			end
		end 
		
		local arg = {adata ,atarget,nindex}
		g_target_arg = arg
		flextodiv(div_target_str,arg ,"frame_more",nil,nil,{5,"target_onloadcmp",{g_dTouchX,g_dTouchY}})
	else
		showClum({"当前目标已经全部完成了",1})	
	end
end

function target_getData()	
	local atarget = copytable( CUserData.m_aSNStageTask )	
	--测试数据
	--atarget = {1,1,0,1}	
	print("target_show atarget:"..tabletostring(atarget) )
	--读取数据表
	local aconf   = CUserData:getTaskStageByid(atarget[2] )
	if aconf ~= nil then
		--print("target_show aconf:"..tabletostring(aconf) )
		--组织数据
		local adata = {}--{目标编码,目标配置,目标完成情况,目标描述}
		local nIsDone = 1--子项完成情况
		if atarget[3] == 0 then
			nIsDone = 0
		end 
		for i = 1 ,#aconf do
			table.insert(adata,{tonumber(aconf[i]["F0"]),aconf[i],nIsDone})
		end
		
		--排序
		local function target_datasort(a , b )
			if tonumber(a[1]) < tonumber(b[1]) then    --编码从小到大排序
				return true
			elseif tonumber(a[1]) >= tonumber(b[1]) then--判断条件相同则返回false
				return false
			end
		end
		table.sort(adata,target_datasort)
		
		--判断子目标的完成情况
		--组织目标描述
		for i =1 ,#adata do
			if adata[i][1] % 1000 == 0 then
				if atarget[3] ~= 1 then
					adata[i][3] = atarget[3]--目标完成情况
				end
				adata[i][4] = CData:GetTranlang( adata[i][2]["F1"] )--目标描述
			else
				-- 1 ,2 ,4 ,8 ,16 ,32 ..
				if atarget[3] ~= 1 then
--					local a = atarget[4]
--					local b = math.pow(2,(adata[i][1] % 1000 - 1 ) )
--					print(string.format("a=%d,b=%d,c=%d",a,b,cintand(a,b)))
					if cintand( atarget[4] ,math.pow(2,(adata[i][1] % 1000 - 1 ) ) ) > 0 then -- a & b 
						adata[i][3] = 1--目标完成情况    已完成
					else
						adata[i][3] = 0--目标完成情况    未完成	
					end
				end			
				--目标描述	
				adata[i][4] = CUserData:format( { CData:GetTranlang( adata[i][2]["F1"] ) ,tonumber( adata[i][2]["F4"] ) } )
			end
			--print("target_show adata:"..i)
			--print("target_show adata:"..tabletostring(adata[i] ) )
		end
		
		return adata
	else
		return {}
	end
end

function target_onloadcmp(a)
	print("target_onloadcmp")	
	guideNew_showHotRect({1,{102}})
	guideNew_showHotRect({2,{102}})
	guideNew_showHotRect({3,{102}})
	guideNew_showHotRect({4,{102}})
	guideNew_showHotRect({5,{102}})
	guideNew_showHotRect({6,{102}})
end

function target_btnClose(a)
	print("target_btnClose")
	deldiv("frame_more","target_main")
end

function target_btnClick(a)
	print("target_btnClick")
	--判断领奖条件
	local arg = g_target_arg 
	local atarget = arg[2]
	if atarget[3] == 1 then
		g_target_ncuridBygift = atarget[2]
		httpsend( 1 , 0x013d , 0 , {CUserData.m_nUserID },"target_revMsg","httpdp_svrStatus"  )
		btnloading_show(a.pBase:getid() )
	else
		showClum({"目标未完成",1})			
	end
end

function target_revMsg(ntype , nseqno , nret , arg )--0x013d
	print("ntype: nseqno: nret: arg:",ntype,nseqno,nret,tabletostring(arg))
	http_getdata(ntype , nseqno , nret , arg)
	btnloading_del("target_btnGetGift")
	
	if nret ~= 0 then 	
		return 
	end 
	table.insert(arg,1,nret)
	
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s target_revMsg" , ntype , nseqno , nret, tabletostring(arg) ) )
	--数据刷新
	CUserData:onTakeStageTaskBonus(arg)
	--界面刷新
	
	--新手阶段发送记录信息
	if g_target_ncuridBygift < 7 then --1 ~6
		local str = string.format("4|t_stage_%d",g_target_ncuridBygift)
		conenttosocial(9 , str )--9 统计信息 conent:[登陆游戏: "1|0"],[充值成功: "2|充值额度(美金)"],[主城升级:"3|主城当前等级"],[引导:4|t_stage_0]
		print("conenttosocial 9 str:"..str)
	end
end

function target_btnItemClick(a)	
	local nindex = tonumber(a.pBase:getts() )
	print("target_btnItemClick nindex:"..nindex)
	local arg = g_target_arg
	local adata = arg[1]
	local atarget = arg[2]
	local nindexArg = arg[3]
	if adata[nindex] ~= nil then
		if adata[nindex][3] ~= 1 then--未完成
			local nid = atarget[2] * 1000 + nindex
			local aconf = CUserData:getTaskStageConf(nid)
			if aconf ~= nil then
				--F2类型,F3参数
				local ntype = tonumber(aconf["F2"] )
				local narg1 = tonumber(aconf["F3"] )
				local narg2 = tonumber(aconf["F4"] )
				if ntype ~= nil and narg1 ~= nil and narg2 ~= nil then
					if ntype == 1 then--升级建筑
					
					elseif ntype == 3 then--科技升级
					
					elseif ntype == 5 then--英雄提升到XX
					
					elseif ntype == 6 then--升级装备
					
					elseif ntype == 12 then--采集任意资源
					
					elseif ntype == 13 then--主公改名
					
					elseif ntype == 14 then--杀伤敌军城防战斗力{0}
					
					elseif ntype == 15 then--科技战斗力达到{0}
					
					elseif ntype == 16 then--镶嵌任意{0}颗宝石
					
					elseif ntype == 17 then--石料产量达到XX
					
					elseif ntype == 18 then--训练兵
					
					elseif ntype == 19 then--建造任意1星城防XX
					
					elseif ntype == 20 then--任意兵种科技达到XX
					
					elseif ntype == 21 then--采集   去掉了				
					
					end
				end				
			end	
		end
	end	
	
	if nindexArg ~= nindex then
		target_show(nindex )
	end
end

function target_ref()
	local div = getid2("main","target_main")
	if div ~= nil then
		local arg = g_target_arg 
		target_show(arg[3] )
	end
		
	target_showLightTimerSet()
	target_checkBtnTargetRight()
end

local g_target_showLightCount = 0
local g_target_showLightFlag  = 0

function target_showLightTimerSet()--主城目标图标的闪烁
	g_target_showLightCount = 0
	g_target_showLightFlag  = 0
	target_showLightTimer()
end

function target_showLight()
	local btn = getid2("city_main","city_btnTarget")
	if btn ~= nil then
		if g_target_showLightFlag == 0 then
			btn:setdowned("false")
		else
			btn:setdowned("true")
		end
	end
end

function target_showLightTimer()
	if g_target_showLightFlag == 1 then
		g_target_showLightFlag = 0 
	else
		g_target_showLightFlag = 1
	end
	if g_target_showLightCount > 20 then
		g_target_showLightFlag = 0
		target_showLight()
	else
		g_target_showLightCount = g_target_showLightCount + 1
		
		target_showLight()
		
		settimer(TIMER_ID_TARGET_lIGHT,0.1*1000,"target_showLightTimer",1)
	end
end

	
function target_checkBtnTargetRight()
	local div = getid2("main","city_btnTarget_right")
	if div ~= nil then
		if CUserData.m_aSNStageTask[3] == 1 then--确认目标系统状态是否其中有完成的, 1:全部完成
			if target_getEnabled() == 1 then
				div:sethidden(0)
				
				city_QBtnLight("city_btnTargetCanvas",1,"city_main")--ntype 1,开始闪烁，0 结束
			end
		else
			div:sethidden(1)
			
			city_QBtnLight("city_btnTargetCanvas",0,"city_main")--ntype 1,开始闪烁，0 结束
		end	
	end
end	

--询问某个推荐任务是否关联 当前目标及之前目标系统的子项
--返回 1 有关联, 0 非
function target_checkTaskExist(ntaskid )
--	if 1 == 1 then
--		return
--	end
	print("target_checkTaskExist ntaskid:"..ntaskid )
	if guideNew_getMode() > 6 then --
		return 1
	end
	local atarget = copytable( CUserData.m_aSNStageTask )
	--读取数据表
	local aTaskId = {}
	if atarget[2] > 0 then
		for i = atarget[2] , 0 , -1 do
			local aconf = CUserData:getTaskStageConf( i * 1000 )
			if aconf ~= nil then
				print("target_checkTaskExist aconf:"..tabletostring(aconf) )
				local str   = aconf["F6"]
				print("target_checkTaskExist i:"..i)
				print("target_checkTaskExist str:"..str)			
				local arg 	= string.split( str,"|" )			
				for j = 1 ,#arg do
					local nid = tonumber(arg[j] ) 
					if nid ~= nil then
						table.insert(aTaskId,nid)
					end
				end
			end
		end
	end
	local nfind = 0
	for i = 1 ,#aTaskId do
		if aTaskId[i] == ntaskid then
			nfind = 1
			break
		end
	end
	print("target_checkTaskExist nret:"..nfind)
	return nfind
end

function target_btnTipClick(a)
	print("target_btnTipClick ")
	local arg = g_target_arg
	local atarget = arg[2]
	local nid = atarget[2] * 1000
	local aconf = CUserData:getTaskStageConf(nid)
	if aconf ~= nil then
		print("target_btnTipClick f5:"..aconf["F5"])
		local aGift = CUserData:getAwardTableByStr(aconf["F5"] )
		if #aGift > 0 then
			g_dTouchX,g_dTouchY=a.dTouchX,a.dTouchY
			tip3_show(aGift )
		end
	end
end

