--运送资源
local div_freight_str = [[<mx:Canvas id="freightdiv" systemload="1" width="720" height="1280" onloadcmp="freight_cmp"  mouseThrough="false">
	<mx:Image source="assets/images/bg04.jpg" width="720" height="1168" y="91"/>
	
	<mx:Image source="assets/images/block01Xq.png" y="111" x="6"/>
	{local str = string.format(CData:GetTranlang("城市等级：%d"),arg[2])}
	<mx:Label text="${str}" fontSize="22" styleName="white01" y="230" x="84"/>
	{local str = "运送上限：%s"
	if arg[1] == 1 then
		str = "需求上限：%s"
	end
	}
	<mx:Label text="${string.format(CData:GetTranlang(str),CUserData:getNumStr( arg[3] ,1))}" fontSize="22" styleName="white01" y="181" x="84"/>
	
	<mx:Image visible="${(arg[1] == 1 and 'false' or 'true')}" source="assets/images/bar01Xq.png" y="219" x="440"/>
	{local str = string.format(CData:GetTranlang("税率：%0.1f%%"),arg[4]*100)}
	<mx:Label visible="${(arg[1] == 1 and 'false' or 'true')}" text="${str}" fontSize="22" styleName="white01" y="229" x="502"/>
	
	<mx:VBox verticalGap="0" x="35" y="287">
		{for _,v in pairs(arg[5]) do}
		<mx:Canvas id="freightitem_${v.id}" width="645" height="177"  setts="${v.id}">
			<mx:Image source="assets/images/line01.png" y="174"/>
			<mx:Image source="${v.img}" y="15" x="30"/>
			{local str = (arg[1] == 1 and "需求：" or "实际运送：")}
			<mx:Label text="${str}" fontSize="24" styleName="brown01" x="247" y="24" width="215" textAlign="right"/>
			
			<mx:Image source="assets/images/sliderBar01.png" x="174" y="91"/>
			<mx:Button styleName="btnAdd01" x="158" y="78" setts="1|${v.id}" onclick="freightItem_click"/>
			<mx:Button styleName="btnAdd02" x="590" y="78" setts="2|${v.id}" onclick="freightItem_click"/>
			<mx:Button id="freight_dragBtn" styleName="btn01Slider" y="66" x="${v.x}"/><!-- x坐标从197到537-->
			<mx:Canvas width="433" height="70" x="178" y="65" setts="${v.id}" onbegin="freight_move"  onend="freight_move" onmove="freight_move" mouseThrough="true" backgroundColor="0x000000" backgroundAlpha="0"/>
			<mx:Image source="assets/images/bg02Input.png" x="470" y="17"/>
			<mx:TextInput keyboardtype="2" clickclear="true" id="freight_dragInput${v.id}"  autorow="false" height="37" setts="${v.id}" mouseThrough="false" text="${v.sel}" width="145" styleName="white01" fontSize="24" x="478" y="26" textAlign="center"/>
			{local str = string.format(CData:GetTranlang("拥有：%s"),CUserData:getNumStr( v.cur ,1))}
			<mx:Label text="${str}" fontSize="24" styleName="brown02" x="22" y="126"/>
			{local str = string.format(CData:GetTranlang("扣税：%s"),CUserData:getNumStr( math.floor(v.sel*arg[4]/(1 - arg[4])) ,1))}
			<mx:Label id="freight_taxtext" visible="${(arg[1] == 1 and 'false' or 'true')}" text="${str}" fontSize="24" styleName="brown02" x="416" y="126" width="214" textAlign="right"/>
		</mx:Canvas>
		{end}
	</mx:VBox>
	
	<mx:Image source="assets/images/bar01.png" y="1179" x="0"/>
	<mx:Button styleName="btn05" label="取消" y="1194" x="137" setts="1" onclick="freight_click"/>
	{local str = (arg[1] == 1 and "需求" or "运送")}
	<mx:Button styleName="btn05" label="${str}" y="1194" x="412" setts="2" onclick="freight_click"/>
	<mx:Canvas width="720" height="112">
		<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
		<mx:Label id="frameTop_txt" text="${str}" width="720" textAlign="center" y="35"/>
		<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" onclick="freight_btnCloseClick"/>
	</mx:Canvas>
</mx:Canvas>]]


local freightDragConfig = 
{
	offsetx = 41,
	left   	= 197,
	right   = 537,
	len		= 537-197
}
local freight_arg = nil
local freight_data = nil
local freight_rate = nil
local freight_max = nil
local freight_curdragID = nil
function freight_show(arg,t,aim)--arg需求时为nil, --t==1世界/2联盟/3好友/4讨论组,aim聊天对象，目前参数可以不传
	if (getMapServiceid() == -1 and getMapState() ==0) or (getMapServiceid() == 0 and getMapState() ==1) then
		showClue("在跨服战场中，不能使用该功能。")
		return
	end
	freight_arg = arg
	local citylv   = CUserData:getBuildMaxLvByid(1)
	local cityconfig = CUserData:getFreightByCityLv(citylv)
	if arg == nil then
		freight_max = tonumber(cityconfig["F3"]) -- 最大需求数量
	else
		freight_max = tonumber(cityconfig["F2"]) -- 最大运送数量
	end
	print("---------",CUserData:getNumStr( freight_max ,1),freight_max)
	freight_rate = tonumber(cityconfig["F1"])/1000 --税率
	freight_data = {(arg == nil and 1 or 2),citylv,freight_max,freight_rate}
	
	local res = {}
	local total = 0--当前选择总合
	for i = 1,5 do
		local cur--当前拥有
		local sel--当前选择
		local max--单项最大可选,固定值
		local canmax--当前最大可选，可变
		local x--滑块坐标
		local img = CUserData:getResourceIco(i)
		if arg == nil then
			cur = CUserData:getResourceValue(i)
			sel = 0
			max = freight_max
			canmax = freight_max - total
		else
			local demand = freight_arg[i + 2]
			cur = CUserData:getResourceValue(i)
			max = math.floor(cur*(1 - freight_rate))--math.min(demand,math.floor(cur*(1 - freight_rate)))
			canmax = math.min(max,freight_max - total)
			sel = math.min(canmax,demand)--canmax
		end
		total = total + sel
		x = freight_getDragBtnX(sel,canmax)
		table.insert(res,{id=i,cur=cur,sel=sel,max=max,canmax=canmax,x=x,img=img})
	end
	table.insert(freight_data,res)
	print("freight_show",tabletostring(freight_data))
--	flextodiv(div_freight_str,freight_data,"frame_more")
	freight_refush()
end

function freight_refush()
	local total = 0--当前选择总合
	for i,v in pairs(freight_data[5]) do
		print("sel::",i,v.sel)
		total = total + v.sel
	end
	for _,v in pairs(freight_data[5]) do
		v.canmax = math.min(v.max,freight_max - total + v.sel)
		v.x = freight_getDragBtnX(v.sel,v.canmax)
	end
	print("freight_show",tabletostring(freight_data))
	flextodiv(div_freight_str,freight_data,"frame_more")
end

function freight_getDragBtnX(sel,max)
	if max <= 0 then
		return freightDragConfig.left
	else
		return (sel/max)* (freightDragConfig.right - freightDragConfig.left) + freightDragConfig.left
	end
end

function freight_move(a)
	
	if a.nType==DE_LISTEN_TOUCH_BEGIN then
		print("begin",freight_curdragID,a.pBase:getts())
		freight_curdragID = tonumber(a.pBase:getts())		
	elseif a.nType==DE_LISTEN_TOUCH_MOVE then
		print("move",freight_curdragID,a.pBase:getts())
		if freight_curdragID==tonumber(a.pBase:getts()) and freight_data[5][freight_curdragID].canmax > 0 then
			local div = getid2("freightitem_"..freight_curdragID,"freight_dragBtn")
			if div ~= nil then
				local arg = freightDragConfig
				local divWidth = div:w()/2
				local x = a.dTouchX-main_get_xoffset()-arg.left-arg.offsetx-divWidth
				x=math.min(math.max(x,0),arg.len)
				div:sx(x+arg.left)
				local value = math.ceil(freight_data[5][freight_curdragID].canmax * x / arg.len)
				freight_setDragTextValue(freight_curdragID,value)
				freight_setTaxTextValue(freight_curdragID,value)
			end
		end	
	elseif a.nType== DE_LISTEN_TOUCH_END then
		print("end",freight_curdragID,a.pBase:getts())
		if freight_curdragID==tonumber(a.pBase:getts()) then
			a.nType = DE_LISTEN_TOUCH_MOVE
			freight_move(a)
			freight_refush()
			freight_curdragID = 0
		end
	end
end

function freight_setDragTextValue(id,value)
	local input = getid2("freightdiv","freight_dragInput"..id)
	if input ~= nil then
		freight_data[5][id].sel = value
		input:changetext(value)
	end
end

function freight_setTaxTextValue(id,value)
	local text = getid2("freightitem_"..id,"freight_taxtext")
	if text ~= nil then
		text:changetext((string.format(CData:GetTranlang("扣税：%s"),CUserData:getNumStr( math.floor(value*freight_rate/(1 - freight_rate)) ,1))))
	end
end


function freight_cmp(arg)
	for i = 1,5 do
		local input = getid2("freightdiv","freight_dragInput"..i)
		if input ~= nil then 
			input:addlisten("freight_inputEventBack",DE_LISTEN_KEY_INPUT)
		end
	end
end

function freight_inputEventBack(a)
	print("freight_inputEventBack::",a.nActionType)
	if a.nActionType == 1 then--展开
			
	elseif a.nActionType == 2 then--关闭
		local id=tonumber(a.pBase:getts())
		local value=tonumber(a.pBase:gettext())
		if value==nil then
			value=0
		end
		local v = freight_data[5][id]
		value=math.min(math.max(0,value),v.canmax)
		v.sel = value
		print("freight_inputEventBack value=",value)
		freight_refush()
	end
end

function freightItem_click(a)
	local arr = string.split(a.pBase:getts(),"|")
	local t = tonumber(arr[1])
	local id = tonumber(arr[2])
	if t == 1 then
		local v = freight_data[5][id]
		v.sel = 0
		
		freight_refush()
	elseif t == 2 then
		local v = freight_data[5][id]
		v.sel = v.canmax
		
		freight_refush()
	end
end

function freight_btnCloseClick()
	deldiv("frame_more","freightdiv")
end

function freight_click(a)
	local t = tonumber(a.pBase:getts())
	if t == 1 then
		freight_btnCloseClick()
	elseif t == 2 then
		local exist = false
		local arg = {CUserData.m_nUserID}
		if freight_arg then
			table.insert(arg,freight_arg[1])
		end
		for _,v in pairs(freight_data[5]) do
			if v.sel > 0 then
				exist = true
			end
			table.insert(arg,v.sel)
		end
		if exist == false then
			showClue("请选择资源")
			return
		end
		print("freight_click::",freight_data[5])
		btnloading_show()
		if freight_arg then
			httpsend( 1 , 0x0151 , 0 , arg,"freight_Back"  )
		else
			httpsend( 1 , 0x0150 , 0 , arg,"freight_requstBack"  )
		end
	end
end

--需求
function freight_requstBack(ntype , nseqno , nret , arg)
	btnloading_del()
	if nret ~= 0 then --表示处理消息失败
		return
	end
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s httpdp_revMsgLogin" , ntype , nseqno , nret, tabletostring(arg) ) )
--	showClue("成功发送需求")
	freight_btnCloseClick()
end

--运送
function freight_Back(ntype , nseqno , nret , arg)
	btnloading_del()
	if nret ~= 0 then --表示处理消息失败
		return
	end
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s httpdp_revMsgLogin" , ntype , nseqno , nret, tabletostring(arg) ) )
--	showClue("运送中...")
	freight_btnCloseClick()
end



--资源运送通知
function freight_inform(arg)
	local v = nil
--	1=资源需求
--	2=资源运送
	table.remove(arg,1)
	local str = ""
	local res = {}
	if arg[2] == 1 then
		str = CData:GetTranlang("我急缺一些资源：")
	else
		if arg[12] == CUserData.m_nUserID then
			str = string.format(CData:GetTranlang("我给%s送去了:"),arg[4])
		else
			str = string.format(CData:GetTranlang("%s给%s送去了:"),arg[13],arg[4])
		end
	end
	
	
	for i=1,5 do
		res[i] = {i,arg[19 + i],CUserData:getResourceName(i)}
	end
	
	if arg[2] == 1 then
		v = {1,2,0,{{"res",1,arg[1],arg[3],arg[4],arg[5],arg[6],arg[7],arg[9],arg[10],str,res=res,userid=arg[3]}}}
	else
		v = {1,2,0,{{"res",2,arg[1],arg[12],arg[13],arg[14],arg[15],arg[16],arg[18],arg[19],str,res=res,userid=arg[12]}}}
	end
	if v ~= nil then
		chatlink_showdata(copytable(v))--两者的不同，chatlink_getdata中有存储消息
		flchat_showdata(copytable(v))
	end
end

function freight_giveres(a)
	local arr = string.split(a.pBase:getts(),"|")--送给对象的[玩家编号，名字，五个资源]
	arr[1] = tonumber(arr[1])
	arr[3] = tonumber(arr[3])
	arr[4] = tonumber(arr[4])
	arr[5] = tonumber(arr[5])
	arr[6] = tonumber(arr[6])
	arr[7] = tonumber(arr[7])
	print("freight_giveres::",tabletostring(arr))
	freight_show(arr)
end
