local div_unionHelp_str = [[
<mx:Canvas id="div_unionHelp_id" xmlns:mx="http://www.adobe.com/2006/mxml" width="720" height="1280">
	<mx:Canvas width="720" height="112">
		<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
		<mx:Label id="frameTop_txt" text="帮助" width="720" textAlign="center" y="35"/>
		<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" setts="4" onclick="unionHelpClose_btnClick"/>
	</mx:Canvas>
	{local build,tech,other=arg[1],arg[2],arg[3]}
	<mx:Image source="assets/images/bg04.jpg" width="720" height="1168" x="0" y="111"/>
	<mx:Image source="assets/images/bar06.png" x="7" y="111"/>
	<mx:HBox horizontalCenter="0" y="112">
		<mx:Image source="assets/images/ico2_allyGongxian.png"/>
		<mx:Label text="联盟点数：" fontSize="30" styleName="white02" y="10" textAlign="right"/>
		<mx:Label text="${CUserData.m_nAllyPoint}" styleName="green01" fontSize="30" y="13"/>
	</mx:HBox>
	<mx:Text fontSize="20" styleName="brown02" text="Help功能在于帮助你更快的建造建筑和研发科技，同时希望你能更多的帮助你的盟友进行这项操作，当你完成这项操作时我们还会奖励你一些联盟贡献点数，你可以用他们来购买联盟商城中的道具。" x="57" y="201" width="600"/>
	<mx:Image source="assets/images/bar06.png" x="7" y="313"/>
	<mx:Image source="assets/images/ic01Help.png" x="25" y="313"/>
	<mx:Label text="我的需求" fontSize="30" styleName="white02" x="84" y="324"/>
	{if build ~= 0 then}
	<mx:Image source="assets/images/progBg05.png" x="104" y="393"/>
	<mx:Canvas width="465" height="31" x="111" y="399">
		<mx:Canvas width="${build[4]}" height="31" styleName="prog03"/>
		<mx:Label text="${build[1]}" styleName="white01" fontSize="22" x="10"/>
		<mx:Label text="${build[2]}/${build[3]}" styleName="white01" fontSize="22" right="20"/>
	</mx:Canvas>
	{end}
	{if tech ~= 0 then}
	<mx:Image source="assets/images/progBg05.png" x="104" y="455"/>
	<mx:Canvas width="465" height="31" x="111" y="461">
		<mx:Canvas width="${tech[4]}" height="31" styleName="prog03"/>
		<mx:Label text="${tech[1]}" styleName="white01" fontSize="22" x="10"/>
		<mx:Label text="${tech[2]}/${tech[3]}" styleName="white01" fontSize="22" right="20"/>
	</mx:Canvas>
	{end}
	{if build ==0 and tech == 0 then}
		<mx:Label text="无记录" fontSize="30" styleName="brown02" x="100" y="393"/>
	{end}
	<mx:Image source="assets/images/bar06.png" x="7" y="533"/>
	<mx:Image source="assets/images/ic02Help.png" x="30" y="539"/>
	<mx:Label text="盟友的需求" fontSize="30" styleName="white02" x="84" y="544"/>
	<mx:Canvas y="613" height="550" setslidetype="1">
		<mx:VBox verticalGap="15" verticalScrollPolicy="off" mouseChildren="false" mouseThrough="true">
			{for i = 1 , #other do}
			<mx:Canvas id="item_${other[i][5]}" height="80">
				<mx:Image source="assets/images/headerBg02.png" x="64" bottom="0" mouseThrough="true"/>
				<mx:Image source="assets/role/big/${other[i][6]}.png" width="61" height="63" x="69" bottom="7"/>
				<mx:Image source="assets/union/small/rank${other[i][7]}.png" x="164" y="-2" width="40" height="40"/>
				<mx:Label text="${other[i][8]}" styleName="brown02" fontSize="22" x="220" y="5"/>
				<mx:Image source="assets/images/progBg05.png" x="164" y="36"/>
				<mx:Canvas width="465" height="70" x="172" y="41">
					<mx:Canvas id="pro" width="${other[i][4]}" height="31" styleName="prog05"/>
					<mx:Label text="${other[i][1]}" styleName="white01" fontSize="22" x="10"/>
					<mx:Label id="text" text="${other[i][2]}/${other[i][3]}" styleName="white01" fontSize="22" right="20"  y="5"/>
				</mx:Canvas>
			</mx:Canvas>
			{end}
		</mx:VBox>	
	</mx:Canvas>
	{if #other ==0 then}
		<mx:Label text="无记录" fontSize="30" styleName="brown02" x="100" y="613"/>
	{end}
	<mx:Image source="assets/images/bar01.png" y="1180"/>
	{if g_main_apptype == 1 then }
		<mx:Button id="btn" styleName="btn08" setts="${(#other)}" label="${(#other == 0 and "닫기" or "执行")}" y="1200" x="192" onclick="unionHelp_btnClick"/>
	{else}
		<mx:Button id="btn" styleName="btn08" setts="${(#other)}" label="${(#other == 0 and "Close" or "执行")}" y="1200" x="192" onclick="unionHelp_btnClick"/>
	{end}
</mx:Canvas>
]]

function unionHelpClose_btnClick(a)
	deldiv("frame_more","div_unionHelp_id")
	
	unionUserActivity_checkReShow() 
end

local unionList={}

local function getMSGTable(userid ,username, type,id,level,cur,total,time,img,rank)
	local name = ""
	if type == 1 then
		if level == 0 then --拆除
			name = string.format(CData:GetTranlang("%s 拆除"),CData:GetTranlang(CUserData:getbuildingConfigByid(id,1)))
		else
			name = string.format(CData:GetTranlang("%s %d → %d"),CData:GetTranlang(CUserData:getbuildingConfigByid(id,1)),level - 1,level)
		end
	elseif type == 2 then
		local teahname = CData:GetTranlang(CUserData:getTechListByid(id , 2))
		if teahname ~= nil then
			name = string.format(CData:GetTranlang("%s %d → %d"),teahname,level - 1,level)
		else
			print("科技有问题：",userid ,username, type,id,level,cur,total,time,img,rank)
			name = string.format(CData:GetTranlang("tech %d → %d"),level - 1,level)
		end
	end
	per=cur/total*(img == "" and 465 or 465)
	print(name,cur,total,per , userid.."_"..type)
	return {name,cur,total,per , userid.."_"..type,img,rank,username}
end


function unionHelp_show()
--	CUserData.m_nUnionHelp={0,24,2,3,8,1385851245, 102,4,0,9,1385851245 ,{{1,"fx",2,2,104,4,4,8,1385851245},{2,"fx",5,1,25,4,4,8,1385851245},
--	{1,"fx",2,2,104,4,4,8,1385851245},{2,"fx",5,1,25,4,4,8,1385851245},
--	{1,"fx",2,2,104,4,4,8,1385851245},{2,"fx",5,1,25,4,4,8,1385851245},
--	{1,"fx",2,2,104,4,4,8,1385851245},{2,"fx",5,1,25,4,4,8,1385851245},
--	{1,"fx",2,2,104,4,4,8,1385851245},{2,"fx",5,1,25,4,4,8,1385851245},
--	{1,"fx",2,2,104,4,4,8,1385851245},{2,"fx",5,1,25,4,4,8,1385851245},
--	{1,"fx",2,2,104,4,4,8,1385851245},{2,"fx",5,1,25,4,4,8,1385851245},
--	{1,"fx",2,2,104,4,4,8,1385851245},{2,"fx",5,1,25,4,4,8,1385851245},
--	{1,"fx",2,2,104,4,4,8,1385851245},{2,"fx",5,1,25,4,4,8,1385851245},
--	{1,"fx",2,2,104,4,4,8,1385851245},{2,"fx",5,1,25,4,4,8,1385851245}}}--测试
	local arg = copytable(CUserData.m_nUnionHelp)
--1结果
--2具体建筑编号
--3具体建筑等级
--4已被帮助次数
--5最大帮助次数
--6截止时间
--7具体科技编号
--8具体科技等级
--9已被帮助次数
--10最大帮助次数
--11截止时间
--12记录数
--{
--1主公编号
--2主公名称
--3联盟官职
--4队列类型
--5具体编号
--6具体等级
--7已被帮助次数
--8最大帮助次数
--9截止时间
--}
	print("unionHelp_show::",tabletostring(arg))
	local t1= 0 
	if arg[2] ~= 0 then
		t1 = getMSGTable(CUserData.m_nUserID,"",1,arg[2],arg[3],arg[4],arg[5],arg[6],"",0)
	end
	local t2 = 0
	if arg[7] ~= 0 then
		t2 = getMSGTable(CUserData.m_nUserID,"",2,arg[7],arg[8],arg[9],arg[10],arg[11],"",0)
	end
	unionList=arg[12]
	for i=1 , #unionList do
		print("-------",i)
		unionList[i] = getMSGTable(unionList[i][1] ,unionList[i][2],unionList[i][4],unionList[i][5],unionList[i][6],unionList[i][7],unionList[i][8],unionList[i][9],unionList[i][10],unionList[i][3])
	end
	flextodiv(div_unionHelp_str,{t1,t2,unionList},"frame_more")
end


function AllyHelpHelp()
	btnloading_show("div_unionHelp_id",320,1200)
	btn = getid2("div_unionHelp_id","btn")
	if btn then
		btn:enabled('false')
	end
	httpsend( 1 , 0x00000148 , 0 , {CUserData.m_nUserID},"InvitationActionBack2","httpdp_svrStatusLogin"  )
end

function InvitationActionBack2(ntype , nseqno , nret , arg)
	http_getdata(ntype , nseqno , nret , arg)
	print(string.format("httpdp_revMsgLogin ntype:%x ：nseqno:%d nret:%d",ntype , nseqno , nret) )
	
	btnloading_del("div_unionHelp_id")
	btn = getid2("div_unionHelp_id","btn")
	if btn then
		btn:enabled('true')
	end
	if nret ~= 0 then --表示处理消息失败
		return
	end
	table.insert(arg,1,nret)
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s httpdp_revMsgLogin" , ntype , nseqno , nret, tabletostring(arg) ) )
	
--结果
--被帮助主公编号
--队列类型
	--CUserData:updateUnionHelp({0,1,arg[2],0,0,arg[3]})
	--deldiv("div_unionHelp_id","item_"..arg[2].."_"..arg[3])
	--showClum({"帮助成功",1})
	
	CUserData.m_nAllyPoint=arg[2]
	
	CUserData.m_nUnionHelp[12] = arg[4]
	unionHelp_show()
	queue_refrushHelp()
end

function unionHelp_btnClick(a)
	local t = tonumber(a.pBase:getts())
	if t == 0 then
		unionHelpClose_btnClick()
	else
		--for _,v in pairs(CUserData.m_nUnionHelp[12]) do
			AllyHelpHelp()
		--end
	end
end

function unionHelp_refush(t,arg)--0更新，1新增，2删除
	print("unionHelp_refush::",t,tabletostring(arg))
	if getid2("frame_more","div_unionHelp_id") then
		if t == 0 then
			local div = getid2("div_unionHelp_id","item_"..arg[1].."_"..arg[4])
			if div then
				local v = getMSGTable(arg[1] ,arg[2],arg[4],arg[5],arg[6],arg[7],arg[8],arg[9],arg[10],arg[3])
				getid2("item_"..arg[1].."_"..arg[4],"pro"):sw(v[4])
				getid2("item_"..arg[1].."_"..arg[4],"text"):changetext(v[2].."/"..v[3])
			end
		elseif t == 1 then
			unionHelp_show()
		elseif t == 2 then
			unionHelp_controlbtn(arg)
			deldiv("div_unionHelp_id","item_"..arg[1].."_"..arg[4])
			
		end
	end
end


function unionHelp_controlbtn(arg)
	local help = copytable(CUserData.m_nUnionHelp[12])
	for i,v in pairs(help) do
		if v[1] == arg[1] and v[4] == arg[4] then
			table.remove(help,i)
			break
		end
	end
	local btn = getid2("div_unionHelp_id","btn")
	if btn then
		btn:setts(#help)
		if g_main_apptype == 1 then 
			btn:changetext((#help == 0 and "닫기" or "执行"))
		else 
			btn:changetext((#help == 0 and "Close" or "执行"))
		end
	end
end