--申请信息
local div_unionMessage_str = [[
	<mx:Canvas id="div_unionMessage_id" width="720" height="1280">
		<mx:Canvas width="720" height="112">
			<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
			<mx:Label id="frameTop_txt" text="申请" width="720" textAlign="center" y="35"/>
			<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" setts="4" onclick="unionMessageClose_btnClick"/>
		</mx:Canvas>
		<mx:Image source="assets/images/bg02.jpg" width="720" height="990" x="0" y="111"/>
		<mx:Image source="assets/images/bar06.png" x="7" y="111"/>
		<mx:Label text="需要回复的信息" fontSize="30" styleName="white02" x="100" y="122" width="500" textAlign="center"/>
		<mx:Button enabled="${arg.select}" mouseEnabled="1" styleName="check01" x="45" y="182" onclick="unionMessageSelectAll_btnClick"/>
		<mx:Label text="名称" styleName="white03" fontSize="24" x="182" y="191"/>
		<mx:Label text="城市等级" styleName="white03" fontSize="24" x="366" y="191"/>
		<mx:Label text="战斗力" styleName="white03" fontSize="24" x="559" y="191"/>
		<mx:Canvas x="17" y="234" width="685" height="760" setslidetype="1">
		<mx:VBox verticalGap="0" verticalScrollPolicy="off">
			{for i=1 , #arg do}
				<mx:Canvas width="685" height="85">
					<mx:Image source="assets/images/block14.png" x="0" y="0" mouseThrough="true"/>
					<mx:Canvas backgroundColor="0xFFFFFF" x="0" y="0" width="685" height="85" alpha="0" mouseThrough="true" onbegin="clickEffectShow" onend="clickEffectHide"/>
					<mx:Button enabled="${arg[i].select}" mouseEnabled="1" setts="${arg[i][2]}" onclick="unionMessageSelect_btnClick" styleName="check01" x="27" y="18"/>
					<mx:Label text="${arg[i][3]}" fontSize="24" styleName="black03" x="96" y="25" mouseThrough="true"/>
					<mx:Label text="${arg[i][8]}" fontSize="24" styleName="green01" x="376" y="25" textAlign="center" width="50" mouseThrough="true"/>
					<mx:Label text="${arg[i][6]}" fontSize="24" styleName="black03" x="513" y="25" width="142" textAlign="center" mouseThrough="true"/>
					
					<mx:Canvas x="96" y="0" width="588" height="85" mouseThrough="true"  setts="${arg[i][2]}" onclick="unionMessagelock_btnClick"/>
				</mx:Canvas>
			{end}
		</mx:VBox>
		<mx:Label text="当前没有申请信息！" visible="${(#arg==0 and 1 or 0)}" fontSize="26" styleName="white03" horizontalCenter="0" verticalCenter="0" width="500" textAlign="center"/>
		</mx:Canvas>
		<mx:Image source="assets/images/bar01.png" y="1000"/>
		{local str = string.format(CData:GetTranlang("已选：%d/%d"),arg.cur,arg.total)}
		<mx:Label text="${str}" styleName="green01" y="1030" fontSize="24" x="73"/>
		<mx:Button label="通过" styleName="btn03" y="1020" x="244" onclick="unionMessagePass_btnClick"/>
		<mx:Button label="拒绝" styleName="btn04" y="1020" x="452" onclick="unionMessageReject_btnClick"/>
	</mx:Canvas>
]]

function unionMessageClose_btnClick(a)
	deldiv("main","div_unionMessage_id")
end

function unionMessage_show()
	local t={}
	t.select="true"
	t.cur=0
	t.total=0
	flextodiv(div_unionMessage_str,t,"frame_more")
	unionApplicationAction(0,0)
end	
--
function unionApplicationAction(action,userID)
	btnloading_show("frame_top",360-20,640-50)
	httpsend( 1 , 0x00000117 , 0 , {CUserData.m_nUserID,action,userID},"unionApplicationActionBack","httpdp_svrStatusLogin"  )
end

local userList={}
function unionApplicationActionBack(ntype , nseqno , nret , arg)
	btnloading_del("frame_top")
	http_getdata(ntype , nseqno , nret , arg)
	print(string.format("httpdp_revMsgLogin ntype:%x ：nseqno:%d nret:%d",ntype , nseqno , nret) )
	if nret ~= 0 then --表示处理消息失败
		return
	end
	table.insert(arg,1,nret)
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s httpdp_revMsgLogin" , ntype , nseqno , nret, tabletostring(arg) ) )
	
--结果
--操作类型
--申请总数
--记录数量
--{
--申请时间
--主公编号
--主公名称
--主公头像
--VIP等级
--主公战力
--主公击杀
--城池等级
--}
	for i=1,#arg[4] do
		arg[4][i][7] = CUserData_tranTotalKill(arg[4][i][7] )
	end
	userList=arg[4]
	userList.select="true"
	userList.cur=0
	userList.total=#userList
	for i=1 , #userList do
		userList[i].select="true"
	end
	flextodiv(div_unionMessage_str,userList,"frame_more")
end

function unionMessageSelect_btnClick(a)
	local div=a.pBase
	local id=tonumber(div:getts())
	for i=1 , #userList do
		if userList[i][2]==id then
			if userList[i].select=="true" then
				userList[i].select="false"
				userList.cur=userList.cur+1
--				div:enabled("false")
			else
				userList[i].select="true"
				userList.cur=userList.cur-1
--				div:enabled("true")
			end
		end
	end
--	div:setmouseenabled(1)
	flextodiv(div_unionMessage_str,userList,"frame_more")
end	

function unionMessageSelectAll_btnClick(a)
	local div=a.pBase
	div:setmouseenabled(0)
	if userList.select=="true" then
		userList.select="false"
		userList.cur=userList.total
	else
		userList.select="true"
		userList.cur=0
	end
	for i=1 , #userList do
		userList[i].select=userList.select
	end
	flextodiv(div_unionMessage_str,userList,"frame_more")
end	

function unionMessagePass_btnClick(a)
	for i=1 , #userList do
		if userList[i].select=="false" then
			unionApplicationAction(1,userList[i][2])
		end
	end
end	

function unionMessageReject_btnClick(a)
	for i=1 , #userList do
		if userList[i].select=="false" then
			unionApplicationAction(2,userList[i][2])
		end
	end
end	

function unionMessagelock_btnClick(a)
	local id=tonumber(a.pBase:getts())
	power_show(id)
end