--加入联盟
local div_unionvote_str = [[
<mx:Canvas width="720" height="1280" id="unionvotediv" onloadcmp="unionvote_cmp">
	<mx:Image source="assets/images/bg04.jpg" width="720" height="1168" y="111" x="0"/>
	<mx:Image source="assets/images/bg02Vote.png" width="691" height="1029" x="14" y="111"/>
	<mx:Label text="通过投票来决定联盟官员这周薪水数额" fontSize="24" styleName="red01" y="132" x="103" width="514" textAlign="center"/>
	<mx:Label id="time" text="${unionvote_getTimeStr(arg[1],arg[2])}" fontSize="30" styleName="yellow02" y="198" x="213" width="294" textAlign="center"/>
	
	<mx:VBox verticalGap="3" x="61" y="319">
		{for i,v in pairs(arg[7]) do}
		<mx:Canvas width="595" height="142" {if arg.select == v[1] then} backgroundColor="0x3e5178" {end} mouseChildren="false" setts="${v[1]}" onclick="unionvote_select">
			<mx:Canvas width="125" height="128" x="30" y="7">
				<mx:Image source="assets/images/headerBg01.png"/>
				<mx:Image source="assets/role/big/${v[3]}.png" x="12" y="12"/>
			</mx:Canvas>
			<mx:Label text="${v[2]}" fontSize="22" styleName="white01" x="183" y="30"/>
			<mx:Label text="${v[6]}" fontSize="30" styleName="white01" x="507" y="68"/>
			<mx:Image source="assets/images/progBg16.png" x="178" y="70"/>
			<mx:Canvas width="${(v[6]/100)*310}" height="30" backgroundColor="${unionvote_getColor(i)}" x="183" y="75"/>
		</mx:Canvas>
		{end}
	</mx:VBox>
	<mx:Button label="投票" styleName="btn08" y="1167" x="175" onclick="unionvote_click"/>
	<mx:Canvas width="720" height="112">
		<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
		<mx:Label id="frameTop_txt" text="投票" width="720" textAlign="center" y="35"/>
		<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" setts="4" onclick="unionvote_colse"/>
	</mx:Canvas>
</mx:Canvas>
	
]]

local unionvote_color = {"0x8f3ec2","0xd19e15","0x006a64","0x088f08","0x8f1508"}
local unionvote_clum = {
						"未在投票时段"
						,"本周已经投票"
						,"建盟时间不足7天"
						,"入盟时间不足7天"
						,"联盟活跃度过低"
						,"非RANK2/3成员"
						,"官员数量过低"
						}

function unionvote_getColor(index)
	return unionvote_color[index]
end

local unionvote_data = nil
function unionvote_show(arg)
	if arg == nil then
		unionvote_data = {0,0,0,0,0,0,{}}
		unionvote_data.select = 0
	else
		unionvote_data = arg
	end
	if unionvote_data.select == nil then
		unionvote_data.select = 1
	end
	print(tabletostring(unionvote_data))
	flextodiv(div_unionvote_str,unionvote_data,"frame_more")
	
	if arg == nil then
		btnloading_show()
		httpsend( 1 , 0x0000011d , 0 , {CUserData.m_nUserID,0,0},"unionvote_Back","httpdp_svrStatusLogin"  )
	end
end

function unionvote_Back(ntype , nseqno , nret , arg)
	if arg[1] == 1 then
		btnloading_del()
	end
	if nret ~= 0 then --表示处理消息失败
		return
	end
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s httpdp_revMsgLogin" , ntype , nseqno , nret, tabletostring(arg) ) )
	
	if arg[1] == 1 then
		unionvote_data[4] = arg[2]
		unionvote_data[3] = 2--已经投票
		unionvote_data.select = 1
	end
	unionvote_show(unionvote_data)
end

function unionvote_httpBack(arg)
	btnloading_del()
	if getid2("frame_more","unionvotediv") then
		table.remove(arg,1)
		if unionvote_data and unionvote_data.select then
			arg.selset = unionvote_data.select
		end
		unionvote_show(arg)
	end
end


function unionvote_cmp()
	settimer(TIMER_ID_UNIONVOTE_TIME,1000,"unionvote_time",100000)
end

function unionvote_select(a)
	if unionvote_data then
		unionvote_data.select = tonumber(a.pBase:getts())
		unionvote_show(unionvote_data)
	end
end

function unionvote_click()
	if unionvote_data and unionvote_data.select and unionvote_data.select > 0 then
		if unionvote_data[3] == 0 then
			httpsend( 1 , 0x0000011d , 0 , {CUserData.m_nUserID,1,unionvote_data.select},"unionvote_Back","httpdp_svrStatusLogin"  )
		elseif unionvote_data[3] < 8 then
			showClue(unionvote_clum[unionvote_data[3]])
		end
	end
end


function unionvote_colse()
	settimer(TIMER_ID_UNIONVOTE_TIME,0,"unionvote_time",0)
	
	deldiv("frame_more","unionvotediv")
end

function unionvote_time()
	local div = getid2("unionvotediv","time")
	if div then
		div:changetext(unionvote_getTimeStr(unionvote_data[1],unionvote_data[2]))
	end
end

function unionvote_getTimeStr(s , e)
	local str = ""
	if s == 0 then
		return str
	end
	local st = CUserData:getLeavingsTime(s)
	if st > 0 then
		str = string.format(CData:GetTranlang("开始 %s"),formatTime(st,true))
	else
		local et = CUserData:getLeavingsTime(e)
		if et > 0 then
			str = string.format(CData:GetTranlang("截止 %s"),formatTime(et,true))
		else
			str = "已截止"
			settimer(TIMER_ID_UNIONVOTE_TIME,0,"unionvote_time",0)
		end
	end
	return str
end