--联盟战争
local div_unionWarList_str = [[
<mx:Canvas id="div_unionWarList_id" onloadcmp="div_unionWarList_comp" width="720" height="1280">
	<mx:Canvas width="720" height="112">
		<mx:Image source="assets/images/topBg01.png" mouseThrough="false"/>
		<mx:Label id="frameTop_txt" text="战争" width="720" textAlign="center" y="35"/>
		<mx:Button styleName="btn01Back" id="closeBtn" x="27" y="18" setts="4" onclick="unionWarListClose_btnClick"/>
	</mx:Canvas>
	<mx:Image source="assets/images/bg03.jpg" width="720" height="1189" x="0" y="90"/>
	<mx:Image source="assets/images/bar07.png" x="15" y="114"/>
	<mx:Button styleName="nv02" label="联合攻击" enabled="${(unionWarListCurType==1 and "false" or "true")}" x="54" y="121" onclick="unionWarListTab1_btnClick"/>
	<mx:Button styleName="nv02" label="防御信息" enabled="${(unionWarListCurType==2 and "false" or "true")}" x="390" y="121" onclick="unionWarListTab2_btnClick"/>
	<mx:Canvas x="10" y="200" width="700" height="1059" setslidetype="1">
	<mx:VBox verticalGap="0"  verticalScrollPolicy="off">
		{for i = 1 , #arg do}
		<mx:Canvas width="706" height="171" setts="${arg[i][1]}" sound="defalut" onclick="unionWarList_btnClick">
			<mx:Image source="assets/images/block06.png" width="706" height="171" x="0" y="0" mouseThrough="true"/>
			<mx:Canvas backgroundColor="0xFFFFFF" x="0" y="0" width="706" height="171" alpha="0" mouseThrough="true" onbegin="clickEffectShow" onend="clickEffectHide"/>
			<mx:Image source="assets/images/testImg04.png" x="52" y="37" mouseThrough="true"/>
			<mx:Label text="${arg[i][2]}" fontSize="20" styleName="brown02" x="153" y="30" mouseThrough="true"/>
			<mx:Label text="${arg[i][3]}" fontSize="20" styleName="brown02" x="153" y="60" mouseThrough="true"/>
			<mx:Image source="assets/images/progBg08.png" x="153" y="100" mouseThrough="true"/>
			<mx:Canvas id="coolTimeBar${arg[i][1]}" styleName="prog02" width="1" height="24" x="160" y="105" mouseThrough="true"/>
			<mx:Label text="${arg[i][4]}" fontSize="16" styleName="white01" x="162" y="105" mouseThrough="true"/>
			<mx:Label id="coolTime${arg[i][1]}" text="--" fontSize="20" styleName="green02" x="475" y="105" mouseThrough="true"/>
			<mx:Image source="assets/images/arr01.png" x="600" y="51" setts="${arg[i][1]}" sound="defalut" onclick="unionWarList_btnClick"/>
		</mx:Canvas>
		{end}
	</mx:VBox>
	<mx:Label text="当前没有战争信息！" visible="${(#arg==0 and 1 or 0)}" fontSize="26" styleName="white03" horizontalCenter="0" verticalCenter="0" width="500" textAlign="center"/>
	</mx:Canvas>
</mx:Canvas>
]]

--	1发起者编号
--	2战争类型
--	3攻击坐标
--	4目标类型
--	5被攻击者编号
--	6被攻击联盟简称
--	7被攻击主公名称
--	8状态
--	9状态开始时间
--	0状态截止时间
function unionWarListClose_btnClick(a)
	deldiv("main","div_unionWarList_id")
end

--1＝主动攻击
--2＝被联盟攻击
unionWarListCurType=1
local unionWarList={}
local g_unionWarList_curData = {}
function unionWarList_getCurData()
	return g_unionWarList_curData
end
local curWarList=nil
local function getCurWarList()
	local t={}
	for i = 1 , #unionWarList do
		if unionWarList[i][2]==unionWarListCurType then
			local id=unionWarList[i][1]
			local target = ""
			if unionWarList[i][4] == 1 then
				target=CUserData:getUserNameString(unionWarList[i][6],unionWarList[i][7])
			elseif unionWarList[i][4] == 2 then
				if g_main_apptype == 1 then 
					target=CData:GetTranlang(CUserData:getBattleNPCConfigById(unionWarList[i][5],1)) .."(레벨 "..CUserData:getBattleNPCConfigById(unionWarList[i][5],6)..")"
				else 
					target=CData:GetTranlang(CUserData:getBattleNPCConfigById(unionWarList[i][5],1)) .."(Lv."..CUserData:getBattleNPCConfigById(unionWarList[i][5],6)..")"
				end
			elseif unionWarList[i][4] == 3 then
				target=string.format(CData:GetTranlang("%s要塞"),unionWarList[i][6])
			elseif unionWarList[i][4] == 4 then
				if unionWarList[i][3] > 10000 then
					target=CData:GetTranlang(getSmallBeachNameByMAPID(unionWarList[i][3]))
				else
					target=CData:GetTranlang(map_getBeachHeadName(unionWarList[i][3]))
				end
			end
			local x,y=getMapXYByDataID(unionWarList[i][3],true)
			local pos=CUserData:getMapPosString(x,y)
--			if 130305 == unionWarList[i][3] then 
			if mapBigBase_checkmapid(unionWarList[i][3]) == 1 then 
				target = CData:GetTranlang("魔君")
			end
			target=CData:GetTranlang("攻击目标：")..target
			pos=CData:GetTranlang("攻击坐标")..pos
--			0＝正在集结
--			1＝集结后出征
			local state=unionWarList[i][8]
			if unionWarListCurType==1 then
				if state==0 then
					state="召集时间"
				elseif state==1 then
					state="行军时间"
				end
			elseif unionWarListCurType==2 then
				state="敌军进攻时间"
			end
			print("getCurWarList::",tabletostring(unionWarList[i]))
			table.insert(t,{id,target,pos,state,unionWarList[i][9],unionWarList[i][10]})
		end
	end
	print("????????????????",tabletostring(t))
	return t
end
function unionWarList_show()
	print("unionWarList_show")
	settimer(TIMER_ID_FOR_UNIONWARLIST,1*1000,"unionWarListTimer",0)
	flextodiv(div_unionWarList_str,{},"frame_more")
	httpsend( 1 , 0x00000022 , 0 , {CUserData.m_nUserID},"getAllyWarListsBack","httpdp_svrStatusLogin"  )
	btnloading_show("frame_top",360-20,640-50)
end

function unionWarListGuide_show()
	curWarList=getCurWarList()
	flextodiv(div_unionWarList_str,curWarList,"frame_more")
end

local function refreshUnionWarList(frist)
	local div=getid2("frame_more","div_unionWarList_id")
	if div~=nil then
		if frist == true then
			curWarList=getCurWarList()
			if #curWarList == 0 then
				unionWarListCurType= (unionWarListCurType == 1 and 2 or 1)
				curWarList=getCurWarList()
			end
			flextodiv(div_unionWarList_str,curWarList,"frame_more")
		else
			curWarList=getCurWarList()
			flextodiv(div_unionWarList_str,curWarList,"frame_more")
		end
	end
end

function getAllyWarListsBack(ntype , nseqno , nret , arg)
	btnloading_del("frame_top")
	http_getdata(ntype , nseqno , nret , arg)
	print(string.format("httpdp_revMsgLogin ntype:%x ：nseqno:%d nret:%d",ntype , nseqno , nret) )
	if nret ~= 0 then --表示处理消息失败
		return
	end
	print("getAllyWarListsBack:"..type(arg))
	table.insert(arg,1,nret)
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s httpdp_revMsgLogin" , ntype , nseqno , nret, tabletostring(arg) ) )
	
	--test
	--local arg = {0,{{3,1,229094,1,40,"chj","78900100004",0,1400059460,1400059520}}}
	
	unionWarList=arg[2]
	refreshUnionWarList(true)
end

function setAllyWar(arg)
	unionWarList=arg[2]
end

function hasAllyWar()
	return #unionWarList>0 and 0 or 1
end

function SNAllyWar(arg)
	local type=arg[2]
	table.remove(arg,1)
	table.remove(arg,1)
	if type==0 then
		for i = 1 , #unionWarList do
			if unionWarList[i][1]==arg[1] and unionWarList[i][2]==arg[2] then
				unionWarList[i]=arg
				refreshUnionWarList()
				return
			end
		end
		table.insert(unionWarList,arg)
	elseif type==1 then
		for i = #unionWarList ,1,-1  do
			if unionWarList[i][1]==arg[1] and unionWarList[i][2]==arg[2] then
				table.remove(unionWarList,i)
			end
		end
	end
	refreshUnionWarList()
end

function div_unionWarList_comp()
	if guideNew_getMapType()==1 then
		return
	end
	if curWarList~=nil and #curWarList>0 then
		unionWarListTimer()
	end
end

function unionWarListTimer()
	local needFresh=false
	for i = #curWarList , 1,-1 do
		local time1=curWarList[i][5]
		local time2=curWarList[i][6]
		local time=CUserData:getLeavingsTime(time2)
		if time>0 then
			needFresh=true
			local id=curWarList[i][1]
			local coolTime=getid2("div_unionWarList_id","coolTime"..id)
			if coolTime~=nil then
				coolTime:changetext(formatTime(time))
				local coolTimeBar=getid2("div_unionWarList_id","coolTimeBar"..id)
				coolTimeBar:sw(399-time/(time2-time1)*399)
			end
		end
	end
	if needFresh then
		settimer(TIMER_ID_FOR_UNIONWARLIST,1*1000,"unionWarListTimer",1)
	end
end

function unionWarListTab1_btnClick(a)
	unionWarListCurType=1
	refreshUnionWarList()
end

function unionWarListTab2_btnClick(a)
	unionWarListCurType=2
	refreshUnionWarList()
end

function unionWarList_btnClick(a)
	print("unionWarList_btnClick")
	if guideNew_getMapType()==1 then
		unionWarJoin_show2()
		return
	end
	local id = tonumber(a.pBase:getts())
	if unionWarListCurType==1 then
		--g_unionWarList_curData
		for i = 1 , #unionWarList do
			if unionWarList[i][1] == id then
				g_unionWarList_curData = copytable(unionWarList[i] )
			end
		end
		unionWarJoin_show(1,id)
	elseif unionWarListCurType==2 then
		for i = 1 , #unionWarList do
			if unionWarList[i][1] == id then
				unionWarDefence_show(2,id,unionWarList[i][4])
				break
			end
		end
	end
end